<?php 


function getFolderSize($path)
{	
	$size = 0;

        $d = dir($path);
        while($e=$d->read())
        {
                if($e=="."||$e=="..") continue;
                if(is_dir($path."/".$e))
                {
                        $size += getFolderSize($path."/".$e);
                        
                }
                else
                {
                        $size += filesize($path."/".$e);
                }
        }
	return $size;
}

function copyFolder($in_path, $out_path, $force=false)
{
	if(!file_exists($out_path))
	{	if(!mkdir($out_path, 0777)) return false;
    		if(!chmod($out_path,0777)) return false;
	}

	@chmod($out_path,0777);

	return _copyFolder($in_path, $out_path, $force);
}


function _copyFolder($in_path, $out_path, $force)
{
	@chmod($out_path,0777);

        $d = dir($in_path);
        while($e=$d->read())
        {
                if($e=="."||$e=="..") continue;
                if(is_dir($in_path."/".$e))
                {
                     if(!mkdir($out_path."/".$e, 0777)) return false;
                     if(!chmod($out_path."/".$e,0777)) return false;
                     if(!_copyFolder($in_path."/".$e, $out_path."/".$e, $force)) return false; 
                }
                else
                {
			if($force && file_exists($out_path."/".$e))
				unlink($out_path."/".$e);
			if(!copy($in_path."/".$e, $out_path."/".$e)) 
//pr("Can't copy file".$e);			
			NULL;//return false;
			
//pr($e);			
			
                }
        }
		return true;
}

function deleteFolder($path)
{
/*
echo "[";
    if($path=="c:/work/htdocs/COURSES/course146.backup/mods/442/target_114")
    {	rmdir($path."/146");
    	rmdir($path);
        return 1;
    }
echo "]";
*/
        $d = dir($path);
        while($e=$d->read())
        {
                if($e=="."||$e=="..") continue;
                if(is_dir($path."/".$e))
                {
                    if(!deleteFolder($path."/".$e)) return false; 
                }
                else
                {
			@chmod($path."/".$e, 0777);
			if(!unlink($path."/".$e)) return false;
                }
        }

        $d->close();
        unset($d);

	@chmod($path, 0777);
	return rmdir($path);
}

function makeDir($path)
{
	if(!mkdir($path, 0777))
        	return false;
    	if(!chmod($path,0777))
        	return false;

    return true;
}

?>