
DDMenuUtility = {
		bottom_z: 1000,
		p_screen: null,
		p_menus: {},

		p_inited: false,
		p_fed_screen: null,
		p_fed_message: null,
		
		p_query: [],
		p_screens: [],
		z_drag: null,

		init: function()
			{
				if (!DDMenuUtility.p_inited)
					{
						DDMenuUtility.p_inited=true;
						window.attachEvent('onresize', DDMenuUtility.onresize);
						var frame=document.createElement('IFRAME');
						frame.allowTransparency=true;
						frame.width='100%';
						frame.height='100%';
						frame.src='blank.html';
						with(frame.style)
							{
								position='absolute';
								backgroundColor='transparent';
								posLeft=0;
								posRight=0;
								display='none';
								filter="progid:DXImageTransform.Microsoft.Alpha(opacity=1)";
							}
						document.body.insertBefore(frame);
						DDMenuUtility.p_screen=frame;
					}
			},

		register: function(oMenu)
			{
				DDMenuUtility.p_menus[oMenu]=oMenu;
			},

		show: function(oMenu, iX, iY, iWidth, iHeight)
			{
				var t=document.body, pX, pY, pW=Math.round(t.clientWidth/2), pH=200,
				maxw= Math.round(t.clientWidth * (t.clientWidth > 800 ? 0.7 : 0.9)),
				maxh= Math.round(t.clientHeight * (t.clientHeight > 600 ? 0.85 : 0.95)),
				index;

				oMenu.p_holder.style.posLeft=iX;
				oMenu.p_holder.style.posTop=iY;
				oMenu.p_holder.style.posWidth=iWidth;
				oMenu.p_holder.style.display='block';
				oMenu.p_holder.zIndex=DDMenuUtility.bottom_z+DDMenuUtility.p_query.length-1;
				if (iHeight==undefined || iHeight=='auto')
					{
						iHeight=oMenu.p_body.lastChild.offsetTop+oMenu.p_body.lastChild.offsetHeight
					}
				if (iHeight < oMenu.p_body.scrollHeight)
					iHeight=oMenu.p_body.scrollHeight;
				oMenu.p_holder.style.posHeight=iHeight;	
				document.attachEvent('onmousedown', DDMenuUtility.pBlur);
				DDMenuUtility.p_query[DDMenuUtility.p_query.length]=oMenu;
			},

		hide: function(oMenu)
			{
				var o=null, i=0;;
				switch (typeof(oMenu))
					{
						case 'object':
								o=oMenu;
							break;
						case 'string':
								o=DDMenuUtility.p_menus[oMenu];
							break;
					}
				if (o && o.id && o.p_holder)
					{
						o.p_holder.style.display='none';
					}
				o.is_visible=true;
			},

		onresize: function()
			{
//				status=document.body.clientWidth;
			},

		pCancelEvent: function()
			{
				this.parentWindow.event.cancelBubble=true;
				return false;
			},

		pMouseOut: function()
			{
				var p=this.parentWindow.event.toElement;
				if (!(p && p.o_rootid==this.o_root.id) && this.o_root.z_current)
					{
						this.o_root.z_current.className=this.o_root.z_current.oSubMenu ? 'sub' : '';
						this.o_root.z_current=null;
					}
				this.parentWindow.event.cancelBubble=true;
				return false;
			},

		pMouseOver: function()
			{
				var p=this.parentWindow.event.srcElement;
				if (p.tagName=='SPAN') p=p.parentElement;
				if (p.tagName=='DIV' && this.o_root.z_current != p && p.o_rootid==this.o_root.id)
					{
						if (this.o_root.z_current)
							{
								this.o_root.z_current.className=this.o_root.z_current.oSubMenu ? 'sub' : '';
								this.o_root.z_current=null;
							}
		
		/*				if (submenu && oCtrl)
							{
								oCtrl.hide(submenu.dropDown);
								if (p_time) 
								clearTimeout(p_time);
								submenu=null;
							}
							*/
						p.className=p.className+' sel';
						this.o_root.z_current=p;
		/*				if (p.dropDown)
							{
								submenu=p;
								p_time=setTimeout(pExpand, 300);
							}
							*/
					}
				this.parentWindow.event.cancelBubble=true;
				return false;
			},
		pClick: function()
			{
				var p=this.parentWindow.event.srcElement;
				if (p.tagName=='SPAN') p=p.parentElement;
				if (p.tagName=='DIV')
					{
						V=this.o_root.p_holder.document.createEventObject();
						V.eventName='onclick';
						V.key=p.sKey;
						V.value=p.sValue;
						this.o_root.p_holder.fireEvent('oncontrolselect', V);
						this.o_root.hide();
					}
				this.parentWindow.event.cancelBubble=true;
				return false;
			},
			
		pEventControl: function()
			{
				switch(event.eventName)
					{
						case 'onselect':
							if (this.o_root.onselect && typeof(this.o_root.onselect)=='function')
								return this.o_root.onselect()===false ? false : true;
							return true;
						case 'onclick':
							if (this.o_root.onclick && typeof(this.o_root.onclick)=='function')
								return this.o_root.onclick()===false ? false : true;
						case 'onkeydown':
							if (this.o_root.onkeydown && typeof(this.o_root.onkeydown)=='function')
								return this.o_root.onkeydown()===false ? false : true;
					}
			},

		pBlur: function()
			{
				for (var x in DDMenuUtility.p_query)
					{
						DDMenuUtility.p_query[x].hide();
					}
			}
	}

function DropDownMenu(id)
	{
		DDMenuUtility.init();
		this.id=id ? id : "ddmenu"+Math.round(Math.random()*1000)+(t=new Date).getTime();
		this.p_items={};
		this.p_holder=null;
		this.p_body=null;
		this.p_doc=null;
		
		this.onclick=null;
		
		this.z_current=null;

		this.width=150;
		this.height='auto';
		this.fixed=false;

		this.p_screen=null;
		this.is_visible=false;

		DDMenuUtility.register(this);
		var obj=document.createElement('<IFRAME src="blank.html" scrolling="no" hideFocus="true" unselectable="on" frameborder="no">');
		obj.style.cssText='background:buttonface!important; position:absolute!important; width:100px; display:none';
		document.body.insertBefore(obj);
		this.p_holder=obj;
		this.p_doc=obj.contentWindow.document;
		this.p_doc.open();
		this.p_doc.write('<HTML><HEAD><STYLE>BODY {margin:0; text-align:center; font-family:Tahoma; font-size:11px}; DIV {width:100%; height:20px; text-align:left; color:#000000; padding:3px 10px 0 22px; cursor:default}; DIV{background-position-x: right; background-position-y: 1px; display:block;}; DIV.sel {color:#ffffff; background-color:highlight; background-position:right -21px};  S {height:1px; margin:2 0 4 0;padding:0; border:none; width:98%; border-bottom:1px solid #777; font-size:1px;}; DIV.sub {background-image:url(flexed_images/arrowright.gif);  background-repeat:no-repeat}; SPAN {white-space:nowrap!important; text-overflow:ellipsis!important; overflow-x:hidden!important; width:100%}; </STYLE><STYLE> .*{} </STYLE></HEAD><BODY hideFocus="true" unselectable="on"></BODY></HTML>');
		this.p_doc.close();
		this.p_doc.onmouseover=DDMenuUtility.pMouseOver;
		this.p_doc.onmouseout=DDMenuUtility.pMouseOut;
		this.p_doc.onclick=DDMenuUtility.pClick;
		this.p_doc.onselectstart = DDMenuUtility.pCancelEvent;
		this.p_doc.o_root=this;
		obj.oncontrolselect=DDMenuUtility.pEventControl;
		
		this.p_body=this.p_doc.body;
		obj.o_root=this;
		obj.contentWindow.o_root=this;
		return this;
	}

DropDownMenu.prototype.hide=function()
	{
		DDMenuUtility.hide(this);
	}

DropDownMenu.prototype.show=function(iX, iY, oObject)
	{
		if (typeof(oObject)=='object')
			{
				var dx=0, dy=0, o=oObject;
				while(o.parentElement && o.tagName.toLowerCase()!='body')
					{
						dx+=o.offsetLeft;
						dy+=o.offsetTop;
						o=o.parentElement;
					}
				iX+=dx;
				iY+=dy;
			}
		DDMenuUtility.show(this, iX, iY, this.width, this.height);
	}

DropDownMenu.prototype.addBreak=function()
	{
		var obj=this.p_doc.createElement('S');
		obj.iMode=1;
		this.p_body.appendChild(obj);
	}

DropDownMenu.prototype.addItem=function(sKey, sValue, sStyle, sClass, iIcon)
	{
		if (this.p_body)
			{
				var obj=this.p_body.document.createElement('<DIV unselectable="on">'), span=this.p_body.document.createElement('<SPAN unselectable="on">');
				obj.sValue=sValue;
				obj.sKey=sKey;
				obj.className=sClass;
				obj.style.cssText=sStyle;
				obj.iIcon=iIcon;
				obj.isItem=2;
				obj.hideFocus=true;
				obj.o_rootid=this.id;
				obj.o_root=this;
				this.p_items[sKey]=obj;
				span.innerText=sValue;
				span.hideFocus=true;
				obj.appendChild(span);
				this.p_body.appendChild(obj);
			}
	}

DropDownMenu.prototype.addSubmenu=function(sKey, oMenu)
	{
		if (this.p_items[sKey])
			{
				var obj=this.p_items[sKey];
				obj.className='sub';
				obj.oSubMenu=1;
				//arrow.src='flexed_images/arrowright.gif'
				//obj.insertBefore(arrow);
			}
	}

DropDownMenu.prototype.setMode=function(sKey, iMode)
	{
		var x=this.p_items[sKey];
		if (x)
			{
				x.disabled=(mode & 1 ? false : true); // enabled;
				if ((x.mode & 2) != (mode & 2))	//invisible
					{
						var n=x.nextSibling, p=x.previousSibling, m=(mode&2) ? 'none' : 'block';
						x.style.display=x;
						if (n && n.isItem && (!p || (p && p.isItem)))	
							n.style.display=x;
						else
							if (p && p.iMode)
								p.style.display=x;
					}
				x.mode=mode;
			}
	}

DropDownMenu.prototype.getMode=function(sKey)
	{
		var x=this.p_items[sKey];
		if (x)
			return x.mode;
	}

DropDownMenu.prototype.setCssStyle=function(sText)
	{
		this.p_doc.styleSheets(1).cssText=sText;
	}