TX=null;
TY=null;
EV=null;
function getAbsoulteXY(oObj)
	{
		if (typeof(oObj)=='object')
			{
				var dx=0, dy=0, o=oObj;
				while(o)
					{
						if (!(o.tagName=='TD' || o.tagName=='TR'))
							{
								dx+=o.offsetLeft;
								dy+=o.offsetTop;
							}
						if (o.parentElement)
							o=o.parentElement;
						else
							{
								if (o.document.parentWindow.frameElement)
									o=o.document.parentWindow.frameElement;
								else
									break;
							}
					}
				return {x: dx, y: dy};
			}
		return null
	}

function Message(msg, type, btns, head)
	{
		var pTypes={critical: 16, exclamation: 48, question: 32, info: 64},
		pBtns={ok: 0, ok_cancel: 1, abort_retry_ignore: 2, yes_no_cancel: 3, yes_no: 4, retry_cancel: 5},
		pResults=[0, 'ok', 'cancel', 'abort', 'retry', 'ignore', 'yes', 'no'],
		ops=0, res;

		if (!pTypes[type])
			type='critical';

		if (!pBtns[btns])
			btns='ok';

		ops=pTypes[type]+pBtns[btns]+4096;
		try
			{
				res=Number(tMessage(msg, ops, head));
				return pResults[res] ? pResults[res] : 'ok';
			}
		catch(e)
			{
			}
		return false;
	}

document.cookies={
	create: function(N, V, H)
			{
				var ex= "";
				if (H)
					{
						var X = new Date();
						X.setTime(X.getTime()+(H*60*60*1000));
						ex = "; expires="+X.toGMTString();
					}
				document.cookie = N+"="+V+ex+"; path=/";
			},

	get:	function(N)
			{
				var NE = N + "=", ca = document.cookie.split(';');
				for(var i=0;i < ca.length;i++)
					{
						var c = ca[i];
						while(c.charAt(0)==' ')
							c=c.substring(1,c.length);
						if(c.indexOf(NE) == 0)
							return c.substring(NE.length, c.length);
					}
				return null;
			},

	getExcl: function(N)
		{
			var NE = N + "=", ca = document.cookie.split(';'), res='';
			for(var i=0; i < ca.length;i++)
				{
					var c = ca[i];
					while(c.charAt(0)==' ')
						c=c.substring(1,c.length);
					if(c.indexOf(NE) == -1)
						res+=c;
				}
			return res;
		},

	remove: function(N)
			{
				document.cookies.create(N,"",-1)
			}
}

function isPositiveNum(num)
	{
		return isNaN(num=parseInt(num)) ? false : (num > 0 ? true : false);
	}

FAUtil=
	{
		factor_x: 120/1024,
		factor_y: 90/768,
		gridsize: 21,
		delta_x: 0,
		delta_y: 0,
		scroll_x: 0,
		scroll_y: 0,
		p_temp_images: {},
		p_temp_image_idx: 0,
		items_names: {},
		is_snapping: false,
		
		defaultObjects : {
				'image' : {w: 120, h: 120},
				'hotspot' : {w: 120, h: 120},
				'label' : {w: 130, h: 32},
				'textinput' : {w: 140, h: 32},
				'message' : {w: 35, h: 35},
				'checkbox' : {w: 120, h: 32},
				'select' : {w: 120, h: 32},
				'button' : {w: 120, h: 35},
				'radio' : {w: 120, h: 35}
			},
		fonts : {
					"arial":	"Arial",
					"courier new": "Courier New",
					"georgia": "Georgia",
					"tahoma": "Tahoma",
					"times new roman": "Times New Roman",
					"verdana": "Verdana",
					"helvetica": "Helvetica",
					"impact": "Impact",
					'trebuchet ms': "Trebuchet MS"
				},
		
		getUniqueID: function(sID)
			{
				var index=1, pre_id, p;
				if (!sID)
					sID='uniqid';
				if (p=sID.match(/(.*)_([\d]+)$/))
					{
						pre_id=p[1];
						index=parseInt(p[2]);
					}
				else
					pre_id=sID;

				if (this.items_names[pre_id+'_'+index])
					{
						while(this.items_names[pre_id+'_'+index])
							index++;
					}
				this.items_names[sID=pre_id+'_'+index]=1;
				return [sID, index];
			},

		cancelEvent: function()
			{
				this.document.parentWindow.event.cancelBubble=true;
				return false;
			},

		cancelEditEvent: function()
			{
				if (!(this.document.parentWindow.event.srcElement.tagName == 'INPUT' || this.document.parentWindow.event.srcElement.tagName == 'TEXTAREA'))
					{
						this.document.parentWindow.event.cancelBubble=true;
						return false;
					}
			},

		frameClick: function()
			{
				this.o_ref.select();
			},

		frameDblClick: function()	
			{
				this.o_ref.switchTo();
			},

		switchToFrame: function(oObj)	
			{
				if (oObj.o_ref.z_curframe)
					{
						oObj.o_ref.z_curframe.o_screen.style.display='none';
						oObj.o_ref.z_curframe=null;
					}
				oObj.o_ref.disableControlPanel(false);
				oObj.o_ref.p_disabled=false;
				oObj.select();
				if (oObj.o_screen)
					{
						oObj.o_screen.style.display='block';
						oObj.o_ref.z_curframe=oObj;
						oObj.o_ref.p_editor_cap.innerHTML=oObj.name ? oObj.name : oObj.id;
					}
					
				if (oObj.o_ref.p_tree)
					oObj.o_ref.p_tree.findNode(oObj.id);
			},

		pPanelDragStart: function()
			{
				var oObj=event.srcElement;
				if (oObj.o_ref.p_cp_disabled)
					{
						return false;
					}
				if (oObj.iType==2)
					{
						oObj.o_ref.z_dragged=this;
						oObj.o_ref.setDragDropObject(oObj.sKey, oObj.alt, oObj.src, oObj.defWidth, oObj.defHeight);
						if (oObj.o_ref.is_drag_start)
							{
								FAUtil.scroll_x=oObj.o_ref.z_editor.scrollLeft;
								FAUtil.scroll_y=oObj.o_ref.z_editor.scrollTop;
								if (FAUtil.is_snapping)
									{
										oObj.o_ref.o_dragger.style.posLeft=5+FAUtil.gridsize * Math.floor((this.document.parentWindow.event.x - 33 + FAUtil.scroll_x) / FAUtil.gridsize);
										oObj.o_ref.o_dragger.style.posTop=5+FAUtil.gridsize * Math.floor((this.document.parentWindow.event.y - 115 + FAUtil.scroll_y) / FAUtil.gridsize);
									}
								else
									{
										oObj.o_ref.o_dragger.style.posLeft=5+oObj.document.parentWindow.event.x - 33 + FAUtil.scroll_x;
										oObj.o_ref.o_dragger.style.posTop=5+oObj.document.parentWindow.event.y - 115 + FAUtil.scroll_y;
									}
								oObj.o_ref.o_dragger.style.display='block';
								oObj.o_ref.is_drag_start=false;
							}
						FAUtil.is_moving = true;
						oObj.ondrag=FAUtil.zDrag;
						oObj.ondragend=FAUtil.zDragEnd;
						event.dataTransfer.setData("Text", "CObject_"+oObj.sKey);
						event.dataTransfer.effectAllowed="copyMove";
						oObj=oObj.parentElement;
						this.ondragover=FAUtil.pPanelDragOver;
						this.ondragenter=FAUtil.pPanelDragOver;
					}
			},
		
		pPanelDragEnd: function()
			{
				var oObj=event.srcElement;
				if (oObj.NN==2)
					{
						//event.cancelBubble=true;
						//ode.fire();
						oObj.o_ref.releaseDragDropObject();
						oObj.ondragend=null;
						oObj.ondrag=null;
					}
				FAUtil.is_moving = false;
				this.ondragover=null;
				this.ondragenter=null;
			},
		
		zDrag: function()
			{
				if (FAUtil.is_snapping)
					{
						this.o_ref.o_dragger.style.posLeft=5+FAUtil.gridsize * Math.floor((this.document.parentWindow.event.x - 33 + FAUtil.scroll_x) / FAUtil.gridsize);
						this.o_ref.o_dragger.style.posTop=5+FAUtil.gridsize * Math.floor((this.document.parentWindow.event.y - 115 + FAUtil.scroll_y) / FAUtil.gridsize);
					}
				else
					{
						this.o_ref.o_dragger.style.posLeft=5+this.document.parentWindow.event.x - 33 + FAUtil.scroll_x;
						this.o_ref.o_dragger.style.posTop=5+this.document.parentWindow.event.y - 115 + FAUtil.scroll_y;
					}
			},

		zDragEnd: function()
			{
				FAUtil.is_moving = false;
				this.o_ref.o_dragger.style.display='none';
			},

		pPanelDragOver: function()
			{
				event.dataTransfer.dropEffect="none";
				event.cancelBubble=true;
				return false;
			},

		
		treeSelect: function()
			{
				if (event)
					{
						var oObj=this.keys[event.key], sFrameKey, sCurKey, oFrame, item_id;
						if (oObj)
							{
								switch (oObj.iGroup)
									{
										case 0:
											if (oObj.sKey==0 && this.o_ref.p_scenario)
												{
													var oObj={}, oScen=this.o_ref.p_scenario;
													this.o_ref.p_scenario.getItem=1;
													this.o_ref.p_scenario.name=oScen.title;
													this.o_ref.showProperties(this.o_ref.p_scenario);
												}
											return true;
										case 1:
											if (this.o_ref.p_scenario.p_keys[event.key])
												this.o_ref.showProperties(this.o_ref.p_scenario.p_keys[event.key]);
											return true;
										default:
											if (item_id=event.key.match(/(.*)\|(.*)/))
												{
													sFrameKey=item_id[1];
													item_id=item_id[2];
												}
											else
												return;

											if (sFrameKey=='root' && this.o_ref.p_scenario.p_items[item_id])
												{
													this.o_ref.showProperties(this.o_ref.p_scenario.p_items[item_id]);
												}
											else
												{
													var item;
													sFrameKey = event.key;
													do
														sFrameKey=this.getAncestor(sFrameKey);
													while(sFrameKey && !this.o_ref.p_scenario.p_keys[sFrameKey]);

													if (this.o_ref.p_scenario.p_keys[sFrameKey] && (item=this.o_ref.p_scenario.p_keys[sFrameKey].getItem(item_id)))
														{
															if (this.o_ref.z_curframe && this.o_ref.z_curframe.id==sFrameKey && !item.isLocked)
																this.o_ref.z_curframe.selectItem(item_id);
															else
																this.o_ref.showProperties(item);
														}
												}
											return true;

									}
							}
					}
				this.o_ref.showProperties();
				return false;
			},

		treeDblClick: function()
			{
				if (event)
					{
						
						var oObj=this.keys[event.key], sFrameKey, oFrame, item_id;

						if (oObj.iGroup==0 && this.o_ref.p_scenario.p_keys[event.key])
							{
								this.o_ref.p_scenario.p_keys[event.key].switchTo();
								//this.o_ref.z_curframe.selectItem(item_id);
							}
					}
			},

		treeMove: function(ev)
			{
				var oFrame, oFrameTarget, sFKey, sTargetFKey, itemKey;
				if (sFKey=ev.key.match(/(.*)\|(.*)/))
					{
						itemKey=sFKey[2];
						sFKey=sFKey[1];
					}
				else
					return;

				if (sTargetFKey=ev.target.match(/(.*)\|(.*)/))
					sTargetFKey=sTargetFKey[1];
				else
					sTargetFKey=ev.target;

				if ((oFrame=this.o_ref.p_scenario.getFrame(sFKey)) && (oFrameTarget=this.o_ref.p_scenario.getFrame(sTargetFKey))
				 &&
					sFKey != sTargetFKey)
					{
						this.reindexItem(ev.key, sTargetFKey+'|'+itemKey);
						var oItem=oFrame.removeItem(itemKey, true);
						oFrameTarget.insertItem(oItem);
					}
				
			},

		treeRename: function(ev)
			{
				var oFrame, sKey, itemKey;
				if (ev.key==0)
					{
						this.o_ref.p_scenario.setTitle(ev.value);
					}
				else
					{
						if (sKey=ev.key.match(/(.*)\|(.*)/))
							{
								itemKey=sKey[2];
								sKey=sKey[1];
							}
						else
							sKey=ev.key;
		
						if (oFrame=this.o_ref.p_scenario.getFrame(sKey))
							{
								if (itemKey)
									{
										if (oFrame.getItem(itemKey))
											oFrame.renameItem(itemKey, ev.value);
									}
								else
									oFrame.setName(ev.value);
							}
					}
			},

		treeFilter: function()
			{
				this.title = this.checked ? FAStrings.mode_full : FAStrings.mode_compact;
				if (!this.o_ref.p_tree.setGroupFilter([10, 11, 12, 13, 14, 15, 16], this.checked))
					{
						this.checked=false;
						this.className='';
					}
			},

		pPanelDblClick: function()
			{
			},

		pPanelMouseDown: function()
			{
			},

		pScroll: function()	
			{
				self.document.selection.empty();
				FAUtil.scroll_x=this.scrollLeft;
				FAUtil.scroll_y=this.scrollTop;
			},

		objectMoveStart: function()
			{
				EV=this.document.parentWindow.event;
				if (EV.srcElement.isLocked)
					{
						EV.cancelBubble=true
						return false
					}
				EV.srcElement.delta_x=EV.offsetX+10;
				EV.srcElement.delta_y=EV.offsetY+10;
				EV.srcElement.onmove=FAUtil.is_snapping ? FAUtil.objectMoveSnapping : FAUtil.objectMove;
				EV.srcElement.onmoveend=FAUtil.objectMoveEnd;
				//EV.srcElement.setCapture(false);
			},

		objectMoveEnd: function()
			{
				EV=this.document.parentWindow.event;
				if (this.isLocked)
					{
						EV.cancelBubble=true;
						return false;
					}
				if (this.oFrameObj)
					{
						this.oFrameObj.style.posLeft=(this.style.posLeft) * FAUtil.factor_x;
						this.oFrameObj.style.posTop=(this.style.posTop) * FAUtil.factor_y;
					}
				this.onmove=null;
				this.onmoveend=null;
				//this.document.releaseCapture();
			},

		objectMoveSnapping: function()
			{
				this.onmove=null;
				EV=this.document.parentWindow.event;
				TX=FAUtil.gridsize * Math.floor((EV.x - this.delta_x + FAUtil.scroll_x) / FAUtil.gridsize);
				TY=FAUtil.gridsize * Math.floor((EV.y - this.delta_y + FAUtil.scroll_y) / FAUtil.gridsize);
				if (TX < 0)
					TX=0;
				if (TY < 0)
					TY=0;
				this.style.posLeft=TX;
				this.style.posTop=TY;
				this.o_ref.o_ref.setProperty(this, 'x', TX);
				this.o_ref.o_ref.setProperty(this, 'y', TY);
				EV.cancelBubble=true;
				this.onmove=FAUtil.objectMoveSnapping;
				return false;
			},

		objectMove: function()
			{
				this.onmove=null;
				EV=this.document.parentWindow.event;
				TX=EV.x - this.delta_x + FAUtil.scroll_x;
				TY=EV.y - this.delta_y + FAUtil.scroll_y;
				//status+='x:'+TX+' y:'+TY;
				if (TX < 0)
					TX=0;
				if (TY < 0)
					TY=0;
				
				this.style.posLeft=TX;
				this.style.posTop=TY;
				
				this.o_ref.o_ref.setProperty(this, 'x', TX);
				this.o_ref.o_ref.setProperty(this, 'y', TY);
				EV.cancelBubble=true;
				this.onmove=FAUtil.objectMove;
				return false;
			},

		objectResizeStart: function()
			{
				EV=this.document.parentWindow.event;
				if (EV.srcElement.isLocked || EV.srcElement.isUnresizable)
					{
						EV.cancelBubble=true;
						return false;
					}

				if (!EV.srcElement.isFixed)
					{
						EV.srcElement.isByHeight=(EV.offsetY < 0 || EV.offsetY >= EV.srcElement.clientHeight);
						EV.srcElement.firstResize=true;
					}
				EV.srcElement.delta_x=EV.offsetX;
				EV.srcElement.delta_y=EV.offsetY;
				EV.srcElement.onresize=FAUtil.objectResize;
				EV.srcElement.onresizeend=FAUtil.objectResizeEnd;
			},

		objectResizeEnd: function()
			{
				EV=this.document.parentWindow.event;
				if (this.isLocked || this.isUnresizable)
					{
						EV.cancelBubble=true
						return false
					}
				this.onresize=null;
				this.onresizeend=null;
				if (this.oFrameObj)
					{
						this.oFrameObj.style.posWidth=this.style.posWidth * FAUtil.factor_x;
						this.oFrameObj.style.posHeight=this.style.posHeight * FAUtil.factor_y;
					}
			},

		objectResize: function()
			{
				EV=this.document.parentWindow.event;
				if (this.firstResize)
					{
						this.style.posWidth=this.oParams.width[1];
						this.style.posHeight=this.oParams.height[1];
						this.firstResize=false;
					}
				else
					{
						if (this.propsLocked)
							{
								if (this.isByHeight)
									this.style.posWidth=this.style.posHeight * this.propsLocked;
								else
									this.style.posHeight=this.style.posWidth / this.propsLocked;
							}

						this.o_ref.o_ref.setProperty(this, 'width', this.style.posWidth);
						this.o_ref.o_ref.setProperty(this, 'height', this.style.posHeight);
						this.o_ref.o_ref.setProperty(this, 'x', this.style.posLeft);
						this.o_ref.o_ref.setProperty(this, 'y', this.style.posTop);
					}
				EV.cancelBubble=true;
				return false;
			},

		editorKeyDown: function()
			{
				EV=this.document.parentWindow.event;
				if (this.document.selection.type=='Control')
					{
						var range=this.document.selection.createRange(), dx=0, dy=0, i, x;
						switch (EV.keyCode)
							{
								case 37:
										dx=EV.shiftKey ? -21 : EV.ctrlKey ? -1 : -3;
									break;
								case 38:
										dy=EV.shiftKey ? -21 : EV.ctrlKey ? -1 : -3;
									break;
								case 39:
										dx=EV.shiftKey ? 21 : EV.ctrlKey ? 1 : 3
									break;
								case 40:
										dy=EV.shiftKey ? 21 : EV.ctrlKey ? 1 : 3;
									break;
								case 113:
									if (this.o_ref.p_tree.p_current)
										{
											this.o_ref.p_tree.setNodeEditable(this.o_ref.p_tree.p_current.sKey);
										}
									return false;
								case 13:
									this.document.parentWindow.event.cancelBubble=true;
									return false;
								case 46:
									for(i=0; i<range.length; i++)
										{
											range.item(i).o_ref.removeItem(range.item(i).local_id);
											/*
											oFrameObj.removeNode();
											range.item(i).removeNode();
											*/
										}
									return false;
									break;
								default:
									return true;
							}
						for(i=0; i<range.length; i++)
							{
								x=range.item(i);
								x.style.posLeft+=dx;
								x.style.posTop+=dy;
								x.oFrameObj.style.posLeft=Number(x.style.posLeft * FAUtil.factor_x);
								x.oFrameObj.style.posTop=Number(x.style.posTop * FAUtil.factor_y);
								x.o_ref.o_ref.setProperty(x, 'x', x.style.posLeft);
								x.o_ref.o_ref.setProperty(x, 'y', x.style.posTop);
							}
						EV.cancelBubble=true;
						return false;
					}
			},

		unresizeable: function()
			{
				return false;
			},

		imageRSchange: function()
			{
				if (this.readyState=='complete')
					{
						if (this.o_image)
							FAUtil.setImageStats(this.o_image, this.sFile, this.width, this.height, this.fileSize);
						delete FAUtil.p_temp_images[this.p_index];
					}
			},

		setImageStats: function(oImg, src, width, height, size)
			{
				if (src)
					{
						oImg.className='';
						oImg.oFrameObj.className='';
						oImg.o_ref.o_ref.setProperty(oImg, 'src', src, true);
						oImg.o_ref.o_ref.setProperty(oImg, 'size', size, true);
						oImg.o_ref.o_ref.setProperty(oImg, 'real_width', width, true);
						oImg.o_ref.o_ref.setProperty(oImg, 'real_height', height, true);
					}
				else
					{
						oImg.className='empty';
						oImg.style.backgroundImage='url('+oImg.o_ref.o_ref.images_dir+'empty_bg.gif)';
						oImg.oFrameObj.className='empty';
						oImg.o_ref.o_ref.setProperty(oImg, 'src', '', true);
						oImg.o_ref.o_ref.setProperty(oImg, 'size', '', true);
						oImg.o_ref.o_ref.setProperty(oImg, 'real_width', '', true);
						oImg.o_ref.o_ref.setProperty(oImg, 'real_height', '', true);
					}
			},

		timelineContextMenu: function()
			{
				this.parentWindow.event.cancelBubble=true;
				return false;
			},

		frameEditCap: function()
			{
				var width, x;
				width=parseInt(this.clientWidth);
				this.innerHTML='<INPUT type=text value="'+this.innerText+'">';
				var x=this.firstChild;
				if (width > x.clientWidth)
					x.style.posWidth=width;
				x.old_text=x.value;
				x.onfocus=FAUtil.frameEditFocus;
				x.onkeydown=FAUtil.frameEditKeyDown;
				//x.onselectstart=FAUtil.cancelEditEvent;
				x.onmousedown=FAUtil.cancelEditEvent;
				x.onblur=FAUtil.frameEditBlur;
				x.focus();
				x.setActive();
			},

		frameEditFocus: function()
			{
				this.select();
			},

		frameEditBlur: function()
			{
				var p=this.document.parentWindow.event.srcElement.parentElement;
				this.onblur=null;
				this.onfocus=null;
				this.onmousedown=null;
				this.onselectstart=null;
				p.innerText=this.old_text;
				this.document.parentWindow.event.cancelBubble=true;
				p=undefined;
				return false;
			},

		frameEditKeyDown: function()
			{
				ev=this.document.parentWindow.event;
				var k=ev.keyCode, oEdit=ev.srcElement, sVal, P;
				sVal=oEdit.value;
				if (k==27 || k==13 && sVal.replace(/\s/g, '')=='')
					{
						oEdit.document.parentWindow.event.returnValue=false;
						oEdit.blur();
						return false;
					}
				if (k==13)
					{
						oEdit.blur();
						oEdit.onblur=null;
						oEdit.onmousedown=null;
						oEdit.onselectstart=null;
						oEdit.old_text=sVal;
						oEdit.document.parentWindow.event.returnValue=false;
						oEdit.parentElement.o_ref.setName(sVal);
						return false;
					}
				k=undefined;
				return true;
			},
			
		editorScreenMove: function()
			{
				this.o_ref.z_editor.scrollLeft = FAUtil.scroll_x - this.document.parentWindow.event.x;
				this.o_ref.z_editor.scrollTop = FAUtil.scroll_y - this.document.parentWindow.event.y;
			},

		editorSelect : function()
			{
				if (this.selection.type=='Text')
					{
						this.parentWindow.event.cancelBubble=true;
						return false;
					}
			},

		inControlRange : function (oRange, oObj)
			{
				if (oRange)
					for (var i=0; i<oRange.length; i++)
						if (oRange.item(i)===oObj)
							return i+1;
				return false;
			},

		editorClick : function()
			{
				EV=this.document.parentWindow.event;
				//status+='c';
				if (EV.srcElement !== this)
					{
						var oRng=this.document.selection.createRange()
						if (!FAUtil.inControlRange(oRng, EV.srcElement) && !EV.ctrlKey)
							{
								oRng=this.document.body.createControlRange();
								oRng.add(EV.srcElement);
								oRng.select();
								return false;
							}
					}
			},

		editorDblClick: function()
			{
				this.document.selection.empty();
				return false;
			},

		editorMouseUp: function()
			{
				FAUtil.scroll_x=this.o_ref.z_editor.scrollLeft;
				FAUtil.scroll_y=this.o_ref.z_editor.scrollTop;
				this.o_ref.z_editor.onscroll = FAUtil.pScroll;
				this.releaseCapture();
				this.onmouseup=null;
				this.onmousemove=null;
			},

		editorMouseDown: function()
			{
				EV=this.document.parentWindow.event;
				if (EV.button==4)
					{
						this.setCapture(true);
						FAUtil.scroll_x=this.o_ref.z_editor.scrollLeft+EV.x;
						FAUtil.scroll_y=this.o_ref.z_editor.scrollTop+EV.y;
						this.o_ref.z_editor.onscroll=null;
						this.onmousemove=FAUtil.editorScreenMove;
						this.onmouseup=FAUtil.editorMouseUp;
					//	this.document.styleSheets['def_style'].rules(0).style.cssText="cursor:move!important";
					}
				else if (EV.srcElement)
					{
						if (EV.srcElement !== this)
							{
								var oRng;
								if (this.document.selection.type=='control')
									oRng=this.document.selection.createRange();
								if (!FAUtil.inControlRange(oRng, EV.srcElement) && !EV.ctrlKey && (oRng=this.document.body.createControlRange()))
									{
										oRng.add(EV.srcElement);
										oRng.select();
										return false;
									}
							}
						else
							if (EV.srcElement.isEditor && this.document.selection)
								this.document.selection.empty();
					}
				this.document.parentWindow.event.cancelBubble=true;
				return false;
			},

		editorControlSelect: function()
			{
				var o=this.document.parentWindow.event.srcElement;
				if (o.full_id)
					{
						if (o.isLocked)
							{
								this.document.parentWindow.event.cancelBubble=true
								return false
							}
						this.o_ref.p_tree.selectNode(o.full_id, true);
						this.o_ref.showProperties(o);
						this.o_ref.z_curframe.z_current=o;
					}
			},
		dragDivDragOver: function()
			{
				this.document.parentWindow.event.dataTransfer.dropEffect="copy";
				this.document.parentWindow.event.cancelBubble=true;
				return false;
			},

		dragDivDragEnter: function()
			{
				this.document.parentWindow.event.dataTransfer.dropEffect="copy";
		 		this.document.parentWindow.event.cancelBubble=true;
				return false;
			},

		dragDivDrop: function()
			{
				if (this.o_ref.p_disabled)
					return;
				if (this.o_ref.z_curframe)
					{
						var
							ev=this.document.parentWindow.event,
							sType=ev.dataTransfer.getData("Text").substr(8),
							oDragger=this.o_ref.o_dragger;
						this.o_ref.z_curframe.addItem(sType, null, oDragger.style.posLeft-5, oDragger.style.posTop-5, oDragger.oData.width, oDragger.oData.height);
					}
				this.o_ref.releaseDragDropObject();
				this.document.parentWindow.event.cancelBubble=true;
				return false;
			},

		dragDivLeave: function()
			{
				if (innerDDODrag)
					innerDDODrag=false;
				else
					{
						drgDIV.style.display='none';
						nisDragging=true;
					}
				event.cancelBubble=true;
				return false;
			},

		btnFrameMoveBack: function()
			{
				if (this.o_ref.z_curframe_tl)
					this.o_ref.p_scenario.moveFrame(this.o_ref.z_curframe_tl.id, -1);
			},
		
		btnFrameMoveFwd: function()
			{
				if (this.o_ref.z_curframe_tl)
					this.o_ref.p_scenario.moveFrame(this.o_ref.z_curframe_tl.id, 1);
			},

		btnAddFrame: function()
			{
				this.o_ref.p_scenario.addFrame();
			},
		
		btnRemoveFrame: function()
			{
				if (this.o_ref.z_curframe_tl)
					{
						this.o_ref.p_scenario.removeFrame(this.o_ref.z_curframe_tl.id);
						this.o_ref.z_curframe_tl=null;
						return false;
					}
			},

		btnOver: function()
			{
				if (this.document.parentWindow.event.srcElement.tagName=='SPAN')
					{
						this.document.parentWindow.event.srcElement.className=this.document.parentWindow.event.srcElement.checked ? 'btnchecked btnover' : 'btnover';
					}
			},

		btnOut: function()
			{
				if (this.document.parentWindow.event.srcElement.tagName=='SPAN')
					{
						this.document.parentWindow.event.srcElement.className=this.document.parentWindow.event.srcElement.checked ? 'btnchecked' : '';
					}
			},

		btnDown: function()
			{
				if (this.document.parentWindow.event.srcElement.tagName=='SPAN')
					{
						this.document.parentWindow.event.srcElement.className=this.document.parentWindow.event.srcElement.checked ? 'btnchecked btndown' : 'btndown';
					}
			},

		btnUp: function()
			{
				var o=this.document.parentWindow.event.srcElement;
				if (o.tagName=='SPAN')
					{
						if (o.isChecker)
							{
								o.className=o.checked ? 'btnover' : 'btnchecked btnover'
								o.checked=!Boolean(o.checked);
							}
						else
							{
								o.className='btnover';
							}
					}
			},

		setImage: function(oObj, sSrc, sUrl)
			{
				var oImg=new Image();
				oImg.onreadystatechange=FAUtil.imageRSchange;
				oImg.o_ref=oObj.o_ref;
				oImg.o_image=oObj;
				oImg.sFile=sSrc;
				oImg.sSrc=sUrl;
			//	alert(oObj.o_ref.o_ref.work_dir+sUrl);
				oImg.src=oObj.o_ref.o_ref.work_dir+sUrl;
				oImg.p_index=++this.p_temp_image_idx;
              //  alert(oImg.src);
				this.p_temp_images[oImg.p_index]=oImg;
			},

		propertyDialog: function(ev)
			{
				if (this.o_ref.z_current_prop && this.o_ref.z_current_prop.tagName=='IMG')
					{
						var oArgs = {'title' : FAStrings.header_source_image, 'nourl' : true, 'noabs': true};
						res=this.o_ref.fileDialog(oArgs, true);
                       
						if (res)
							{
                               // alert((res.dirname ? res.dirname+'/' : '')+res.filename);
								FAUtil.setImage(this.o_ref.z_current_prop, (res.dirname ? res.dirname+'/' : '')+res.filename, res.url);
							}
						else
							return false;
					}
			},

		propertyChange: function(event)
			{
				var oObj;
				if (oObj=this.o_ref.z_current_prop)
					{
						this.o_ref.setProperty(oObj, event.key, event.value, true)
					}
			},

		treeContextMenu: function()
			{
				var dim, ev=this.document.parentWindow.event, sKey, oNode, sType, bInsert=true;
				if (sKey=this.o_ref.p_tree.getNodeFromElement(ev.srcElement))
					{
						dim=getAbsoulteXY(this.firstChild)
					}
				else	if (ev.srcElement.id=='btn_add_item')
					{
						sKey=this.o_ref.p_tree.getCurrent();
						dim=getAbsoulteXY(this);
					}
				else
					return false;
				if (sKey)
					{
						oNode=this.o_ref.p_tree.keys[sKey];

						if (oNode.iGroup < 10)
							{
								this.o_ref.p_script_menu.setModes(1);
								this.o_ref.p_script_menu.setModes('frame', 'set', 'if', 'else', 'call', 'switch', 'case', 'otherwise', 'goto', 0);
							}
						else
							{
								if (oNode.oData)
									sType=oNode.oData.sType;
								this.o_ref.p_script_menu.setModes(0);
								switch (sType)
									{
										case 'if':
												this.o_ref.p_script_menu.setModes('set', 'if', 'else', 'call', 'switch', 'goto', 1);
											break;
										case 'switch':
												this.o_ref.p_script_menu.setModes('case', 'otherwise', 1);
											break;
										case 'event': case 'else': case 'case': case 'otherwise':
												this.o_ref.p_script_menu.setModes('if', 'set', 'call', 'switch', 'goto', 1);
											break;
										case 'call': case 'set': case 'goto':
												this.o_ref.p_script_menu.setModes(0);
												bInsert=false;
											break;
										default:
									}
							}
					}
				else
					{
						this.o_ref.p_script_menu.setModes(0);
						this.o_ref.p_script_menu.setModes('frame', 'set', 'call', 'goto', 'message', 1);
					}
				if (ev.srcElement.id=='btn_add_item')
					{
						this.o_ref.p_script_menu.show(dim.x-85, dim.y+15);
					}
				else
					{
						this.o_ref.p_tree_menu.setMode('insert', bInsert ? 1 : 0);
						this.o_ref.p_tree_menu.setMode('rename', (oNode.iFlags & 0x20) ? 0 : 1);
						this.o_ref.p_tree_menu.setMode('gotoframe', (oNode.iGroup==1) ? 1 : 2);
						this.o_ref.p_tree_menu.setMode('delete', (oNode.iFlags & 0x2) ? 0 : 1);
						this.o_ref.p_tree_menu.setMode('expand', (oNode.isHasChildren) ? 1 : 0);
						this.o_ref.p_tree_menu.setCaption('expand', (oNode.isExpanded) ? FAStrings.collapse : FAStrings.expand);
						this.o_ref.p_tree.selectNode(sKey);
						this.o_ref.p_tree_menu.show(dim.x+ev.x, dim.y+ev.y);
					}
				ev.cancelBubble=true;
				return false;
			},

		editorContextMenu: function()
			{
				if (this.o_ref.p_disabled || FAUtil.is_moving)
					return false;
				var ev=this.document.parentWindow.event;
				if (ev.srcElement.full_id)
					{
						this.o_ref.p_editor_menu.o_range=this.o_ref.getCurrentRange();
						this.o_ref.emptySelection();
					}

				this.o_ref.p_editor_menu.show(ev.x+5, ev.y+85, this);
				return false;
			},

		treeMenuClick : function(ev)
			{
				var sKey=this.o_editor.p_tree.getCurrent(), sCur, oFrame=this.o_editor.getTreeParentFrame();
				if (sKey)
					{
						if (sCur=sKey.match(/(.*)\|(.*)/))
							sCur=sCur[2];
						else
							sCur=sKey;
					}

				switch (ev.key)
					{
						case 'frame':
								this.o_editor.p_scenario.addFrame();
							break;
						case 'image':
						case 'hotspot':
						case 'label':
						case 'textinput':
						case 'message':
						case 'checkbox':
						case 'button':
						//case 'select':
						//case 'radio':
								if (oFrame)
									oFrame.addItem(ev.key);
								else
									this.o_editor.p_scenario.addItem(ev.key);
							break;
						case 'if':
						case 'switch':
						case 'event':
						case 'set':
						case 'else':
						case 'call':
						case 'case':
						case 'otherwise':
						case 'goto':
							if (sCur && oFrame)
								oFrame.addScriptItem(ev.key, sCur);
							else
								this.o_editor.p_scenario.addItem(ev.key);
							break;
						case 'expand':
								this.o_editor.p_tree.expandNode(sKey);
							break;
						case 'rename':
								this.o_editor.p_tree.setNodeEditable(sKey);
							break;
						case 'gotoframe':
								if (oFrame)
									oFrame.switchTo();
							break;
						case 'delete':
							if (oFrame)
								{
									if (oFrame.id==sCur)
										oFrame.remove()
									else
										oFrame.removeItem(sCur);
								}
							else
								this.o_editor.p_tree.removeNode(sKey);
							break;
					}
			},

		editorContextMenuClick: function(event)
			{
				switch(event.key)
					{
						case 'ToFront':
						case 'ToBack':
						case 'Forward':
						case 'Backward':
								if (this.o_range)
									{
										var i=0;
										for(; i< this.o_range.length; i++)
											if (!this.o_range.item(i).isLocked)
												FAUtil.setZIndex(this.o_range.item(i), event.key);
									}
							break;
					}

				if (this.o_range)
					this.o_ref.restoreSelection(this.o_range);
			},

		getAttributeParam: function(oItem, sParam, sAttrName)
			{
				if (!sAttrName)
					sAttrName=sParam;
				if (oItem.oParams[sParam])
					{
						if (oItem.oParams[sParam][2]=='checkbox')
							return sAttrName+'="'+(oItem.oParams[sParam][1] ? 1 : 0)+'" ';
						else
							if (!(oItem.oParams[sParam][1]==undefined || oItem.oParams[sParam][1]===null))
								{
									var x=String(oItem.oParams[sParam][1]);
									x=x.replace(/&/g, "&amp;").replace(/</g, "&lt;")
										.replace(/>/g, "&gt;")
										.replace(/'/g, "&apos;")
										.replace(/"/g, "&quot;")
									return sAttrName+'="'+x+'" ';
								}
					}
				return '';
			},

		getScriptNodeXml : function(oNode, sPrefix)
			{
				var oItem=null, i=0, sTag='', sAttribs='', sContent='', sResult='';
				if (!sPrefix)
					sPrefix='';
				if (oNode.oHolder && oNode.isHasChildren)
					{
						for(i=0; i < oNode.oHolder.children.length; i++)
							if (oNode.oHolder.children[i].oData)
								{
									oItem=oNode.oHolder.children[i].oData;
									sTag='';
									sAttribs=FAUtil.getAttributeParam(oItem, 'id');
									//sAttribs=FAUtil
									sContent='';
									switch (oItem.sType)
										{
											case 'if':
													sTag='IF';
													sAttribs+=FAUtil.getAttributeParam(oItem, 'expression');
												break;
											case 'switch':
													sTag='SWITCH';
													sAttribs+=FAUtil.getAttributeParam(oItem, 'expression');
												break;
											case 'event':
													sTag='EVENT';
													sAttribs+=FAUtil.getAttributeParam(oItem, 'event');
													var oFor=oItem.o_ref.o_ref.p_tree.getAncestor(oItem.full_id), tmp=oFor.match(/(.*)\|(.*)/);
													if (tmp)
														oFor=tmp[2];
													sAttribs+=' for="'+oFor+'" ';
												break;
											case 'set':
													sTag='SET';
													sAttribs+=FAUtil.getAttributeParam(oItem, 'variable')+FAUtil.getAttributeParam(oItem, 'expression');
												break;
											case 'call':
													sAttribs+=FAUtil.getAttributeParam(oItem, 'method');
													sTag='CALL';
												break;
											case 'case':
													sTag='CASE';
													sAttribs+=FAUtil.getAttributeParam(oItem, 'compare');
												break;
											case 'else':
											case 'otherwise':
													sTag=oItem.sType.toUpperCase();
												break;
											case 'goto':
													sTag='GOTO';
													sAttribs+=FAUtil.getAttributeParam(oItem, 'frame');
												break;
										}
									if (sTag)
										{
											sAttribs+=FAUtil.getAttributeParam(oItem, 'active')+FAUtil.getAttributeParam(oItem, 'locked');
											sResult+=sPrefix+'<'+sTag+' '+sAttribs+'>\n' + (sContent ? sPrefix+'\t<![CDATA['+sContent+']]>\n' : '');
											if (oNode.oHolder.children[i].isHasChildren)
												sResult+=FAUtil.getScriptNodeXml(oNode.oHolder.children[i], sPrefix+'\t');
											sResult+=sPrefix+'</'+sTag+'>\n';
										}
								}
							else
								{
									if (oNode.oHolder.children[i].isHasChildren)
										sResult+=FAUtil.getScriptNodeXml(oNode.oHolder.children[i], sPrefix);
								}
					}
				return sResult;
			},

		setZIndex: function(oObj, sMode)
			{
				var x, targetZ, currentZ;
				switch(sMode)
					{
						case 'ToFront':
								x=oObj.parentElement.firstChild;
								currentZ = oObj.style.zIndex;
								while(x)
									{
										if (x.style.zIndex >= currentZ)
											{
												currentZ=x.style.zIndex;
												x.style.zIndex--;
												x.oFrameObj.style.zIndex--;
											}
										x=x.nextSibling;
									}
								targetZ=currentZ;
							break;

						case 'ToBack':
								x=oObj.parentElement.firstChild;
								currentZ=oObj.style.zIndex;
								while(x)
									{
										if (x.style.zIndex <= currentZ)
											{
												currentZ=x.style.zIndex;
												x.style.zIndex++;
												x.oFrameObj.style.zIndex++;
											}
										x=x.nextSibling;
									}	
								targetZ=currentZ;
							break;

						case 'Forward':
 								x=oObj.parentElement.firstChild;
								t=oObj.o_ref.items_count;
								currentZ=oObj.o_ref.items_count;
								targetZ=oObj.style.zIndex;
								while(x)
									{
										if (x.style.zIndex > targetZ)
											{
												if (x.style.zIndex < currentZ)
														currentZ=x.style.zIndex;
												x.style.zIndex--;
												x.oFrameObj.style.zIndex--;
											}
										x=x.nextSibling;
									}
								targetZ=currentZ;
							break;

						case 'Backward':
 								x=oObj.parentElement.firstChild;
								currentZ=1;
								targetZ=oObj.style.zIndex;
								while(x)
									{
										if (x.style.zIndex < targetZ)
											{
												if (x.style.zIndex > currentZ)
														currentZ=x.style.zIndex;
												x.style.zIndex++;
												x.oFrameObj.style.zIndex++;
											}
										x=x.nextSibling;
									}
								targetZ=currentZ;
						break;
					}
				oObj.style.zIndex=targetZ ? targetZ : 0;
				oObj.oFrameObj.style.zIndex = targetZ ? targetZ : 0;
			},

		fileMenuBeforeShow:  function()
			{
				if (this.o_ref.p_recent.length)
					{
						var oRecentMenu=this.getSubMenu('file_recent');
						 if (!(oRecentMenu.p_items_length == this.o_ref.p_recent.length && oRecentMenu.p_last_item==this.o_ref.p_recent[0]))
						 	{
								oRecentMenu.clear();
								var i;
								for(i=0; i < this.o_ref.p_recent.length; i++)
									oRecentMenu.addItem('file_recent_'+i, this.o_ref.p_recent[i]);
								oRecentMenu.p_items_length=this.o_ref.p_recent.length;
								oRecentMenu.p_last_item=this.o_ref.p_recent[0];
							}
					}
				else
					{
						this.removeSubMenu('file_recent');
					}
			},

		mainMenuOnSelect: function()
			{
				this.o_ref.emptySelection();
			},
		
		exportValue: function(sVal)
			{
				return sVal;
			},

		frameResize: function()
			{
				if (this.parentElement.parentElement.o_ref)
					this.parentElement.parentElement.o_ref.storePreferences();
			},

		stripTags: function (sString)
			{
				return sString;
				//sString=String(sString).replace('<(A|B|U|I|STRONG|EM)(>
			}
	}
