FLEX_ED_EXPAND=0x1; 

function _p_supress_event(ev)
	{
		if (ev)
			{
				
			}
		else
			if (window.Event)
			window.Event.cancelBubble=true;
		return false;
	}


FlexEdUtility={
		pre_buttons : {
			'UNDO':			['Undo'	,				'UNDO',		0],
			'REDO':			['Redo'	,				'REDO',		1],
			'COPY':			['Copy'	,				'COPY',		2],
			'CUT':				['Cut'	,				'CUT',			3],
			'PASTE':			['Paste',				'PASTE',		4],
			'DELETE':		['Delete',				'DELETE',	5],

			'BOLD':					['Bold'	,				'BOLD',						7],
			'ITALIC':					['Italic'	,				'ITALIC',						8],
			'UNDERLINE':			['Underline',			'UNDERLINE',				9],
			'STRIKE':					['Strikethrough',	'STRIKETHROUGH',	10],
			'SUBSCRIPT':			['Subscript',			'SUBSCRIPT',				11],
			'SUPERSCRIPT':		['Superscript',		'SUPERSCRIPT',			12],

			'INSERTSYMBOL':	['Insert Symbol',			null,				29,	0, 'pExecInsertSymbol', null],
			'HLINK':					['Insert HyperLink',		null,				30,	0, 'pExecInsertLink', null],
			'APPLY':					['Apply',						null,				37,	0, 'pApply', null]
			},

		info :
			{
				isIE : true
			},

		createRange: function(oWindow, oSelection)
			{
				if (!oWindow)
					return false;
				if (!oSelection && oWindow.document)
					oSelection=oWindow.document.selection;
				if (!oSelection)
					return null;
				if (FlexEdUtility.info.isIE)
					{
						return oSelection.createRange();
					}
				else
					if (typeof oSelection != 'undefined')
						{
							try
								{
									return oSelection.getRangeAt(0);
								}
							catch(e)
								{
									return this.z_editor.createRange();
								}
						}
					else
						return this.z_editor.createRange();
			},

		isBlock: function(sTag)
			{
				return (sTag.length && sTag.match( /(^|\s)(p(re)?|h([1-6]|r)|br|d(iv|e?l)|[uod]l|li|d[dt]|table|caption|t([rdh]|head|body|foot)|blockquote|address|fieldset|form|noscript|ins|script)$/)) ? true : false;
			},
		
		sXSLT: '',

		oXslt: null,
		nbsp: String.fromCharCode(160),

		cleanHtml: function(sOldHtml)
			{
				var sHtml=sOldHtml.replace(/&nbsp;/g, FlexEdUtility.nbsp),
				sXml='<?xml version="1.0"?>\n<html>' + sHtml.replace(/(<\/\w+>)\s+</g, "$1\xa6\xa7\xa8<") + '</html>',
				oXml;
				
				if (!FlexEdUtility.oXslt)
					{
						FlexEdUtility.oXslt=getXml(FlexEdUtility.sXSLT.replace(/<!DOCTYPE\s[^>]*>/, ""));
					}
				oXml=getXml(sXml);
				sHtml=oXml.transformNode(FlexEdUtility.oXslt);
				sHtml=sHtml.replace(/\xa6\xa7\xa8/g, " ");
				return sHtml.replace( /.*<body(\s+[^>]*)*>(.*?)<\/body>/i, "$2");
			},

		setXslt: function(obj)
			{
				if (obj)
					FlexEdUtility.oXslt=obj.responseData;
			},

		getAttributesString: function(oElem)
			{
				var attr=oElem.attributes, text='', i=0, x, re, val, classes, j;
				for(; i < attr.length; i++)
					{
						x=attr[i];
						if (x.nodeValue && x.nodeValue != 'null' && !(x.nodeName.match(/(:|^(hidefocus|contenteditable|disabled|nowrap|tabindex|compact|start|lang)$)/gi)))
							text=text+' '+x.nodeName.toLowerCase()+'="'+x.nodeValue+'"';
					}
				return text.replace( /&/g, "&amp;" ).replace( /</g, "&lt;" ).replace(/>/g, "&gt;");
			},

		getHtmlString: function(oElem)
			{
				var childs = oElem.childNodes,
				s_name='', s_text='', s_value='', s_break='', inner_text='', i=0, pattern;
				for(; i < childs.length; i++)
					{
						if (childs[i].nodeType == 1)
							{
								s_name=childs[i].nodeName.toLowerCase();
								inner_text=FlexEdUtility.getHtmlString(childs[i]);
								if (inner_text!='' || s_name.match(/^(t[dh]|caption)$/))
									{
										if (inner_text==' ' || inner_text==FlexEdUtility.nbsp)
											{
												s_text+=' ';
											}
										else
											{
												s_break = FlexEdUtility.isBlock(s_name) ? '\n' : '';
												s_text += s_break + '<'+s_name+' '+FlexEdUtility.getAttributesString(childs[i]) + '>'+inner_text+'</'+s_name+'>';
												s_text = s_text.replace( /(\s+)(<\/[a-z]+>)/, '$2$1' );
												s_text+=s_break;
											}
									}
								else if (s_name == 'br' || s_name=='hr' || s_name == 'img')
									{
										s_text+='<'+s_name+' '+FlexEdUtility.getAttributesString(childs[i])+' />';
									}
							}
						else if (childs[i].nodeType==3  && (!childs[i].nodeValue || !childs[i].nodeValue.match(/^\n+$/)))
							{
								s_value=childs[i].nodeValue.replace( /&/g, "&amp;" ).replace( /</g, "&lt;" ).replace( />/g, "&gt;" );
								s_text += s_value;
							}
					}
				s_text=s_text.replace(/<span\s*>(.*?)<\/span>/g, '$1');
				pattern=new RegExp( "<(?!nobr)([\\w\\-]+)(\\s+[^>]+)?>(.*?)</\\1>([\x20]*|&nbsp;)<\\1\\2>", "g");
				while(s_text.match(pattern))
					{
						s_text=s_text.replace(pattern, function(str, m1, m2, m3, m4)
							{
								if (FlexEdUtility.isBlock(p1))
									return str;
								else
									{
										if (!m2) m2='';
										if (!m3) m3='';
										return '<'+m1+m2+'>'+m3+m4;
									}
							});
					}
				return s_text.replace(/\n\n+/g, '\n');
			}
	}

function FlexEdMini(width, height)
	{
		this.z_menu=null;
		this.z_body=null;

		this.z_main_frame=null;
		this.z_editor=null;
		this.z_editor_window=null;

		this.z_helper=null;
		this.z_helper_frame=null;
		
		this.p_main_holder=null;
		
		this.p_width=width ? width : '100%';
		this.p_height=height ? height : '100%';
		
		this.p_id="flexed"+Math.round(Math.random()*1000)+(t=new Date).getTime()

		this.p_inited=false;
		this.p_locked=false;

		this.p_items=[];
		this.p_pans=[];

		this.p_bookmark		=null;

		this.z_current_item=null;
		this.z_pressed=null;
		this.z_fixed=null;

		this.p_cur_tag=null;
		
		this.p_src=false;
		this.p_file='';

		this.create=function()
			{
				if (this.p_inited) return false;
				if (document.readyState!='complete')
					{
						document.write('<DIV id="'+this.p_id+'_holder" class="flexed" style="width:'+this.p_width+'; height:'+this.p_height+';"><TABLE cellspacing=1 cellpadding=0 border=0 width=100% height=100%><TR><TD id='
						+this.p_id+'_menu class="flexed_menu" unselectable=on></TD></TR><TR><TD  id='
						+this.p_id+'_body  height=100% width=100% style="background-color:transparent"></TD></TR></TABLE></DIV>');
						this.p_main_holder=document.getElementById(this.p_id+'_holder');
						this.z_menu=document.getElementById(this.p_id+'_menu');
						this.z_body=document.getElementById(this.p_id+'_body');
						this.assemble();
					}
			}

		this.assemble=function()
			{
				if (this.p_inited) return false;
				this.p_inited=true;
				if (!this.p_main_holder)
					{
						return false;
					}
				this.z_menu.oncontextmenu=_p_supress_event;
				this.z_menu.onselectstart=function()
					{
						if (event.srcElement.tagName!='INPUT')
							{
								_p_supress_event();
								return false;
							}
					}
				
				this.z_main_frame=document.createElement('<IFRAME src="blank.html" style="width:100%; height:100%; border:1px inset #ffffff" frameborder=0>');
				this.z_helper_frame=document.createElement('<IFRAME src="blank.html" style="width:100%; height:100%; position:absolute; z-index:2; width:25px; height:25px; left:-100px; top:-600px; z-index:-100"  frameborder=0>');
				this.z_body.insertAdjacentElement('AfterBegin', this.z_main_frame);
				this.z_body.insertAdjacentElement('BeforeEnd', this.z_helper_frame);
				this.z_editor_window=this.z_main_frame.contentWindow;
				if (!FlexEdUtility.oXslt)
					{
						var r=xHttp.getRequest('../scripts/clean.xml');
						r.isXml=true;
						r.handler=FlexEdUtility.setXslt;
						r.execute();
					}

				var w=this.z_main_frame.contentWindow.document, v=this.z_helper_frame.contentWindow.document;
				w.open();
				w.write('<BODY contenteditable="true" bgColor=#ffffff style="margin:2px;"></BODY>');
				w.close();

				v.open();
				v.write('<BODY contenteditable="true"  bgColor=#ffffff style="margin:2px;"></BODY>');
				v.close();

				this.z_editor=w.body;
				this.z_editor.o_root=this;
				this.z_helper=v.body;

				this.z_editor.onmousedown=function()
					{
						this.o_root.p_main_holder.document.body.fireEvent('onmousedown');
					}

				this.z_editor.onkeyup=this.z_ekey_up;
				this.z_editor.onmouseup=this.z_emouse_up;
				this.z_editor.onpaste=this.z_epaste;
				this.z_editor.document.onkeypress=this.z_key_press;
			}
		
		this.pApply=function()
			{
				self.returnValue={text : this.getFixedText()};
				self.close();
			}

		this.addPanel=function(key, buttons)
			{
				var p=document.createElement('NOBR'), span=document.createElement('<SPAN unselectable="on" />');
				p.appendChild(span);
				p.key=key;
				this.p_pans[key]=p;
				this.z_menu.appendChild(p);
				if (buttons && typeof(buttons)=='object')
					{
						for(var i=0, L=buttons.length; i<L; i++)
							this.addItem(key, buttons[i]);
					}
				return p;
			}
		
		this.addItem=function(_pankey, _btn_obj)
			{
				var itm, btn_sign, temp, cmd, alt, img, img_x, type, faction, fstatus, fexpand, is_exp, flags=0, is_color=false, caption;
				if (typeof(_btn_obj)=='string')
					{
						if (_btn_obj=='|')
							itm=this.addDivider(_pankey);
						return itm;
					}
				type=_btn_obj.type;
				itm=document.createElement('DIV');
				itm.onmouseenter=this.pMouseEnter;
				itm.onmouseleave=this.pMouseLeave;
				itm.onmousedown=this.pMouseDown;
				itm.onclick=this.pMouseUp;
				itm.ondblclick=this.pMouseUp;
				itm.state=0;
				itm.hideFocus=true;
				itm.unselectable="on";
				itm.o_root=this;

				btn_sign=FlexEdUtility.pre_buttons[_btn_obj.type];

				if (btn_sign)
					{
						alt=_btn_obj.alt ? _btn_obj.alt : btn_sign[0];
						if (!_btn_obj.img)
							img_x=btn_sign[2];
						cmd=btn_sign[1];
						faction=btn_sign[4];
						fstatus=btn_sign[5];
						fexpand=btn_sign[6];
						is_exp=btn_sign[3] & FLEX_ED_EXPAND;
					}
				else
						return false;

				if (itm.tagName=='DIV')
					{
						if (img)
							{
								itm.style.backgroundImage='url('+img+')';
							}
						else
							if (img_x!==undefined)
								{
									itm.style.backgroundImage='url(../images/def_btns.gif)';
									itm.style.backgroundPositionX=-(img_x*24);
								}
					}

				if (alt)
					itm.title=alt;
				itm.pressed=false;
				itm.ctype=type;

				this.p_items[type]=[itm, type, cmd,  flags, faction, fstatus, fexpand];
				
				
				if (itm.tagName && this.p_pans[_pankey])
					this.p_pans[_pankey].appendChild(itm);
				return itm;
			}
		
		this.addDivider=function(_pankey)
			{
				var div=document.createElement('U');
				div.unselectable="on";
				div.hideFocus=true;
				if (this.p_pans[_pankey])
					this.p_pans[_pankey].appendChild(div);
			}

		this.pToggleButton=function(oBtn, iMode)
			{
				if (this.z_current_item && this.z_current_item==oBtn)
					{
						iMode |= 1;
					}
				else
					if (!oBtn)
						return;

				if (iMode & 16)
					{
						oBtn.className='disabled';
						oBtn.disabled=true;
					}
				else
					{
						if (oBtn.disabled)
							oBtn.disabled=false;
						oBtn.className=(iMode & 4 ? 'checked' : '')+(iMode & 1 ? 'over' : '')+(iMode & 2 ? ' pressed' : '')
					}
				oBtn.state=iMode;
			}

		this.pItemAction=function(sItem, bExpandPressed)
			{
				var v=null, ui=false, btn, cmd, func, range=FlexEdUtility.createRange(this.z_editor_window);
				btn=this.p_items[sItem];
				if (btn)
					{
						cmd=btn[2];
						if (bExpandPressed)
							func=btn[6] ? btn[6] : (btn[4] ? btn[4] : null);
						else
							func=btn[4] ? btn[4] : null;
						
						if (typeof(func)=='string')
							eval('func=this.'+func);
						if (typeof(func)!='function')
							func=null;

						if (cmd)
							{
								if (!range.length)
									res=this.z_editor.document.execCommand(cmd, false, v);
							}
						else
							if (func)
								func.call(this, btn);
						}
				this.pUpdateToolbar();
				this.focus();
				return true;
			}

		this.pUpdateToolbar=function()
			{
				var button, state, func;
				for(i in this.p_items)
					{
						btn=this.p_items[i];
						state=false;
						if (btn[2])
							{
								state = this.z_editor.document.queryCommandEnabled(btn[2]) ? 0 : 16;
								state |= this.z_editor.document.queryCommandState(btn[2]) ? 4 : 0;
							}
						else
							if (func=btn[5])
								{
									if (typeof(func)=='string')
										state=eval('this.'+func+'(btn)');
									else
										if (typeof(func)=='function')
											state = func(btn);
									if (state==true)
										state=4
									else
										if (state==-1)
											state=16;
										else
												state=0;
								}
						this.pToggleButton(btn[0], state);
					}
			}

		this.pMouseUp=function()
			{
				if (this.o_root.p_locked) return false;
				this.o_root.pItemAction(this.ctype, (event.srcElement.tagName.toLowerCase()!='div') ? true : false);
				this.o_root.z_pressed=null;
				event.cancelBubble=true;
				return false;
			}
		
		this.pMouseDown=function()
			{
				if (this.o_root.p_locked || this.tagName=='DIV')
					{
						this.o_root.z_pressed=this;
						this.o_root.pToggleButton(this, this.state|3);
						event.cancelBubble=true;
						return false;
					}
			}

		this.pMouseEnter=function()
			{
				if (this.o_root.p_locked || this.tagName!='DIV') return false;
				this.o_root.z_current_item=this;
				this.o_root.pToggleButton(this, this.state|1);
				event.cancelBubble=true;
				return false;
			}
		
		this.pMouseLeave=function()
			{
				if (this.o_root.p_locked || this.tagName!='DIV') return false;
				if (this.o_root.z_current_item && (this.o_root.z_pressed==this.o_root.z_current_item))
					this.o_root.z_pressed=null;
				this.o_root.z_current_item=null;
				this.o_root.pToggleButton(this, this.state & 4);
				event.cancelBubble=true;
				return false;
			}

		this.pExecInsertLink=function(oBtn)
			{
				var obj=this.pGetSelectedElement(), sel=FlexEdUtility.createRange(this.z_editor_window),
					attributes={
						'nourl' : 'true',
						'value': '',
						oRef : this
						}, result;
				if (obj)
					{
						while(obj.tagName!='A' && obj.parentElement && obj.tagName!='BODY')
							obj=obj.parentElement;
						if (obj.tagName=='A')
							{
								attributes.value=obj.href;
								if (sel)
									{
										sel.moveToElementText(obj);
										sel.select();
									}
							}
						else
							obj=null;
					}
				result=showModalDialog('../scripts/link.html', attributes, 'border:thick; center:yes; dialogHeight:185px; dialogWidth:420px; help:no; maximize:no; minimize:no; status:no; resizable:no');
				if (result && result!==null)
					{
						if (result[0])
							{
								if (obj)
									{
										obj.href=result[0];
										if (result[1])
											obj.target=result[1];
										
									}
								else
									if (sel)
										{
											var txt=sel.text, html=sel.htmlText.toString();
											html=html.replace(/<A[^>]*>(.*)<\/A>/mig, '$1');
											this.insertHtml('<A href="'+result[0]+'" '+(result[1] ? 'target="'+result[1]+'"' : '')+'>'+html+'</A>');
										}
							}
					}
			}

		this.pExecInsertSymbol=function()
			{
				var dialog, attributes={
					func : this.pInsertSymbol,
					oRef: this,
					last_insert : []
					}
				dialog=showModelessDialog('../scripts/insert_symbol.html', attributes, 'border:thin;center:yes;dialogHeight:368px;dialogWidth:470px;help:yes;maximize:no;minimize:no;status:no;resizable:yes');
			}

		this.pInsertSymbol=function(x)
			{
				var r=FlexEdUtility.createRange(this.z_editor_window);
				r.pasteHTML('&#'+x);
				r.collapse(0);
				r.select();
			}

		this.z_ekey_up=function()
			{
				//status=this.document.parentWindow.event.keyCode;
				this.o_root.pUpdateToolbar();
			}

		this.z_emouse_up=function()
			{
				this.o_root.pUpdateToolbar();
			}
		
		this.z_epaste=function()
			{
				var W=this.o_root.z_editor_window, html='', state;
				this.o_root.pStoreSelection();
				this.o_root.z_helper.focus();
				this.o_root.z_helper.document.execCommand('SelectAll', false)
				this.o_root.z_helper.document.execCommand('PASTE', false);
				W.event.cancelBubble=true;
				W.event.returnValue=false;
				html=FlexEdUtility.getHtmlString(this.o_root.z_helper, this.o_root);
				html=FlexEdUtility.cleanHtml(html);
				this.o_root.focus();
				this.o_root.pRestoreSelection();
				this.o_root.insertHtml(html);
				return false;
			}
		
		this.z_key_press=function()
			{
				var ev=this.parentWindow.event;
				switch (ev.keyCode)
					{
						case 111:
							if (ev.ctrlKey)
								{
									this.body.o_root.saveDocument();
									return false;
								}
							
							break;

						case 114:
							if (ev.ctrlKey)
								{
									this.pExecSearch();
									return false;
								}
							break;

						case 115:
							if (ev.ctrlKey)
								{
									
									this.body.o_root.openDocument(ev.shiftKey ? null : false);
									return false;
								}
							break;
					}
			}

		this.isChanged=function()
			{
				return this.p_src != this.z_editor.innerHTML;
			}
		
		this.createRange=function()
			{
				return FlexEdUtility.createRange(this.z_editor_window);
			}

		this.getText=function()
			{
				if (this.z_editor)
					{
						var t=String(this.z_editor.innerHTML);
						return t;
					}
			}

		this.setText=function(text)
			{
				if (this.z_editor)
					{
						this.z_editor.innerHTML=text;
						this.p_src=this.z_editor.innerHTML;
					}
				return true;
			}

		this.getFixedText=function()
			{
				if (this.z_editor)
					{
						var text=FlexEdUtility.getHtmlString(this.z_editor);
						return text;
					}
			}

		this.focus=function()
			{
				if (this.z_editor_window && this.z_editor_window.focus)
					{
						this.z_editor_window.focus();
						this.pRestoreSelection();
					}
			}

		this.pGetSelectedElement=function()
			{
				var range=FlexEdUtility.createRange(this.z_editor_window), res=range.length ? range(0) : range.parentElement();
				return res;
			}

		this.insertHtml=function(sHtml, bKeep)
			{
				var r, t;
				r=this.z_editor.document.selection.createRange();
				if (r.length)
					{
						var x=r(0), i=x.sourceIndex;
						x.outerHTML=sHtml;
						t=this.z_editor.createControlRange();
						if (this.z_editor.document.all[i])
							{
								t.add(this.z_editor.document.all[i]);
								t.select();
							}
					}
				else
					if (bKeep)
						{
							var end=r.duplicate(), start=r.duplicate();
							end.collapse(0);
							start.collapse(1);
							r.pasteHTML(sHtml);
							r.setEndPoint('StartToStart', start);
							r.setEndPoint('EndToEnd', end);
							r.select();
						}
					else
						{
							r.pasteHTML(sHtml);
							r.collapse();
							r.select();
						}
			}

		this.lock=function(x)
			{
				this.p_locked=true;
				if (this.p_inited)
					for (o in this.p_items)
						{
							this.p_items[o].disabled=true;
							this.p_items[o].className='disabled';
						}
				return true;
			}

		this.unlock=function(x)
			{
				this.p_locked=false;
				if (this.p_inited)
					{
						for (o in this.p_items)
							this.p_items[o].disabled=false;
						this.pUpdateToolbar();
					}
				return true;
			}
		
		this.pEmptyStoredSelection=function()
			{

			}

		this.pStoreSelection=function()
			{
				if (!this.p_bookmark)
					{
						this.focus();
						var oRange=FlexEdUtility.createRange(this.z_editor_window), endRange=this.z_editor.createTextRange();
							bd=String(Math.round(Math.random()*10000)+(t=new Date).getTime());
						if (endRange.inRange(oRange))
							{
								endRange=oRange.duplicate();
								oRange.collapse(1);
								oRange.pasteHTML('<SPAN id="_'+bd+'" style="font-size:1px; overflow:hidden;"></SPAN>');
								endRange.collapse(0);
								endRange.pasteHTML('<SPAN id="'+bd+'_" style="font-size:1px; overflow:hidden;"></SPAN>');
								oRange.setEndPoint('EndToEnd', endRange);
								oRange.moveStart('character', -1);
								oRange.select();
							}
						this.p_bookmark=bd;
					}
			}

		this.pRestoreSelection=function()
			{
				if (this.p_bookmark)
					{
						var oStartEl=this.z_editor.document.getElementById('_'+bd), oEndEl=this.z_editor.document.getElementById(bd+'_'),
						oRange=this.z_editor.createTextRange(), oStart=oRange.duplicate(), oEnd=oRange.duplicate();
						if (oStartEl && oEndEl)
							{
								oStart.moveToElementText(oStartEl);
								oEnd.moveToElementText(oEndEl);
								/*
								oStart.text='';
								oEnd.text='';
								*/
								oRange.setEndPoint('StartToStart', oStart);
								oRange.setEndPoint('EndToEnd', oEnd);
								oRange.select();
								oStartEl.removeNode();
								oEndEl.removeNode();
							}
					}
				this.p_bookmark='';
			}
		this.pExecIncDecFont=function(oBtn)
			{

			}	
		return this;
	}