function inspect(oObj)
	{
		if (oObj && typeof(oObj)=='object')
			{
				var s='', x, val, sp=[], i, j, L, iMax=0;
				for(x in oObj)
					{
						val= oObj[x] ? oObj[x] : '-';
						try
							{
								if (val.toString)
									{
										val = String(val);
										val=val.replace(/[\n|\s]+/ig, ' ');
										if (x.length > iMax)
											iMax=x.length;
										sp.push([x, (val.length > 70 ? (val.substr(0, 70)+'...') : val)]);
									}
							}
						catch(e)
							{
							}
					}
				if (sp)
					{
						s='';
						for (i=0; i < sp.length; i++)
							{
								x=sp[i][0]+' := ';
								for (j=0, L=Math.round((iMax - x.length+1) / 9); j < L; j++)
									x+='\t';
								s+=x+sp[i][1]+'\n';
								if (i > 0 && (i % 50) == 0)
									{
										alert(s);
										s='';
									}
							}
						if ((i-1) % 50 !=0)
							alert(s);
					}
			}
	}

CON =
	{
		is_inited : false,
		max_chars : 10000,
		offs_top: 0,
		offs_left: 0,
		console_visible: false,
		auto_eval : true,
		line_height : 20,
		p_id : "con"+Math.round(Math.random()*100)+(t=new Date).getTime(),
		p_frame : null,
		p_win : null,
		p_body : null,
		p_holder : null,
		p_header : null,
		p_input : null,
		p_last_active : null,
		p_context : null,
		p_lcommands : [],
		p_cmdidx : 0,
		p_predata : [],
	
		initialize : function()
			{
				if (!top.CON)
					top.CON=this;
				if (top.CON.is_inited !== false)
					return false;
				top.CON.is_inited=true;
				var oWin=self;
				this.p_context=oWin;
				do
					{				
						oWin.document.attachEvent('onkeydown', this.pDocKeyDown);
						oWin=oWin.frameElement ? oWin.frameElement.document.parentWindow : null;
					}
				while(oWin);

				oDoc=top.document;
				var oFrame=oDoc.createElement('<IFRAME src="blank.html" frameborder=0>'), oFrameDoc;
				oFrame.style.cssText='position:absolute; z-index:65534; top:0px; left:0px; width:100%; height:40%; border-bottom:1px solid #000000; display:none';
				oDoc.body.insertAdjacentElement('AfterBegin', oFrame);
				oFrameDoc=oFrame.contentWindow.document;
				oFrameDoc.open();
				oFrameDoc.write('<HEAD><STYLE>.* {font-family:System, Arial}; TD.header {font-size:10px; color:#555555}; H4 {position:relative; left:-5px; margin:0px}; CITE {line-height : '+this.line_height+'px; font-style : normal; word-wrap : break-word;  }; CITE.waring {color:#ff0000}; CITE.builtin {color:#0000ff}; CITE.string {color:#008800}</STYLE></HEAD><BODY style="margin: 0px" scroll=no><TABLE border=0 cellspacing=0 cellpadding=0 style="width:100%; height:100%; table-layout:fixed"><TR><TD style="height:20px" id="'+this.p_id+'_header" class="header"></TD></TR><TR><TD><DIV hideFocus=true id="'+this.p_id+'_holder" style="width:100%; height:100%; overflow-x : hidden; overflow-y:auto; word-wrap : break-word; "><DIV id="'+this.p_id+'_body" style="padding:0 0 0 20px; width:100%; height:100%; border:none; word-wrap:break-word" hideFocus=true ></DIV></DIV></TD></TR><TR><TD height=20 style="padding:0px 2px"><INPUT id="'+this.p_id+'_input" style="width:100%; height: 20px; border: 0px"></TD></TR></TABLE></BODY>');
				oFrameDoc.close();

				this.p_frame = oFrame;
				this.p_win=oFrame.contentWindow;
				this.p_header = oFrameDoc.getElementById(this.p_id+'_header');
				this.p_holder = oFrameDoc.getElementById(this.p_id+'_holder');
				this.p_body = oFrameDoc.getElementById(this.p_id+'_body');
				this.p_input = oFrameDoc.getElementById(this.p_id+'_input');
	
				oFrameDoc.o_console_ref = this;
				this.p_body.o_console_ref=this;
				this.p_input.o_console_ref=this;
				oFrame.contentWindow.o_console_ref=this;

				if (!oFrameDoc.attachEvent('onkeydown', this.pFrameDocKeyDown))
					oFrameDoc.onkeydown=this.pFrameDocKeyDown;
				var aCookies=document.cookie.split(';'), i=0, c='', cIdx=0;
				for(; i < aCookies.length; i++)
					{
						c=aCookies[i];
						j=-1;
						while (c.charAt(++j)==' ');
						if (j)
							c=c.substring(j);
						if (c)
							{
								if (c.indexOf('JSCON=') == 0)
									{
										c = c.substring(6, c.length);
										if (c==1)
											this.toggleConsole(true);
									}
								else if (c.indexOf('JSCONCMD') == 0)
									{
										if (!isNaN(cIdx=parseInt(c.substr(8, 1))))
											{
												this.p_lcommands[cIdx]=c.substring(10).replace(/\[\[\[RP\]\]\]/g, ';');
												this.p_cmdidx=cIdx+1;
											}
									}
							}
					}
			},
		
		pApplyInput : function(oObj)
			{
				if (oObj===this.p_input)
					{
						var sText=this.p_input.value;
						sText=sText.split(' ');
						this.cmd.apply(this, sText);
						this.p_input.value='';
					}
			},

		cmd : function()
			{
				var sCmd=arguments[0], sData='', oRes, i;
				for(var i=1; i < arguments.length-1; i++)
					sData+=arguments[i]+' ';
				if (arguments.length > 1)
					sData+=arguments[arguments.length-1];
				switch (sCmd)
					{
						case 'get':
							break;

						case 'set':
							break;

						case 'println':
						case 'out':
						case 'print':
									try
										{
											try
												{
													var oFunc=new Function('return '+sData+'');
													oRes=oFunc.call(this.p_context);
												}
											catch(e)
												{
													oRes=eval(sData);
												}
											if (sCmd=='print')
												this.print(oRes, 'string');
											else
												this.println(oRes, null, 'string');
										}
									catch(e)
										{
											oRes=sData;
											if (sCmd=='print')
												this.print(oRes, 'text');
											else
												this.println(oRes, null, 'text');
										}
							break;

						case 'find':
							break;
						
						case 'send':
							break;
						
						case 'emulate':
							break;

						case 'inspect':
								try
									{
										oRes = eval(sData);
										if (oRes)
											{
												this.inspect(oRes);
											}
									}
								catch(e)
									{
										this.println(sErr ? String(e.message).replace(new RegExp(sErr), sData) : e.message, null, 'waring');
									}
							break;

						case 'clr':
								this.p_body.innerHTML='';
								this.p_predata=[];
								this.println('clr', null, 'builtin');
							break;

						case 'context':
								try
									{
										oRes=eval(sData);
										var sErr;
										if (typeof(oRes)!='object')
											throw {message : '   '};
										if (oRes === this)
											{
												sErr="replace"+Math.round(Math.random()*100)+(t=new Date).getTime();
												eval(sErr);
											}
										this.p_context=oRes;
										this.p_header.innerText='Context : '+sData;
										this.println('context set to `'+sData+'`', null, 'builtin');
									}
								catch(e)
									{
										this.println(sErr ? String(e.message).replace(new RegExp(sErr), sData) : e.message, null, 'waring');
									}
							break;
						case 'eval':
								try
									{
										try
											{
												var oFunc=new Function('return '+sData+''), oRes;
												oRes=oFunc.call(this.p_context);
													this.println('eval ' + sData + ' : ', null, 'builtin');
													this.println(oRes, null, 'string');
												break;
											}
										catch(e)
											{
												oRes=eval(sData);
											}
									}
								catch(e)
									{
										this.println('  `'+sData+'`', null, 'waring');
										break;
									}
								switch (typeof(oRes))
									{
										case 'string':
												oRes=sData+' : "'+oRes+'"';
											break;
										case 'object':
										case 'number':
												oRes+=sData+' : '+oRes;
											break;
										case 'boolean':
												oRes+=sData+' : '+(oRes ? 'true' : 'false');
											break;
										case 'function':
												oRes+=sData+' : '+oRes;
											break;
										case 'undefined' :
												oRes+=sData+' : undefined';
											break;
									}
								this.println('eval ' + oRes, null, 'builtin');
							break;
						default:
							if (this.auto_eval)
								{
									sCmd+=' '+sData;
									try
										{
											try
												{
													var oFunc=new Function('return '+sCmd+'');
													oRes=oFunc.call(this.p_context);
												}
											catch(e)
												{
													oRes=eval(sCmd);
												}
										}
									catch(e)
										{
											this.println('  `'+sCmd+'`', null, 'waring');
											break;
										}
									switch (typeof(oRes))
										{
											case 'string':
													oRes=sCmd+' : "'+oRes+'"';
												break;
											case 'object':
											case 'number':
													oRes=sCmd+' : '+oRes;
												break;
											case 'boolean':
													oRes=sCmd+' : '+(oRes ? 'true' : 'false');
												break;
											case 'function':
													oRes=sCmd+' : '+oRes;
												break;
											case 'undefined' :
													oRes=sCmd+' : undefined';
												break;
										}
									this.println(oRes, null, 'string');
								}
							else
								{
									sCmd=sCmd ? String(sCmd) : '';
									this.println('Unrecognized command `'+sCmd+'`', null, 'waring');
									return false;
								}
					}
				this.p_lcommands.push(arguments[0]+' '+sData);
				this.p_cmdidx=this.p_lcommands.length;
				if (this.p_lcommands.length > 10)
					{
						this.p_lcommands.unshift(0);
					}
				var oDate = new Date();
				oDate.setTime(oDate.getTime()+86400000);
				for (i=0; i < 10; i++)
					{
						if (this.p_lcommands[i])
							{
								document.cookie = "JSCONCMD"+i+'='+this.p_lcommands[i].replace(/;/g, '[[[RP]]]')+"; expires="+oDate.toGMTString()+"; path=/";
							}
						else
							document.cookie = "JSCONCMD"+i+"=''; expires=-1; path=/";
					}
				return true;
			},
		

		pFrameDocKeyDown : function(oEv)
			{
				if (!oEv)
					oEv=this.parentWindow ? this.parentWindow.event : this.window.event;
				var oCon=oEv.srcElement.o_console_ref;
				if (!oCon)
					oCon=oEv.srcElement.document.o_console_ref;
				if (oCon)
					{
						switch(oEv.keyCode)
							{
								case 192:
										if (oEv.ctrlKey)
											{
												oCon.toggleConsole(!oCon.console_visible);
												oEv.cancelBubble=true;
												return false;
											}
										break;
								case 13:
											oCon.pApplyInput(oEv.srcElement);
										break;
								case 27:
										if (oEv.ctrlKey)
											{
												
											}
								case 38:
											
											if (oEv.ctrlKey)
												{
													if (oCon.p_lcommands[oCon.p_cmdidx-1])
														{
															oCon.p_cmdidx--;
															oCon.p_input.value=oCon.p_lcommands[oCon.p_cmdidx];
														}
												}
											else
												{
													oCon.p_holder.scrollTop = (Math.round(oCon.p_holder.scrollTop / oCon.line_height)-1) * oCon.line_height;
												}
										break;
								case 40:
											if (oEv.ctrlKey)
												{
													if (oCon.p_lcommands[oCon.p_cmdidx+1])
														{
															oCon.p_cmdidx++;
															oCon.p_input.value=oCon.p_lcommands[oCon.p_cmdidx];
														}
													else
														{
															oCon.p_cmdidx=oCon.p_lcommands.length;
															oCon.p_input.value='';
														}
												}
											else
												{
													oCon.p_holder.scrollTop = (Math.round(oCon.p_holder.scrollTop / oCon.line_height)+1) * oCon.line_height;
												}
										break;
								case 33:
											var x=Math.floor(oCon.p_holder.offsetHeight / oCon.line_height) * oCon.line_height;
											oCon.p_holder.scrollTop = (Math.round(oCon.p_holder.scrollTop / x ) -1) * x;
										break;
								case 34:
											var x=Math.floor(oCon.p_holder.offsetHeight / oCon.line_height) * oCon.line_height;
											oCon.p_holder.scrollTop = (Math.round(oCon.p_holder.scrollTop / x ) +1) * x;
										break;
							}
					}
				return true;
			},

		pDocKeyDown : function(oEv)
			{
				if (oEv && oEv.keyCode == 192 && oEv.ctrlKey && top.CON && top.CON.toggleConsole)
					{
						top.CON.toggleConsole(!top.CON.console_visible, oEv.srcElement);
						if (this.parentWindow)
							top.CON.setContext(this.parentWindow);
						oEv.cancelBubble = true;
						return false;
					}
			},

		setContext : function(oObj)
			{
				this.p_context = oObj;
			},

		toggleConsole : function(bFlag, oLastActive)
			{
				if (this.is_inited)
					{
						if (bFlag===undefined)
							bFlag = !this.console_visible;
						this.console_visible = Boolean(bFlag);
						if (this.console_visible && this.p_predata.length)
							{
								for(var i=0; i < this.p_predata.length; i++)
									if (this.p_predata[i].length==2)
										this.print(this.p_predata[i][0], this.p_predata[i][1]);
									else
										this.println(this.p_predata[i][0], this.p_predata[i][1], this.p_predata[i][2]);
								this.p_predata=[];
							}
						this.p_frame.style.display = this.console_visible ? 'block' : 'none';
						this.focus(this.console_visible);
						this.p_last_active = null;
						if (oLastActive && oLastActive.focus)
							this.p_last_active = oLastActive;
						this.p_holder.scrollTop = this.p_body.scrollHeight - this.p_holder.offsetHeight;

						var oDate = new Date();
						oDate.setTime(oDate.getTime()+(24*3600000));
						document.cookie = "JSCON="+(bFlag ? 1 : -1)+"; expires="+oDate.toGMTString()+"; path=/";
					}
			},
		
		focus : function(bFlag)
			{
				var oRange;
				if (bFlag===false)
					{
						if (this.p_win.document.hasFocus() && this.p_win.document.activeElement)
							{
								this.p_input.onblur=null;
								if (this.p_win.document.selection.type == 'text')
									this.p_win.document.selection.empty();
								this.p_input.blur();
							}
						if (this.p_last_active)
							{
								oRange=this.p_last_active.document.body.createTextRange();
								this.p_last_active.setActive();
								oRange.moveToElementText(this.p_last_active);
								oRange.collapse(false);
								oRange.select();								
								this.p_last_active.focus();
							}
						else
							{
								if (document.selection)
									document.selection.empty();
							}
					}
				else
					{
						oRange=this.p_input.createTextRange();
						oRange.collapse(false);
						oRange.select();
						this.p_input.focus();
						//this.p_input.onblur=this.pInputBlur;
					}
			},

		pInputBlur : function()
			{
				this.focus();
				this.document.parentWindow.event.cancelBubble=true;
				return false;
			},

		pFormat : function(sText)
			{
				return String(sText).replace(/&/g, "&amp;").replace(/\</g, "&lt;").replace(/\n/gi, '<br>').replace(/\s/gi, '&nbsp;');
			},

		print : function(sData, sType)
			{
				if (this.is_inited && this.console_visible)
					{
						if (!this.p_cur_line || sType && this.p_cur_line.className != sType)
							{
								this.p_cur_line=this.p_win.document.createElement('CITE');
								this.p_cur_line.innerHTML=this.pFormat(sData);
								this.p_body.appendChild(this.p_cur_line);
								if (sType)
									this.p_cur_line.className=sType;
							}
						else
							{
								this.p_cur_line.insertAdjacentText('BeforeEnd', sData);
							}
						if (this.p_frame.style.display == 'block')
							{
								var iScroll=this.p_body.scrollHeight - this.p_holder.offsetHeight;
								if (this.p_holder.scrollTop != iScroll)
									this.p_holder.scrollTop = iScroll;
							}
					}
				else
					this.p_predata.push([sData, sType]);
				return true;
			},

		println : function(sText, sTitle, sType)
			{
				if (this.is_inited && this.console_visible)
					{
						var oLine, oHead;
						if (sTitle)
							{
								oHead=this.p_win.document.createElement('H4');
								oHead.innerText=this.pFormat(sTitle);
								this.p_body.appendChild(oHead);
							}
						if (sText)
							{
								oLine=this.p_win.document.createElement('CITE');
								oLine.innerHTML=this.pFormat(sText);
								if (sType)
									oLine.className=sType
								oLine.style.display='block';
								this.p_body.appendChild(oLine);
							}
						this.p_cur_line=null;

						if (this.p_frame.style.display == 'block')
							{
								var iScroll=this.p_body.scrollHeight - this.p_holder.offsetHeight;
								if (this.p_holder.scrollTop != iScroll)
									this.p_holder.scrollTop = iScroll;
							}
					}
				else
					{
						this.p_predata.push([sText, sTitle, sType]);
						
					}
				return true;
			},
		lines_per_view : 50,
		chars_per_line : 70,
		inspect : function(oObj, bAlert, sIndent)
			{
				if (oObj && typeof(oObj)=='object')
					{
						var s='', x, val, prop, sp=[], i, j, L, iMax=0, tp;
						for(x in oObj)
							{
								val = oObj[x] ? oObj[x] : '-';
								try
									{
										if (val.toString)
											{
												val = String(val);
												val=val.replace(/[\n|\s]+/ig, ' ');
												if (x.length > iMax)
													iMax=x.length;
												if (val.length > this.chars_per_line)
													val = val.substr(0, this.chars_per_line)+'...'
												tp=typeof (val);
												switch (tp)
													{
														case 'string':
																val = '"'+val+'"';
															break;
														case 'array':
																val = '['+val+']';
															break;
														case 'object':
																val = '{'+
																	
																+'}'
															break;
													}
												sp.push([x]);
											}
									}
								catch(e)
									{
									}
							}
						if (bAlert)
							{
								if (sp)
									{
										s='';
										for (i=0; i < sp.length; i++)
											{
												x=sp[i][0]+' := ';
												for (j=0, L=Math.round((iMax - x.length+1) / 9); j < L; j++)
													x+='\t';
												s+=x+sp[i][1]+'\n';
												if (i > 0 && (i % this.lines_per_view) == 0)
													{
														alert(s);
														s='';
													}
											}
										if ((i-1) % this.lines_per_view !=0)
											alert(s);
									}
							}
						else
							{
								if (sp)
									{
										s='';
										for (i=0; i < sp.length; i++)
											{
												x=sp[i][0]+' := ';
												for (j=0, L=Math.round((iMax - x.length+1) / 9); j < L; j++)
													x+='\t';
												s+=x+sp[i][1]+'\n';
											}
										this.println(s);
									}
							}
					}
			},

		windowLoad : function()
			{
				CON.initialize();
				return;
			}
	}

//@cc_on
//@set @JSCON=1
window.attachEvent('onload', CON.windowLoad);
