
function ClassMenuUtil()
  {
    this.is_inited = false;
    this.p_items = {};
    this.p_panels = {};
    //this.p_screen = null;
    this.p_is_screen = false;
    this.bottom_z = 10000;
    return this;
  }

MenuUtil=new ClassMenuUtil();

function ClassMenuUtil.prototype.init()
  {
    if (this.is_inited)
      return false;
    this.is_inited=true;
    var frame=document.createElement('IFRAME');
    frame.id="oScreenFrame"
    frame.allowTransparency=true;
    frame.width='99%';
    frame.height='99%';
    frame.src='blank.html';
    with(frame.style)
      {
        position='absolute';
        backgroundColor='transparent';
        posLeft=-1;
        posTop=-1;
        display='none';
        filter="progid:DXImageTransform.Microsoft.Alpha(opacity=0)";
      }
    frame.style.zIndex=this.bottom_z;
    document.body.insertBefore(frame);
    frame.contentWindow.document.o_ref=this;
    frame.contentWindow.document.onmousedown=this.hideAll;
    frame.contentWindow.document.onclick=this.hideAll;
    frame.contentWindow.document.oncontextmenu=this.cancelEvent;
    window.attachEvent('onbeforeunload', MenuUtil.gc);
    //this.p_screen=frame;
  }



function ClassMenuUtil.prototype.gc()
  {
    var x, y;
    for(x in MenuUtil.p_panels)
      {
        
        for(y in MenuUtil.p_panels[x].p_items)
          MenuUtil.p_panels[x].p_items[y]=null;
        MenuUtil.p_panels[x]=null;
        delete MenuUtil.p_panels[x];
      }

    for(x in MenuUtil.p_items)
      {
        MenuUtil.p_items[x].removeNode(true);
        MenuUtil.p_items[x]=null;
        delete MenuUtil.p_items[x];
      }
    MenuUtil.p_items=null;
    MenuUtil.p_panels=null;
    //MenuUtil.p_screen.removeNode(true);
    //MenuUtil.p_screen=null;
  }

function ClassMenuUtil.prototype.zMouseOver()
  {
    ev=event ? event : this.document.parentWindow.event;
    var p=ev.srcElement;
    if (p.tagName=='U') p=p.parentElement;
    if (p.tagName!='MENU') p=p.parentElement;
    if (p.tagName=='MENU' && (!ev.fromElement || ev.toElement.sKey != ev.fromElement.sKey))
      this.o_ref.toggleItem(p, 1);
    ev.cancelBubble=true;
    return false;
  }

function ClassMenuUtil.prototype.zMouseOut()
  {
    ev=event ? event : this.document.parentWindow.event;
    if (!ev.toElement || ev.toElement.sKey != ev.fromElement.sKey)
      { 
        var p=ev.fromElement;
        if (p.tagName=='U') p=p.parentElement;
        if (p.tagName!='MENU') p=p.parentElement;
        if (p.tagName=='MENU')
          this.o_ref.toggleItem(p, 0);
      }
    else
      {
      }
    ev.cancelBubble=true
    return false;
  }

/*
function ClassMenuUtil.prototype.p()
  {
    onblur
  }
*/

function ClassMenuUtil.prototype.hideAll()
  {
    var x, t;
    for(x in MenuUtil.p_panels)
      {
        t=MenuUtil.p_panels[x];
        if (t.is_visible)
          {
            t.toggleItem(t.z_current, 4);
            t.hide();
          }
      }
    MenuUtil.pShowScreen(false);
    if (this.parentWindow && this.parentWindow.event)
      {
        this.parentWindow.event.cancelBubble=true;
        return false;
      }
  }

function ClassMenuUtil.prototype.addItem(sKey, sValue, sAccess, iIcon, sShortCut, sStyle)
  {
    if (!this.p_body)
      return false;
    var oItem=this.p_doc.createElement('<MENU unselectable="on">');
    if (sAccess)
      {
        sValue=sValue.replace(new RegExp('('+sAccess+')', 'i'), '<U unselectable="on" isItem="1" sKey="'+sKey+'">$1</U>');
        oItem.accessKey=sAccess;
      }
    oItem.isItem=1;
    if (iIcon < 0)
      {
        oItem.isChecker=true;
        oItem.checked = iIcon == -1 ? true : false;
        oItem.innerHTML='<I isItem="1" sKey="'+sKey+'">'+(oItem.checked ? '&#252;' : '')+'</I>'+sValue;
      }
    else
      {
        oItem.innerHTML=sValue;
      }   
    oItem.sKey=sKey;
    oItem.sValue=sValue;
    oItem.o_ref=this;
    oItem.oSubMenu=null;
    oItem.iMode=1;
    this.p_items[sKey]=oItem;
    this.p_body.appendChild(oItem);
  }

function ClassMenuUtil.prototype.addBreak()
  {
    var obj=this.p_doc.createElement('S');
    obj.iMode=1;
    obj.isBreak;
    this.p_body.appendChild(obj);
  }

function ClassMenuUtil.prototype.getSubMenu(sKey, oSubMenu)
  {
    var obj=this.p_items[sKey];
    if (obj)
      {
        if (!obj.oSubMenu)
          {
            obj.className='submenu';
            if (oSubMenu && oSubMenu.isDropDown)
              {
                obj.oSubMenu=oSubMenu;
              }
            else
              obj.oSubMenu=new DropDownMenu(sKey);
            obj.oSubMenu.o_parent=this;
            if (this.inherit_css && this.p_css)
              obj.oSubMenu.setCssStyle(this.p_css);
          }
        return obj.oSubMenu;
      }
    return null;
  }

function ClassMenuUtil.prototype.removeSubMenu(sKey)
  {
    var obj=this.p_items[sKey];
    if (obj && obj.oSubMenu)
      {
        obj.oSubMenu.remove();
        obj.oSubMenu=undefined;
        obj.className='';
        return true;
      }
    return false;
  }

function ClassMenuUtil.prototype.remove()
  {
    this.clear();
    this.p_items=null;
    this.p_body = null;
    this.p_doc=document;
    this.is_visible = true
    this.is_constant = true;
    this.onclick = null;
    this.onblur = null;
    this.sub_x=0;
    this.sub_y=22;
    this.o_parent=null;
  }

function ClassMenuUtil.prototype.clear()
  {
    for (var x in this.p_items)
      {
        if (this.p_items[x].oSubMenu)
          this.p_items[x].oSubMenu.remove();
        this.p_items[x].removeNode(true);
        delete this.p_items[x];
      }
    this.p_items={};
    this.z_over = null;
    this.z_current = null;
  }

function ClassMenuUtil.prototype.register(oObj)
  {
    this.p_panels[oObj.id]=oObj;
  }

function ClassMenuUtil.prototype.zMouseDown()
  {
    var o=event ? event.srcElement  : this.document.parentWindow.event.srcElement;
    if (o.tagName=='U')
      o=o.parentElement;
    if (o.tagName!='MENU')
      o=o.parentElement;
    if (o.is_disabled)
      return false;
    if (o.tagName!='MENU')
      {
        if (this.o_ref.z_current)
          this.o_ref.toggleItem(this.o_ref.z_current, 4);
        MenuUtil.pShowScreen(false);
      }
    else
      {
        var V=this.o_ref.p_doc.createEventObject();
        if (o.oSubMenu)
          {
            this.o_ref.toggleItem(o, 2);
            MenuUtil.pShowScreen(true);
            V.eventName='onselect';
          }
        else
          {
            V.eventName='onclick';
            if (o.isChecker)
              {
                o.checked=!o.checked;
                o.firstChild.innerHTML=o.checked ? '&#252;' : '';
                V.checked=o.checked
              }
            else
              {
                this.o_ref.toggleItem(o, 4);
                MenuUtil.hideAll();
              }
          }
        V.key=o.sKey;
        V.value=o.sValue;
        this.o_ref.p_body.fireEvent('oncontrolselect', V);
        return false;
      }
  }

function ClassMenuUtil.prototype.pShowScreen(x)
  {
    var t=document.getElementById('oScreenFrame');
    t.style.display=x ? 'block' : 'none';
  }

function ClassMenuUtil.prototype.removeItem(sKey)
  {
    if (this.p_items[sKey])
      {
        this.p_items[sKey].removeNode();
        delete this.p_items[sKey];
      }
  }

function ClassMenuUtil.prototype.toggleItem(oObj, bMode)
  {
    if (!oObj || oObj.is_disabled)
      return false;
    switch(bMode)
      {
        case 1:
            if (oObj.o_ref.z_current)
              {
                if (oObj.o_ref.z_current !== oObj)
                  {
                    if (oObj.oSubMenu)
                      {
                        oObj.className='submenu pressed';
                        if (oObj.oSubMenu.onbeforeshow)
                          oObj.oSubMenu.onbeforeshow();
                        oObj.oSubMenu.show(oObj.o_ref.sub_x, oObj.o_ref.sub_y, oObj);
                      }
                    else
                      oObj.className='pressed';
                    oObj.o_ref.toggleItem(oObj.o_ref.z_current, 4);
                  }
                oObj.o_ref.z_current=oObj;
              }
            else
              oObj.className=oObj.oSubMenu ? 'submenu over' : 'over';

            oObj.o_ref.z_over=oObj;
          break;

        case 2:
            if (oObj.o_ref.z_current)
              {
                oObj.o_ref.toggleItem(oObj.o_ref.z_current, 0);
              }
            if (oObj.o_ref.z_current===oObj)
              {
                oObj.o_ref.z_current=null;
                if (oObj.oSubMenu)
                  {
                    oObj.className='submenu over';
                    oObj.oSubMenu.hide()
                  }
                else
                  oObj.className='over';
              }
            else
              {
                oObj.o_ref.z_current=oObj;
                oObj.className='pressed';
                if (oObj.oSubMenu)
                  {
                    oObj.className='submenu pressed';
                    if (oObj.oSubMenu.onbeforeshow)
                      oObj.oSubMenu.onbeforeshow();
                    oObj.oSubMenu.show(oObj.o_ref.sub_x, oObj.o_ref.sub_y, oObj)
                  }
                else
                  oObj.className='pressed';
              }
            oObj.o_ref.z_over=oObj;
          break;

        case 3:
            oObj.className='disabled';
          break;

        case 4:
          if (oObj.o_ref.z_current===oObj)
            {
              oObj.o_ref.z_current=null;
              if (oObj.oSubMenu)
                {
                  oObj.className='submenu';
                  oObj.oSubMenu.hide();
                }
              else
                oObj.className='';
            }
        default:
          oObj.o_ref.z_over=null;
          if (oObj.o_ref.z_current)
            {
              if (self.event && self.event.toElement && self.event.toElement.ISMITEM)
                {
                  if (oObj.oSubMenu)
                    {
                      oObj.className='submenu';
                      oObj.oSubMenu.hide();
                    }
                  else
                    oObj.className='';
                }
            }
          else
            {
              oObj.className=oObj.oSubMenu ? 'submenu' : '';
            }
      }
  }

function ClassMenuUtil.prototype.setModes()
  {
    var i=0, iMode=arguments[arguments.length-1];
    if (arguments.length==1)
      {
        for(i in this.p_items)
          this.setMode(i, iMode);
      }
    else
      for(; i< arguments.length-1; i++)
        this.setMode(arguments[i], iMode);
  }

function ClassMenuUtil.prototype.setMode(sKey, iMode)
  {
    var x=this.p_items[sKey];
    if (x)
      {
        x.className = iMode & 1 ? x.className.replace(/disabled/g, '') : (x.className+' disabled');
        x.is_disabled=(iMode & 1 ? false : true); // enabled;

        if ((x.iMode & 2) != (iMode & 2)) //invisible
          {
            var n=x.nextSibling, p=x.previousSibling, m=(iMode & 2) ? 'none' : 'block';
            x.style.display=m;
            if (n && n.isBreak && (!p || (p && p.isBreak))) 
              n.style.display=m;
            else
              if (p && p.isBreak)
                p.style.display=m;
          }
        x.iMode=iMode;
      }
  }

function ClassMenuUtil.prototype.getMode(sKey)
  {
    var x=this.p_items[sKey];
    if (x)
      return x.mode;
  }

function ClassMenuUtil.prototype.select()
  {
  }

function ClassMenuUtil.prototype.show(oMenu, iX, iY, iWidth, iHeight)
  {
    var t=document.body;
    oMenu.p_holder.style.posLeft=iX;
    oMenu.p_holder.style.posTop=iY;
    oMenu.p_holder.style.posWidth=iWidth;
    oMenu.p_holder.style.display='block';
    oMenu.p_holder.style.zIndex=this.bottom_z+this.p_panels.length+1;

    if ((iHeight==undefined || iHeight=='auto') && oMenu.p_body.lastChild)
      {
        iHeight=oMenu.p_body.lastChild.offsetTop+oMenu.p_body.lastChild.offsetHeight
      }
    if (iHeight < oMenu.p_body.scrollHeight)
      iHeight=oMenu.p_body.scrollHeight;
    oMenu.p_holder.style.posHeight=iHeight; 
    document.attachEvent('onmousedown', MenuUtil.pBlur);
    oMenu.is_visible=true;
    oMenu.offsetX=iX;
    oMenu.offsetY=iY;
  }

function ClassMenuUtil.prototype.hide(oMenu)
  {
    var o=null, i=0;
    switch (typeof(oMenu))
      {
        case 'object':
            o=oMenu;
          break;
        case 'string':
            o=MenuUtil.p_panels[oMenu];
          break;
      }
    if (!o.is_visible)
      return false;
    if (o && o.id && o.p_holder)
      {
        o.p_holder.style.display='none';
      }
    if (!o.is_constant)
      o.is_visible=false;
    if (o.z_current)
      o.toggleItem(o.z_current, 4);
    o.z_current=null;
  }

function ClassMenuUtil.prototype.cancelEvent()
  {
    if (this.parentWindow)
      this.parentWindow.event.cancelBubble=true;  
    else
      this.document.parentWindow.event.cancelBubble=true;
    return false;
  }

function ClassMenuUtil.prototype.pEventControl()
  {
    var ev=event ? event : this.document.parentWindow.event, c=this.o_ref;
    switch(ev.eventName)
      {
        case 'onclick':
          while (c && !(c.onclick || typeof(c.onclick)=='function'))
            c=c.o_parent;
          if (c && c.onclick && typeof(c.onclick)=='function')
            return c.onclick(ev)===false ? false : true;
          return true;
        case 'onselect':
          while (c && !(c.onselect || typeof(c.onselect)=='function'))
            c=c.o_parent;
          if (c && c.onselect && typeof(c.onselect)=='function')
            return c.onselect(ev)===false ? false : true;
          return true;
        case 'onblur':
          while (c && !(c.onblur || typeof(c.onblur)=='function'))
            c=c.o_parent;
          if (c && c.onblur && typeof(c.onblur)=='function')
            return c.onblur(ev)===false ? false : true;
          return true;
      }
  }

function ClassMenuUtil.prototype.pBlur()
  {
  }

function ClassMenuUtil.prototype.setCaption(sKey, sTitle)
  {
    var p, h
    if (p=this.p_items[sKey])
      {
        p.firstChild.data=sTitle;
//        h=p.innerHTML;
//        p.innerHTML=h;
      }
  }

function DropDownMenu(id)
  {
    this.id=id ? id : ("ddmenu"+String(Math.round(Math.random()*100)*Math.round((t=new Date).getTime()/100)));
    
    this.o_parent=null;
    this.offsetX=0;
    this.offsetY=0;
    this.p_items={};
    this.p_holder=null;
    this.p_body=null;
    this.p_doc=null;

    this.p_css=false;
    this.inherit_css=true;
    
    this.onclick=null;
    this.onblur=null;
    this.onselect=null;
    this.onbeforeshow=null;
    
    this.z_current=null;
    this.z_over=null;
    this.sub_x=150;
    this.sub_y=1;

    this.width=150;
    this.height='auto';

    this.is_visible=false;
    this.isDropDown=true;

    MenuUtil.init();
    MenuUtil.register(this);

    var obj=document.createElement('<IFRAME src="blank.html" scrolling="no" hideFocus="true" unselectable="on" frameborder="no" style="background:buttonface!important; position:absolute!important; width:100px; display:none">');
    document.body.insertBefore(obj);

    obj.o_ref=this;
    obj.contentWindow.o_ref=this;
    this.p_holder=obj;
    this.p_doc=obj.contentWindow.document;
    this.p_doc.open();
    this.p_doc.write('<HTML><HEAD><STYLE>'
    +'BODY {margin:0; padding:0px; text-align:center; font-family:Tahoma; font-size:11px; background:#505050; border:#646464 1px solid; border-right-color:#303030; border-bottom-color:#303030 };'
    +'MENU {width:100%; height:20px; margin:0px; text-align:left; color:#000000; padding:3px 10px 0 20px; cursor:default; background-position-x: right; background-position-y: 1px};'
    +'MENU.over {color:#ffffff; background-color:highlight; background-position:right -21px};'
    +'MENU.pressed {color:#ffffff; background-color:highlight; background-position:right -21px};'
    +'MENU.submenu {background-image:url(images/arrowright.gif);  background-repeat:no-repeat; };'
    +'I { width:18px; height:18px; margin-top:-2px; margin-left:-20px; font-style:normal; font-family: wingdings; text-align:right; font-size:15px; lien-height:15px; padding:2px 2px 0px 0px; vertical-align:top}'
    +'S {height:1px; margin:2 0 4 0;padding:0; border:none; width:98%; border-bottom:1px solid #777; font-size:1px;};'
    +'SPAN {white-space:nowrap!important; text-overflow:ellipsis!important; overflow-x:hidden!important; width:100%;};'
    +'</STYLE><STYLE> .*{} </STYLE></HEAD><BODY hideFocus="true" unselectable="on"></BODY></HTML>');
    this.p_doc.close();
    this.p_doc.o_ref=this;
    this.p_body=this.p_doc.body;
    this.p_body.o_ref=this;
    
    this.p_doc.onselectstart = MenuUtil.cancelEvent;
    this.p_body.onmousedown=MenuUtil.zMouseDown;
    this.p_body.onmouseover=MenuUtil.zMouseOver;
    this.p_body.onmouseout=MenuUtil.zMouseOut;
    this.p_body.oncontrolselect=MenuUtil.pEventControl;
    this.p_body.oncontextmenu=MenuUtil.cancelEvent;

    this.toggleItem=MenuUtil.toggleItem;
    this.addBreak=MenuUtil.addBreak;
    this.addItem=MenuUtil.addItem;
    this.removeItem=MenuUtil.removeItem;
    this.getMode=MenuUtil.getMode;
    this.setMode=MenuUtil.setMode;
    this.setModes=MenuUtil.setModes;
    this.setCaption=MenuUtil.setCaption;
    this.hideAll=MenuUtil.hideAll;
    this.getSubMenu=MenuUtil.getSubMenu;
    this.removeSubMenu=MenuUtil.removeSubMenu;
    this.clear=MenuUtil.clear;
    this.remove=MenuUtil.remove;
    
    return this;
  }

function DropDownMenu.prototype.hide()
  {
    MenuUtil.hide(this);
  }

function DropDownMenu.prototype.show(iX, iY, oObject)
  {
    this.sub_x=this.width;
    if (typeof(oObject)=='object')
      {
        var dx=0, dy=0, o=oObject;
        while(o.parentElement && o.tagName.toLowerCase()!='body')
          {
            if (!(o.tagName=='TD' || o.tagName=='TR' || o.tagName=='TBODY'))
              {
                dx+=o.offsetLeft;
                dy+=o.offsetTop;
              }
            o=o.parentElement;
          }
        iX+=dx;
        iY+=dy;

        if (oObject.o_ref)
          {
            if (oObject.o_ref.offsetX)
              iX+=oObject.o_ref.offsetX;
            if (oObject.o_ref.offsetY)
              iY+=oObject.o_ref.offsetY;
          }
        if (iX + this.width > document.body.clientWidth-5)
          {
            iX-=this.width;
            if (oObject.o_ref && oObject.o_ref.width)
              iX-=oObject.o_ref.width;
          }
      }
    MenuUtil.pShowScreen(true);
    MenuUtil.show(this, iX, iY, this.width, this.height);
  }


function DropDownMenu.prototype.setCssStyle(sText)
  {
    this.p_css=sText;
    this.p_doc.styleSheets(1).cssText=sText;
  }

function MainMenu(id)
  {
    this.id=id ? id : ("mmenu"+String(Math.round(Math.random()*100)*Math.round((t=new Date).getTime()/100)));
    this.p_items = {};
    this.z_over = null;
    this.z_current = null;
    this.p_body = null;
    this.p_doc=document;
    this.is_visible = true
    this.is_constant = true;

    this.p_css=false;
    this.inherit_css=true;
    this.isDropDown=false;

    this.onclick = null;
    this.onblur = null;
    this.onselect = null;
    this.sub_x=0;
    this.sub_y=22;
    this.o_parent=null;

    MenuUtil.init();
    MenuUtil.register(this);
    this.toggleItem=MenuUtil.toggleItem;
    this.addBreak=MenuUtil.addBreak;
    this.addItem=MenuUtil.addItem;
    this.removeItem=MenuUtil.removeItem;
    this.getMode=MenuUtil.getMode;
    this.setMode=MenuUtil.setMode;
    this.setModes=MenuUtil.setModes;
    this.setCaption=MenuUtil.setCaption;
    this.hideAll=MenuUtil.hideAll;
    this.getSubMenu=MenuUtil.getSubMenu;
    this.removeSubMenu=MenuUtil.removeSubMenu;
    this.clear=MenuUtil.clear;
    this.remove=MenuUtil.remove;
    this.setCssStyle=MenuUtil.MMsetCssStyle

    return this;
  }

MainMenu.prototype=DropDownMenu.prototype;

MainMenu.prototype.wrapAround=function(sId)
  {
    var o=document.getElementById(sId);
    if (!o)
      return false;
    this.p_body=document.createElement('<DIV id="oMainMenu"style="position:relative; top:0px; left:0px">');
    this.p_body.o_ref=this;
    this.p_body.onmousedown=MenuUtil.zMouseDown;
    this.p_body.onmouseover=MenuUtil.zMouseOver;
    this.p_body.onmouseout=MenuUtil.zMouseOut;
    this.p_body.style.zIndex=MenuUtil.bottom_z+1;
    this.p_body.oncontrolselect=MenuUtil.pEventControl;
    o.replaceNode(this.p_body);
    this.is_inited=true;
  }

MainMenu.prototype.create=function()
  {
  }

MainMenu.prototype.fireClick=function(sKey)
  {
    if (this.p_items[sKey])
      {
        var V=this.p_doc.createEventObject();
        V.eventName='onclick';
        V.key=this.p_items[sKey].sKey;
        V.value=this.p_items[sKey].sValue;
        this.p_body.fireEvent('oncontrolselect', V);
      }
  }

ClassMenuUtil.prototype.MMsetCssStyle=function(sText)
  {
    this.p_css=sText;
  }