<?php 
/*  fun_lib.inc.php
 *
 *  My php functions for eLearn.
 *
 *  @autor Andy. (c) Hypermethod company.
 *
 *   $Id: fun_lub.inc.php ,v 0.91 2002/19/11 18:22:35 kk Exp $
 *
 */

/*
 *   $dean, $admin, $teach, $stud  
 */
//  .
   include("utf2win1256.inc.php");

   $optionstable         =        "OPTIONS";
   $deans_table         =        "deans";
   $peopletable         =        "People";
   $mod_list_table        =        "mod_list";


   if (isset($dean)) unset($dean);
   if (isset($admin)) unset($admin);
   if (isset($teach)) unset($teach);
   if (isset($stud)) unset($stud);

   $s=(isset($_SESSION['s'])) ? $_SESSION['s'] : "";

   // $s -  - 3   
   $dean=(login_chek($s,$access['d'])) ? 1 : 0;

   // $s -  - 4   
   $admin=(login_chek($s,$access['a'])) ? 1 : 0;

   // $s -  - 2   
   $teach=(login_chek($s,$access['t'])) ? 1 : 0;

   // $s -  - 1   
   $stud=(login_chek($s,$access['s'])) ? 1 : 0;

   if (isset($courses)) unset($courses);

   if ($teach) $courses=$s['tkurs'];
      elseif ($stud) $courses=$s['skurs'];

////////////////////////////////////////////
   $nameweek = loadwords("all-days.html");
//   array("sunday","monday","tuesday","wednesday","thursday",
//   "friday","saturday","sunday");
   $MONTHES = loadwords("all-months.html");
////////////////////////////////////////////

class log_elarn_error
{
   var $errors;

   function add_error($error,$num)
   {
      $this->errors[$error]=$num;
   }
   function get_error()
   {
      return ($this->errors);
   }
   function is_errors()
   {
      $ret=1;
      if (empty($this->errors)) $ret=0;
      return $ret;
   }
}
function to_mysql($text, $post = false)
{
        if ($post) {
                if (!get_magic_quotes_gpc()) {
                        $text = str_replace("'", "\'", $text);
                } else {
                        $text = str_replace('\"', '"', $text);
                }
        } else {
                $text = str_replace("'", "\'", $text);
        }
        return $text;
}
function getField($tableName, $fieldName, $idname='', $id='', $as='', $order='')
{
        $fld=$fieldName;

		$tableName = strtolower($tableName);
        if(strtolower($tableName)=="options" && IFMYSQL==1) $fieldName=" SQL_CACHE ".$fieldName;
        if(strlen($as>2))
                $Result = sqldb_query("SELECT $fieldName AS $as FROM $tableName WHERE $idname = '$id' $order");
        else
                if($idname!="")
                $Result = sqldb_query("SELECT $fieldName FROM $tableName WHERE $idname = '$id' $order");
                else
                $Result = sqldb_query("SELECT $fieldName FROM $tableName $order");

        if(!$Result) return FALSE;
        if(num_rows($Result)==0) return FALSE;
        return sqldb_result($Result,0,$fld);
}

function mydate($old)
{  $new=substr($old,8,2).".".substr($old,5,2).".".substr($old,0,4);
   return $new;
}
function randString ($pass_len = 10)
{
   $allchars = 'abcdefghijklnmopqrstuvwxyzABCDEFGHIJKLNMOPQRSTUVWXYZ';
   $string = '';
   mt_srand ((double) microtime() * 1000000);
   for ($i = 0; $i < $pass_len; $i++)
      $string .= $allchars{mt_rand (0,strlen($allchars))};
   return $string;
}
function validateEmail($email)
{  return eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email);
}

function utf_2_win1256_arr($intDecUtf)
{
        global $arrUtfWin1256;

        $strHexUtf = (string)dechex($intDecUtf);
        if (strlen($strHexUtf) < 4) {
                $strHexUtf = str_pad($strHexUtf, 4, "0", STR_PAD_LEFT);
                $strHexUtf = strtoupper($strHexUtf);
        }
        if (isset($arrUtfWin1256[$strHexUtf])) {
                return chr(hexdec($arrUtfWin1256[$strHexUtf]));
        } else {
                return "&#{$intDecUtf};";
        }
}

function encode_utf($str, $constCodePage)
{
        switch ($constCodePage) {
                case CODEPAGE_WIN1251:
                        $strProperFunc = "win1251_2_utf";
                        break;
                case CODEPAGE_WIN1256:
                        $strProperFunc = "win1256_2_utf_arr";
                        break;
        }
$strNewStr="";
        for ($i = 0; $i < (strlen($str)); $i++)
        {
                $strChar = substr($str, $i, 1);
                $strNewStr .= $strProperFunc($strChar);
        }

        return $strNewStr;
}

function win1256_2_utf_arr($strChar)
{
        global $arrUtfWin1256;

        $strCharCode = (string)bin2hex($strChar);

        if ($strUtfHex = array_search(strtoupper($strCharCode), $arrUtfWin1256))
        {
                $strUtfDec = hexdec($strUtfHex);
                return "&#{$strUtfDec};";
        }
        else return $strChar;
}

function win1251_2_utf($strChar)
{
        $intCharCode = bin2hex($strChar);
        $intCharCodeDec = hexdec($intCharCode);
        if ((($intCharCodeDec <= 255) && ($intCharCodeDec >= 192)) || ($intCharCodeDec == 168) || ($intCharCodeDec == 184)) {
                $intCharCodeUtf = $intCharCodeDec + 848;
                return "&#{$intCharCodeUtf};";
        } else {
                return $strChar;
        }
}

function containsUtf($str, $constLang)
{
        $arrChars = explode("&#",$str);
        for ($i = 1; $i < count($arrChars); $i++)
             $arrChars[$i] = substr($arrChars[$i], 0, 5);

        if (is_array($arrChars))
        {
                   for ($i = 1; $i < count($arrChars); $i++)
                   {
                    $intCommaPos = strPos($arrChars[$i], ";");
                    if ($intCommaPos > 3)
                    {
                            $intCode = (int)substr($arrChars[$i], 0, $intCommaPos);
                            $strCodeUtf = "&#".$intCode.";";

                                if ($strCodeUtf != utf_2_win1256_arr($intCode)) {
                                        return true;
                                }
                    }
                   }
        }
        return false;
}

function htmlspecialchars1($val, $quote_style=ENT_COMPAT)
{
   $val=str_replace("&#","QWERTYZ",$val); //  

   $val=htmlspecialchars($val, $quote_style);

   $val=str_replace("QWERTYZ","&#", $val);

//   $val=str_replace("&amp;","&",$val);
   return $val;
}

function return_valid_value($val, $boolEncode = ENCODE_OFF)
{
        $boolEncode = ENCODE_OFF;
        if ($boolEncode == ENCODE_ON) {
                   /* <bam comment 08.04.2005
                   Don't making encode
                   Page code always win-1251
           if ($_SESSION['language'] == "r") {
                 $val = encode_utf($val, CODEPAGE_WIN1251);
           } else {
                 $val = encode_utf($val, CODEPAGE_WIN1256);
           }
                   */
                   $val = encode_utf($val, CODEPAGE_WIN1251);
        } elseif (strpos($val, "&#") !== false) {
            //DECODE
                $arrChars = explode("&#",$val);
            for ($i = 1; $i < count($arrChars); $i++) {
                    $intCommaPos = strPos($arrChars[$i], ";");
                    if ($intCommaPos > 3){
                            $intCode = (int)substr($arrChars[$i], 0, $intCommaPos);
                            $strTail = substr($arrChars[$i], $intCommaPos+1);
                            $arrChars[$i] = utf_2_win1256_arr($intCode).$strTail;
                    }
            }
            $val = implode("", $arrChars);
    }

    $val=htmlspecialchars1($val);
///////////////////////////////////////
   $val=addslashes($val);
   return $val;
}


function empty_dir($d)
{
                   if (!isset($d)) $d=realpath("./")."/";
                   if ($d[strlen($d)-1]!="/") $d.="/";
                   if (isset($files)) unset($files);
                   $di=@dir($d);

if(is_object($di)){

                while ($name=$di->read()){
			
                    if ($name=="." || $name=="..") continue;
                if (@is_dir($d.$name)) $files["1 $name"]=$name;
                        else $files["2 $name"]=$name;
                        $ftype[$name]=@filetype($d.$name);
                                }  //while
                        $di->close();
} //if is_object($di)
                        if (isset($files))
                        {
                        if(count($files)!=0)
                        {
                        ksort($files);
                           foreach ($files as $k=>$v) {
                                $name=$d.$v;
                                switch($ftype[$v]) {
                                case "file":
                                        @unlink($d.urlencode($v));

                                     break;
                                case "dir":
                                //          unlink($d.urlencode($v));
               empty_dir($d.urlencode($v));
               @rmdir($d.urlencode($v));
                                     break;
                                        }       // swith --
                                }       //foreach --
                        }       //if count $files = 0
                        } //if set $files

        }   // empty_dir($d)


function create_course_list($who)
{
   $teacher=0;
   $ret="";
   $error->teach_courses=0;
   $error->stud_courses=0;

   if (is_teacher($who)) $teacher=1;
   if ($teacher) $ret=get_teacher_courses($who);
      else $ret=get_student_courses($who);

//if($error->teach_courses || $error->stud_courses) print_error($error);

   return $ret;
}

function is_teacher($who)
{
   global $teacherstable;
   $teacher=0;
   $sql="SELECT PID FROM ".$teacherstable." WHERE MID='".$who."'";
   $sql_result=sqldb_query($sql);
   if (num_rows($sql_result)>0) $teacher=1;
   return $teacher;
}

function is_dean($who)
{
   global $deans_table;
   $dean=0;
   $sql="SELECT DID FROM ".$deans_table." WHERE MID='".$who."'";
   $sql_result=sqldb_query($sql);
   if (num_rows($sql_result)>0) $dean=1;
   return $dean;
}

function get_teacher_courses($who)
{

   global $teacherstable,$coursestable,$sitepath;
   $i=1;
   $ret="";
   $sql="SELECT ".$coursestable.".".f_name("Title")." as Title,".$teacherstable.".CID FROM ".$teacherstable.",".$coursestable." WHERE ".$coursestable.".Status!=0 AND ".$teacherstable.".MID='".$who."' AND ".$teacherstable.".CID=".$coursestable.".CID "; //ORDER by ".$coursestable.".CID DESC
   $sql_result=sqldb_query($sql);

   if (num_rows($sql_result)<0) return 1;
   while($res=fetch_array($sql_result))
      $ret.=$i++.". <a href=\"".$sitepath."teachers/manage_course.php?CID=".$res['CID']."\">".$res['title']."</a><br>\n";
   return $ret;

}

function get_student_courses($who)
{
   $i=1;
   global $studentstable,$coursestable,$sitepath;
   $ret="";
//  2002 10 01

   $sql="SELECT ".f_name("Title")." as Title,".$studentstable.".CID FROM ".$studentstable.",".$coursestable." WHERE ".$coursestable.".Status=2 AND ".$studentstable.".MID='".$who."' AND ".$studentstable.".CID=".$coursestable.".CID"; // ORDER by ".$coursestable.".CID

// end

   $sql_result=sqldb_query($sql);
   if (num_rows($sql_result)<0) return 1;
   while($res=fetch_array($sql_result))
//    echo $i++.". ".$res['Title']."<br>";
      $ret.=$i++.". <a href=\"".$sitepath."teachers/manage_course.php?CID=".$res['CID']."\">".$res['title']."</a><br>\n";
   return $ret;
}

function print_error($error)
{
   if($error->stud_courses) echo "   ";
   if($error->teach_courses) echo "   ";
   echo " ";
}

function get_course_title($cid)
{
   global $coursestable;
   $sql="SELECT ".f_name("Title")." as Title FROM ".$coursestable." WHERE CID='".$cid."'";
   $sql_result=sqldb_query($sql);
   if (num_rows($sql_result)<0) return "  .";
   $res=fetch_array($sql_result);
   return $res['title'];

}

function get_pid($who,$cid)
{
   global $teacherstable;

   $sql="SELECT PID FROM ".$teacherstable." WHERE MID='".$who."' AND CID='".$cid."'";

// 2002 10 02

   if (!$sql_result=sqldb_query($sql)) return 0;

// end

   if (num_rows($sql_result)<0) return 0;
   $res=fetch_array($sql_result);
   return $res['PID'];
}

function get_scorm_opt($cid) {                // whether the SCORM course is optimized
        global $coursestable;
        //bragin
        $sql="SELECT scorm_opt FROM " . $coursestable . " WHERE CID='" . $cid . "'";
        if (!$sql_result = sqldb_query($sql))
                return 0;
        if (num_rows($sql_result) < 0)
                return 0;
        $res = fetch_array($sql_result);
        return $res['scorm_opt'];
}

function get_sid($who,$cid)
{
   global $studentstable;
   global $coursestable;

// 2002 10 01

//   $sql="SELECT ".$studentstable.".SID as SID FROM ".$studentstable.",".$coursestable." WHERE ".$studentstable.".MID='".$who."' AND ".$studentstable.".CID='".$cid."' AND ".$coursestable.".CID=".$studentstable.".CID AND ".$coursestable.".Status='2'";
   $sql="SELECT ".$studentstable.".SID as SID FROM ".$studentstable.",".$coursestable." WHERE ".$studentstable.".MID='".$who."' AND ".$studentstable.".CID='".$cid."' AND ".$coursestable.".CID=".$studentstable.".CID";

//end
   if (!$sql_result=@sqldb_query($sql)) return 0;
   if (num_rows($sql_result)<0) return 0;
   $res=fetch_array($sql_result);
   return $res['SID'];

}


function forum_id_string()
{
   global $mod_list_table;
   $str="0";
   $sql="SELECT forum_id FROM ".$mod_list_table." WHERE forum_id!='NULL' AND Pub='0'";

   if (!$sql_result=sqldb_query($sql)) return $str;
   if (num_rows($sql_result)<0) return $str;
   $res=fetch_row($sql_result);
   $str=$res[0];
   while ($res=fetch_row($sql_result)) $str.=",".$res[0];
   $str=(empty($str)) ? "0" : $str;
   return $str;
}

// 2002 10 03

function add_stud_tasks($MID,$CID)
{
   global $scheduletable;
   global $vedtable;

   $str=1;

   $sql = "SELECT SHEID FROM ".$scheduletable." WHERE CID=".$CID." AND LOCATE('sAddToAllnew=1',toolParams)!=0";

   if (!$sql_result=@sqldb_query($sql))
   {
                return $str;
   }

   if (num_rows($sql_result)<0)
   {
                return $str;
   }

   while($res=fetch_array($sql_result))
   {
      $sql = "INSERT INTO ".$vedtable." (SHEID,MID,V_STATUS) VALUES (".$res['SHEID'].",".$MID.",'-1')";
      @sqldb_query($sql);
   }
   return $str;
}

function returnStudInterfLang($lang=false)
{  global $s, $language;

   if(!isset($s['mid']) || $s['mid']==0)
       return $language;
   else
   if(isset($s['perm']) && ($s['perm']==1 || $s['perm']==0))//  
      return $lang?$lang:$language;
   else
      return "e";
}
/*
function GetResource($ID, $replaces=false, $lang=false)
{
         $fieldPostfix = "";
         if(returnStudInterfLang($lang)=="f")
            $fieldPostfix = "_fa";
         else
         if(returnStudInterfLang($lang)=="r")
            $fieldPostfix = "_ru";

        $query = "SELECT ".(IFMYSQL==1?"SQL_CACHE ":"")."Title".$fieldPostfix." as Title FROM resources WHERE ID='$ID'";
       // var_dump($query);
         $res = sqldb_query($query);

         if(!$res) return "<H1>UNKNOWN RESOURCE $ID</H1>";

         $row = fetch_assoc($res);

         if(!$row) return "<H1>INCORRECT RESOURCE DATA $ID</H1>";

         $ret_data = $row['title'];

         if($replaces)
         {  foreach($replaces as $pattern=>$value)
                    $ret_data = str_replace($pattern, $value, $ret_data);
         }

         return $ret_data;
}

function EchoResource($ID, $replaces=false)
{
         echo GetResource($ID, $replaces);
}

*/
function STYLE_CSS()
{
        return returnStudInterfLang()=="f"?"_fa":"";
}

function STYLE_CSS_EXT()
{
        global $language;
        return ($language == "f") ? "_ext_fa" : "_ext";
}

function getImageSubpath($file)
{
    global $wwf;
    $table = array("e"=>"en/", "r"=>"ru/", "f"=>"fa/");

    $filepath = $table[returnStudInterfLang()].$file;

    return (@file_exists($wwf."/images/".$filepath))?$filepath:$file;
}

function getTemplateSubpath($file)
{   global $templdir, $language;

    $table = array("e"=>"en/", "r"=>"ru/", "f"=>"fa/");

    $lang = ($file=="all-mail.html")?$language:returnStudInterfLang();

    $filepath = $templdir.$table[$lang].$file;

    return (@file_exists($filepath))?$filepath:$templdir.$table["e"].$file;
}
/*
function getTemplateSubpath($file)
{   global $templdir;

        $table = array("e"=>"en/", "r"=>"ru/", "f"=>"fa/");

        $filepath = $templdir.$table[returnStudInterfLang()].$file;

        return (@file_exists($filepath))?$filepath:$templdir.$table["e"].$file;
}
*/
function getTestTemplateSubpath($file, $bFullPath=true)
{        global $testdir;

        $file = str_replace("template_test/", "", $file);

        $table = array("e"=>"en/", "r"=>"ru/", "f"=>"fa/");

        $filepath = $testdir.$table[returnStudInterfLang()].$file;

        if(!$bFullPath)
            return (@file_exists($filepath))?$table[returnStudInterfLang()].$file:$table["e"].$file;

        return (@file_exists($filepath))?$filepath:$testdir.$table["e"].$file;
}

function loadtmpl($in)
{
   global $templdir;
   $templ_filepath = getTemplateSubpath($in);

   if (!@is_file($templ_filepath)) return "<h1> </h1>";

   $out = implode("",file($templ_filepath));

   if (get_magic_quotes_gpc()) return stripslashes($out);
   if (get_magic_quotes_runtime()) return stripslashes($out);

   $out=str_replace("[RTL]",$_SESSION['language']=='f'?"dir=RTL":"",$out);

   return $out;
}

function loadwords($in, $boolTranslate = TRANSLATE_OFF)
   {
   global $templdir;

   $templ_filepath = getTemplateSubpath($in);


   if (!@is_file($templ_filepath)) return "<h1>Words error</h1>";


   $words=file($templ_filepath);


    if (get_magic_quotes_gpc() || get_magic_quotes_runtime() || $boolTranslate)
            {
               while (list($key,$val)=each($words)) {
                               if ($boolTranslate) {
                                       $arrVal = explode("|", $val);
                                       if ($_SESSION['language'] == 'r' && $arrVal[1])
                                       {   $val = $arrVal[1];
                                       }
                                       else
                                       {   $val = $arrVal[0];
                                       }
                               }
                               $words[$key]=stripslashes(str_replace(array("\r", "\n"), "", $val));
               }
            }

   return  $words;
   }

function get_news($nums="",$where="",$limitation="")
{
       global $newstable, $dean, $_SESSION, $num, $s;

        $llang = (isset($_SESSION['language'])?$_SESSION['language']:false);
/*
        $llang = "fa";
        switch($_SESSION[language])
        {
                case "r": $llang = "ru";
                break;
                case "e": $llang = "en";
                break;
                case "f": $llang = "fa";
                break;
        }
*/
$utcv="";
        if(IFMYSQL==0) $utcv="dbo.unixtime3";
        $SQL3 = array(
        'mysql'=>"SELECT *, $utcv(date) as date FROM ".$newstable." WHERE showflag".($dean?"<'2'":">'0'").($llang=="r"?" AND lang='r'":" AND lang<>'r' "),
        'mssql'=>"SELECT *, $utcv(date) as date FROM ".$newstable." WHERE showflag".($dean?"<'2'":">'0'").($llang=="r"?" AND lang='r'":" AND lang<>'r'"),
       'oci8'=>"SELECT \"date\" FROM ".$newstable." WHERE showflag".($dean?"<'2'":">'0'"        ).($llang=="r"?" AND lang='r'":" AND lang<>'r'"));

//060207 by alpv
//'oci8'=>"select t1.*,count(rn) over() as s_rowcnt from (SELECT n.*, row_number() over (order by 1 desc) rn FROM ".$newstable." n WHERE showflag".($dean?"<'2'":">'0'"        ).($llang=="r"?" AND lang='r'":" AND lang<>'r') t1"));
//

        // lang='$llang
$SQL2 ="";
$SQL1="";

   if ($where)
                $SQL2 .=" ".$where." ";

   $SQL2 .= " ORDER BY ".nsort_type()." DESC $limitation";




   if ($nums) $SQL1=array(
   //'mysql'=>" LIMIT 0, ".$num,   'mssql'=>" LIMIT 0, ".$num,

   'mysql'=> '',   'mssql'=> '',


   //'oci8'=>" LIMIT 0, ".$num //060207 by alpv

//060207 by alpv
  // 'oci8'=>"  where rn <= ".$nums//." order by 1 desc"
    );
//
$SQL['mysql']=$SQL3['mysql'].$SQL1['mysql'].$SQL2;
$SQL['mssql']=$SQL3['mssql'].$SQL1['mssql'].$SQL2['mssql'];
$SQL['oci8'] = $SQL3['oci8'].$SQL1['oci8'].$SQL2['oci8'];

$num=num_rows(sqldb_query($SQL));
//var_dump($SQL['oci8']);

$SQL['mysql']=$SQL3['mysql'].$SQL1['mysql'].$SQL2;//." ".$where." ['mysql']order by date desc ".$limitation;
$SQL['mssql']=$SQL3['mssql'].$SQL1['mssql'].$SQL2['mssql']." $limitation";
$SQL['oci8'] = $SQL3['oci8'].$SQL1['oci8'].$SQL2['oci8']." $limitation";


//var_dump($SQL['mysql']);
   $result=sqldb_query($SQL);
//echo $SQL['mysql'].$limitation;
//die();
//echo $num."<BR>".$SQL['mysql'];

   return $result;
   }

function nsort_type()
{
   global $s;

   if (!isset($s['user']['nsort'])) return "nID";
   if (!$s['user']['nsort']) return "nID";

   return "date";
}

function replace_tr($menu, $subj)
{
        $menu = str_replace("<tr><td align=\"right\"><a href=\"[PATH]".$subj, "<tr class=hidden><td><a href=\"[PATH]".$subj, $menu);
        return $menu;
}

function create_new_html($top,$m,$perm="")
{
GLOBAL $type_id,$s,$language,$_SESSION,$full_self;
      $html=loadtmpl("all-html.html");

      $allheader=loadtmpl("all-header.html");

      $topmenu="";
      $menu="";
      $allmenu="";
      $words=array();

      $allwords=loadwords("all-words.html");

      if (!is_array($allwords)) return "<h1>Words error</h1>";

      $words['title']=$allwords[0];

      $words['MAINWIDTH']=$allwords[9];

      if ($top)
          {

            $topmenu=loadtmpl("all-topmenu.html");
            $words['home']=$allwords[1];
            $words['reg']=$allwords[2];
            $words['course']=$allwords[3];
            $words['lib']=$allwords[4];
            $words['serv']=$allwords[5];
            $words['help']=$allwords[6];
            $words['hello']=$allwords[7];
            $words['MAINWIDTH']=$allwords[8];

            if($language=="f") $topmenu=preg_replace("|images\/menu\/far.gif|","images/menu/far_pr.gif",$topmenu);
            if($language=="e") $topmenu=preg_replace("|images\/menu\/eng.gif|","images/menu/eng_pr.gif",$topmenu);
            if($language=="r") $topmenu=preg_replace("|images\/menu\/rus.gif|","images/menu/rus_pr.gif",$topmenu);

            $topmenu=str_replace("[W-far]"," ",$topmenu);
            $topmenu=str_replace("[W-eng]"," ",$topmenu);
            $topmenu=str_replace("[W-rus]"," ",$topmenu);

            if(isset($s['mid']) && redirect_toMail($_SESSION['s']['mid']))
            {
               $topmenu=preg_replace("|index.php|","mail.php",$topmenu);
            }
          }

      if ($m)
      {
              global $optionstable;
        $menu=loadtmpl($m."-lMenu.html");
        $sched=getField($optionstable,"value","name","schedule");
        $mail=getField($optionstable,"value","name","Mail");


        if(get_options('chat')=="")
                $menu = replace_tr($menu, "chat.php");





        if($sched==0)
        {
        //   $menu = replace_tr($menu, "events.php");
           $menu = replace_tr($menu, "schedule.php");
        }
//[alx - 12.02.2007 - extended results by default]
//      else
//      {
//              $menu=preg_replace("|ved.php|","ved2.php",$menu);
//      }
global $teacherstable;
if(isset($s['mid']))
$type_id = @sqldb_result(sqldb_query("select type from $teacherstable  where mid='".$s['mid']."'"),0,'type');

;
        if($perm<2)
        {

          // $menu = replace_tr($menu, "print.php");
           $menu = replace_tr($menu, "ved.php");
           $menu = replace_tr($menu, "monitor.php");
           $menu = replace_tr($menu, "courses.php");
           $menu = replace_tr($menu, "exercise.php");
/*
//[che]
           if($sched==0)
                                $menu = replace_tr($menu, "test_test.php");
*/
           $menu = replace_tr($menu, "test_test.php");

        }
		


if(($type_id==0) && $s['perm']==2){

        $menu = replace_tr($menu, "ved.php");
        $menu = replace_tr($menu, "schedule.php");

}

if(($type_id==1) && $s['perm']==2){

        $menu = replace_tr($menu, "test_test.php");


}

        if($mail==0)
           $menu = replace_tr($menu, "mail.php");

        if($t = redirect_toMail($_SESSION['s']['mid']))
        {
           $menu = str_replace("<tr><td><a href=\"[PATH]", "<tr class=hidden><td><a href=\"[PATH]", $menu);
           $menu = str_replace("<tr><td height=5><hr/></td></tr>", "", $menu);
        }

        $words['MAINWIDTH']=$allwords[8];
      }


      if ($menu!="<h1>Template error</h1>" && !empty($menu))
          $allmenu=loadtmpl("all-menu.html");
      else $menu="";


      $html=str_replace("[ALL-HEADER]",$allheader,$html);
      $html=str_replace("[TOP-MENU]",$topmenu,$html);
      $html=str_replace("[ALL-MENU]",$allmenu,$html);
      $html=str_replace("[MENU]",$menu,$html);
      $full_self=preg_replace("|&|","%26",$full_self);

      //////   GET         
      $strip_get_query_pages = array("admin/teachers.php", "admin/students.php", "admin/sp.php", "admin/abitur.php");
      foreach($strip_get_query_pages as $page)
      {
              if(!(strpos($full_self, $page)===false))
              {    $pos = strpos($full_self, "?");
                   if(!($pos===false))
                      $full_self = substr($full_self, 0, $pos);
                   break;
              }
      }
      /////////////////////////////////////////////////////////////////////////////////////

      $html=str_replace("[SELF]",$full_self,$html);


      $html=words_parse($html,$words);

      return $html;
   }

   function change_level($chl,$ml,$cl)
   {
global $s, $teacherstable ;
if(isset($s['mid']))
$type_id = @sqldb_result(sqldb_query("select type from $teacherstable  where mid=".$s['mid']),0,'type');
      if ($ml>=$chl && $chl>0) return $chl;
      hack_log(1,"change level");
      return $ml;

   }


        function show_cur_html($perm) {
//[alx - 14.02.2007 - new tempalate for web_cd + for test/123]
//                if ((WEB_CD && $_SESSION['s']['perm'] == 1) || $_SESSION['s']['mid'] == 6461) {

                if ((WEB_CD && $_SESSION['s']['perm'] < 2)) {
                        $html = create_new_html("top", "rm", $perm);
                } else {
                        $html = create_new_html("top", "st", $perm);

                        if (3 == $perm) {
                                $html = create_new_html("top", "dean", $perm);
                        } elseif (4 == $perm) {
                                $html=create_new_html("top", "admin", $perm);
                        }
                }

                return $html;
        }

function GetCID2()
{
        global $_SESSION;

        if(isset($_SESSION['s']['user']['scourse']))
        {
                $CCIDD=$_SESSION['s']['user']['scourse'];
        }
        elseif(isset($_SESSION['CID2']))
        {
                $CCIDD=$_SESSION['CID2'];
        }
        elseif(isset($_SESSION['s']['CID2']))
        {
                $CCIDD=$_SESSION['s']['CID2'];
        }
        elseif(isset($_SESSION['s']['cid']))
        {
                $CCIDD=$_SESSION['s']['cid'];
        }
        elseif(isset($_SESSION['cid']))
        {
                $CCIDD=$_SESSION['cid'];
        }

        return $CCIDD;
}

function path_sess_parse($html)
   {
      global $sess;
      global $sessf;
      global $sitepath;
      global $self;
      global $full_self;

      $html=str_replace("[SESSID]",$sess,$html);
      $html=str_replace("[FSESSID]",$sessf,$html);
      $html=str_replace("[PATH]",$sitepath,$html);
      $html=str_replace("[STYLE_CSS]",STYLE_CSS(),$html);
      $html=str_replace("[STYLE_CSS_EXT]",STYLE_CSS_EXT(),$html);
      $html=str_replace("[SELF]",$full_self,$html);
      $html=str_replace("[PAGE]",$self,$html);
      $html=str_replace("[LANGUAGE]",$_SESSION['charset'],$html);

      global $release;
      $html=str_replace("[IMPEXP_REPLACE]",$release?"export.php":"import.php",$html);
      $html=str_replace("[IMPEXP_REPLACE_NAME]",$release?"Export":"Import",$html);

//          if(isset($_SESSION['che_cid']));
//                    $html=str_replace("[CHE_CID]","CHE_CID=$_SESSION[che_cid]",$html);

      return $html;
   }

function words_parse($html,$words,$k="W-")
   {
   if (is_array($words))
      {
      while(list($key,$val)=each($words))
         {
            $val=str_replace("\r\n","",$val);
//          $val=str_replace("\r","",$val);
            $html=str_replace("[".$k.$key."]",$val,$html);
         }
      }
   return $html;
   }

/*
function news_parse($html,$words)
   {
   if (is_array($words))
      {
      while(list($key,$val)=each($words))
         {
            $html=str_replace("[N-".$key."]",$val,$html);
         }
      }
   return $html;
   }
*/
function get_announce($num,$CIDs)
   {

   global $guestbook, $_SESSION;
//      $guestbook="posts3";



        $lang = false;//$_SESSION[language];

$lang_where = "lang".($lang=="r"?"='r'":"<>'r'");

      if (is_array($CIDs))
      {

         $add_sql="";
         foreach($CIDs as $CID_){
                 $add_sql.=$CID_.",";
         }
         $add_sql=substr($add_sql,0,strlen($add_sql)-1);
         //corr date 060207 by alpv, "g" alias added
         //$SQL = "SELECT g.*, UNIX_TIMESTAMP(posted) as posted FROM $guestbook g WHERE ( CID='".$val."'";
         //
         //while (list($key,$val)=each($CIDs))
         //               $SQL.=" OR CID='".$val."'";
         //$SQL .= ") AND ".$lang_where." ORDER BY posted DESC LIMIT 0, ".$num;
//corr date 200207 by alpv "limit" dropped
         $SQL = "SELECT g.*,
                                UNIX_TIMESTAMP(posted) as posted2

                           FROM $guestbook g
                          WHERE ";
         $SQL .= (strlen($add_sql)>0?" CID IN (".$add_sql.") AND ":"").$lang_where.= " ORDER  BY posted desc";
//corr date 200207 by alpv
//var_dump($SQL);
       }
         else
          if("admin"==$CIDs)
        //corr date 060207 by alpv, "g" alias added
        $SQL = "SELECT g.*, UNIX_TIMESTAMP(posted) as posted FROM $guestbook g WHERE $lang_where ORDER  BY posted desc";
        //
 /*
        select t.*, count(posted_t) over() s_rowcnt
from (
SELECT gs.*, UNIX_TIMESTAMP(posted) as posted_t FROM posts3 gs WHERE (CID='165' ) AND lang<>'r' ORDER BY posted DESC) t
    */


      else exit("error cids");
      $result=sqldb_query($SQL);
//var_dump(num_rows($result));
      return $result;
   }

function tosql($str)
{
   $str=str_replace("#","",$str);
   if (!get_magic_quotes_gpc() && !get_magic_quotes_runtime())
            {
               $str=addslashes($str);
              }
   return $str;
}

function cCourse_links($perm) {
        global $s, $coursestable;

        $links = "";
        $i = 1;
        $sql = "";
        $line = loadtmpl("st-links.html");
        $scorm_line = loadtmpl("st-scorm.html");

        if (1 == $perm && is_array($s['skurs'])) {
                reset($s['skurs']);
                list($key,$val) = each($s['skurs']);
                $sql = "SELECT CID, " . f_name("Title") . " as Title, scorm, title FROM $coursestable WHERE CID = '" . $val . "'";
                while (list($key,$val) = each($s['skurs']))
                        $sql .= " OR CID = '" . $val . "'";
        } elseif (2 == $perm && is_array($s['tkurs'])) {
                reset($s['tkurs']);
                list($key,$val) = each($s['tkurs']);

                $sql = "SELECT CID, " . f_name("Title") . " as Title, scorm, title FROM $coursestable WHERE CID = '" . $val . "'";
                while (list($key,$val) = each($s['tkurs'])) {
                        $sql .= " OR CID = '" . $val . "'";

                }

        } else
                return loadtmpl("st-nolinks.html");

        if (!$result = sqldb_query($sql)) return $links;
        if (num_rows($result) < 1) return $links;
//echo "$sql<BR>";
        while ($row = fetch_assoc($result)) {
                $tmp = (isset($row['scorm']) && $row['scorm']==1) ? $scorm_line : $line;
                $tmp = str_replace("[ID]", $i, $tmp);
                $tmp = str_replace("[TITLE]", $row['title'], $tmp); // Title=>TITLE by alpv 25.02.2007
                $tmp = str_replace("[CID]", $row['cid'], $tmp);
                $links .= $tmp;
                $i++;
        }

        return $links;
}



function getCourseList($perm) {
        global $s, $coursestable;

        $links = "";
        $i = 1;
        $sql = "";

        if (1 == $perm && is_array($s['skurs'])) {
                reset($s['skurs']);
                list($key,$val) = each($s['skurs']);
                $sql = "SELECT CID, cBegin, cEnd, TypeDes, description, " . f_name("Title") . " as Title, scorm, title FROM $coursestable WHERE CID = '" . $val . "'";
                while (list($key,$val) = each($s['skurs']))
                        $sql .= " OR CID = '" . $val . "'";
        } elseif (2 == $perm && is_array($s['tkurs'])) {
                reset($s['tkurs']);
                list($key,$val) = each($s['tkurs']);

                $sql = "SELECT CID, cBegin, cEnd, TypeDes, description, " . f_name("Title") . " as Title, scorm, title FROM $coursestable WHERE CID = '" . $val . "'";
                while (list($key,$val) = each($s['tkurs'])) {
                        $sql .= " OR CID = '" . $val . "'";

                }

        } else
                return null;

        if (!$result = sqldb_query($sql)) return null;
        if (num_rows($result) < 1) return null;

        $tmp = array();
        while ($row = fetch_assoc($result)) {
                $tmp{$row['title']}=$row['CID'].",".$row['cBegin'].",".$row['cEnd'].",".$row['TypeDes'].",".base64_encode($row['description']);
                //$tmp{$row['CID']} = $row['title'];
        }

        return $tmp;
/*
$temp = array();
$temp = getCourseList($s['perm']);
foreach ($temp as $value){
        //echo "$value<BR>";
}
*/
}




   function login_chek($s,$mod)
   {
      //    MID 
       if (!isset($s['mid'])) return false;

      //      
       if (!isset($s['perm'])) return false;

      //         
       if ($mod>$s['perm']) return false;

    return true;
   }

   function login_error()
   {
      global $sitepath;
       header("location:".$sitepath."index.php");
      exit();
   }


   function show_tb($type=0)
   {

      global $s;
      static $tb;
      if (is_array($tb))  {
                     $_SESSION['s']=$s;
                     return $tb[1];
                     }
      $html=create_new_html("top","all");

      if (isset($s['perm'])) {
                     $html=show_cur_html($s['perm']);
                     $words['ucLINKS']=cCourse_links($s['perm']);
                     if (isset($s['user']['fname'])) $words['uNAME']=$s['user']['fname'];
                     $html=words_parse($html,$words);
                     }

      $html=path_sess_parse($html);
      $html=str_replace("[LANGUAGE]",$_SESSION['charset'],$html);

      if ($type)  return $html;

      $tb=explode("[ALL-CONTENT]",$html);

      return $tb[0];
   }

   function day($i)
   {
      if (1==strlen($i)) $i="0".$i;
      return $i;
   }

   function month($i)
   {
      $months=loadwords("all-months.html");
      return $months[$i-1];
   }

   function hack_log($i,$s)
   {
//    echo "Hack detected: ".$s;
   }

   function select_day($b_date="")
   {
       $b_day="";
      for($j="1";$j<32;$j++)
            {
               $b_temp="";

               if ($b_date==$j)  $b_temp="selected";

               $b_day.="<option value=".day($j)." ".$b_temp.">".day($j)."</option>\n";

            }
      return $b_day;

   }

   function select_month($b_date="")
   {
      $b_month="";
      for($j="1";$j<13;$j++)
            {
               $b_temp="";

               if ($b_date==$j)  $b_temp="selected";

               $b_month.="<option value=".day($j)." ".$b_temp.">".month($j)."</option>\n";
            }
      return $b_month;
   }

   function select_year($b_date="")
   {
      $b_year="";
      for($j=date("Y")-1;$j-8<date("Y");$j++)
            {
               $b_temp="";

               if ($b_date==$j)  $b_temp="selected";

               $b_year.="<option value=".$j." ".$b_temp.">".$j."</option>\n";
            }
      return $b_year;
   }

   function v_text($str)
   {
      $str=strip_tags($str);
      if (!get_magic_quotes_gpc())
            {
               $str=addslashes($str);
              }
      $str=htmlspecialchars($str); //??
      $str=nl2br($str);
      return $str;
   }

   function v_year($str)
   {
     return intval($str);
   }
   function v_month($str)
   {
     $str=intval($str);
     $str=day($str);
     return $str;
   }
   function v_day($str)
   {
     $str=intval($str);
     $str=day($str);
     return $str;
   }
   function v_hours($str)
   {
     $str=intval($str);
     $str=day($str);
     return $str;
   }
   function v_min($str)
   {
     $str=intval($str);
     $str=day($str);
     return $str;
   }

   function printtmpl($html) {
      global $s,$words;
      $html=str_replace("[LANGUAGE]",$_SESSION['charset'],$html);
      $html=words_parse($html,$words);
      $html=path_sess_parse($html);

      $_SESSION['s']=$s;
      echo $html;
      s_timeprint();
   }

   function getName($mid)
   {                        GLOBAL $peopletable;
                $res=sqldb_query("SELECT LastName, FirstName, Login FROM $peopletable WHERE MID='$mid'");
                return sqldb_result($res,0,'LastName')." ".sqldb_result($res,0,'FirstName');//." (".sqlres($res,0,'Login').")";
   }
   function helptitle($title,$a,$lnk="")
   {
     return "<a href=\"".$lnk."\" title=\"".$title."\" onclick=\"return ".(($lnk) ? "true": "false")."\">".$a."</a>";
   }

   function peopleSelect($to_division = "")
   {
                GLOBAL $peopletable, $admins_table, $deans_table;
      switch ($to_division) {
          case "admins":
               $sql_query = "SELECT ".$peopletable.".MID as MID, $peopletable.Login as login, $peopletable.LastName as lname, $peopletable.FirstName as fname FROM $peopletable LEFT JOIN $admins_table ON $peopletable.MID=$admins_table.MID WHERE NOT $peopletable.MID IN(SELECT MID FROM $admins_table) ORDER BY $peopletable.login";
               break;
          case "deans":
                $sql_query = "SELECT $peopletable.MID as MID, $peopletable.Login as login, $peopletable.LastName as lname, $peopletable.FirstName as fname FROM $peopletable LEFT JOIN $deans_table  ON $peopletable.MID=$deans_table .MID WHERE NOT $peopletable.MID IN(SELECT MID FROM $deans_table) ORDER BY $peopletable.login";
                break;
          default:
              $sql_query = "SELECT $peopletable.MID as MID, $peopletable.Login as login, $peopletable.LastName as lname, $peopletable.FirstName as fname from $peopletable ORDER BY login";
              break;
      }
      $html="";
      $res=sqldb_query($sql_query);
      if (!num_rows($res)) return "<option>---   ---</option>";
      while ($row=fetch_assoc($res)) {
         $html.="<option value=".$row['mid'].">".$row['login'].": ".$row['fname']." ".$row['lname']."</option>";
      }
      return $html;
   }

   function selCourses($aCur,&$selCur) {
         $sel="";
         global $coursestable;
        //18022007 by alpv 'CID'=>CID
        //bragin
         $res=sqldb_query("SELECT cid,title FROM $coursestable WHERE CID IN ('".@implode("','",$aCur)."') ORDER by CID ASC");
//18022007
$i=0;
$selected="selected";
 while ($row=fetch_assoc($res))
                 {
                         $i++;
                        $sel.="<option value=\"".$row['cid']."\" ";

                                if($selCur=="")
                                        $selCur = $row['cid'];
                                else {

                                        //value=""
                                if ($row['cid']!="") {

                                if ($selCur==$row['cid']) $sel.="selected";

                                }
                                }


               $sel.=">".$row['title']."</option>";
            }
           // echo $sel;
      return $sel;

   }

   function getDeansOptions() {
   global $optionstable, $deans_table;
      $sel=array();
      $sel['email']=getField($optionstable,"value","name","dekanEMail");
      $sel['name']=getField($optionstable,"value","name","dekanName");

      $sel['mids'] = array();
      //bragin
          $res=sqldb_query("SELECT $deans_table.mid FROM $deans_table ");

          if($res)
          while($row= fetch_assoc($res))
                      //    if (!isset($row['mid'])) $row['mid']="";//bragin
                $sel['mids'][] = $row['mid'];
      return $sel;
   }


   /*
   newpass:
      0 -   
      1 -  
      2 -  ,      
   */
   function getPLE($mid,$newpass=1) {
      global $teach, $peopletable;
      $pl=array();
      //bragin
      $res=sqldb_query("SELECT mid FROM $peopletable WHERE mid=$mid");
      $num=num_rows($res);
      if ($num==0) $newpass=1;
      $Password=randString(7);
      $msgPassword="  ,   ";

      switch ($newpass) {

         case 2:
            $r=fetch_assoc($res);
            sqlfree($res);
            if (intval($r['last'])==0) {
               $res=sqldb_query("UPDATE `$peopletable` SET Password='".md5($Password)."' WHERE `MID`='".$mid."'");
               $msgPassword=$Password;
            }
            break;

         case 1:
             $res=sqldb_query("UPDATE `$peopletable` SET Password='".md5($Password)."' WHERE `MID`='".$mid."'");
            $msgPassword=$Password;
            break;

      }

      $res=sqldb_query("SELECT Login, Email FROM $peopletable WHERE `MID`='".$mid."'");
      if (num_rows($res)>0) {
         $pl=fetch_assoc($res);
         $pl['Password']=$msgPassword;
      }
      return $pl;
   }

   function getStCol($cgid) {
   global $freestud,$studentstable;
   $sql="SELECT MID FROM $studentstable WHERE cgid=".$cgid." GROUP BY MID";
   $res=sqldb_query($sql);
   $groupuser=num_rows($res);
   if (isset($freestud)) $freestud=$freestud-$groupuser;
   return $groupuser;
   }

   function showSortImg($html,$num) {
   global $s;
      $imgname="[SORTIMG".$num."]";
      $imgpath="<img src='[PATH]images/sort_".((2==$s['user']['corder']) ? "up" : "down").".gif' border=0>";
      $html=str_replace($imgname,$imgpath,$html);
      for($i=1;$i<10;$i++) $html=str_replace("[SORTIMG".$i."]","",$html);
      return $html;
   }


   function selGr($cid) {
                global $groupname_table, $cgname_table;
        $numRows = 0;

         $sel="";
         $sel.="<option value=\"0\">---  ---</option>\n";
         $res=sqldb_query("SELECT cgid, name FROM $cgname_table ORDER BY cgid");
                $numRows += num_rows($res);
         while ($row=fetch_assoc($res)) $sel.="<option value=\"d".$row['cgid']."\">".$row['name']."</option>\n";

         $sel.="<option value=\"1\" selected>---  ---</option>\n";

         $res=sqldb_query("SELECT gid, cid, name FROM $groupname_table WHERE `CID`='".$cid."' AND  status=1 ORDER BY gid");
                $numRows += num_rows($res);
         while ($row=fetch_assoc($res)) $sel.="<option value=\"g".$row['gid']."\">".$row['name']."</option>\n";

     return $numRows>0 ? $sel : "<option value='1'>(     )";
   }


   function selGrved($cid,$gr) {
   $sel="";
   global  $groupname_table, $cgname_table;

         $res=sqldb_query("SELECT cgid, name FROM $cgname_table  ORDER BY cgid");
         while ($row=fetch_assoc($res)) {
               $sel.="<option value=\"d".$row['cgid']."\" ";
               if ($gr=="d".$row['cgid']) $sel.="selected" ;
               $sel.=">".$row['name']."</option>";
            }

       $sel.="<option value=\"0\" ";
       if ($gr=="0") $sel.="selected" ;
       $sel.=">---  ---</option>";


         $res=sqldb_query("SELECT gid, cid, name FROM $groupname_table WHERE `CID`='".$cid."' AND status='1' ORDER BY gid");
         while ($row=fetch_assoc($res)) {
               $sel.="<option value=\"g".$row['gid']."\" ";
               if ($gr=="g".$row['gid']) $sel.="selected" ;
               $sel.=">".$row['name']."</option>";
            }



      return $sel;

   }

   function grArray($cid) {
           global $groupname_table,  $groupuser_table, $cgname_table;
         $sel="";
         global $studentstable;
         $res=sqldb_query("SELECT cgid, name FROM $cgname_table");
         while ($row=fetch_assoc($res)) {
            $resin=sqldb_query("SELECT MID FROM $studentstable WHERE cgid='".$row['cgid']."' AND CID='".$cid."'");
            $sel.=" var d".$row['cgid']." = new Array(".num_rows($resin).");\n";
            $i=1;
            while ($rowin=fetch_assoc($resin)) {
            $sel.="d".$row['cgid']."[".$i."] = ".$rowin['MID'].";\n";
            $i++;
            }
         }

         $res=sqldb_query("SELECT gid, cid, name FROM $groupname_table WHERE `CID`='".$cid."' ORDER BY gid");
         while ($row=fetch_assoc($res)) {
            $resin=sqldb_query("SELECT mid FROM $groupuser_table WHERE gid='".$row['gid']."' ");
            $sel.=" var g".$row['gid']." = new Array(".num_rows($resin).");\n";
            $i=1;
            while ($rowin=fetch_assoc($resin)) {
            $sel.="g".$row['gid']."[".$i."] = ".$rowin['mid'].";\n";
            $i++;
            }
         }

      return $sel;
   }
   function MIDgroupArray($mid,$cid) {
                   global $studentstable, $groupname_table,  $groupuser_table;

      $sql="SELECT $groupuser_table.mid as mid, ".$groupname_table.".name as gname FROM $groupuser_table, ".$groupname_table." WHERE $groupuser_table.mid='".$mid."' AND $groupuser_table.gid=".$groupname_table.".gid AND ".$groupname_table.".cid='".$cid."'";
      if ($res=@sqldb_query($sql))
      while ($row = fetch_assoc($res)) {
         $rgroup[]=$row['gname'];
      }
      $rgroup['dean']=sqlvalue("SELECT name FROM $cgname_table, $studentstable WHERE ".$cgname_table.".cgid=$studentstable.cgid AND MID='$mid' AND CID='$cid'");
      return $rgroup;
   }

// function retrun value of all claimants on the course
   function gAbNum($CID)
   {
                GLOBAL $peopletable, $cgname_table,$claimtable;
      $sql="SELECT COUNT(*) FROM $claimtable, $peopletable WHERE ".$claimtable.".CID='".$CID."' AND ".$claimtable .".Teacher='0' AND $peopletable.MID=".$claimtable .".MID";
      $res=sqlvalue($sql,1,1);
      return $res;
      }


   function gGroupNum($CID) {
           global $groupname_table;
      $sql="SELECT COUNT(*) FROM $groupname_table WHERE CID='".$CID."'";
      $res=sqlvalue($sql,1,1);
      return $res;
      }


// function retrun value of all non moder answers on the course
   function gModerNum($CID) {
           global $seance_table;
      $cnt1=sqlvalue("SELECT COUNT(*) FROM $seance_table WHERE cid = ".$CID." AND bal IS NULL");
      $cnt2=sqlvalue("SELECT COUNT(*) FROM $seance_table WHERE cid = ".$CID." AND bal IS NOT NULL");
      return $cnt1+$cnt2;
   }

        function toMail($mid)
        {        GLOBAL $peopletable;



                                if($mid=="") return 0;
                                //bragin
                    $sql="SELECT mid FROM $peopletable WHERE MID=".$mid." AND reg=0;";

                $res=sqldb_query($sql);
                if($res && num_rows($res))
                {
					pr($s);
                //              header("Location: mail.php?");
                          exit();
                }
                return 0;
        }

        function redirect_toMail($mid)
        {
                return 0;
        }

//getImageSubpath
function show_submit($lang, $fun)
{
         echo show_submit_r($lang, $fun);
         return;
/*
         $phrase = "<span color=RED>You can't create on this language. Please switch to ENG mode !</span>";

         global $sitepath;
         if($lang=='e')
         {

          if ($fun!='0')
              $cl = 'onClick="'.$fun.'"';
          else
              $cl='';

 ?><input type="image" onMouseOver="this.src='<?php echo $sitepath?>images/send_.gif';" onMouseOut="this.src='<?php echo $sitepath?>images/send.gif';" src="<?php echo $sitepath?>images/send.gif" align="right" alt="ok" border=0  ".$cl.">
 <?php 
 }else{
       echo "$phrase <img src =\"".$sitepath."images/send.gif\" align=\"right\" alt=\"ok\" border=0>";
 }
*/
}

function show_submit_r($lang, $fun)
{
    global $sitepath;

    $phrase = "<span style='color:RED'>You can't create on this language. Please switch to ENG mode !</span>";

    if($lang=='e')
    {
         if ($fun!='0')
                $cl = 'onClick="'.$fun.'"';
         else
                $cl='';

         $all = okbutton("", $cl, "");//"<input type=\"image\" onMouseOver=\"this.src='".$sitepath."images/send_.gif';\" onMouseOut=\"this.src='".$sitepath."images/send.gif';\" src=\"".$sitepath."images/send.gif\" align=\"right\" alt==\"ok\" border=0 ".$cl.">";
    }
    else
         $all =  $phrase." ".okbutton_disabled("");//"$phrase <img src =\"".$sitepath."images/send.gif\" align=\"right\" alt=\"ok\" border=0>";

    return $all;
}

function print_years($from, $year_sel, $year_add, $pr=true)
{
    $today = getdate();
    $year = $today['year'];

    $i=$from;
        $out = "";
    do
    {       $out .= "<option ";
            if($year_sel==$i) $out .= " selected ";
            $out .= " value=".$i.">".$i;
            $i++;
    } while($i<($year+$year_add));

        if($pr)
                echo $out;

        return $out;
}

function print_months($mon_sel, $pr=true)
{
    global $MONTHES;

    $out = "";

    for($i=0;$i<12;$i++)
    {
            $out .= "<option ";
            if($mon_sel==($i+1)) $out .= " selected ";
            $out .= " value=".($i+1).">".$MONTHES[$i];
    }

        if($pr)
                echo $out;

        return $out;
}




function UnlinkFolder($object, $object_id)
{
   GLOBAL $CCOURSES;
   global $target_table, $lesson_table, $mod_list_table;
        if($object=="lesson")
        {
                $res = sqldb_query("SELECT lesson_target FROM $lesson_table WHERE LID='$object_id'");
                if(!$res || !($row = fetch_array($res))) return;

                $targetIDs = explode(";",$row[0]);

                foreach($targetIDs as $targetID)
                        UnlinkFolder("target", $targetID);

                return; // !
        }

        if($object=="target")
        {
                $res = sqldb_query("SELECT LID FROM $target_table WHERE TID='$object_id'");

                if(!$res || !($row = fetch_array($res))) return;

                $res = sqldb_query("SELECT MID, CID FROM $lesson_table WHERE LID='$row[0]'");
                if(!$res || !($row = fetch_array($res))) return;

                $path = "$CCOURSES/course".$row[1]."/mods/".$row[0]."/target_".$object_id;
        }

        if($object=="module")
        {
                $res = sqldb_query("SELECT CID FROM $mod_list_table WHERE ModID='$object_id'");
                if(!$res || !($row = fetch_array($res))) return;

                $path = "$CCOURSES/course".$row[0]."/mods/".$object_id;
        }

        if(!isset($path) || $path=="")
                return;

        if(!is_dir($path))
        $path = "../".$path;

        if(is_dir($path))
    {   empty_dir($path);
                rmdir($path);
        }
}


//////////////////////////////////////
// FILES functions


function GetExt($filePathName)      //      
{
   $pos = strrpos($filePathName, ".");
   if($pos===false) return "";

   return substr($filePathName, $pos);
}
function GetFilePathName($kod, $fnum, $fname)
{    global $CCOURSES;
     return "$CCOURSES/FILES/".$kod."_".$fnum.GetExt($fname);
}

function GetAttachFileName($kod, $fnum)
{
     global $file_table;

     $sql_select = "SELECT fname FROM $file_table WHERE kod='".addslashes($kod)."' AND fnum='".addslashes($fnum)."'";

     $res = sqldb_query($sql_select);

     if (num_rows($res)<=0) return false;

     $row = fetch_array($res);
     $fname = $row[0];
     sqlfree($res);

     return $fname;
}

function GetAttachFileSize($kod, $fnum, &$fx, &$fy)
{
     global $file_table;

     $sql_select = "SELECT fx, fy FROM $file_table WHERE kod='".addslashes($kod)."' AND fnum='".addslashes($fnum)."'";
     $res = sqldb_query($sql_select);
     if (num_rows($res)<=0) return false;
     $row = fetch_array($res);
     $fx = $row[0];
     $fy = $row[1];
     sqlfree($res);

     return $fx!=-1 && $fy!=-1 ;
}

function GetAttachFilePathName($kod, $fnum)
{    global $CCOURSES;
     if($fname = GetAttachFileName($kod, $fnum))
     return "$CCOURSES/FILES/".$kod."_".$fnum.GetExt($fname);

     return "";
}

function DeleteAttach($kod, $fnum)
{    global $file_table;

     if(!($fname = GetAttachFileName($kod, $fnum))) return false;

     $res=sqldb_query("DELETE FROM $file_table WHERE kod='".addslashes($kod)."' AND fnum='".addslashes($fnum)."'");
     sqlfree($res);

     unlink(GetFilePathName($kod, $fnum, $fname));

     return true;
}

//  ID   
function getDeanID()
{
        global $deans_table;
        return GetField($deans_table, "MID", "", "", "", "ORDER BY MID DESC");
}

//   
function getCourseOwner($cid)
{
        global $coursestable;
        $address[0] = 0;
        $address[1] = false;
        $owner = getField($coursestable, "createby", "CID", $cid);
        if (intval($owner) != -1) {
                if (preg_match("/^\w+([\.\w]+)*\w@\w((\.\w)*\w+)*\.\w{2,3}$/", $owner)) {
                        $address[1] = true;
                }
                $address[0] = $owner;
        }
        return $address;
}


function getFrameHeader()
{
        GLOBAL $sitepath;
return '
                  <HTML>
                  <head>
                  <META content="text/html; charset=windows-1251" http-equiv="Content-Type">
                  <TITLE>  </TITLE>
                  <script language="Javascript" type="text/javascript">
                  <!--
                      if(navigator.appName.indexOf("Netscape") != -1){
                        alert(" IE  5.0   !");
                        close();
                          }
                      if (navigator.userAgent.indexOf("Opera") != -1){
                        alert(" IE  5.0   !");
                        close();
                      }
                  // -->
                  </script>
                  <SCRIPT src="'.$sitepath.'js/FormCheck.js" language="JScript" type="text/javascript"></script>
                  <SCRIPT src="'.$sitepath.'js/img.js" language="JScript" type="text/javascript"></script>
                  <SCRIPT src="'.$sitepath.'js/hide.js" language="JScript" type="text/javascript"></script>
                  <title>Distance Learning Studio</title>
                  <link rel="stylesheet" href="'.$sitepath.'styles/style'.STYLE_CSS().'.css" type="text/css">
                  <link rel="stylesheet" href="'.$sitepath.'styles/style'.STYLE_CSS_EXT().'.css" type="text/css">
                  </head>
                  <BODY  class=cPageBG leftmargin=10 rightmargin=10 marginwidth=0 topmargin=10 marginheight=0>
        ';
}
//////////////////////////////////////


function show_login_form ()
{        GLOBAL $peopletable;
        $num_of_people = num_rows(sqldb_query("SELECT COUNT(*) FROM $peopletable")) > 0;
}

function insert_reg_form ($message) {        // inserts user registration/import form
        if (WEB_CD) {
                return str_replace('[MESSAGE]', $message, str_replace('[SEND_BUTTON]', okbutton(), loadtmpl("index-impreg.html")));
        } else {
                return '';
        }
}

function insert_reg_data ()
{                        // get reg data from uploaded file, insert into DB
        GLOBAL $peopletable;
        global $studentstable,$testcount;

        if (is_uploaded_file($_FILES['impreg']['tmp_name'])) {
                $content = preg_split('/[\n\r]+/', decrypt(base64_decode(file_get_contents($_FILES['impreg']['tmp_name']))));
                foreach ($content as $line) {
                        if (!preg_match("/^\s*#/", $line)) {
                                list($k, $v) = split('=', $line, 2);
                                $reg_data[trim(strtolower($k))] = trim(preg_replace("/^\s*\"(.+)\"\s*$/", "\\1", $v));
                        }
                }
                if (isset($reg_data['login']) && isset($reg_data['mid']) && isset($reg_data['password']) && isset($reg_data['category']) && isset($reg_data['courses'])) {
                        $course_list = split(',', $reg_data['courses']);
                        $sql = "DELETE FROM $peopletable WHERE MID = " . $reg_data['mid'];
                        @sqldb_query($sql);
                        $sql = "DELETE FROM $studentstable WHERE MID = " . $reg_data['mid'];
                        @sqldb_query($sql);
                        $sql = "INSERT INTO $peopletable (MID, LastName, FirstName, Password, Login, RegisterDate, Category, reg) VALUES (" . $reg_data['mid'] . ", '" . (isset($reg_data['lastname']) ? $reg_data['lastname'] : '') . "', '" . (isset($reg_data['firstname']) ? $reg_data['firstname'] : '') . "', MD5('" . $reg_data['password'] . "'), '" . $reg_data['login'] . "', NOW(), '" . $reg_data['category'] . "', 1)";
                        if (!$r = @sqldb_query($sql)) {
                                die ("INSERT INTO $peopletable FAILED: " . $sql);
                        }
                        $mid = $reg_data['mid'];
                        foreach ($course_list as $cid) {
							
                                $sql = "INSERT INTO $studentstable (MID, CID, Registered) VALUES (" . $mid . ", " . $cid . ", 1)";
                                if (!$r = @sqldb_query($sql)) {
                                        die ("INSERT INTO $studentstable FAILED: " . $sql);
                                }
								else
							{
sqldb_query("DELETE FROM $testcount WHERE mid=".$mid." and cid = ".$cid."  ");
							}
                        }
                        return ": " . $reg_data['login'] . "\n<br>: " . $reg_data['password'] . "\n<br>";
                } else {
                        return('    ');
                }
        } else {
                return('  ');
        }
}

function action_log($mid,$action_type,$role,$success=1)
{
        global $action_log_table;
        if (!$mid)$mid=0; //bragin
        if (!$role)$role=0; //bragin
        if (!$success)$success=0;//bragin

        sqldb_query("INSERT INTO ".$action_log_table."(MID,action_type, data, role, success) VALUES($mid,'$action_type',NOW(),$role,$success)");
}

function mid_log()
{
        global $s, $PHP_SELF, $_SERVER, $studentstable, $admins_table, $action_log_table, $mid_log, $deans_table, $teacherstable;

        $page =  substr($_SERVER['PHP_SELF'],strrpos($_SERVER['PHP_SELF'],'/')+1);

 switch($page){

         case "index.php":
                 $pg=1;
         break;
         case "schedule.php":
                 $pg=2;
         break;
         case "ved.php":
                 $pg=3;
         break;
         case "treeview2.php":
                 $pg=4;
         break;
         case "show_album.php":
                 $pg=4;
         break;
         case "test_vopros.php":
                 $pg=5;
         break;
         case "mail.php":
                 $pg=6;
         break;
         case "manage_course.php":
                 $pg=7;
         break;
         case "forum.php":
                 $pg=8;
         break;
         default:
                 $pg='';
                 break;


 }



 if($pg!='' && isset($s['mid'])){

         $sql="SELECT SID FROM $studentstable WHERE MID='".$s['mid']."'";

      $result=sqldb_query($sql);
      $perm=0;
      if (num_rows($result)>0) $perm = 1;

      $sql="SELECT PID FROM $teacherstable  WHERE MID='".$s['mid']."'";

      $result=sqldb_query($sql);

      if (num_rows($result)>0) $perm=2;

      $sql="SELECT DID FROM $deans_table WHERE MID='".$s['mid']."'";

      $result=sqldb_query($sql);

      if (num_rows($result)==1) $perm=3;


      $sql="SELECT AID FROM $admins_table WHERE MID='".$s['mid']."'";

      $result=sqldb_query($sql);

      if (num_rows($result)==1) $perm=4;

 if(isset($s['mid']) && $s['mid']!=''){
         global $mid_log;
 $res = sqldb_query("select mid from $mid_log where mid=".$s['mid']);
 if(num_rows($res)<1)
          $sql = "INSERT INTO ".$mid_log."(mid,page,role,data) VALUES('".$s['mid']."','".$pg."',".$perm.",NOW())";
 else
          $sql = "UPDATE ".$mid_log." SET page='".$pg."',role=".$perm.",data=NOW() where mid=".$s['mid'];
     

// echo "INSERT INTO $mid_log VALUES('".$s['mid']."','".$pg."',".$s['perm'].",NOW())";
 sqldb_query($sql);
 }
 }
}


function GetStudCourses($mid){
        global $studentstable;
        $res = sqldb_query("select cid from $studentstable where MID='$mid'");
        while($row=fetch_assoc($res)) $arr[]=$row['cid'];

        return $arr;
}
function GetTeachCourses($mid){
        //bragin
        $res = sqldb_query("select cid from teachers where MID='$mid'");
        while($row=fetch_assoc($res)) $arr[]=$row['cid'];

        return $arr;
}

function check_logon($mid)
{
        GLOBAL $peopletable, $action_log_table;
        if(CHECK_LOGON==0)
                return true;
//bragin
        $res = sqldb_query("select last from $peopletable where MID='".$mid."'");
        $row=fetch_assoc($res);
        $last=$row['last'];
        $mins=round((time()-$last)/60);
        if($mins<=5){
                $res = fetch_assoc(sqldb_query("select UNIX_TIMESTAMP(data) as date1,action_type from ".$action_log_table." where mid='$mid' ORDER BY data DESC"));
                //var_dump($res['date1']-$last);
                $cnt = num_rows(sqldb_query("select UNIX_TIMESTAMP(data) as date1 from ".$action_log_table." where mid='$mid' and action_type='logoff' ORDER BY data DESC"));

                if($cnt<1)
                 return true;


                if($res['action_type']=='logoff' && ($res['date1']>(time()-300)))        {
                return true;
                }else{
                        return false;
                }
        }
        else return true;
}

function user_fio($mid)
{
        GLOBAL $peopletable;
        $sql="SELECT FirstName, LastName, Email FROM $peopletable WHERE MID='".$mid."'";

        if (!$result=sqldb_query($sql)) return 0;
        if (num_rows($result)<1) return 0;
        $row=fetch_assoc($result);

        return $row;
}

?>