jsCore.ui={
	ready: false,
	calledButton: '',
	popups: new Array(),
	dialogs: new Array(),
	p_names: new Array(),
	d_names: new Array(),
	activated: null,
	tabsData: new Array(),
	add: function(w,o,n){
		var win='';
		var win_name='';
		switch(w){
			case 'popup':
				win='popups';
				win_name='p_names';
				break;
			case 'dialog':
				win='dialogs';
				win_name='d_names';
				break;
		}
		if(win.length>0&&win_name.length>0){
			switch(typeof o){
				case 'function':
					jsCore.ui[win].push(o.call());
					break;
				case 'object':
					jsCore.ui[win].push(o);
					break;
			}
			jsCore.dom.set.style(jsCore.ui[win][jsCore.ui[win].length-1],'display','none');
			jsCore.ui[win_name].push(n);
		}
	},
	preload: function(){
		jsCore.dom.set.item.add(
			jsCore.dom.get.body(),
			new jsCore.element({
				id: 'glassPopups',
				style: {
					display: 'none',
					width: jsCore.dom.get.availWidth.call()+'px',
					height: jsCore.dom.get.availHeight.call()+'px',
					position:'absolute',
					zIndex:'5000',
					top:'0px',
					left:'0px'
				},
				items: [
					new jsCore.image({
						id: 'imgGlassPopups',
						style: {
							width: jsCore.dom.get.availWidth.call()+'px',
							height: jsCore.dom.get.availHeight.call()+'px',
							filter: 'alpha(opacity=0)'
						},
						on: {
							click: function(){
								jsCore.func.recoverState();
							}
						}
					})
				]
			})
		);
		for(var ui in jsCore.ui.popups)
			jsCore.dom.set.item.add($('glassPopups'),jsCore.ui.popups[ui]);
		jsCore.dom.set.item.add(
			jsCore.dom.get.body(),
			new jsCore.element({
				id: 'glassDialogs',
				style: {
					display: 'none',
					width: jsCore.dom.get.availWidth.call()+'px',
					height: jsCore.dom.get.availHeight.call()+'px',
					position:'absolute',
					zIndex:'5000',
					top:'0px',
					left:'0px'
				},
				items: [
					new jsCore.image({
						id: 'imgGlassDialogs',
						style: {
							width: jsCore.dom.get.availWidth.call()+'px',
							height: jsCore.dom.get.availHeight.call()+'px',
							filter: 'alpha(opacity=0)'
						}
					})
				]
			})
		);
		for(var ui in jsCore.ui.dialogs)
			jsCore.dom.set.item.add($('glassDialogs'),jsCore.ui.dialogs[ui]);
		jsCore.ui.ready=true;
	},
	showPopup: function(n){
		var c=jsCore.ui.calledButton;
		var o=jsCore.ui.popups[inarray(n,jsCore.ui.p_names)];
		if(o){
			with(jsCore.func){
				setState(c,jsCore.storage.tbActiveItems);
				activateButton(c);
				showElem(o);
				showElem($('glassPopups'));
			}
			jsCore.ui.activated=o;
		}
	},
	showDialog: function(n){
		var c=jsCore.ui.calledButton;
		var o=jsCore.ui.dialogs[inarray(n,jsCore.ui.d_names)];
		if(o){
			with(jsCore.func){
				setState(c,jsCore.storage.tbActiveItems);
				activateButton(c);
				showElem(o);
				showElem($('glassDialogs'));
			}
			jsCore.ui.activated=o;
		}
	},
	renderDD: function(n){
		var c=$(jsCore.ui.calledButton);
		var o=jsCore.ui.popups[inarray(n,jsCore.ui.p_names)];
		if(o){
			with(jsCore.dom.set){
				x(o,jsCore.dom.get.x(c));
				y(o,jsCore.dom.get.y(c)+21);
			}
		}
	},
	renderDialog: function(n){
		var o=jsCore.ui.dialogs[inarray(n,jsCore.ui.d_names)];
		if(o){
			with(jsCore.dom.set){
				x(o,parseInt((jsCore.dom.get.availWidth()-jsCore.dom.get.width(o))/2));
				y(o,parseInt((jsCore.dom.get.availHeight()-jsCore.dom.get.height(o))/2));
			}
		}
	},
	makeDialog: function(o,h){
		return new jsCore.table({
			cls: 'popup',
			attributes: {
				cellPadding: '0',
				cellSpacing: '0'
			},
			rows: [
				{
					cells: [
						{
							cls: 'nw'
						},
						{
							cls: 'top',
							items: [
								new jsCore.table({
									cls: 'header_modal',
									attributes: {
										cellPadding: '0',
										cellSpacing: '0'
									},
									rows: [
										{
											cells: [
												{
													text: '<b>'+h+'</b>'
												},
												{
													attributes: {
														align: 'left',
														vAlign: 'top'
													},
													style: {
														width: '40px',
														height: '26px',
														cursor: 'pointer',
														background: 'transparent url("'+jsCore.imgURL+'buttons/close_dialog.png") 0px 0px no-repeat'

													},
													items: [
														new jsCore.image({
															style: {
																width: '40px',
																height: '14px',
																filter: 'alpha(opacity=0)'
															},
															on: {
																click: function(){
																	jsCore.func.recoverState();
																},
																mouseover: function(){
																	var self=null;
																	if(jsCore.browser.isIE)
																		self=arguments[0].srcElement.parentNode;
																	else
																		self=this.parentNode;
																	jsCore.dom.set.style(self,'backgroundPosition','-40px 0px');
																},
																mouseout: function(){
																	var self=null;
																	if(jsCore.browser.isIE)
																		self=arguments[0].srcElement.parentNode;
																	else
																		self=this.parentNode;
																	jsCore.dom.set.style(self,'backgroundPosition','0px 0px');
																}
															}
														})
													]
												}
											]
										}
									]
								})
							]
						},
						{
							cls: 'ne'
						}
					]
				},
				{
					cells: [
						{
							cls: 'west'
						},
						{
							id: 'popupMain',
							cls: 'popupMain',
							attributes: {
								vAlign: 'top'
							},
							items: [o]
						},
						{
							cls: 'east'
						}
					]
				},
				{
					cells: [
						{
							cls: 'sw'
						},
						{
							cls: 'bottom'
						},
						{
							cls: 'se'
						}
					]
				}
			]
		});
	},
	makeDDContainer: function(o){
		return new jsCore.element({
			id: 'ddMenu',
			cls: 'ddPanel',
			items: [o]
		});
	},
	createTab: function(i,c,h){
		return new jsCore.element({
			tag: 'div',
			style: {
				cssFloat: 'left',
				margin: '0px',
				padding: '0px'
			},
			items: [
				new jsCore.table({
					id: i,
					cls: c,
					attributes: {
						cellPadding: '0',
						cellSpacing: '0'
					},
					rows: [
						{
							cells: [
								{
									cls: 'left'
								},
								{
									cls: 'header',
									text: h
								},
								{
									cls: 'right'
								}
							]
						}
					]
				})
			],
			on: {
				click: function(){
					var but=null;
					var self=null;
					if(jsCore.browser.isIE)
						but=arguments[0].srcElement;
					else
						but=this.childNodes[0];
					while(but)
						if(but.getCls().indexOf('tab_panel')==-1){
							but=but.parentNode;
							if(but.tagName.toLowerCase()==='tbody')
								but=but.parentNode;
						}else
							break;
					self=but;
					var cls=self.getCls();
					if(cls==='tab_panel_active'||cls==='tab_panel_disabled'){
						jsCore.func.empty;
					}else{
						var tp=$('tabs_container');
						for(var a=0;a<tp.childNodes.length;a++){
							var tab=tp.childNodes[a].childNodes[0];
							cls=jsCore.dom.get.cls(tab);
							if(cls==='tab_panel_disabled'){
							}else if(tab==self){
								jsCore.dom.set.cls.replace(tab,cls,'tab_panel_active');
								jsCore.dom.set.style(jsCore.ui.tabsData[a],'display','block');
							}else{
								jsCore.dom.set.cls.replace(tab,cls,'tab_panel');
								jsCore.dom.set.style(jsCore.ui.tabsData[a],'display','none');
							}
						}
					}
				}
			}
		});
	},
	makeTabContainer: function(i){
		var tabs=new Array();
		if(i.length>0){
			var cls='';
			for(var a=0;a<i.length;a++){
				var self=i[a];
/**
 * @TODO:  
 */
				jsCore.ui.tabsData[a]=self.items[0];
				cls='tab_panel';
				switch(self.active){
					case 0:
						jsCore.dom.set.style(jsCore.ui.tabsData[a],'display','none');
						break;
					case 1:
						cls+='_active';
						jsCore.dom.set.style(jsCore.ui.tabsData[a],'display','block');
						break;
					case 2:
						cls+='_disabled';
						jsCore.dom.set.style(jsCore.ui.tabsData[a],'display','none');
						break;
				}
				tabs[a]=jsCore.ui.createTab(self.id||'tab'+a,cls,self.header);
			}
			return new jsCore.table({
				cls: 'tabarea',
				attributes: {
					cellPadding: '0',
					cellSpacing: '0'
				},
				style: {
					width: '500px'
				},
				rows: [
					{
						cells: [
							{
								id: 'tabarea_tabs',
								cls: 'panels',
								items: [
									new jsCore.element({
										id: 'tabs_container',
										items: tabs
									})
								]
							}
						]
					},
					{
						cells: [
							{
								cls: 'center'
							}
						]
					},
					{
						cells: [
							{
								id: 'tabarea_main',
								cls: 'mainarea',
								items: jsCore.ui.tabsData
							}
						]
					}
				]
			});
		}else{
			return false;
		}
	}
};