<?php
define('WRITING_LOG_FILES',true);
$root_path=$_SERVER["DOCUMENT_ROOT"];
if(substr($root_path,-1)==='/')
	$root_path=substr($root_path,0,-1);
$images_folder='MEDIA';
/**
 * DEBUG
 */
if(WRITING_LOG_FILES){
	$rootdir=dirname(__FILE__);
	$general_log=$rootdir.'/general_log.html';
	$save_log=$rootdir.'/save_log.html';
	$upload_log=$rootdir.'/upload_log.html';
	$fhgl = fopen($general_log, 'w');
	$fhsl = fopen($save_log, 'w');
	$fhul = fopen($upload_log, 'w');
	$log_data=date("Y-m-d h:i:s")."<br />\nPOST:<br />\n";
	foreach($_POST as $key=>$val){
		$log_data.=$key.' => '.$val."<br />\n";
	}
	$log_data.="GET:<br />\n";
	foreach($_GET as $key=>$val){
		$log_data.=$key.' => '.$val."<br />\n";
	}
	$log_data.="FILES:<br />\n";
	foreach($_FILES as $dk=>$data){
		$log_data.="==[$dk]==:<br />\n";
		foreach($data as $key=>$val){
			$log_data.=$key.' => '.$val."<br />\n";
		}
	}
	fwrite($fhgl,$log_data);
	fwrite($fhsl,$log_data);
	fwrite($fhul,$log_data);
}
/**
 * DEBUG
 */

/**
 *   
 * @param <string> $str
 * @return <string>    
 */
function inTranslit($str=''){
	$str=trim($str);
	if(!empty($str)){
		$r1_symb=array(
			'','','','','','','','','','',
			'','','','','','','','','','',
			'','','','','','','','','','',
			'','','',' ','`','"',"'"
		);
		$r2_symb=array(
			'','','','','','','','','','',
			'','','','','','','','','','',
			'','','','','','','','','','',
			'','','',' ','`','"',"'"
		);
		$translit=array(
			'a','b','w','g','d','e','jo','zh','z','i',
			'j','k','l','m','n','o','p','r','s','t',
			'u','f','h','ts','ch','sh','tsch','_','y','_',
			'e','u','ya','_','_','_','_'
		);
		return str_replace($r1_symb,$translit,str_replace($r2_symb,$translit,$str));
	}
}

function check_symb($s=''){
	if(strlen($s)>0){
		$n=(int)$s;
		if(($n>1039 && $n<1104) || ($n==1025) || ($n==1105)){
			return html_entity_decode('&#'.$n.';', ENT_NOQUOTES, 'UTF-8');
		}else{
			return '&#'.$s.';';
		}
	}else
		return '';
}

/**
 *   POST 
 *          
 * @param <string> $string     utf-8
 * @return <string>   
 */
function charset_decode_utf_8($string=''){
	if(strlen($string)==0)
		return '';
// Only do the slow convert if there are 8-bit characters
// avoid using 0xA0 (\240) in ereg ranges. RH73 does not like that
	if (!ereg("[\200-\237]",$string) and !ereg("[\241-\377]",$string))
		return $string;
// decode three byte unicode characters
	$string=preg_replace("/([\340-\357])([\200-\277])([\200-\277])/e",
		"check_symb((ord('\\1')-224)*4096 + (ord('\\2')-128)*64 + (ord('\\3')-128))",
		$string);
// decode two byte unicode characters
	$string=preg_replace("/([\300-\337])([\200-\277])/e",
		"check_symb((ord('\\1')-192)*64+(ord('\\2')-128))",
		$string);
	return $string;
}

/**
 *  
 */
$output='';
if(count($_GET)>0){
	foreach($_GET as $k=>$v){
		switch($k){
/**
 *   
 */
			case 'newdoc':
				if((int)$_GET['newdoc']==1){
					$arr=array();
					$base_root=trim($_GET['base_root']);
					if($dh=opendir($base_root)){
						while(($file=readdir($dh))!==false){
							if($file=='.' || $file=='..' || is_dir($base_root.'/'.$file)){
								continue;
							}else{
								$fdata=pathinfo($file);
								$arr[]=(int)str_replace('.'.$dfile['extension'],'',$file);
							}
						}
						closedir($dh);
					}
					$newname=str_pad(max($arr)+1,2,"0",STR_PAD_LEFT).'.html';
					$content='<html>
<head>
<title></title>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1251" />
</head>
<body>
   
</body>
</html>';
					if($hndl=fopen($base_root.'/'.$newname,'w')){
						if(fwrite($hndl,$content)===FALSE){
							//Any errs signals
						}
						fclose($hndl);
					}
					$output=json_encode($newname);
					header('Content-Type: text/newpage; charset=windows-1251');
				}
				break;
/**
 *   
 */
			case 'getdoc':
				if(strlen($_GET['getdoc'])>0 && strlen($_GET['base_root'])>0 && file_exists($_GET['base_root'].'/'.$_GET['getdoc'])){
					$content=file($_GET['base_root'].'/'.$_GET['getdoc']);
					if(count($content)>0)
						foreach($content as $str)
//							$output.=str_replace($images_folder.'/',str_replace($root_path,'',$_GET['base_root']).'/'.$images_folder.'/',$str);
							$output.=str_replace($images_folder.'/',str_replace($root_path,'http://'.$_SERVER["HTTP_HOST"],$_GET['base_root']).'/'.$images_folder.'/',$str);
					header('Content-Type: text/html; charset=windows-1251');
				}
				break;
/**
 *   
 */
			case 'gfc':
				if(strlen($_GET['gfc'])>0){
					$base_root=trim($_GET['base_root']);
					$root=trim($_GET['root']);
					$gfc=trim($_GET['gfc']);
					if(!file_exists($base_root.'/'.$images_folder))
						@mkdir($base_root.'/'.$images_folder);
					if($gfc==='root'){
						$path=$base_root.'/'.$images_folder;
					}elseif($gfc==='..'){
						if((strlen($_GET['root'])>0) and ($_GET['root']!=='file')){
							$path=dirname($base_root.'/'.$root);
						}else{
							$path=$base_root.'/'.$images_folder;
						}
					}else{
						if((strlen($_GET['root'])>0) and ($_GET['root']!=='file')){
							$path=$base_root.'/'.$root.'/'.$gfc;
						}else{
							$path=$base_root.'/'.$gfc;
						}
					}
					$root_name=(strtoupper(basename($path))===$images_folder ? '' : str_replace($base_root.'/','',$path));
					$folders=array();
					$files=array();
					$a=0;
					$b=0;
					if($hndl=opendir($path)){
						if(WRITING_LOG_FILES){
							fwrite($fhgl,'directory content:'."<br />\n");
						}
						while(($file=readdir($hndl))!==false){
							if(WRITING_LOG_FILES){
								fwrite($fhgl,$file."<br />\n");
							}
							if($file=='.'){
								continue;
							}else if($file=='..'){
								if((($_GET['gfc']=='..') and (strtoupper(basename($path))===$images_folder)) or ($_GET['gfc']=='root')){
									continue;
								}else{
									$folders[$a]='..';
									$a++;
								}
							}else{
								if(is_dir($path.'/'.$file)){
									$folders[$a]=$file;
									$a++;
								}else{
									$datafile=pathinfo($file);
									if(eregi("(gif|png|jpg|jpeg|bmp)",$datafile['extension'])){
										$files[$b]=$file;
										$b++;
									}
								}
							}
						}
						closedir($hndl);
						$content=array();
						$a=0;
						if(count($folders)>0){
							asort($folders);
							foreach($folders as $file){
								if($file=='..'){
									$content[$a]=array('value'=>$root_name,'text'=>$file);
								}else{
									$content[$a]=array('value'=>'folder','text'=>$file);
								}
								$a++;
							}
						}
						if(count($files)>0){
							asort($files);
							foreach($files as $file){
								$content[$a]=array('value'=>'file','text'=>$file);
								$a++;
							}
						}
					}
					$output=json_encode($content);
					header('Content-Type: text/json; charset=windows-1251');
				}
				break;
/**
 *   
 */
			case 'getdoclist':
				if((int)$_GET['getdoclist']==1 && strlen($_GET['base_root'])>0){
					$base_root=trim($_GET['base_root']);
					$files=array();
					if($hndl=opendir($base_root)){
						while(($file=readdir($hndl))!==false){
							if($file=='.' || $file=='..' || is_dir($base_root.'/'.$file)){
								continue;
							}else{
								$datafile=pathinfo($file);
								if(eregi("(html|htm)",$datafile['extension'])){
									$files[]=$file;
								}
							}
						}
						closedir($hndl);
					}
					$a=0;
					if(count($files)>0){
						asort($files);
						foreach($files as $file){
							$content[$a]=array('value'=>'file','text'=>$file);
							$a++;
						}
					}
					$output=json_encode($content);
					header('Content-Type: text/json; charset=windows-1251');
				}
				break;
		}
	}
}
/**
 *  
 */
if(count($_POST)>0){
	foreach($_POST as $k=>$v){
		switch($k){
/**
 *   
 */
			case 'indir':
				if((strlen($_POST['indir'])>0) and (count($_FILES)>0)){
					list($handle,$type,$a)=split('/',$_FILES['imgfile']['type']);
					if(($_FILES['imgfile']['error']==0) and ($handle==="image")){
						$base_root=str_replace("\\",'/',dirname(__FILE__));
						if(!file_exists($base_root.'/'.$images_folder))
							@mkdir($base_root.'/'.$images_folder);
						if(WRITING_LOG_FILES){
							fwrite($fhul,'move uploaded file: '.$_FILES['imgfile']['tmp_name'].' => '.trim($_POST['indir']).'/'.inTranslit($_FILES['imgfile']['name'])."<br />\n");
						}
						$res=move_uploaded_file($_FILES['imgfile']['tmp_name'],trim($_POST['indir']).'/'.inTranslit($_FILES['imgfile']['name']));
						if(WRITING_LOG_FILES){
							fwrite($fhul,'result: "'.$res.'"');
						}
					}
				}
				break;
/**
 *   
 */
			case 'savedoc':
				if(strlen($_POST['base_root'])>0){
					$base_root=urldecode($_POST['base_root']);
					$base_url=urldecode($_POST['base_url']);
					$path=urldecode($_POST['path']).'/';
					$editfile=$base_root.$path.urldecode($v);
					$content=iconv('UTF-8','CP1251',stripslashes(charset_decode_utf_8($_POST['cont'])));
					$content=str_replace($base_url.$path,'',$content);
					if(WRITING_LOG_FILES){
//						fwrite($fhsl,"<br />\n=========================\n".iconv('UTF-8','CP1251',stripslashes(charset_decode_utf_8($_POST['cont'])))."\n=========================<br />\n<br />\n");
						fwrite($fhsl,"<br />\n".'path to file: '.$editfile."<br />\n");
					}
					if($hndl=fopen($editfile,'w')){
						if(($err=fwrite($hndl,$content))===FALSE){
							//Any errs signals
							if(WRITING_LOG_FILES){
								fwrite($fhsl,"<br />\n".'<b>ERROR ON WRITTING FILE</b>: '.$err."<br />\n".'editfile: '.$editfile."<br />\n");
							}
						}else{
							if(WRITING_LOG_FILES){
								fwrite($fhsl,"<br />\n".'All right to writing! => "'.$err.'"'."<br />\n".'editfile: '.$editfile."<br />\n");
							}
						}
						fclose($hndl);
					}
					if(WRITING_LOG_FILES){
						fwrite($fhsl,"<br />\n".'<b>$path</b>:'.$path."<br />\n".'<b>$content</b>: '.$content."<br />\n");
					}
					header('Content-Type: text/empty; charset=windows-1251');
				}
				break;
		}
	}
}
if(strlen($output)>0)
	echo $output;

if(WRITING_LOG_FILES){
	fclose($fhgl);
	fclose($fhsl);
	fclose($fhul);
}
?>
