<?php 

include("../1.php");
include("access.php");


if(!WEB_CD)//$ldap
{
	// include LDAP class
	include_once("ldap.php");
}


global $ldap;

//print $ldap;

$template['info'] = '
<span class="shedtitle">     LDAP .</span>
<p><span>*</span>  ,     LDAP ,     config.ini</p><br />

<!-- 
   Ldap information table
//-->
<form name="main" method="post">
<table cellpadding="3" cellspacing="0" border="0" >
<tr>
 <td > LDAP :</td>
 <td >{ldap_admin}</td>
</tr>
<tr>
 <td >LDAP URI  </td>
 <td >{ldap_url}</td>
</tr>
<tr>
 <td >LDAP Domain ():</td>
 <td >{ldap_domain}</td>
</tr
<tr>
 <td >LDAP DN ( ):</td>
 <td >{ldap_dn}</td>
</tr>
<tr>
 <td >LDAP    </td>
 <td >{ldap_import_fields}</td>
</tr>
</table>

<br />

<input type="submit" name="import" value="   LDAP">
<input type="submit" name="export" value="    LDAP">
<p>&nbsp;</p>
{connStatus}
</form>


';

$template['connStatus']  = "<p> <span>:</span> <b>{connRes}</b></p>";

// import templates
$template['importTable']     = '
  <hr width="90%" /> 
  <p align="center" ><span class="shedtitle">{resStatus}</span></p>
  <table align="center" class="brdr" width="70%" cellpadding="3" cellspaing="0">{importContentRows}</table>';
$template['importTableRow']  = '<tr>{importContentColumns}</tr>';
$template['importRowColumn'] = '<td>&nbsp;{importContent}</td>';
$template['importHeadRowColumn'] = '<th>{importContent}</th>';

$template['end'] = "</body></html>";


# insert function
function insert($pattern, $needle, $content) {
    return preg_replace("/\{$pattern\}/", $needle, $content);
}

function Encode ( $str, $type )
{
 // $type:
// 'w' - encodes from UTF to win
 // 'u' - encodes from win to UTF

   static $conv='';
   if (!is_array ( $conv ))
   {   
       $conv=array ();
       for ( $x=128; $x <=143; $x++ )
       {
         $conv['utf'][]=chr(209).chr($x);
         $conv['win'][]=chr($x+112);
       }

       for ( $x=144; $x <=191; $x++ )
       {
               $conv['utf'][]=chr(208).chr($x);
               $conv['win'][]=chr($x+48);
       }
 
       $conv['utf'][]=chr(208).chr(129);
       $conv['win'][]=chr(168);
       $conv['utf'][]=chr(209).chr(145);
       $conv['win'][]=chr(184);
     }
     if ( $type=='w' )
         return str_replace ( $conv['utf'], $conv['win'], $str );
     elseif ( $type=='u' )
         return str_replace ( $conv['win'], $conv['utf'], $str );
     else
       return $str;
 }

// draw main content
$resContent   = $template['info'];
$templateInfo = $ldap->info();

// if testing connection to ldap
if (isset($_POST['import']) or isset($_POST['export'])) {
    if ($ldap->connect()) {

        // LDAP import
        $ldap->import();
        if ($importRes = $ldap->resDict()) {
            $connStatus = insert("connRes", "", $template['connStatus']);
            $flag = 0;
            
            $importTableRowTempl = $template['importTableRow'];
            
            // fill import table template by import results
            $tableContent = "";
            for($entryId=0; $entryId<=count($importRes); $entryId++) {

                // fill import table columns
                $rowContent = "";
                
                // fill import table head
                if (!$flag) {
                    $headContent = "";
                    $headAttr    = $ldap->getImportAttr();

                    foreach ($headAttr as $headName) {
                        $headContent .=  insert("importContent", $headName, $template['importHeadRowColumn']);
                    }
                    $rowContent = $headContent;
                    $flag = TRUE;
                }

                $curEntry = $importRes[$entryId];
                foreach ($curEntry as $entryName => $entryValue) {
                    $rowContent .= insert("importContent", Encode($entryValue,'w'), $template['importRowColumn']);
                }
                
                // fill import table rows
                $tableContent  .= insert("importContentColumns", $rowContent , $template['importTableRow']);

            }

            // ...........
            (isset($_POST['import'])) ? $resStatus = " ": $resStatus = " ";
            $templateInfo['connStatus'] = $connStatus.insert("importContentRows", $tableContent, insert("resStatus", $resStatus, $template['importTable']));
 

        }
        
    }
    else {
        $templateInfo['connStatus'] = insert("connRes", "  ", $template['connStatus']);
    }
} else  $templateInfo['connStatus'] = "";


// fill main content
foreach ($templateInfo as $templMask => $templValue) {
    
    if ($templMask == "ldap_import_fields") {
        $resContent = insert($templMask, implode(", ",$templValue), $resContent);
    }
    else 
       $resContent = insert($templMask, $templValue, $resContent);
}

// draw content
echo show_tb();
echo $resContent.$template['end'];
?>
