<?php 
include('../inc/impexp.inc.php');
include_once("../1.php");

define ('INSERT_SQL', TRUE);	// import or simulate/print SQL requests

$err0r = '';

global $vopotch_table,$testotch_table,$arhiv_table;
$phpsql = array (
	$arhiv_table => array('PID', 'id', 'cid', 'vremya'),
	$testotch_table  => array('bal', 'tid', 'pid', 'time', 'VID'),
	$vopotch_table => array('tid', 'pid', 'time', 'vid', 'bal', 'otv'),
);

if (isset($_POST['upload_results_x']) || isset($_POST['upload_results'])) {		// both image and submit buttons
	$datadir = './DATA/' . date('YmdHis') . '/';
	if (!@mkdir($datadir)) {
		clr_exit('  ' . $dir);
	}
	if ($r = upload_file($datadir) != 1) {
		clr_exit($r);
	}

//	$content = aes_dec(file_get_contents($datadir . $_FILES['filereport']['name']));			// AES - extra chars
//	$content = file_get_contents($datadir . $_FILES['filereport']['name']);						// no enc
	$content = decrypt(file_get_contents($datadir . $_FILES['filereport']['name']), CD_AES);	// local decrypt
	unlink($datadir . $_FILES['filereport']['name']);
	$fp = fopen($datadir . $_FILES['filereport']['name'], 'wb');
	fwrite($fp, $content);
	fclose($fp);
	
	$archive = new PclZip($datadir . $_FILES['filereport']['name']);
	if ($archive->extract(PCLZIP_OPT_PATH, $datadir, PCLZIP_OPT_REMOVE_ALL_PATH) == 0) {
		clr_exit("   <br>\n  <br>\n<hr>\n");
	}
	unlink($datadir . $_FILES['filereport']['name']);

	$success = 1;
	$d = dir($datadir);
	while($f = $d->read()) {
		if(strstr($f, '.csv')) {
			$table_name = preg_replace("/\.csv$/", "", $f);
			$results = parse_csv_file($datadir . $f, true);
			list($all_data, $false_data, $dupl_data, $new_data) = check_data($results);
			print ("  <b>$table_name</b>: <br>\n : <b>$all_data</b><br> :<br>\n<b>$dupl_data</b>    <br>\n<b>$false_data</b>  / <br>\n<b>$new_data</b>  <br>\n<hr>\n");
			if ($false_data > 0)
				$success = 0;
		}
	}
	print ("      .<br>\n");
	action_log($_POST['mid'], 'export', 1, $success);

	rmrf($datadir);
} else {
	echo show_tb();
	print_form();
}

exit;

function clr_exit($err0r) {
	global $datadir;
	if (is_dir($datadir)) {
		rmrf($datadir);
	}
	print "<b>:</b><br>\n" . $err0r . "<br>\n";
	exit;
}

function print_form() {
	print '
<form action=' . $_SERVER['PHP_SELF'] . ' enctype="multipart/form-data" method="POST">
<input type="hidden" name="upload_results">
<input name="filereport" type="file" value="" style="width:320px" class="ltr">
<input type="submit" value="">
</form>
';
}

function get_val($arr, $arr2) {		// concat necessary columns of the table to calc their hash
	$ret = '';
	foreach ($arr as $k) {
		$ret .= $arr2[$k];
	}
	return sha1(CD_NUM . $ret);
}

function check_data($results) {
	global $phpsql, $table_name;
	$false_data = $dupl_data = $new_data = 0;
	$cols = count($results[0]);
	$rows = count($results);

	$sql_head = "INSERT INTO $table_name (";
	foreach ($results[0] as $key => $value) {			// column headers
		$sql_head .= $key . ', ';
	}
	$sql_head = substr($sql_head, 0, -2);
	$sql_head .= ") VALUES (";

	for ($ii = 0; $ii < $rows; $ii++) {					// each row
		$sql = "SELECT * FROM $table_name WHERE ";
		foreach ($results[$ii] as $key => $value) {		// each column
			$sql .= $key . " = '" . addslashes($value) . "' AND ";
		}
		$sql = substr($sql, 0, -5);

		if (num_rows(sqldb_query($sql)) > 0) {
			$dupl_data++;
		} elseif ($results[$ii]['md5'] != get_val($phpsql[$table_name], $results[$ii])) {
			$false_data++;
		} else {
			$new_data++;
			$sql_data = '';
			foreach ($results[$ii] as $key => $value) {		// each column
				$sql_data .= "'" . addslashes($value) . "', ";
			}
			$sql_data = substr($sql_data, 0, -2);
			$sql_data .= ")";
			$sql = $sql_head . $sql_data;
			if (INSERT_SQL) {
				sqldb_query($sql);
			} else {
				print $sql . "<br>\n";
			}
		}
	}

	return array($rows, $false_data, $dupl_data, $new_data);
}

function parse_csv_file($file, $columnheadings = false, $delimiter = ';', $enclosure = "\"") {
	$row = 1;
	$rows = array();
	$handle = fopen($file, 'r');
 
	while (($data = fgetcsv($handle, 100000, $delimiter, $enclosure )) !== FALSE) {
		if (!($columnheadings == false) && ($row == 1)) {
			$headingTexts = $data;
		} elseif (!($columnheadings == false)) {
			foreach ($data as $key => $value) {
				unset($data[$key]);
				$data[$headingTexts[$key]] = $value;
			}
			$rows[] = $data;
		} else {
			$rows[] = $data;
		}
		$row++;
	}
	fclose($handle);
	return $rows;
}

function upload_file($datadir) {
	global $sitefol;

	if($_FILES['filereport']['size'] == 0)
		return('    !');

	if(@move_uploaded_file($_FILES['filereport']['tmp_name'], $datadir . $_FILES['filereport']['name'])) {
		chmod($datadir . $_FILES['filereport']['name'], 0777);
		return 1;
	} else {
		if($_FILES['filereport']['name'] == '')
			return('    .');
		else
			if($_FILES['filereport']['tmp_name'] == '')
				return('  .');
			else
				return('     .     TEMP.');
	}
}
?>