
function FlexAbility()
	{
		this.p_id="FA"+String(Math.round(Math.random()*100)*Math.round((t=new Date).getTime()/100));
		
		this.title_prefix = FAStrings.flexability_title;
		this.server_script='editor.php';
		this.root_dir='/';
		this.work_dir='';
		this.images_work_dir='';
		this.temp_work_dir='';
		this.images_dir='';
		this.scripts_dir='';
		this.player_dir='';

		this.is_stand_alone = false;

		this.h_main=null;
		this.h_menu=null;
		this.h_status=null;
		this.h_frame=null;

		this.h_frame_doc=null;
		this.h_workframe=null;
		this.h_timeline=null;
		this.h_tree=null;
		this.h_property=null;
		this.h_panel = null;

		this.p_menu=null;
		this.p_timeline=null;
		this.p_tree=null;
		
		this.p_editor_cap=null;
		
		this.z_editor=null;
		this.z_editor_body=null;
		this.z_timeline=null;
		
		this.z_curframe_tl=null
		this.z_curframe=null;
		this.z_current_prop=null;

		this.is_inited=false;
		this.is_ready=false;

		this.p_styleSheets={};

		this.z_dragged=null;
		this.o_dragger=null;

		this.p_scenario=null;

		this.p_property=null;
		this.p_property_caption='';

		this.p_temp_image=null;

		this.p_disabled=true;
		this.p_cp_disabled=false;
		
		this.p_recent=[];
		this.max_recent_files=5;

		this.is_dragging=false;
		this.is_drag_start=false;
		this.z_drag_key='';

		this.z_prop_has_frames=false;

		this.p_src='';
		
		this.is_grid=true;
		this.events = {
				0: FAStrings.event_none,
				'onkeydown': FAStrings.event_on_keydown,
				'onkeyup': FAStrings.event_on_keyup,
				'onmousedown': FAStrings.event_on_mousedown,
				'onmouseup': FAStrings.event_on_mouseup,
				'onmouseover': FAStrings.event_on_mouseover,
				'onmousemove': FAStrings.event_on_mousemove,
				'onmouseout': FAStrings.event_on_mouseout,
				'onclick': FAStrings.event_on_click,
				'onenter': FAStrings.event_on_enter,
				'onleave': FAStrings.event_on_leave
				};
		return this;
	}

FlexAbility.prototype.setStyleSheet=function(sFrame, sId)
	{
		var s, i=0, r, t='';
		s=document.styleSheets.item(sId);
		if (s && s.rules)
			{
				for(; i<s.rules.length; i++)
					{
						t+=s.rules[i].selectorText + ' {'+s.rules[i].style.cssText+'};\n';
					}
				this.p_styleSheets[sFrame]=t;
			}
	}

FlexAbility.prototype.create=function()
	{
	//	if (!this.root_dir)
	//		this.root_dir='/';
		mystring = window.location.href;
		myarray = mystring.split(/\//);
		for (var i = 0; i < myarray.length; i++) {
			//alert(i+myarray[i]);
			if (i==2)
				var locdir = myarray[i];
		}
		
		this.root_dir = '/'+locdir+ this.root_dir;
		

		this.root_dir = window.location.protocol + '//' + window.location.host +this.root_dir;

		if (this.root_dir.charAt(this.root_dir.length-1)!='/')
			this.root_dir+='/';
		this.server_script=this.root_dir+this.server_script;

		if (this.server_script.indexOf('?')==-1)
			this.server_script+='?';

		if (!this.images_dir)
			this.images_dir=this.root_dir+'images/';

		if (!this.scripts_dir)
			this.scripts_dir=this.root_dir+'scripts/';
		if (!this.player_dir)
			this.player_dir=this.root_dir+'faplayer.swf';
		

		if (this.work_dir)
			{
				this.server_script += 'path='+this.work_dir;
				this.work_dir = window.location.protocol + '//' + window.location.host +"/"+locdir+"/"+ this.work_dir;
				//this.work_dir = window.location.protocol + '//' + window.location.host +"/twclass/"+ this.work_dir;

                //alert(this.work_dir);
				if (this.work_dir.charAt(this.work_dir.length-1)!='/')
					this.work_dir+='/';
			}
             
		var prefs=this.getPreferences();
		FAUtil.is_snapping=prefs.snapping ? true : false;
		document.write('<DIV id="'+this.p_id+'_holder" class="flexAbility" style="width:'+this.p_width+'; height:'+this.p_height+';"><TABLE cellspacing=3 cellpadding=0 border=0 width=100% height=100%><TR><TD id='
				+this.p_id+'_menu class="flexAbility_menu" src="blank.html" unselectable=on><DIV id="subMainMenu"></DIV><DIV id="'+this.p_id+'_objects" class="objects_panel"></DIV></TD></TR><TR><TD style="background-color:transparent"><IFRAME id="'
				+this.p_id+'_frame" frameborder=1 style="border:1px; width:100%; position:relative; vertical-align:top; left: 0px; top:0px;  height:expression(this.parentElement.clientHeight-1);"></IFRAME></TD></TR><TR><TD  id="'
				+this.p_id+'_status" style="height:15px;"><DIV class="panel flexAbility_status"></DIV></TD></TR></TABLE></DIV>');

		var str='<FRAMESET id="'+this.p_id+'_mainset" cols="*, '+(prefs.property_width ? prefs.property_width : 240)+'" border=1 framespacing=4 bordercolor="#404040">'
				+'<FRAMESET rows="*, '+(prefs.timeline_height ? prefs.timeline_height : 135)+'" frameborder=1 border=1 framespacing=4 bordercolor="#404040">'
					+'<FRAME id="'+this.p_id+'_workfield" tabIndex=-1 scrolling=no allowtransparency=true >'
					+'<FRAME id="'+this.p_id+'_tline" tabIndex=-1 scrolling=no allowtransparency=true>'
				+'</FRAMESET>'
				+'<FRAMESET rows="'+(prefs.property_height ? '*, '+prefs.property_height : '50%, 50%')+'" frameborder=1 border=1 framespacing=4 bordercolor="#404040">'
					+'<FRAME id="'+this.p_id+'_tree" tabIndex=-1 scrolling=no allowtransparency=true>'
					+'<FRAME id="'+this.p_id+'_property" tabIndex=-1 scrolling=no allowtransparency=true>'
				+'</FRAMESET>'
				+'</FRAMESET>';
		var d, frame=document.getElementById(this.p_id+'_frame'), oPanel=document.getElementById(this.p_id+'_objects');
		
		/* Objects Shelf */
		this.h_panel=oPanel;
		this.h_panel.ondragstart=FAUtil.pPanelDragStart;
		this.h_panel.onmousedown=FAUtil.pPanelMouseDown;
		this.h_panel.ondblclick=FAUtil.pPanelDblClick;
		this.pAddControlObject(FAStrings.object_image, this.images_dir+'icon_image.gif', 'image');
		this.pAddControlObject(FAStrings.object_hotspot, this.images_dir+'icon_hotspot.gif', 'hotspot');
		this.pAddControlObject(FAStrings.object_label, this.images_dir+'icon_label.gif', 'label');
		this.pAddControlObject(FAStrings.object_textinput , this.images_dir+'icon_textinput.gif', 'textinput');
		this.pAddControlObject(FAStrings.object_message , this.images_dir+'icon_message.gif', 'message');
		this.pAddControlObject(FAStrings.object_checkbox , this.images_dir+'icon_checkbox.gif', 'checkbox');
		this.pAddControlObject(FAStrings.object_button , this.images_dir+'icon_btn.gif', 'button');
		this.disableControlPanel(true);

		d=frame.contentWindow.document;
		d.open();
		d.write(str);
		d.close();
		this.h_frame_doc=d;
		this.h_main=document.getElementById(this.p_id+'_holder');
		this.h_main.o_ref=this;
		this.h_menu=document.getElementById(this.p_id+'_menu');
		this.h_frame=document.getElementById(this.p_id+'_frame');
		this.h_status=document.getElementById(this.p_id+'_status');
		var mainset = this.h_frame_doc.getElementById(this.p_id+'_mainset');
		mainset.o_ref=this;
		mainset.firstChild.firstChild.onresize=FAUtil.frameResize;
		mainset.lastChild.firstChild.onresize=FAUtil.frameResize;

		var css='BODY {margin:0; margin-bottom:2px; padding:0px; text-align:center; font-family:Tahoma; font-size:11px; background:#505050; border:#646464 1px solid; border-right-color:#303030; border-bottom-color:#303030 };'
		+'MENU {width:100%; height:20px; margin:0px; text-align:left; color:#a7a7a7; padding:3px 10px 0 22px; cursor:default; background-position-x: right; background-position-y: 1px};'
		+'MENU.over {color:#ffffff; background-color:highlight; background-position:right -21px};'
		+'MENU.pressed {color:#ffffff; background-color:highlight; background-position:right -21px};'
		+'MENU.submenu {background-image:url('+this.images_dir+'arrowright.gif);  background-repeat:no-repeat; };'
		+'MENU.disabled {color:#666666};'
		+'I { width:18px; height:18px; margin-top:-2px; margin-left:-20px; font-style:normal; font-family: wingdings; text-align:right; font-size:15px; lien-height:15px; padding:2px 2px 0px 0px; vertical-align:top}'
		+'S {height:1px; margin:2 0 4 0;padding:0; border:none; width:98%; border-bottom:1px solid #777; font-size:1px;};'

		var oMainMenu=new MainMenu();
		oMainMenu.onselect=FAUtil.mainMenuOnSelect
		oMainMenu.setCssStyle(css);
		oMainMenu.wrapAround('subMainMenu');
		oMainMenu.o_ref=this;
		oMainMenu.addItem('file', FAStrings.menu_file, 'f');
		oMainMenu.addItem('edit', FAStrings.menu_edit, 'e');
		oMainMenu.addItem('scenario', FAStrings.menu_scenario, 'c');
		//oMainMenu.addItem('script', 'Script', 'r');
		oMainMenu.addItem('help', FAStrings.menu_help, 'h');

		var oFileMenu=oMainMenu.getSubMenu('file');
		oFileMenu.o_ref=this;
		oFileMenu.onbeforeshow=FAUtil.fileMenuBeforeShow;
		oFileMenu.addItem('file_new', FAStrings.menu_new, 'n');
		oFileMenu.addItem('file_open', FAStrings.menu_open, 'o');
		//oFileMenu.addItem('file_merge', 'Merge...', 'm');
		oFileMenu.addItem('file_save', FAStrings.menu_save, 's');
		oFileMenu.addItem('file_saveas', FAStrings.menu_save_as, 'a');
		oFileMenu.addBreak();
		oFileMenu.addItem('file_recent', FAStrings.menu_recent, 'c');
		//oFileMenu.addBreak();
		//oFileMenu.addItem('file_pref', 'Preferences', 'r');
		oFileMenu.addBreak();
		oFileMenu.addItem('file_exit', FAStrings.menu_exit, 'x');
		
		var oEditMenu=oMainMenu.getSubMenu('edit');
		oEditMenu.addItem('edit_timeline', FAStrings.menu_timeline, 't');
		oEditMenu.addItem('edit_objects', FAStrings.menu_objects, 'o');
		oEditMenu.addBreak();
		oEditMenu.addItem('edit_grid', FAStrings.menu_grid, 'g', prefs.grid ? -1 : -2);
		oEditMenu.addItem('edit_snap', FAStrings.menu_snap, 'a', prefs.snapping ? -1 : -2);
		//oEditMenu.addItem('edit_rulers', 'Show rulers', 'r', -2);
		//oEditMenu.addBreak();
		//oEditMenu.addItem('edit_align', 'Align', 'a');
		
		//var oGridMenu=oEditMenu.getSubMenu('edit_grid');
		//oGridMenu.addItem('grid_show', 'Show Grid', 's');
		//oGridMenu.addItem('grid_size', 'Grid size...', 'r');
		
		var oTLMenu=oEditMenu.getSubMenu('edit_timeline');
		oTLMenu.addItem('edit_newframe', FAStrings.menu_insert_frame, 'n');
		oTLMenu.addItem('edit_delframe', FAStrings.menu_delete_frame, 'a');

		var oObjMenu=oEditMenu.getSubMenu('edit_objects');
		oObjMenu.addItem('edit_insimage', FAStrings.menu_insert_image, 'n');
		oObjMenu.addItem('edit_inslabel', FAStrings.menu_insert_label, 'n');
		oObjMenu.addItem('edit_inshotspot', FAStrings.menu_insert_hotspot, 'n');
		oObjMenu.addItem('edit_instext', FAStrings.menu_insert_textinput, 'n');
		oObjMenu.addItem('edit_insmsg', FAStrings.menu_insert_message, 'n');
		oObjMenu.addItem('edit_inscheckbox', FAStrings.menu_insert_checkbox, 'n');
		oObjMenu.addItem('edit_insbutton', FAStrings.menu_insert_button, 'n');
		oObjMenu.addBreak();
		oObjMenu.addItem('edit_delobj', FAStrings.menu_delete_object, 'a');
		
		var oHelpMenu=oMainMenu.getSubMenu('help');
		oHelpMenu.addItem('help_main', FAStrings.menu_help, 'h');
		//oHelpMenu.addItem('help_about', FAStrings.menu_about, 'a');
		
		var oCompile=oMainMenu.getSubMenu('scenario');
		oCompile.width=210;
		oCompile.addItem('scenario_test', FAStrings.menu_test, 't');
		oCompile.addItem('scenario_testcur', FAStrings.menu_test_current, 't');
		
		var oEditorMenu=new DropDownMenu();
		oEditorMenu.setCssStyle(css);
		oEditorMenu.addItem('ToFront', FAStrings.menu_to_front);
		oEditorMenu.addItem('ToBack', FAStrings.menu_to_back);
		oEditorMenu.addItem('Forward', FAStrings.menu_forward);
		oEditorMenu.addItem('Backward', FAStrings.menu_backward);
		oEditorMenu.onclick=FAUtil.editorContextMenuClick;
		oEditorMenu.o_ref=this;

		this.p_editor_menu=oEditorMenu;

		oMainMenu.onclick=this.pMenuClick;
		
		var oScriptMenu=new DropDownMenu();
		oScriptMenu.o_editor=this;
		oScriptMenu.width=130;
		oScriptMenu.setCssStyle(css);
		oScriptMenu.addItem('frame', FAStrings.smenu_frame);
		oScriptMenu.addBreak();
		oScriptMenu.addItem('image', FAStrings.smenu_image);
		oScriptMenu.addItem('hotspot', FAStrings.smenu_hotspot);
		oScriptMenu.addItem('label', FAStrings.smenu_label);
		oScriptMenu.addItem('textinput', FAStrings.smenu_textinput);
		oScriptMenu.addItem('message', FAStrings.smenu_message);
		oScriptMenu.addItem('checkbox', FAStrings.smenu_checkbox);
		oScriptMenu.addItem('button', FAStrings.smenu_button);
		//oScriptMenu.addItem('select', 'Select');
		//oScriptMenu.addItem('radio', 'Radio');
		oScriptMenu.addBreak();
		oScriptMenu.addItem('event', 'EVENT');
		oScriptMenu.addItem('set', 'SET');
		oScriptMenu.addItem('if', 'IF');
		oScriptMenu.addItem('else', 'ELSE');
		oScriptMenu.addItem('goto', 'GOTO');
		oScriptMenu.addItem('call', 'CALL');
		oScriptMenu.addItem('switch', 'SWITCH');
		oScriptMenu.addItem('case', 'CASE');
		oScriptMenu.addItem('otherwise', 'OTHERWISE');
		oScriptMenu.onclick=FAUtil.treeMenuClick;
		
		var oTreeMenu=new DropDownMenu();
		oTreeMenu.o_editor=this;
		oTreeMenu.width=120;
		oTreeMenu.setCssStyle(css);
		oTreeMenu.addItem('expand', FAStrings.smenu_expand);
		oTreeMenu.addBreak();
		oTreeMenu.addItem('insert', FAStrings.smenu_insert);
		oTreeMenu.addItem('rename', FAStrings.smenu_rename);
		oTreeMenu.addItem('gotoframe', FAStrings.smenu_go_to);
		oTreeMenu.addBreak();
		oTreeMenu.addItem('delete', FAStrings.smenu_delete);
		oTreeMenu.getSubMenu('insert', oScriptMenu);
		oTreeMenu.onclick=FAUtil.treeMenuClick;

		this.p_tree_menu=oTreeMenu;
		this.p_script_menu=oScriptMenu;
		//capDIV.ondragenter=cap_drag;
		//capDIV.ondragover=cap_drag;

		this.assembleFrame('workframe', this.p_id+'_workfield');
		this.assembleFrame('timeline', this.p_id+'_tline');
		this.assembleFrame('tree', this.p_id+'_tree');
		this.assembleFrame('property', this.p_id+'_property');

		if (document.cookies)
			{
				var p=document.cookies.get('recent_files');
				if (p)
					if (!(this.p_recent=p.split(':::')))
						this.p_recent=[];
			}

		if (prefs.grid)
			{
				this.z_editor_body.style.backgroundImage='url('+this.images_dir+'workfield_bg.gif)';
			}

		this.newDocument(FAStrings.untitled_scenario);
		if (this.is_stand_alone)
			{
				window.onbeforeunload=new Function('var p=document.getElementById("'+this.p_id+'_holder"); if (p && p.o_ref) p.o_ref.beforeUnload()');
				window.document.body.oncontextmenu=FAUtil.cancelEvent;
			}
	}
	
FlexAbility.prototype.beforeUnload=function()
	{
		if (this.isChanged())
			{
				var r=Message(FAStrings.doc_unsaved, 'exclamation', 'yes_no', FAStrings.doc_unsaved_header);
				if (r=='yes')
					{
						this.saveDocument();
					}
				else if (r=='cancel')
					{
						if (self.event)
							self.event.returnValue=false;
						return false;
					}
				return true;
			}
		return true;
	}

FlexAbility.prototype.assembleFrame=function(frame_id, sId)
	{
		var obj=this.h_frame_doc.all[sId], d;
		if (!obj) return false;

		this['h_'+frame_id]=obj;
		d=obj.contentWindow.document;
		switch(frame_id)
			{
				case 'workframe':
						d.open();
						d.write('<HEAD><STYLE>' + (this.p_styleSheets[frame_id] ? this.p_styleSheets[frame_id] : '') + '</STYLE>'+(this.work_dir ? '<BASE href="'+this.work_dir+'" />' : '')								
						+'</HEAD><BODY class="'+frame_id+'" style="padding:3px; margin:0px; font-family:Tahoma; font-size:12px;"><DIV class="workfield" style="width:100%; height:100%; "></DIV></BODY>');
						d.close();
						var wf=d.createElement('<DIV unselectable=on isEditor="1" style="width:3000px; height:1500px; overflow:hidden; background: #404040">'),
						drag=d.createElement('<DIV style="font-size:10px; position:absolute; width:100px; height:60px; border:2px dotted #777; filter:alpha(opacity=50); position:absolute; z-index:65010; display:none; background-repeat:no-repeat">');
						drag.innerHTML='<SPAN style="height:16px; padding: 0 2px; overflow:hidden; text-overflow:ellipsis; word-wrap:break-word; margin-left:37px; color:#ffffff"></SPAN>';
						drag.oData={
								x : null,
								y : null,
								width : null,
								height : null, 
								type : null 
							}

						wf.onmousedown = FAUtil.editorMouseDown;
						wf.onkeydown = FAUtil.editorKeyDown;
						wf.onmovestart = FAUtil.objectMoveStart;
						wf.onresizestart = FAUtil.objectResizeStart;
						wf.onbeforeeditfocus = FAUtil.cancelEvent;
						wf.oncontrolselect = FAUtil.editorControlSelect;
						//wf.onclick = FAUtil.editorClick;
						wf.ondblclick = FAUtil.editorDblClick;

						d.onselectstart = FAUtil.editorSelect;
						d.body.oncontextmenu = FAUtil.editorContextMenu;
						d.body.onbeforepaste = FAUtil.cancelEvent;
						d.body.onbeforecut = FAUtil.cancelEvent;
						d.body.oncut = FAUtil.cancelEvent;
						d.body.onpaste = FAUtil.cancelEvent;
						
						d.body.firstChild.onscroll=FAUtil.pScroll;
						d.body.firstChild.oncontrolselect=FAUtil.editorControlSelect;
						d.body.firstChild.o_ref=this;
						d.body.o_ref=this;
						wf.o_ref=this;

						this.z_editor_body=wf;
						this.z_editor=d.body.firstChild;
						this.o_dragger=drag;

						this.p_editor_cap=d.createElement('<DIV style="position:absolute; z-index:65020; left:10; top:10; color:#666666">');
						this.p_editor_cap.innerHTML=FAStrings.default_caption;
						d.body.appendChild(this.p_editor_cap);
						d.body.firstChild.appendChild(wf);
						d.body.firstChild.appendChild(drag);
					break;

				case 'timeline':
						d.open();
						d.write('<STYLE>' + (this.p_styleSheets[frame_id] ? this.p_styleSheets[frame_id] : '') + '</STYLE><BODY class="'+frame_id+'" style=" font-family:Tahoma; font-size:12px;"><DIV class="workfield"></DIV><DIV class="timeline_panel"><SPAN>+</SPAN><SPAN>&#215;</SPAN><SPAN>&laquo;]</SPAN><SPAN>[&raquo;</SPAN><DIV>'+FAStrings.timeline+'</DIV></DIV></BODY>');
						d.close();
						d.body.o_ref=this;
						this.p_timeline=d.body;
						this.z_timeline=d.body.firstChild;

						this.p_btn_addframe=d.body.lastChild.children[0];
						this.p_btn_addframe.title=FAStrings.timeline_addframe;
						this.p_btn_addframe.o_ref=this;
						this.p_btn_addframe.onmousedown=FAUtil.btnAddFrame;

						this.p_btn_rmvframe=d.body.lastChild.children[1];
						this.p_btn_rmvframe.title=FAStrings.timeline_remove_frame;
						this.p_btn_rmvframe.o_ref=this;
						this.p_btn_rmvframe.onmousedown=FAUtil.btnRemoveFrame;
						
						this.p_btn_swapprev=d.body.lastChild.children[2];
						this.p_btn_swapprev.title=FAStrings.timeline_move_frame_prev;
						this.p_btn_swapprev.o_ref=this;
						this.p_btn_swapprev.onmousedown=FAUtil.btnFrameMoveBack;
						
						this.p_btn_swapnext=d.body.lastChild.children[3];
						this.p_btn_swapnext.title=FAStrings.timeline_move_frame_next;
						this.p_btn_swapnext.o_ref=this;
						this.p_btn_swapnext.onmousedown=FAUtil.btnFrameMoveFwd;
						
						d.body.lastChild.onmouseover=FAUtil.btnOver;
						d.body.lastChild.onmouseout=FAUtil.btnOut;
						d.body.lastChild.onmousedown=FAUtil.btnDown;
						d.body.lastChild.onmouseup=FAUtil.btnUp;
						d.body.onselectstart=FAUtil.cancelEditEvent;
						d.oncontextmenu=FAUtil.timelineContextMenu;
					break;

				case 'tree':
						d.open();
						d.write('<STYLE>' + (this.p_styleSheets[frame_id] ? this.p_styleSheets[frame_id] : '') + '</STYLE><BODY class="'+frame_id+'" style="font-family:Tahoma; font-size:12px;"><TABLE border="0" cellspacing="0" cellpadding="0" class="workfield" style="width:100%; height:100%"><TR><TD valign="top" class="panel_header" ><DIV id="control_panel"><SPAN id="btn_filter_mode" title="'+FAStrings.mode_compact+'">&#164;</SPAN><SPAN id="btn_add_item" title="'+FAStrings.btn_additem+'">[+]</SPAN></DIV>'+FAStrings.structure+'</TD></TR><TR><TD class="panel_body" height=100%><DIV class="panel_body" id="oTreePlaceHolder"></DIV></TD></TR></TABLE></BODY>');
						d.close();
						var t=d.getElementById('oTreePlaceHolder'), oTree=new Tree();
						if (t)
							{
								d.onselectstart=new Function('if (!(this.parentWindow.event.srcElement.tagName=="INPUT" || this.parentWindow.event.srcElement.tagName=="TEXTAREA")) {this.parentWindow.event.cancelBubble=false; return false;}')
								oTree.wrapAround(t, true);
								oTree.onselect=FAUtil.treeSelect;
								oTree.onmove=FAUtil.treeMove;
								oTree.onrename=FAUtil.treeRename;
								oTree.ondblclick=FAUtil.treeDblClick;
								oTree.icon_src=this.images_dir+'tree_icons.gif';
								oTree.setGroups({
									0: [1, 20, 11], // Frame
									1: [2, 3, 4, 5, 6, 7, 8, 9, 10], // Frame
									2: [10], //Image
									3: [10], //hotspot
									4: [10], //label
									5: [10], //textinput
									6: [10], //message
									7: [10], //checkbox,
									8: [10],	//select
									9: [10], //button
									10: [11, 12, 13], //
									11: [],
									12: [11, 14],
									13: [11, 15],
									14: [11, 12, 13],
									15: [11, 12, 13],
									20: [] //default message;
									});
								oTree.o_ref=this;
								this.p_tree=oTree;
							}
						if (t=d.getElementById('control_panel'))
							{
								t.onmouseover=FAUtil.btnOver;
								t.onmouseout=FAUtil.btnOut;
								t.onmousedown=FAUtil.btnDown;
								t.onmouseup=FAUtil.btnUp;
								this.p_btn_add_item=t.lastChild;
								this.p_btn_add_item.o_ref=this;
								this.p_btn_add_item.onclick=FAUtil.treeContextMenu;
								this.p_btn_filter_item=t.firstChild;
								this.p_btn_filter_item.o_ref=this;
								this.p_btn_filter_item.isChecker=true;
								this.p_btn_filter_item.onclick=FAUtil.treeFilter;
							}
						d.body.oncontextmenu=FAUtil.treeContextMenu;
						d.body.o_ref=this;
					break;
				case 'property':
					d.open();
					d.write('<STYLE>' + (this.p_styleSheets[frame_id] ? this.p_styleSheets[frame_id] : '') + '</STYLE><BODY class="'+frame_id+'" style="font-family:Tahoma; font-size:12px;"><TABLE  id="property_panel" border="0" cellspacing="0" cellpadding="0" class="workfield" style="width:100%; height:100%; table-layout:fixed"><TR><TD valign="top" class="panel_header" id="properties_cap">'+FAStrings.properties+'</TD></TR><TR><TD height="100%" valign="top" class="panel"><DIV class="panel_body" id="oGridPlaceHolder"></DIV></TD></TR></TABLE></BODY>');
					d.close();
					d.body.o_ref=this;
					var h_property=d.getElementById('oGridPlaceHolder'), oGrid=new EditableGrid();
					oGrid.header_visible=false;
					oGrid.wrapAround(h_property, true);
					oGrid.o_ref=this;
					oGrid.onchange=FAUtil.propertyChange;
					oGrid.ondialog=FAUtil.propertyDialog;
					oGrid.addColumn('Property', '40%', {type : 'label'});
					oGrid.addColumn('Value', '60%', {type : 'text'});
					this.p_property=oGrid;
					this.h_property=d.getElementById('property_panel');
					this.p_property_caption=d.getElementById('properties_cap');
					break;
			}
	}


FlexAbility.prototype.pAddControlObject=function(sTitle, sSrc, sKey)
	{
		var oImg=document.createElement('IMG');
		oImg.alt=sTitle;
		oImg.sKey=sKey;
		oImg.src=sSrc;
		oImg.iType=2;
		oImg.o_ref=this;
		oImg.defWidth=120;
		switch (sKey)
			{
				case 'image':
					oImg.defHeight=120;
					break;
				case 'hotspot':
					oImg.defHeight=120;
					break;
				case 'label':
					oImg.defWidth=130;
					oImg.defHeight=32;
					break;
				case 'textinput':
					oImg.defWidth=140;
					oImg.defHeight=32;
					break;
				case 'message':
					oImg.defWidth=35;
					oImg.defHeight=35;
					break;
				case 'checkbox':
					oImg.defHeight=32;
					break;
				case 'button':
					oImg.defWidth=130;
					oImg.defHeight=32;
					break;
			}
		this.h_panel.appendChild(oImg);
	}

FlexAbility.prototype.disableControlPanel=function(x)
	{
		this.p_cp_disabled=x ? true : false;
		this.h_panel.style.filter=x ? "progid:DXImageTransform.Microsoft.BasicImage(grayscale=1), progid:DXImageTransform.Microsoft.Alpha(opacity=50);" : '';
	}

FlexAbility.prototype.setDragDropObject=function(sKey, sTitle, sIcon, width, height)
	{
		if (this.p_disabled) return;
		this.o_dragger.firstChild.innerText=sTitle;
		if (sIcon)
			{
				this.o_dragger.style.backgroundImage='url('+sIcon+')';
			}
		this.o_dragger.style.posWidth=width ? width : 100;
		this.o_dragger.style.posHeight=height ? height : 100;
		this.o_dragger.oData.type=sKey;
		this.o_dragger.oData.width=width;
		this.o_dragger.oData.height=height;

		this.z_editor.ondragover=FAUtil.dragDivDragOver;
		this.z_editor.ondragenter=FAUtil.dragDivDragEnter;
		this.z_editor.ondrop=FAUtil.dragDivDrop;
		this.is_dragging=true;
		this.is_drag_start=true;
	}
	
FlexAbility.prototype.releaseDragDropObject=function()
	{
		with(this.o_dragger.oData)
			{
				type=null;
				width=null;
				height=null;
			}
		this.z_drag_key=null;
		this.z_editor.ondragover=null;
		this.z_editor.ondragenter=null;
		this.z_editor.ondrop=null;
		this.o_dragger.style.display='none';
		this.is_dragging=false;
		this.is_drag_start=true;
	}

FlexAbility.prototype.setPropertyPanelCaption=function(sCaption, sFrame)
	{
		this.p_property_caption.innerText=FAStrings.properties+(sFrame ? ' : '+sFrame : '') + (sCaption ? ' : '+sCaption : '');
	}
	
FlexAbility.prototype.pGetFramesArray=function(sIdExclude)
	{
		var aRes={0 : '&#151;'}, i;
		for (i=0; i < this.z_timeline.children.length; i++)
			if (this.z_timeline.children[i].o_ref && sIdExclude != this.z_timeline.children[i].o_ref.id)
				aRes[this.z_timeline.children[i].o_ref.id] = this.z_timeline.children[i].o_ref.name;
		return aRes;
	}

FlexAbility.prototype.showProperties=function(oObj)
	{
		this.z_current_prop=null;
		this.p_property.clear();
		this.setPropertyPanelCaption('');
		this.z_prop_has_frames=false;
		if (oObj && oObj.oParams) //this.z_curframe && oObj.o_ref.id==this.z_curframe.id
			{
				if (this.h_property.style.display=='none')
					this.h_property.style.display='block';
				var x=0, pname={'value' : null}, pvalue={'value' : null};
				this.z_current_prop=oObj;

				this.setPropertyPanelCaption(oObj.name, oObj.getItem ? null : oObj.o_ref.name);

				for (x in oObj.oParams)
					{
						if (this.p_scenario.is_complex && x.indexOf('XSMPL')==-1 || !this.p_scenario.is_complex && x.indexOf('XCMPL')==-1)
							{
								pname.value=oObj.oParams[x][0];
								pvalue.value=oObj.oParams[x][1];
								switch (pvalue.type=oObj.oParams[x][2])
									{
										case 'file':
												pvalue.type='dialog';
											break;
										case 'select':
												pvalue.options=oObj.oParams[x][3];
											break;
										case 'frames':
											/* getting all frames. */
											pvalue.type='select';
											pvalue.options=this.pGetFramesArray(oObj.id);
											if (!pvalue.value && oObj.o_frame) // if oObj is a frame -- trying to guess which is next 
												{
													if (oObj.o_frame.nextSibling && oObj.o_frame.nextSibling.o_ref)
														{
															pvalue.value=oObj.o_frame.nextSibling.o_ref.id;
														}
												}
											this.z_prop_has_frames=true;
											break;
										case 'events':
												pvalue.type='select';
												pvalue.options=oObj.o_ref.pGetEvents(oObj.local_id);
											break;
	
										case 'variable_type':
												pvalue.type='select';
												pvalue.options={
														'number': 'number',
														'string': 'string',
														'boolean': 'boolean'
													}
											break;
										case 'fontsize':
												pvalue.type='select';
												pvalue.options={'' : '-', 6: '6px', 7: '7px', 8: '8px', 9: '9px', 10: '10px', 11: '11px', 12: '12px', 13: '13px', 14: '14px', 16: '16px', 18 : '18px', 24 : '24px'}
											break;
									}										
								this.p_property.addRow(x, pname, pvalue);
							}
					}
			}
		else
			{
				this.h_property.style.display='none';
			}
	}
	
FlexAbility.prototype.setStatus=function(sText)
	{
		this.h_status.firstChild.innerText=sText;
	}

FlexAbility.prototype.getTreeParentFrame=function(sKey)
	{
		if (!sKey)
			sKey=this.p_tree.getCurrent();
		while(sKey && !this.p_scenario.p_keys[sKey])
			sKey=this.p_tree.getAncestor(sKey);
		return (sKey && this.p_scenario.p_keys[sKey]) ? this.p_scenario.p_keys[sKey] : null;
	}

FlexAbility.prototype.setProperty=function(oItem, sProperty, oValue, bAction)
	{
		if (oItem.oParams[sProperty])
			{
				if (oItem.oParams[sProperty][2] != 'command')
					oItem.oParams[sProperty][1] = oValue;
				if (this.z_current_prop===oItem)
					this.p_property.setValue(sProperty, 1, oValue);
			}

		if (bAction)
			{
				switch(sProperty)
					{
						case 'x':
							oItem.style.posLeft=oValue;
							break;
						case 'y':
							oItem.style.posTop=oValue;
							break;
						case 'width':
							if (!isNaN(oValue))
								{
									oItem.style.posWidth=oValue;
									if (oItem.propsLocked)
										oItem.style.posHeight = oValue / oItem.propsLocked;
								}
							break;
						case 'height':
							if (!isNaN(oValue))
								{
									oItem.style.posHeight=oValue;
									if (oItem.propsLocked)
										oItem.style.posWidth=oValue * oItem.propsLocked;
								}
							break;
						case 'name':
								oItem.o_ref.renameItem(oItem.local_id, oValue);
							break;
						case 'event':
								var sName;
								sName=this.events[oValue];
								if (oValue!=0 && sName)
									sName=' ('+sName+')';
								else
									sName='';
								oItem.o_ref.renameItem(oItem.local_id, 'EVENT'+sName+'');
							break;
						case 'locked':
								oItem.isLocked=oValue ? true : false;
								oItem.hideFocus=oValue ? true : false;
								var range, i=0;
								if (oValue)
									{
										if (range=this.getCurrentRange())
											for(; i<range.length; i++)
												if (range.item(i)===oItem)
													{
														range.remove(i);
														range.select();
														break;
													}
									}
								else
									{
										range=this.z_editor.document.body.createControlRange();
										range.add(oItem);
										range.select();
									}
							break;
						case 'src':
								oItem.src=oValue;
								if (oItem.oFrameObj)
									oItem.oFrameObj.src=oValue;
							break;
						case 'proportional':
								oItem.propsLocked=oValue ? (oItem.style.posWidth / oItem.style.posHeight) : 0;
							break;
						case 'restore':
								if (isPositiveNum(oItem.oParams['real_width'][1]) && isPositiveNum(oItem.oParams['real_height'][1]))
									{
										oItem.style.posWidth=oItem.oParams['real_width'][1];
										oItem.style.posHeight=oItem.oParams['real_height'][1];
										if (oItem.propsLocked)
											oItem.propsLocked=oItem.style.posWidth / oItem.style.posHeight;
										if (oItem.oFrameObj)
											{
												oItem.oFrameObj.style.posWidth=oItem.style.posWidth * FAUtil.factor_x;
												oItem.oFrameObj.style.posHeight=oItem.style.posHeight * FAUtil.factor_y;
											}
										this.setProperty(oItem, 'width', oItem.style.posWidth);
										this.setProperty(oItem, 'height', oItem.style.posHeight);
									}
							break;
						case 'frame_name':
								if (oItem.setName)
									oItem.setName(oValue);
							break;
						case 'fontsize':
								if (oValue)
									{
										oItem.style.fontSize=oValue;
									}
							break;
						case 'default':
						case 'input_value':
								oItem.value=oValue;
							break;
						case 's_edit_options':
								var res, arguments={
									panels : oItem.p_panels,
									messages : oItem.p_messages
									}
								res=showModalDialog(this.scripts_dir+"preferences.html", arguments, "border:thin; center:yes; dialogHeight:350px; dialogWidth:550px; help:no; maximize:no; minimize:no; status:no; resizable:yes");
								if (res)
									{
										var i=0, oArr={};
										if (res.panels)
											{
												for (i=0; i < res.panels.length; i++)
													{
														oArr[res.panels[i][0]]={'title': res.panels[i][1], 'data': res.panels[i][2], 'height': res.panels[i][3], 'expanded': res.panels[i][4]}
													}
												oItem.p_panels=oArr;
											}
											/*
										if (res.messages)
											{
												oArr={};
												for (i=0; i < res.panels.length; i++)
													oArr[res.panels[i][0]]=res.panels[i][1]
												oItem.p_messages=oArr;
											}		
											*/											
									}
							break;
						case 'edit_frame_descr':
								var res, arguments={
									'text' : oItem.oParams.description[1]
								}
								res=showModalDialog(this.scripts_dir+"edit.html", arguments, "border:thin; center:yes; dialogHeight:300px; dialogWidth:500px; help:no; maximize:no; minimize:no; status:no; resizable:yes");
								if (res)
									this.setProperty(oItem, 'description', res.text ? res.text : '', true);
							break;
						case 'label_text':
								oItem.innerText=oValue;
							break;
						case 's_title':
								oItem.title=oValue;
								this.p_tree.setCaption(oValue);
							break;
						case 's_mode':
								oItem.is_complex = (oValue==1 ? true : false);
								this.showProperties(oItem);
								return false;
							break;
						case 's_mission':
								oItem.p_panels['task'].data=oValue;
							break;
					}
			}
	}

FlexAbility.prototype.getCurrentRange=function()
	{
		var range=this.z_editor.document.selection.createRange();
		if (range.length) return range;
		return false;
	}
	
FlexAbility.prototype.emptySelection=function()
	{
		try
			{
				if (this.z_editor.document.selection)
				this.z_editor.document.selection.empty();
			}
		catch (e)
			{
			}
		return true;
	}
	
FlexAbility.prototype.restoreSelection=function(aItems)
	{
		var range=this.z_editor.document.body.createControlRange();
		if (aItems.length)
			{
				for(var i=0; i < aItems.length; i++)
					range.add(aItems.item(i));
				range.select();
			}
	}

FlexAbility.prototype.pMenuClick=function(ev)
	{
		if (ev.key.substr(0, 12)=='file_recent_')
			{
				var sFile=this.o_ref.p_recent[ev.key.substr(12)];
				if (sFile)
					this.o_ref.loadDocument(sFile);
			}
		else
			switch (ev.key)
				{
					case 'file_new':
						this.o_ref.newDocument(FAStrings.untitled_scenario);
					break;
					case 'file_save':
						this.o_ref.saveDocument(this.o_ref.p_scenario.file);
					break;
					case 'file_saveas':
						this.o_ref.saveDocument(null);
					break;
					case 'file_open':
						this.o_ref.loadDocument();
					break;
					//case 'file_merge': break;
					case 'file_pref':
					break;
					case 'file_exit':
						this.o_ref.exit();
					break;
					case 'edit_snap':
						FAUtil.is_snapping=ev.checked ? true : false;
						this.o_ref.storePreferences();
					break;
					case 'edit_rulers': break;
					case 'edit_grid':
						if (ev.checked)
							{
								this.o_ref.z_editor_body.style.backgroundImage='url('+this.o_ref.images_dir+'workfield_bg.gif)';
								this.o_ref.is_grid=true;
							}
						else
							{
								this.o_ref.z_editor_body.style.backgroundImage='none';
								this.o_ref.is_grid=false;
							}
						this.o_ref.storePreferences();
					break;
					case 'edit_newframe':
						this.o_ref.p_scenario.addFrame();
					break;
					case 'edit_delframe':
						if (this.o_ref.z_curframe_tl)
							{
								this.o_ref.p_scenario.removeFrame(this.o_ref.z_curframe_tl.id);
								this.o_ref.z_curframe_tl=null;
							}
					break;
					case 'edit_insimage':
						if (this.o_ref.z_curframe)
							this.o_ref.z_curframe.addItem('image');
					break;
					case 'edit_inslabel':
						if (this.o_ref.z_curframe)
							this.o_ref.z_curframe.addItem('label');
					break;
					case 'edit_inshotspot':
						if (this.o_ref.z_curframe)
							this.o_ref.z_curframe.addItem('hotspot');
					break;
					case 'edit_instext':
						if (this.o_ref.z_curframe)
							this.o_ref.z_curframe.addItem('textinput');
					break;
					case 'edit_insmsg':
						if (this.o_ref.z_curframe)
							this.o_ref.z_curframe.addItem('message');
					break;
					case 'edit_inscheckbox':
						if (this.o_ref.z_curframe)
							this.o_ref.z_curframe.addItem('checkbox');
					break;
					case 'edit_insbutton':
						if (this.o_ref.z_curframe)
							this.o_ref.z_curframe.addItem('button');
					break;
					case 'edit_delobj':
						var range=this.o_ref.getCurrentRange(), i;
						if (range)
							for(i=0; i<range.length; i++)
								range.item(i).o_ref.removeItem(range.item(i).local_id);
					break;
					case 'scenario_pref':
						if (this.p_scenario)
							this.p_scenario.showPreferences();
					break;
					case 'scenario_testcur':
						this.o_ref.runTest(true);
					break
					case 'scenario_test':
						this.o_ref.runTest();
					break;
					case 'help_main':
						this.o_ref.showHelp();
					break;
			}
	}
	
FlexAbility.prototype.showHelp=function()
	{
		oRes=showModalDialog(this.scripts_dir+"help.html", arguments, "border:thin; center:yes; dialogHeight:500px; dialogWidth:650px; maximize:yes; minimize:no; status:no; resizable:yes");
	}

FlexAbility.prototype.runTest=function(bFromCurrent)
	{
		if (!this.p_scenario)
			return false;
		var sCode=this.p_scenario.getXmlString(true), oRes,
		arguments = 
			{
				'code' : sCode,
				'scenario' : this.p_scenario,
				'editor': this,
				'player' : this.player_dir,
				'base_path' : this.work_dir,
				'start_frame' : ((bFromCurrent && this.z_curframe) ? this.z_curframe.id : null)
			}
		oRes=showModalDialog(this.scripts_dir+"test.html", arguments, "border:thin; center:yes; dialogHeight:650px; dialogWidth:850px; maximize:yes; minimize:no; status:no; resizable:yes");
		return true
	}

FlexAbility.prototype.onProcessDocument=function(result)
	{
		var t=String(result.responseData), cmd, args;
		if (cmd=t.match(/<!--(LOAD|SAVE)\s+\{(OK|ERROR)\}(.+)-->\n/i))
			{
				args=cmd[3].match(/\{([^\}]*)\}/g);
				for(var i=0; i<args.length; i++)
					args[i]=args[i].replace(/\{([^\}]*)\}/, "$1");
				if (cmd[2]!='OK')
					{
						Message(args[0], 'exclamation', 'ok', 'Error!');
					}
				if (cmd[1].toLowerCase()=='load')
					{
						if (cmd[2]=='OK')
							{
								t=t.replace(/\s/mg, ' ');
								if (text=t.match(/<FASCRIPT(\s+[^>]*)*>(.*?)<\/FASCRIPT>/i))
									{
										if (text[2])
											{
												if (result.data.p_scenario)
													result.data.p_scenario.clear();
												result.data.p_scenario = new FAScenario();
												result.data.p_scenario.o_ref = result.data;
												result.data.p_scenario.file=args[1];
												result.data.p_scenario.setXmlString(text[2])
												result.data.addToRecent(args[0]+args[1]);
												result.data.p_src=result.data.p_scenario.getXmlString();
											}
									}
								else
									{
										//TODO errors, errors!	
									}
								result.data.setStatus(FAStrings.doc_loaded);
							}
						else
							{
								result.data.setStatus(FAStrings.doc_load_failed);
							}
					}
				else
					{
						if (cmd[2]=='OK')
							{
								result.data.setStatus(FAStrings.doc_saved);
								result.data.p_src=result.data.p_scenario.getXmlString();
							}
						else
							{
								result.data.setStatus(FAStrings.doc_save_failed);
							}
					}
			}
	}

FlexAbility.prototype.isChanged=function()
	{
		if (this.p_scenario)
			{
				var src=this.p_scenario.getXmlString();
				if ((this.p_src || src) && (this.p_src != src))
					{
						return true;
					}
			}
		return false;
	}

FlexAbility.prototype.addToRecent=function(sFile)
	{
		for (var i=0; i < this.p_recent.length; i++)
			if (this.p_recent[i]==sFile)
				{
					this.p_recent.splice(i, 1);
					break;
				}

		this.p_recent.unshift(sFile);

		if (this.max_recent_files)
			{
				this.p_recent=this.p_recent.slice(0, this.max_recent_files);
			}
		if (document.cookies)
			{
				document.cookies.create('recent_files', this.p_recent.join(':::'));
			}
	}

FlexAbility.prototype.newDocument=function(sTitle, bNoCheck)
	{
		if (!bNoCheck && this.beforeUnload && !this.beforeUnload())
			return false;

		if (this.p_scenario)
			this.p_scenario.clear();
		this.p_scenario = new FAScenario();
		this.p_scenario.o_ref = this;
		FAUtil.items_names={};
		if (sTitle)
			{
				this.p_scenario.setTitle(sTitle);
			}
		this.p_scenario.addFrame();
		this.p_src=this.p_scenario.getXmlString();
		this.disableControlPanel(true);
		return true;
	}
	
FlexAbility.prototype.fileDialog = function(oArgs, bImgsDir)
	{
		var res;
		if (oArgs)
			{
				this.images_work_dir=this.images_work_dir;
				oArgs.script_file=this.server_script;
				oArgs.start_folder = (bImgsDir && this.images_work_dir) ? this.images_work_dir : '';
				oArgs.list_file=oArgs.script_file;
                //alert(this.images_work_dir);
			}
		res=showModalDialog(this.scripts_dir+'file.html', oArgs, 'border:thin; center:yes; dialogHeight:'+(oArgs.save_only ? 460 : 525)+'px; dialogWidth:600px; help:yes; maximize:no; minimize:no; status:no; resizable:yes');
		//alert(res['filename']);
		//alert(res['dirname']);
		//alert(res['host']);
		//alert(res['url']);
        return res;
	}

FlexAbility.prototype.saveDocument=function(sFile)
	{
		if (!this.p_scenario)
			return false;
		var query, rq, res, oArgs;
		if (sFile===undefined)
			sFile=this.p_scenario.file;
		if (sFile && !this.isChanged())
			return false;
		if (!sFile && (sFile===null || !this.p_scenario.file))
			{
				oArgs={
						"title" : FAStrings.save_scenario_as,
						"nourl" : true,
						'save_only': true
						};
                        
				res=this.fileDialog(oArgs);
				if (res)
					sFile=res.filename;
				else
					return false;
			}
		query='<!--SAVE {' + (this.current_folder ? this.current_folder : '/') + '}{' + sFile + '}-->\n' + this.p_scenario.getXmlString();
		rq=xHttp.getRequest(this.server_script+'&io=1', query);
		rq.async=false;
		rq.data=this;
		rq.handler=this.onProcessDocument;
		rq.execute();
		return true;
	}

FlexAbility.prototype.loadDocument=function(sFile, bNoCheck)
	{
		var query, rq, res, sFile,
				oArgs={
					"title" : FAStrings.load_scenario,
					"nourl" : true
				};

		if (!bNoCheck && this.beforeUnload && !this.beforeUnload())
			return false;

		if (!sFile)
			{
				res=this.fileDialog(oArgs);
			
            if (res)
					sFile=res.filename;
				else
					return false;
			}

		if (this.p_scenario)
			this.p_scenario.clear();
		this.p_scenario = new FAScenario();
		this.p_scenario.o_ref = this;
		FAUtil.items_names={};
		this.p_scenario.addFrame();
		this.p_src=this.p_scenario.getXmlString();
		this.disableControlPanel(true);
		query='<!--LOAD {' + (this.current_folder ? this.current_folder : '/') + '}{' + sFile + '}-->\n';
		rq=xHttp.getRequest(this.server_script+'&io=1', query);
		rq.async=false;
		rq.data=this;
		rq.handler=this.onProcessDocument;
		rq.execute();
		return true;
	}

FlexAbility.prototype.exit = function()
	{
		self.close();
	}
	
FlexAbility.prototype.storePreferences = function()
	{
		var TL=this.h_frame_doc.getElementById(this.p_id+'_tline'), PROP=this.h_frame_doc.getElementById(this.p_id+'_property'),
			pref=TL.height+'::'+PROP.width+'::'+PROP.height+'::'+(this.is_grid ? 1 : 0) + '::' + (FAUtil.is_snapping ? 1 : 0);
		document.cookies.create('fa_pref', pref);
	}

FlexAbility.prototype.getPreferences = function()
	{
		var pref_str=document.cookies.get('fa_pref'),
			pref={
				'timeline_height' : 0,
				'property_width' : 0,
				'property_height' : 0,
				'grid': false,
				'snapping': false
			}
		if (pref_str && (pref_str=pref_str.split('::')))
			{
				pref.timeline_height=pref_str[0];
				pref.property_width=pref_str[1];
				pref.property_height=pref_str[2];
				pref.grid=Boolean(parseInt(pref_str[3]));
				pref.snapping=Boolean(parseInt(pref_str[4]));
			}
		return pref;
	}