<?php
class FlexAbility extends FlexServer
	{
		const
			IMAGES_DIR='images',
			SCRIPTS_DIR='scripts';

		public
			$player_dir='',
			$player_name='faplayer.swf',
			$images_work_dir='',
			$scripts_dir='';
	
		function loadFile($_path, $_folder, $_file)
			{
				
				
				echo '<!--LOAD {OK}{'.$_folder.'}{'.basename($_file).'}-->', "\n";
				if (false!==$content=file_get_contents($_path))
					{
						$this->editor_encoding=strtolower($this->editor_encoding);
						$this->files_encoding=strtolower($this->files_encoding);
						
						$content = iconv($this->files_encoding,$this->editor_encoding,$content);
						//$content=FLEX::CONVERT($content, $this->editor_encoding, $this->files_encoding);
						echo $content;
					}
			}
		
		function saveFile($_path, $_folder, $_file)
			{
				if (preg_match('/<FASCRIPT(\s+[^>]*)*>(.*)<\/FASCRIPT>/is', $this->p_input, $matches))
					{
					//	$this->editor_encoding=strtolower('windows-1251');
						//$this->files_encoding=strtolower('utf-8');
						/*$content="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<FASCRIPT ".$matches[1].">\n".iconv($this->editor_encoding, $this->files_encoding,$matches[2])."\n</FASCRIPT>";*/
						$content="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<FASCRIPT ".$matches[1].">\n".($matches[2])."\n</FASCRIPT>";
						//file_put_contents($_path, $matches[2]);
						if (file_put_contents($_path, $content)) echo '<!--SAVE {OK}{'.$_folder.'}{'.$_file.'}-->', "\n";
					}
			}

		function renderStandAlone()
			{
				FLEX::NO_CACHE();
				?>
<HTML><HEAD>
<TITLE><?php echo ($this->title ? $this->title : 'Flexability'); ?></TITLE>
<META http-equiv="Content-Type" content="text/html; charset=<?php echo $this->charset;?>">
<LINK href='scripts/flexability.css' rel="stylesheet" type="text/css">
<SCRIPT src="scripts/lang_ru.js"></SCRIPT>
<SCRIPT src='scripts/menu.js'></SCRIPT>
<SCRIPT src='scripts/tree.js'></SCRIPT>
<SCRIPT src='scripts/fautil.js'></SCRIPT>
<SCRIPT src='scripts/faframe.js'></SCRIPT>
<SCRIPT src='scripts/fascenario.js'></SCRIPT>
<SCRIPT src='scripts/flexability.js'></SCRIPT>
<SCRIPT src="scripts/pan_grid.js"></SCRIPT>
<SCRIPT src="scripts/xml.js"></SCRIPT>
<SCRIPT src="scripts/message.vbs" language="vbscript"></SCRIPT>
<STYLE id="workfield_style">
BODY.workframe {border:none; margin: none; background:#404040; border:#646464 2px groove; border-left-color:#696969; border-top-color:#696969; background:#505050}
BODY DIV.workfield {border:#646464 1px solid; border-left-color:#303030; border-top-color:#303030; background:#454545; width:100%; height:100%; padding:5px; overflow:auto;  scrollbar-base-color:#404040; scrollbar-arrow-color:#b6b6b6; scrollbar-3dlight-color:#404040; scrollbar-highlight-color:#606060; scrollbar-face-color:#606060; scrollbar-darkshadow-color:#404040; }
.fa_screen {display:none; width:1px; height:1px; background:transparent; font-size:1px; position:absolute;}
.fa_screen .empty {border:1px dashed #777777; background-image:url(images/empty_bg.gif)}
.fa_screen IMG {}
.fa_screen INPUT.hotspot {border:1px solid #ff0000; background:#dd2222; filter:alpha(opacity=35);}
.fa_screen INPUT.message {border:#646464 1px dashed; cursor:move; background-image:url(images/transp_message.gif); border-right-color:#303030; border-bottom-color:#303030; background-color:#454545; background-repeat:no-repeat}
.fa_screen INPUT.label {border:1px solid #dddd44; background:#ffffff; filter:alpha(opacity=50); font-size:11px; color:#000000}
.fa_screen DIV.text {}
.fa_screen .co_selected {border:1px solid #ffffff}
</STYLE>

<STYLE id="timeline_style">
BODY.timeline {border:none; margin: none; background:#404040; padding:0px; margin:0px; }
BODY DIV.workfield {background:#454545; padding:4px; width:expression(this.parentElement.clientWidth-28); height:100%; overflow-x:scroll; overflow-y:hidden; white-space:nowrap; float:left; border:#646464 1px solid; border-left-color:#303030; border-top-color:#303030;
scrollbar-base-color:#404040; scrollbar-arrow-color:#b6b6b6; scrollbar-3dlight-color:#404040; scrollbar-highlight-color:#606060; scrollbar-face-color:#606060; scrollbar-darkshadow-color:#404040; 
}
BODY DIV.timeline_panel {padding-top:2px; text-align:center; float:right; height:100%; width:27px; cursor:default; background:#48555f; color:#aaaaaa; font-size:11px; border:1px solid #55636e; border-bottom-color:#2d3840; border-right-color:#2d3840}
BODY SPAN {width:18px; height:17px; text-align:center; display:block; font-size:11px; padding:0 0 1px 0; margin:3px 0px; cursor:default; border:#48555f 1px solid; color:#ffffff; font-family:Arial}
BODY SPAN.btnover {border:#646464 1px solid; border-bottom-color:#303030; border-right-color:#303030;}
BODY SPAN.btndown {border:#646464 1px solid; border-top-color:#303030; border-left-color:#303030; padding:1px 0 0 1px;}
BODY DIV.timeline_panel DIV {writing-mode: tb-rl;  padding-top:16px; padding-right:6px; letter-spacing:1px; height:10px; line-height:11px;}

.frame_holder {background-color:#4d4d4d; width:127px; height:97px; background-image:url(images/frame_b2.gif); background-repeat: repeat-y; background-position:top right; display:inline; cursor:default;}
.frame_1corn {background:url(images/frame_b1.gif) no-repeat; background-position:top right; font-size:1px; width:127px; height:90; padding-right:7px;}
.frame_body {width:100%; height:90px; border:1px solid #757575; margin:0px; font-size:12px; overflow:hidden!important; overflow-y:hidden!important; border-bottom:none}

.frame_shadow {width:100%; height:7px; background-image:url(images/frame_b4.gif); background-repeat: repeat-x; background-position:top left; font-size:1px;}
.frame_2corn {background:url(images/frame_b3.gif) no-repeat; background-position:bottom right; font-size:1px; width:100%; height:7px;}
.frame_3corn {background:url(images/frame_b5.gif) no-repeat; background-position:bottom right; font-size:1px; width:7px; height:7px;}

.frame_options {font-size:10px; font-family:Tahoma; background-color:#757575; vertical-align:middle;  border:1px solid #757575; border-top:none}
.frame_options IMG {width:9px; height:6px; float:right; margin-top:5px; margin-right:3px; cursor:pointer}
INPUT, .frame_name {margin-left:5px; width:90px; height: 16px; white-space:nowrap; text-overflow:ellipsis; overflow-x:hidden; vertical-align:middle}
INPUT {background:#909090; font-family:Tahoma; border:none; font-size:10px; padding:0px; margin:0px; height:14px}
.selected {background-color:#4d4b48}
.selected .frame_body {border-color:#ea9815}
.selected .frame_options {border-color:#ea9815; background-color:#767066}
</STYLE>

<STYLE id="tree_style">
BODY.tree {
	border:none; margin: 3px; border:#646464 2px groove; border-left-color:#696969; border-top-color:#696969; background:#505050
}

BODY .workfield {
	border:#646464 1px solid; border-left-color:#303030; border-top-color:#303030; width:100%; height:100%; overflow:auto;
	scrollbar-base-color:#404040; scrollbar-arrow-color:#b6b6b6; scrollbar-3dlight-color:#404040; scrollbar-highlight-color:#606060; scrollbar-face-color:#606060; scrollbar-darkshadow-color:#404040;
}

.tree_main {
	cursor:default; width:100%; height:100%; overflow-y:auto; white-space:nowrap; padding-left:2px;
	scrollbar-base-color:#404040; scrollbar-arrow-color:#b6b6b6; scrollbar-3dlight-color:#404040; scrollbar-highlight-color:#606060; scrollbar-face-color:#606060; scrollbar-darkshadow-color:#404040;
}

.tree_main U {
	text-decoration:none; display:none; height:18px; width:100%; padding:0; margin:0; font-family:Arial, Helvetica; font-size:1px; 
}

.tree_main IMG {width:19px; height:16px; border:none; vertical-align:top; background-image:url(images/tree_default.gif); background-position:left top; background-repeat:no-repeat; border-top:1px solid #505050; border-bottom:1px solid #505050}
.tree_main DIV {height:18px; vertical-align:center; display:block; margin-left:16px; background-image:url(images/tree_line.gif); background-position:left top; background-repeat:repeat-y;}
.tree_main DIV.last_node {background-image:url(images/tree_corner.gif); background-repeat:no-repeat}
.tree_main B {background-image:url(images/tree_default.gif); width:19px; height:16px; font-size:10px; vertical-align:top; background-repeat:no-repeat; background-position:left top;}
.tree_main SPAN {padding:0 2px; height:18px; margin:0px; font-family:Arial, Helvetica; border: 1px solid #505050; color:#9d9d9d; font-size:12px}
.tree_main SPAN.edited {padding:0; height:18px; width:102px; border:1px solid #646464; margin-bottom:-1px; font-size:12px; display:inline; vertical-align:top; margin:0; color:#9d9d9d}
.tree_main INPUT {width:100%; height:16px; border:none; font-size:12px; display:inline; margin:-1px 0 -1px 0; vertical-align:top; background:transparent; font-family:Arial, Helvetica; color:#9d9d9d}
.tree_main SPAN.selected {background-color:#08246B; color:white; border: 1px dotted #646464}
.tree_main SPAN.notselected {background-color:none; color:#9d9d9d; border: 1px solid #505050}
.tree_main .dover_top { border-top:1px dotted #ffffff}
.tree_main .dover_bottom {border-bottom:1px dotted #cccccc}
.last_node_joint {background-image:url(/system_imgs/tree_f0.gif)}
.divDrg { height:18px; position:absolute; z-index:25; top:0px; left:0px; filter:alpha(opacity=50);  font-family:Arial, Helvetica; font-size:12px; color:#9d9d9d}

.panel_header {cursor:default; background:#48555f; width:100%; overflow-x:hidden; text-overflow:ellipsis; white-space:nowrap; color:#aaaaaa; font-size:11px; height:22px;  padding:3px 2px 3px 5px; border:1px solid #55636e; border-bottom-color:#2d3840; border-right-color:#2d3840; vertical-align:top}
.panel_body {width:100%; height:100%; color:#aaaaaa}
.panel_header DIV {float:right; text-align:center; vertical-align:top;}
.panel_header DIV SPAN {width:17px; height:17px; text-align:center; font-size:11px; padding:1px 0 1px 1px; margin:0px 3px; cursor:default; border:#48555f 1px solid; color:#ffffff; font-family:Arial}
.panel_header DIV SPAN.btnover {border:#646464 1px solid; border-bottom-color:#303030; border-right-color:#303030;}
.panel_header DIV SPAN.btndown {border:#646464 1px solid; border-top-color:#303030; border-left-color:#303030; padding:1px 0 0 2px;}
.panel_header DIV SPAN.btnchecked {width:17px; height:17px; text-align:center; font-size:11px; margin:0px 3px; cursor:default; color:#ffffff; font-family:Arial; background:#3d3d3d}
</STYLE>
	
<STYLE id="property_style">
BODY.property {border:none; margin: 3px; border:#646464 2px groove; border-left-color:#696969; border-top-color:#696969; background:#505050}
BODY .workfield {
	border:#646464 1px solid; border-left-color:#303030; border-top-color:#303030; width:100%; height:100%;
	scrollbar-base-color:#404040; scrollbar-arrow-color:#b6b6b6; scrollbar-3dlight-color:#404040; scrollbar-highlight-color:#606060; scrollbar-face-color:#606060; scrollbar-darkshadow-color:#404040;
}

.grid_holder {width:100%; height:100%; overflow-y:scroll;  vertical-align:top;
scrollbar-base-color:#404040; scrollbar-arrow-color:#b6b6b6; scrollbar-3dlight-color:#404040; scrollbar-highlight-color:#606060; scrollbar-face-color:#606060; scrollbar-darkshadow-color:#404040; 
}

.grid {background-color:#454545; border-collapse:collapse; table-layout:fixed; font-family: Tahoma; font-size:11px; width:100%}
.grid TR {background-color:none; height:19px;}
.grid TR.selected {background-color:#5a5a5a; color:white}

.grid TD {vertical-align:top; color: #aaaaaa; border:1px solid #404040; padding:0px; text-overflow:ellipsis}
/*.grid TD {width:100%; overflow-x:hidden; height:18px}*/
.grid TD.label  {border-right: 1px solid #303030; padding:2px 2px 2px 5px; font-family:Tahoma;}
.grid TD.readonly  {text-align:right; font-size:11px; color:#aaaaaa; padding:0 3px 0 3px; font-family:Tahoma}
.grid TD.htmlarea {height:84px; width:100%; word-wrap: break-word}
.grid  SPAN.htmlareabody {background:#404040; width:100%; height:100%; overflow-y:auto; white-space:normal; word-wrap: break-word}

.grid TR INPUT {width:100%; text-align:right; padding:2px 3px 0 3px; background:#404040; font-size:11px; color:#aaaaaa; height:18px; border:none; overflow-x:hidden; text-overflow:ellipsis}
.grid TR INPUT.dialog {width:expression(this.parentElement.clientWidth - 19); height:18px; text-align:right}
.grid TR INPUT.button {height:17px; border:1px solid #646464; border-right-color:#303030; border-bottom-color:#303030; width:90%; padding:1px; text-align:center; font-size:10px}
.grid TR TEXTAREA {width:100%; background:#404040; font-size:11px; color:#aaaaaa; height:64px; border:none; font-family:Tahoma; scrollbar-base-color:#404040; scrollbar-arrow-color:#b6b6b6; scrollbar-3dlight-color:#404040; scrollbar-highlight-color:#606060; scrollbar-face-color:#606060; scrollbar-darkshadow-color:#404040;}
.grid TR SELECT {width:100%; background:#404040; font-size:11px; color:#aaaaaa}

.grid TR.selected INPUT, .grid TR.selected SELECT, .grid TR.selected TEXTAREA, .grid TR.selected DIV.htmlareabody {background:#555555; color:#ccccc}

.grid TR BUTTON {width:17px; height:17px; font-size:11px; padding:0px; margin:0px; border:1px solid #646464; border-right-color:#303030; border-bottom-color:#303030; background-color:#454545; color:#aaaaaa}

.panel_header {cursor:default; background:#48555f; width:100%; overflow-x:hidden; text-overflow:ellipsis; white-space:nowrap; color:#aaaaaa; font-size:11px; height:22px;  padding:3px 2px 3px 5px; border:1px solid #55636e; border-bottom-color:#2d3840; border-right-color:#2d3840; vertical-align:top}
.panel_body {width:100%; height:100%; color:#aaaaaa}
.panel_header DIV {float:right; text-align:center; vertical-align:top;}
.panel_header DIV SPAN {width:18px; height:17px; text-align:center; display:block; font-size:11px; padding:0 0 1px 0; margin:0px 3px; cursor:default; border:#48555f 1px solid; color:#ffffff; font-family:Arial}
.panel_header DIV SPAN.btnover {border:#646464 1px solid; border-bottom-color:#303030; border-right-color:#303030;}
.panel_header DIV SPAN.btndown {border:#646464 1px solid; border-top-color:#303030; border-left-color:#303030; padding:1px 0 0 1px;}
</STYLE>
</HEAD>
<BODY style="margin:0px" scroll=no>
<SCRIPT>
FA=new FlexAbility();
FA.setStyleSheet('workframe', 'workfield_style');
FA.setStyleSheet('timeline', 'timeline_style');
FA.setStyleSheet('property', 'property_style');
FA.setStyleSheet('tree', 'tree_style');
FA.is_stand_alone=true;
<?php
	if ($this->root_dir)
		echo 'FA.root_dir="/'.trim($this->root_dir, '/').'";';
	if ($this->work_dir)
		echo 'FA.work_dir="/'.trim($this->work_dir, '/').'";';
	if ($this->title_prefix)
		echo 'FA.title_prefix="'.$this->title_prefix.'";';
	if ($this->images_dir)
		echo 'FA.images_dir="/'.trim($this->images_dir, '/').'/";';
	if ($this->scripts_dir)
		echo 'FA.scripts_dir="/'.trim($this->scripts_dir, '/').'/";';
	if ($this->images_work_dir)
		echo 'FA.images_work_dir="'.trim($this->images_work_dir, '/').'";';
	if ($this->player_dir)
		echo 'FA.player_dir="/'.trim($this->player_dir, '/').'/'.$this->player_name.'";';
?>
FA.create();
<?php
	if ($this->file)
		{
			$file=FLEX::CANONICAL_NAME($this->file, true);
			
			if (file_exists($file)) {
				echo 'document.body.onload=function () {FA.loadDocument("', $this->file, '", true);}';
			}
		}
?>
</SCRIPT>
</BODY>
</HTML>
<?php
			}
	}
?>