if (!self._p_cancel_event)
	{
		_p_cancel_event=new Function('this.document.parentWindow.event.cancelBubble=true;return true;');
	}

function Tree(id)
	{
		this.id=id ? id : ("tree"+String(Math.round(Math.random()*100)*Math.round((t=new Date).getTime()/100)));
		this.p_temp_obj = null;
		this.keys = {};
		this.groups = {
			};

		this.z_size = 25;
		this.z_iheight = 18;
		this.z_delta = null;
		this.z_z = 0;
		this.z_dragged = null;
		this.z_evo = null;
		
		this.o_dragger;
		
		this.z_body = null;
		this.z_tree = null;

		this.z_drag_over = null;
		
		this.p_caption = 'Default Caption';
		this.p_load_obj = null;
		this.p_temp_cur = null;
		this.p_current = null;
		this.p_disabled = null;
		this.p_cursor = null;
		this.p_doc = null;
		
		this.p_id_filter = {};
		this.p_group_filter = {};
		
		this.z_ready = true;

		this.onselect = null;
		this.ondblclick = null;
		this.onmove = null;
		this.onkeydown = null;
		this.onrename = null;
		this.onbeforemove = null;
		
		return this;
}

Tree.prototype.create=function()
	{
		document.write('<DIV id="'+this.id+'_holder"></DIV>');
		this.p_holder=document.all[this.id+'_holder'];
		this.p_doc=document;
		this.assemble();
	}

Tree.prototype.wrapAround=function(oObj, bInheritStyle)
	{
		if (!oObj)
			return false;
		var css='', doc=oObj.document;
		this.p_holder=doc.createElement('DIV');
		this.p_holder.id=this.id;
		
		if (bInheritStyle)
			{
				this.p_holder.style.cssText=css;
				if (oObj.className)
					this.p_holder.className=oObj.className;
				css=oObj.runtimeStyle.cssText;
			}
		oObj.replaceNode(this.p_holder);
		this.p_doc=doc;
		this.assemble();
	}


Tree.prototype.assemble=function()
	{
		this.p_holder.innerHTML='<DIV class="divDrg" noWrap=true><IMG src="images/empty.gif" style="background-position-y: -80px"><SPAN></SPAN></DIV><DIV style="width:100%; height:100%" hideFocus><DIV  class="tree_main" hideFocus noWrap=true sKey="0" iGroup="0"><I unselectable=on hideFocus noWrap=true></I><IMG src="images/empty.gif" hideFocus style="background-position-y: -80px" TYPE=2 /><SPAN noWrap iType=3>&nbsp; Caption</SPAN><U style="display:block; margin-left:-16px" class="main_frame" hideFocus unselectable=on></U></DIV></DIV>';
		this.z_body=this.p_holder.lastChild.firstChild;
		this.z_tree=this.z_body.lastChild;
		this.o_dragger=this.p_holder.firstChild;
		this.z_body.level=0;
		this.z_body.iGroup=0;
		this.z_body.o_ref=this;
		this.z_body.onmousedown=this.pMouseDown;
		this.z_body.onmouseup=this.pMouseUp;
		this.z_body.ondblclick=this.pDblClick;
		this.z_body.ondragstart=this.pDragStart;
		this.z_body.onkeydown=this.pKeyDown;
		this.z_body.oncontrolselect=this.pEvControl;
		this.clear();
	}
	
Tree.prototype.pMouseDown=function()
	{
		ev=this.document.parentWindow.event;
		var t=ev.srcElement;
		if (!(ev.srcElement && ev.srcElement.iType))
			{
				if (ev.srcElement.className=='main_frame')
					this.o_ref.pSelect();
				return false;
			}
		if (ev.srcElement.iType==1 && ev.button==1)
			this.o_ref.pExpand(ev.srcElement.parentElement);
		else
			this.o_ref.pSelect(ev.srcElement.parentElement);
	}

Tree.prototype.pMouseUp=function()
	{
		ev=this.document.parentWindow.event;
		var t=ev.srcElement;
		if (ev.srcElement.iType)
			t=t.parentElement;
		if ((t==this.o_ref.p_current) && ev.button==1 || ev.button==2)
			{
				var v=document.createEventObject();
				v.srcRootElement=this.o_ref;
				v.key=this.o_ref.p_current ? this.o_ref.p_current.sKey : '';
				v.eventName='onselect';
				this.o_ref.z_body.fireEvent('oncontrolselect', v);
			}
		t=undefined;
	}

Tree.prototype.pKeyDown=function()
	{
		ev=this.document.parentWindow.event;
		if(!this.o_ref.p_current || this.o_ref.p_disabled)
			return false;
		if (ev.srcElement.tagName=='INPUT') return true;
		switch (ev.keyCode)
			{
				case 36:
					this.o_ref.pSelect(this);
					break;
				case 35:
					var u=this.o_ref.z_tree.lastChild;
					while ((u.iFlags&4) && u.isExpanded==true)
						u=u.lastChild.lastChild;
					if (u) this.o_ref.pSelect(u);
					break;
				break;
				case 32:
					if (!(this.o_ref.p_current.iFlags&8))
						this.o_ref.pExpand(this.o_ref.p_current);
					break;
				case 113:
						this.o_ref.setNodeEditable(this.o_ref.p_current.sKey);
					break;
				default:
					var v=document.createEventObject();
					v.srcRootElement=this.o_ref;
					v.keyCode=ev.keyCode;
					v.eventName='onkeydown';
					return this.o_ref.z_body.fireEvent('oncontrolselect', v);
					break;
			}
		ev.returnValue=false;
		return false;
	}
	
Tree.prototype.setGroupFilter=function(aGroups, bMode)
	{
		var i=0;
		if (!this.z_ready)
			return false;
		this.z_ready=false;
		if (bMode)
			{
				for (i=0; i<aGroups.length; i++)
					this.p_group_filter[aGroups[i]]=true;
				for(i in this.keys)
					{
						if (this.p_group_filter[this.keys[i].iGroup])
							{
								this.keys[i].style.display='none';
								this.keys[i].parentElement.iVisibleChilds--;
								this.pResolveNode(this.keys[i].parentElement.parentElement);
							}
					}
			}
		else
			{
				for(i in this.keys)
					if (this.p_group_filter[this.keys[i].iGroup])
						{
							this.keys[i].style.display='block';
							this.keys[i].parentElement.iVisibleChilds++;
							this.pResolveNode(this.keys[i].parentElement.parentElement);
						}
				for (i=0; i < aGroups.length; i++)
					delete this.p_group_filter[aGroups[i]];
			}
		this.z_ready=true;
		return true;
	}

Tree.prototype.setIdFilter=function(aIDs, bMode)
	{
		if (!this.z_ready)
			return false;
		this.z_ready=false;
		var i=0;
		if (bMode)
			{
				for (i=0; i<aIDs.length; i++)
					{
						this.p_id_filter[aIDs[i]]=true;
						if (this.keys[aIDs[i]])
							this.keys[aIDs[i]].style.display='none';
					}
			}
		else
			{
				for (i=0; i<aIDs.length; i++)
					{
						delete this.p_id_filter[aIDs[i]];
						if (this.keys[aIDs[i]])
							this.keys[aIDs[i]].style.display='block';								
					}
			}
		this.z_ready=true;
		return true;
	}

Tree.prototype.pDblClick=function()
	{
		var t=this.document.parentWindow.event.srcElement;				
		if (t.iType && t.iType!=1)
			{
				
				if (t.iType==2)
					{
						if ((t.parentElement.iFlags&4) || t.parentElement.isHasChildren)
							this.o_ref.pExpand(t.parentElement);
					}
				else
					{
						var V=document.createEventObject();
						V.srcRootElement=this.o_ref;
						V.key=this.o_ref.p_current ? this.o_ref.p_current.sKey : '';
						V.eventName='ondblclick';
						this.o_ref.z_body.fireEvent('oncontrolselect', V);
					}
				
				this.document.parentWindow.event.cancelBubble=true;
				return false;
			}
	}
	
Tree.prototype.getNodeFromElement=function(oElem)
	{
		if (oElem.iType)
			return oElem.parentElement.sKey ? oElem.parentElement.sKey : false;
		return false;
	}

Tree.prototype.expandNode=function(sKey, bMode)
	{
		if (this.keys[sKey])
			{
				if (this.keys[sKey].isExpanded!=bMode)
					{
						this.pExpand(this.keys[sKey]);
					}
			}
	}

Tree.prototype.insertNode=function(sKey, sTitle, sParentKey, iGroup, iFlags, iIconId, oData, sNextKey)
	{
		var oParent=this.keys[sParentKey];
		if (!oParent)
			oParent=this.z_body;

		if (isNaN(iFlags))
			iFlags=0;

		if (isNaN(iGroup))
			iGroup=0;

		if (!oParent.oHolder)
			return false;
		
		if (!this.pIsAcceptable(oParent.iGroup, iGroup))
			return false;
		var
			oNode=this.p_doc.createElement('DIV'),
			oTitle=this.p_doc.createElement('SPAN'),
			oNext=this.keys[sNextKey],
			oHolder=this.p_doc.createElement('U'),
			oJoint=this.p_doc.createElement('B'),
			oIcon=this.p_doc.createElement('IMG');

		oNode.iFlags=iFlags | 1;
		oNode.oData=oData;
		oNode.iGroup=iGroup ? iGroup : 0;
		oNode.icon = (iIconId && iIconId > 0) ? iIconId : oNode.iGroup;
		oNode.sKey=sKey;
		oNode.sTitle=sTitle;
		oNode.level = oParent.level+1;
		oNode.noWrap=true;
		oNode.o_ref=this;
		oNode.hideFocus=true;
		oNode.isHasChildren=false;

		oTitle.innerText=sTitle;
		oTitle.title=sTitle;
		oTitle.hideFocus=true;

		oJoint.iType=1;
		oIcon.iType=2;
		oIcon.hideFocus=true;
		oTitle.iType=3;

		oNode.className='last_node';
		oJoint.className='last_node_joint';
		oIcon.src='images/empty.gif';

		if (iFlags & 4)
			{
				if (iFlags & 64)
					{
						oJoint.style.backgroundPositionY=-64;
						oHolder.style.display='block';
						oNode.isExpanded=true;
					}
				else
					oJoint.style.backgroundPositionY=-48;
			}
		else
			oJoint.style.backgroundPositionY=0;
		
		if (this.groups && this.icon_src && this.groups[oNode.iGroup])
			{
				oIcon.style.backgroundImage='url('+this.icon_src+')';
				oIcon.style.backgroundPositionY=(-16*oNode.icon);
//						oIcon.style.backgroundPositionY=-96;
				/*
						i2.norm=i2.src=t.img.src;
						if (t.over)
							i2.over=t.over.src;
				*/
			}
		else
			{
				if (iFlags & 8)
					oIcon.style.backgroundPositionY=-112;
				else
					oIcon.style.backgroundPositionY=-96;
			}

		this.keys[sKey]=oNode;

		oNode.oJoint=oJoint;
		oNode.oIcon=oIcon;
		
		
		oNode.oTitle=oTitle;

		oNode.appendChild(oJoint);
		oNode.appendChild(oIcon);
		oNode.appendChild(oTitle);

		if (!(iFlags & 0x8))
			{
				oNode.oHolder=oHolder;
				oNode.appendChild(oHolder);
				oNode.oHolder.iVisibleChilds=0;
			}
		if (this.p_group_filter[iGroup])
			oNode.style.display='none';
		oParent.oHolder.insertBefore(oNode, oNext ? oNext : null);
		oParent.oHolder.iVisibleChilds++;
		oParent.isHasChildren=true;
		oParent.iFlags |= 0x4;
		if (oParent !== this.z_body)
			this.pResolveNode(oParent);
		
		this.pResolveNode(oNode);
		return oNode;
	}
	
Tree.prototype.selectNode=function(sKey, bExpandHidden)
	{
		if (this.keys[sKey])
			{
				this.pSelect(this.keys[sKey]);
				if (bExpandHidden && sKey!=0)
					{
						var cObj=this.keys[sKey].parentElement.parentElement;
						while (cObj.sKey!=0 && cObj.isHasChildren && !cObj.isExpanded)
							{
								this.pExpand(cObj);
								cObj=cObj.parentElement.parentElement;
							}
					}
				return true;
			}
		return false;
	}
	
Tree.prototype.removeNode=function(sKey)
	{
		if (this.keys[sKey])
			this.pRemove(this.keys[sKey]);
	}

Tree.prototype.pResolveNode=function(oNode)
	{
		if (oNode.sKey==0)
			return false;
		oNode.className = oNode.nextSibling ? '' : 'last_node';
		if (oNode.previousSibling)
			oNode.previousSibling.className='';
		var g=0;
		if (oNode.oHolder)
			{
				if (oNode.oHolder.iVisibleChilds < 1 || oNode.iFlags&8 || !(oNode.isHasChildren || oNode.iFlags&4))
					{
						oNode.oHolder.style.display='none';
						if (oNode.oHolder.iVisibleChilds < 1 && oNode.isHasChildren)
							oNode.isExpanded=true;
						else
							oNode.isExpanded=false;
					}
				else
					{
						if (oNode.oHolder.style.display!=(oNode.isExpanded ? 'block' : 'none'))
							oNode.oHolder.style.display=(oNode.isExpanded ? 'block' : 'none')
						g=oNode.isExpanded ? -64 : -48;
					}
			}
		oNode.oJoint.style.backgroundPositionY=g;
	}

Tree.prototype.pRemove=function(oNode)
	{
		if (oNode.sKey===0)
			{
				this.clear();
				return false;
			}
		if (!oNode || oNode.iFlags & 0x2)
			return false;
		var i=-1, oPrev, tormv, x;
		if (!(oPrev=oNode.previousSibling))
			{
				oPrev=oNode.parentElement.parentElement;
				oPrev.oHolder.iVisibleChilds--;
				if (oPrev.oHolder.children.length == 1) //FIXIT  1 or 2 ???
					{
						oPrev.oHolder.iVisibleChilds=0;
						oPrev.isHasChildren=false;
						oPrev.iFlags &=~4;
					}
			}
		if (this.p_current==oNode)
			this.p_current=null;
		tormv=oNode.removeNode(true);
		tormv=tormv.getElementsByTagName('DIV');
		
		delete this.keys[oNode.sKey];
		while(x=tormv[++i])
			{
				if (this.p_current==x)
					this.p_current=null;
				delete this.keys[x.sKey]
			}
		this.pResolveNode(oPrev);
	}
	
Tree.prototype.pExpand=function(oNode)
	{
		if (oNode.iFlags&8 || ! (oNode.isHasChildren || oNode.iFlags & 4))
			return false;
		if (oNode.oHolder.iVisibleChilds > 0)
			{
				if (oNode.isExpanded==true)
					{
						oNode.oJoint.style.backgroundPositionY=-48;
						oNode.isExpanded=false;
						oNode.oHolder.style.display='none';
						if (this.p_current && oNode.contains(this.p_current))
							this.pSelect(oNode);
					}
				else
					{
						oNode.oJoint.style.backgroundPositionY=-64;
						oNode.isExpanded=true;
						oNode.oHolder.style.display='block';
						if ((oNode.iFlags & 4) && !oNode.isHasChildren)
							{
								//p_load_obj=x[3];
								//pExec('EXPAND "'+o.key+'";');
								return true;
							}
					}
			}
	}

Tree.prototype.pSelect=function(oNode, bBordersOnly)
	{
		if (this.p_disabled) return;
		var e, t, f=0;
		if (this.p_current)
			{
				this.p_current.oTitle.className='notselected';
				this.p_current.oIcon.style.backgroundPositionX=0;
				this.p_current=null;
			}
		if (oNode && oNode.iFlags)
			{
				
				if (bBordersOnly)
					{
						oNode.oTitle.className='dover_top';
					}
				else
					{
						oNode.oTitle.className='selected';
						oNode.oIcon.style.backgroundPositionX=-19;
					}
				this.p_current=oNode;
				/*
					for (var t=oNode, f=0; t && t.sKey!=0; t=t.parentElement)
						f+=t.offsetTop;
					t = f - this.z_body.scrollTop + 22
					if (t >= this.z_z) this.z_body.scrollTop = f+this.z_delta;
					else if (t <= 36) this.z_body.scrollTop = f;
				*/
			}
		return true;
	}

Tree.prototype.getUniqueID = function(sID)
	{
		var index=1, pre_id, p;
		if (p=sID.match(/(.*)_([\d]+)$/))
			{
				pre_id=p[1];
				index=parseInt(p[2]);
			}
		else
			pre_id=sID;

		if (this.keys[pre_id+'_'+index])
			{
				while(this.keys[pre_id+'_'+index])
					index++;
			}
		return pre_id+'_'+index;
	}

Tree.prototype.pMove=function(oNode, oTarget, sMethod)
	{
		if (sMethod=='inside' && (oNode.iFlags&2))
			return;
		var v, oPrev, oNext;

		oPrev=oNode.previousSibling;
		oNext=oNode.nextSibling;
		v=oNode.parentElement.parentElement;

		oNode=oNode.removeNode(true);
		v.oHolder.iVisibleChilds--;
		if (v.oHolder && !v.oHolder.firstChild)
			{
				v.oHolder.iVisibleChilds=0;
				v.isHasChildren=false;
				v.iFlags &= ~4;
			}
			

		if (oPrev)
 			this.pResolveNode(oPrev);

 		this.pResolveNode(v);

		switch(sMethod)
			{
				case 'before':	oTarget.insertAdjacentElement('BeforeBegin', oNode); break;
				case 'after': 	oTarget.insertAdjacentElement('AfterEnd', oNode); break;
				case 'inside':
						oTarget.oHolder.insertBefore(oNode);
						oTarget.isHasChildren=true;
						oTarget.iFlags |= 4;
						oTarget.oHolder.iVisibleChilds++;
					break;
				default:
					return false;
			}
	
		//if (psib && psib.expanded) _resolveWays(psib);
	
		this.pResolveNode(oNode);

		if (oNode.previousSibling)
			this.pResolveNode(oNode.previousSibling);
		this.pResolveNode(oNode.parentElement.parentElement);

		if (sMethod=='inside' && !oTarget.isExpanded)
			this.pExpand(oTarget);

		return true;
	}

Tree.prototype.renameNode=function(sKey, sTitle)
	{
		if (this.keys[sKey])
			{
				this.keys[sKey].sTitle=sTitle;
				this.keys[sKey].oTitle.innerText=sTitle;
				return true;
			}
		return false;
	}

Tree.prototype.findNode=function(sKey)
	{
		if (this.keys[sKey])
			{
				this.pSelect(this.keys[sKey]);
				return true;
			}
		return false;
	}
	
Tree.prototype.setNodeEditable=function(sKey)
	{
		var oObj=this.keys[sKey], oEdit, width, x;

		if (oObj && !(oObj.iFlags & 0x20))
			{
				this.p_current=oObj;
				oEdit=oObj.oTitle;
				width=parseInt(oEdit.clientWidth);
				oEdit.className='edited';
				
				oEdit.innerHTML='<INPUT type=text value="'+oEdit.innerText+'">';
				x=oEdit.firstChild;
				if (width > x.clientWidth)
					x.style.posWidth=width;
				x.old_text=x.value;
				x.o_ref=this;
				x.onfocus=this.pEditFocus;
				x.onkeydown=this.pEditKeyDown;
				x.onselectstart=_p_cancel_event;
				x.onmousedown=_p_cancel_event;
				x.onblur=this.pEditBlur;
				x.focus();
				x.setActive();
				
			}
	}

Tree.prototype.pEditFocus = function()
	{
		this.select();
	}

Tree.prototype.pEditBlur = function()
	{
		var p=this.document.parentWindow.event.srcElement.parentElement;
		this.o_ref.pSelect();
		this.onblur=null;
		this.onmousedown=null;
		this.onselectstart=null;
		p.innerText=this.old_text;
		this.document.parentWindow.event.cancelBubble=true;
		this.o_ref.pSelect(p.parentElement);
		p=undefined;
		return false;
	}

Tree.prototype.pEditKeyDown = function()
	{
		ev=this.document.parentWindow.event;
		var k=ev.keyCode, oEdit=ev.srcElement, sVal, P;
		if (k==13)
			{
				sVal=oEdit.value;
				oObj=oEdit.parentElement.parentElement;
				oEdit.onblur=null;
				oEdit.onmousedown=null;
				oEdit.onselectstart=null;
				oEdit.parentElement.innerText=oEdit.old_text;
				this.o_ref.pSelect(null);
				if (this.o_ref.renameNode(oObj.sKey, sVal))
					{
						var v = this.document.createEventObject();
						v.srcRootElement = this.o_ref;
						v.key = oObj.sKey;
						v.value = sVal;
						v.old_value=oEdit.old_text;
						v.eventName = 'onrename';
						this.o_ref.z_body.fireEvent('oncontrolselect', v);
					}
				oEdit.old_text=sVal;
				this.o_ref.pSelect(oObj);
				this.o_ref.focus();
				this.document.parentWindow.event.returnValue=false;
				return false;
			}
		if (k==27)
			{
				oEdit.blur();
				this.document.parentWindow.event.returnValue=false;
				return false;
			}
		k=undefined;
		return true;
	}

Tree.prototype.clear=function()
	{
		this.keys={
				0 : this.z_body
				};
		this.p_disabled=false;
		this.z_tree.innerHTML='';
		this.z_body.level=0;
		this.z_body.isExpanded=1;
		this.z_body.oIcon=this.z_body.children[1];
		this.z_body.oTitle=this.z_body.children[2];
		this.z_body.oHolder=this.z_body.children[3];
		this.z_body.oHolder.iVisibleChilds=0;
		this.z_body.iFlags=1;
		this.z_body.sKey=0;
		this.p_current=null;
		return true;
	}
	
Tree.prototype.setGroups=function(aGroups)
	{
		var x, i=0;
		for(x in aGroups)
			{
				this.groups[x]={};
				for(i=0; i<aGroups[x].length; i++)
					this.groups[x][aGroups[x][i]]=1;
			}
	}
	
Tree.prototype.moveNode=function(sKey, sTarget, sMethod)
	{
		var oNode=this.keys[sKey],
			oTarget=this.keys[sTarget];
		return this.pMove(oNode, oTarget, sMethod);
	}

/*
Tree.prototype.copyNode=function()
	{
	}
*/

Tree.prototype.zDragging = function()
	{
		with(this.o_ref.o_dragger.style)
			{
				display='block';
				posLeft=this.document.parentWindow.event.x+10;
				posTop=this.document.parentWindow.event.y+3;
			}
	}
	
Tree.prototype.zEndDrag=function()
	{
		var t=this.document.parentWindow.event.srcElement
		this.o_ref.o_dragger.style.display='none';
		this.o_ref.pSelectBorders();
		t.ondrag=null;
		t.ondragend=null;
		this.o_ref.z_dragged.ondragenter=null;
		this.o_ref.z_dragged.ondragover=null;
		this.o_ref.z_dragged.isDragged=undefined;
		this.o_ref.z_dragged=null;
		this.o_ref.z_body.ondragover=null;
		this.o_ref.z_body.ondragenter=null;
		this.o_ref.z_body.ondrop=null;
		this.o_ref=undefined;
		t=undefined;
	}

Tree.prototype.zNoDrag=function()
	{
		this.o_ref.pSelectBorders();
		this.document.parentWindow.event.dataTransfer.dropEffect="none";
		this.document.parentWindow.event.cancelBubble=true;
		return false
	}

Tree.prototype.pDragStart=function()
	{
		var t=this.document.parentWindow.event.srcElement, grp, dragged;
		dragged=t.parentElement;

		if (this.o_ref.p_disabled || t.iType!=2 || dragged.iFlags & 0x2 || dragged.sKey==0 || (typeof (this.onbeforemove)=='function' && false===this.onbeforemove()))
			{
				dragged=null;
				this.o_ref.z_dragged=null;
				this.document.parentWindow.event.cancelBubble=true;
				return false;
			}
			
		grp=dragged.iGroup;
		this.o_ref.o_dragger.children[1].innerText=dragged.oTitle.innerText;
		//divDrg.children[0].src=z;
		t.o_ref=this.o_ref;
		t.ondrag=this.o_ref.zDragging;
		t.ondragend=this.o_ref.zEndDrag;

		dragged.ondragenter=this.o_ref.zNoDrag;
		dragged.ondragover=this.o_ref.zNoDrag;
		dragged.isDragged=true;

		with(this.document.parentWindow.event.dataTransfer)
			{
				setData("Text", "TreeNode"+dragged.key);
				effectAllowed = "all";
			}
		t=undefined;
		this.o_ref.z_dragged=dragged;
		this.ondragover=this.o_ref.pDragEnter;
		this.ondragenter=this.o_ref.pDragEnter;
		this.ondrop=this.o_ref.pDrop;
	}

Tree.prototype.pIsAcceptable=function(sTarget, sSrc)
	{
		if (this.groups[sTarget])
			return this.groups[sTarget][sSrc] ? true : false;
		return false;
	}
	
Tree.prototype.pDragLeave=function()
	{
		var o=this.document.parentWindow.event.srcElement, t=this.document.parentWindow.event.toElement;
		if (!o.iFlags)
			o=o.parentElement;
		if (o.iGroup===undefined || o.iGroup===null)
			o=o.parentElement;
		this.o_ref.pSelectBorders(o, 0);
	}

Tree.prototype.pDragEnter=function()
	{
		var t=this.document.parentWindow.event.srcElement, o=t;
		
		if (!o.iFlags)
			o=o.parentElement;
		if (o.iGroup===undefined || o.iGroup===null)
			o=o.parentElement;

		if (this.o_ref.pIsAcceptable(			
			(this.document.parentWindow.event.offsetY <= 5 || this.document.parentWindow.event.offsetY >=13) ? o.parentElement.parentElement.iGroup : o.iGroup,
				this.o_ref.z_dragged.iGroup))
			{
				this.document.parentWindow.event.dataTransfer.dropEffect="move";
				if (t.iType || t.iFlags)
					{
						if (this.document.parentWindow.event.offsetY <= 5)
							{
								this.o_ref.pSelectBorders(o, true);
							}
						else if (this.document.parentWindow.event.offsetY >= 13)
							{
								if (o.nextSibling)
									{
										if (!o.isExpanded)
											this.o_ref.pSelectBorders(o.nextSibling, 1);
									}
								else
									this.o_ref.pSelectBorders(o, true, true);	
							}
						else
							this.o_ref.pSelectBorders(o);
					}
			}
		else
			{
				this.document.parentWindow.event.dataTransfer.dropEffect="none"
				this.o_ref.pSelectBorders();
			}


		this.document.parentWindow.event.cancelBubble=true;
		return false;
	}

Tree.prototype.pSelectBorders=function(oNode, xMode, xBottom)
	{
		
		if (this.z_drag_over)
			{
				this.z_drag_over.oTitle.className='';
				this.z_drag_over.oIcon.className='';
				if (this.z_drag_over.previousSibling)
					{
						this.z_drag_over.previousSibling.oTitle.className='';
						this.z_drag_over.previousSibling.oIcon.className='';
					}

				this.z_drag_over=null;
			}
		if (this.p_current)
			{
				this.pSelect();
			}
		if (oNode && oNode.sKey)
			{
				if (xMode)
					{
						if (xBottom)
							{
								oNode.oTitle.className='dover_bottom';
								oNode.oIcon.className='dover_bottom';
							}	
						else
							{
								oNode.oTitle.className='dover_top';
								oNode.oIcon.className='dover_top';
								if (oNode.previousSibling && !oNode.previousSibling.isExpanded)
									{
										oNode.previousSibling.oTitle.className='dover_bottom';
										oNode.previousSibling.oIcon.className='dover_bottom';
									}
							}
					}
				else
					{
						oNode.oTitle.className='selected';
						if (oNode.previousSibling)
							oNode.previousSibling.oTitle.className='';
					}
				this.z_drag_over=oNode;
			}
	}

Tree.prototype.pDrop=function()
	{
		var obj, x, txt='', sMethod='inside', srcKey, targetKey;
		obj=this.document.parentWindow.event.srcElement;

		if (!(this.o_ref.z_dragged && (obj.iType || obj.iFlags)))
			return false;
		
		this.o_ref.pSelectBorders();
		
		if (obj.iType)
			obj=obj.parentElement;
		

		if (this.document.parentWindow.event.offsetY <= 5)
			{
				sMethod='before';
			}
		else if (this.document.parentWindow.event.offsetY >= 13)
			{
				sMethod='after';
			}
		else
			{	
				sMethod='inside';
				if (obj.iFlags & 24)
					sMethod='before';
			}

		if (obj.sKey==0)
			sMethod='inside';

		//if (event.ctrlKey)
			//this.o_ref.copyNode(this.o_ref.z_dragged.sKey, obj.sKey, sMethod, true);
		//else
		targetKey=obj.sKey;
		srcKey=this.o_ref.z_dragged.sKey;

		if (this.o_ref.moveNode(srcKey, targetKey, sMethod))
			{
				var v = this.document.createEventObject();
				v.srcRootElement = this.o_ref;
				v.method = sMethod;
				v.key = srcKey;
				v.target = targetKey;
				v.eventName = 'onmove';
				this.o_ref.z_body.fireEvent('oncontrolselect', v);
			}

		if (sMethod=='before' || sMethod=='after')
			this.o_ref.pSelect(this.o_ref.z_dragged);
		
		this.document.parentWindow.event.cancelBubble=true;
		return false;
	}
	
Tree.prototype.focus=function()
	{
		this.z_body.focus();
		this.z_body.setActive();
	}
	
Tree.prototype.reindexItem=function(sKey, sNewKey)
	{
		if (this.keys[sKey])
			{
				var o=this.keys[sKey];
				o.sKey=sNewKey;
				this.keys[sNewKey]=o;
				delete this.keys[sKey];
				return true;
			}
		return false;
	}

Tree.prototype.pEvControl=function()
	{
		var ev=parent.event ? parent.event : this.document.parentWindow.event;
		switch(ev.eventName)
			{
				case 'onselect':
					if (this.o_ref.onselect && typeof(this.o_ref.onselect)=='function')
						return this.o_ref.onselect(ev)===false ? false : true;
					return true;
				case 'ondblclick':
					if (this.o_ref.ondblclick && typeof(this.o_ref.ondblclick)=='function')
						return this.o_ref.ondblclick(ev)===false ? false : true;
					break;
				case 'onmove':
					if (this.o_ref.onmove && typeof(this.o_ref.onmove)=='function')
						return this.o_ref.onmove(ev)===false ? false : true;
					break;
				case 'onkeydown':
					if (this.o_ref.onkeydown && typeof(this.o_ref.onkeydown)=='function')
						return this.o_ref.onkeydown(ev)===false ? false : true;
					break;
				case 'onrename':
					if (this.o_ref.onrename && typeof(this.o_ref.onrename)=='function')
						return this.o_ref.onrename(ev)===false ? false : true;
					break;
			}
	}

Tree.prototype.setDisabled=function(x)
	{
		if (x)
			{
				this.p_disabled=true;
				x='hidden';
			}
		else
			{
				this.p_disabled=false;
				x='auto';
			}
		this.z_body.disabled=p_disabled;
		this.z_body.style.overflow=x;
	}

Tree.prototype.getAncestor=function(sKey)
	{
		if (!sKey)
			return false;
		var oObj=this.keys[sKey];
		if (oObj)
			return oObj.parentElement.parentElement.sKey ? oObj.parentElement.parentElement.sKey : false;
	}

Tree.prototype.getCurrent=function()
	{
		return this.p_current ? this.p_current.sKey : '';
	}

Tree.prototype.setCaption=function(sTitle)
	{
		this.z_body.oTitle.innerText=sTitle;
	}