var manageFiles=function(){
	return jsCore.ui.makeDialog(new jsCore.element({
		items: [
			new jsCore.element({
				style: {
					height: '230px'
				},
				items: [
					new jsCore.element({
						tag: 'select',
						id: 'select_html',
						attributes: {
							size: (jsCore.browser.isIE?'14':'12'),
							multiple: 'multiple'
						},
						style: {
							fontFamily: 'Tahoma',
							fontSize: '12px',
							width: '350px',
							border: '1px solid #8db2e3',
							backgroundColor: '#FFFFFF',
							overflow: 'scroll'
						},
						on:{
							change: function(){
								var self=null;
								if(jsCore.browser.isIE)
									self=arguments[0].srcElement;
								else
									self=this;
								jsCore.dom.set.text.replace($('filename'),self.options[self.selectedIndex].text);
							}
						}
					}),
					new jsCore.element({
						items: [
							new jsCore.element({
								tag: 'span',
								text: ' ',
								style: {
									cssFloat: 'left',
									width: '70px',
									margin: '10px 0px 0px 3px'
								}
							}),
							new jsCore.element({
								tag: 'div',
								id: 'filename',
								style: {
									cssFloat: 'left',
									width: '270px',
									height: '18px',
									padding: '3px 2px 0px 3px',
									backgroundColor: '#FFFFFF',
									border: '1px solid #8db2e3',
									margin: '5px 0px 0px 0px'
								}
							})
						]
					})
				]
			}),
			new jsCore.element({
				tag: 'div',
				style: {
					height: '21px',
					padding: '5px',
					textAlign: 'right'
				},
				items: [
					new jsCore.Button({
						text: '',
						style: {
							margin: '0px 0px 0px 5px',
							cssFloat: 'right'
						},
						on: {
							click: function(){
								jsCore.func.recoverState();
							},
							mouseover: jsCore.func.buttonOver,
							mouseout: jsCore.func.buttonOut
						}
					}),
					new jsCore.Button({
						text: '',
						style: {
							cssFloat: 'right'
						},
						on: {
							click: function(){
								var m=$('memo');
								var r=$('richedit');
								var f=$('filename');
								m.replaceText(r.getText());
								var open_other=true;
								if(edit_file===f.innerHTML){
									if(!confirm('     .'+"\n"+'   ?')){
										open_other=false;
									}
								}
								if(open_other){
									if(md5_file!==md5(m.value) && edit_file!==f.innerHTML){
										if(confirm('   .'+"\n"+'  ?')){
											jsCore.func.saveEditPage();
										}
									}
									jsCore.func.getEditPage(f.innerHTML,'open.png','...');
									edit_file=f.innerHTML;
								}
								jsCore.func.recoverState();
							},
							mouseover: jsCore.func.buttonOver,
							mouseout: jsCore.func.buttonOut
						}
					})
				]
			})
		]
	}), ' ');
};
var colorPicker=function(){
	var cellSize=10;
	var wgArray=new Array();
	var web_spectr=[
		'000000',	//black
		'404040',	//----
		'808080',	//gray
		'C0C0C0',	//silver
		'FFFFFF',	//white
		'008000',	//green
		'808000',	//olive
		'FFA500',	//orange
		'00FF00',	//lime
		'FFFF00',	//yellow
		'000080',	//navy
		'0000FF',	//blue
		'FF00FF',	//fuchsia
		'00FFFF',	//aqua
		'800080',	//purple
		'008080',	//teal
		'800000',	//maroon
		'FF0000'	//red
	];
	for(var w=0;w<web_spectr.length;w++){
		wgArray.push(
			{
				id: sprintf('%s',web_spectr[w]),
				attributes: {
					width: cellSize,
					height: cellSize
				},
				style: {
					background: sprintf('#%s',web_spectr[w])
				},
				items: [
					new jsCore.image({
						id: '_'+sprintf('%s',web_spectr[w]),
						style: {
							width: cellSize+'px',
							height: cellSize+'px',
							filter: 'alpha(opacity=0)'
						},
						on: {
							click: function(){
								var tid='';
								if(jsCore.browser.isIE)
									tid=arguments[0].srcElement.id.substring(1);
								else
									tid=this.id.substring(1);
								jsCore.storage[jsCore.ui.calledButton]=tid;
								jsCore.func[jsCore.ui.calledButton]();
								jsCore.func.recoverState();
							},
							mouseover: function(){
								var tid='';
								if(jsCore.browser.isIE)
									tid=arguments[0].srcElement.id.substring(1);
								else
									tid=this.id.substring(1);
								jsCore.dom.set.style($('colorView'),'backgroundColor',sprintf('#%s',tid));
								jsCore.dom.set.text.replace($('colorInfo'),sprintf(': #%s',tid));
							},
							mouseout: function(){
								var tid='';
								if(jsCore.browser.isIE)
									tid=arguments[0].srcElement.id.substring(1);
								else
									tid=this.id.substring(1);
								jsCore.dom.set.style($('colorView'),'backgroundColor',sprintf('#%s',jsCore.storage[jsCore.ui.calledButton]));
								jsCore.dom.set.text.replace($('colorInfo'),sprintf(': #%s',jsCore.storage[jsCore.ui.calledButton]));
							}
						}
					})
				]
			}
		);
	}
	var grArray=new Array();
	var gcArray=null;
	var spectr=['00','33','66','99','CC','FF'];
	var ri=0;
	var gi=0;
	var bi=0;
	for(var r=0;r<12;r++){
		ri=0;
		gi=0;
		gcArray=new Array();
		if(bi>5)
			bi=0;
		for(var c=0;c<18;c++){
			if(gi>5){
				gi=0;
				ri+=1;
			}
			if(r<6)
				if(ri>3)
					ri=0;
			else
				if(ri<3 || ri>6)
					ri=3;
			gcArray.push(
				{
					id: sprintf('%s%s%s',spectr[ri],spectr[gi],spectr[bi]),
					attributes: {
						width: cellSize,
						height: cellSize
					},
					style: {
						background: sprintf('#%s%s%s',spectr[ri],spectr[gi],spectr[bi])
					},
					items: [
						new jsCore.image({
							id: '_'+sprintf('%s%s%s',spectr[ri],spectr[gi],spectr[bi]),
							style: {
								width: cellSize+'px',
								height: cellSize+'px',
								filter: 'alpha(opacity=0)'
							},
							on: {
								click: function(){
									var tid='';
									if(jsCore.browser.isIE)
										tid=arguments[0].srcElement.id.substring(1);
									else
										tid=this.id.substring(1);
									jsCore.storage[jsCore.ui.calledButton]=tid;
									jsCore.func[jsCore.ui.calledButton]();
									jsCore.func.recoverState();
								},
								mouseover: function(){
									var tid='';
									if(jsCore.browser.isIE)
										tid=arguments[0].srcElement.id.substring(1);
									else
										tid=this.id.substring(1);
									jsCore.dom.set.style($('colorView'),'backgroundColor',sprintf('#%s',tid));
									jsCore.dom.set.text.replace($('colorInfo'),sprintf(': #%s',tid));
								},
								mouseout: function(){
									var tid='';
									if(jsCore.browser.isIE)
										tid=arguments[0].srcElement.id.substring(1);
									else
										tid=this.id.substring(1);
									jsCore.dom.set.style($('colorView'),'backgroundColor',sprintf('#%s',jsCore.storage[jsCore.ui.calledButton]));
									jsCore.dom.set.text.replace($('colorInfo'),sprintf(': #%s',jsCore.storage[jsCore.ui.calledButton]));
								}
							}
						})
					]
				}
			);
			gi+=1;
		}
		grArray.push({cells:gcArray});
		bi+=1;
	}
	return jsCore.ui.makeDDContainer(
		new jsCore.element({
			items:[
				new jsCore.table({
					attributes: {
						cellPadding: '0',
						cellSpacing: '0',
						border: '0'
					},
					rows: [
						{
							cells: [
								{
									attributes: {
										colSpan: '2'
									},
									style: {
										fontSize: '10px'
									},
									text: '  :'
								}
							]
						},
						{
							cells: [
								{
									id: 'colorView',
									style: {
										width: '40%',
										height: '30px',
										border: '1px solid #9398A5',
										backgroundColor: '#'+jsCore.storage[jsCore.ui.calledButton]
									},
									items: [
										new jsCore.image({
											style: {
												width: '100%',
												height: '30px',
												filter: 'alpha(opacity=0)',
												cursor: 'pointer'
											},
											on: {
												click: function(){
													jsCore.func[jsCore.ui.calledButton]();
													jsCore.func.recoverState();
												}
											}
										})
									]
								},
								{
									id: 'colorInfo',
									style: {
										width: '60%',
										backgroundColor: '#FFFFFF',
										textIndent: '15px'
									},
									text: ': #'+jsCore.storage[jsCore.ui.calledButton]
								}
							]
						},
						{
							cells: [
								{
									attributes: {
										colSpan: '2'
									},
									style: {
										fontSize: '10px'
									},
									text: ' (web) :'
								}
							]
						},
						{
							cells: [
								{
									attributes: {
										colSpan: '2'
									},
									items: [
										new jsCore.table({
											id: 'menuColorWebGrid',
											attributes: {
												cellPadding: '1',
												cellSpacing: '1'
											},
											style: {
												backgroundColor: '#000000',
												cursor: 'pointer'
											},
											rows: [
												{
													cells: wgArray
												}
											]
										})
									]
								}
							]
						},
						{
							cells: [
								{
									attributes: {
										colSpan: '2'
									},
									style: {
										fontSize: '10px'
									},
									text: ' :'
								}
							]
						},
						{
							cells: [
								{
									attributes: {
										colSpan: '2'
									},
									items: [
										new jsCore.table({
											id: 'menuColorGrid',
											attributes: {
												cellPadding: '1',
												cellSpacing: '1'
											},
											style: {
												backgroundColor: '#000000',
												cursor: 'pointer'
											},
											rows: grArray
										})
									]
								}
							]
						}
					]
				})
			]
		})
	);
};
var manageSymbols=function(){
	var opt0=new Array();
	var opt1=new Array();
	var opt2=new Array();
	(function(){
		for(var a=33;a<192;a++)opt0.push(a);
		opt0.splice(inarray(127,opt0),1);
		opt0.splice(inarray(129,opt0),1);
		opt0.splice(inarray(141,opt0),1);
		opt0.splice(inarray(143,opt0),1);
		opt0.splice(inarray(144,opt0),1);
		opt0.splice(inarray(157,opt0),1);
		opt0.splice(inarray(160,opt0),1);
		opt0.splice(inarray(173,opt0),1);
	}).call();
	(function(){
		for(var a=1040;a<1104;a++)opt1.push(a);
		opt1.push(1025);
		opt1.push(1105);
	}).call();
	(function(){
		var a=0;
		for(a=8208;a<8232;a++)opt2.push(a);
		for(a=8240;a<8287;a++)opt2.push(a);
		opt2.push(8304);
		opt2.push(8305);
		for(a=8308;a<8335;a++)opt2.push(a);
		for(a=8336;a<8341;a++)opt2.push(a);
		for(a=8352;a<8374;a++)opt2.push(a);
	}).call();
	var optmenu={
		opt0:	{id: 'ssmGeneral',	value: '0',	text: ' '},
		opt1:	{id: 'ssmCyrillic',	value: '1',	text: ''}
	};
	if(!jsCore.browser.isIE)
		optmenu.opt2={id: 'ssmOther', value: '2', text: ' '};
	var renderCodeTable=function(i,table){
		var o=new Array();
		switch(i){
			case '0': o=opt0; break;
			case '1': o=opt1; break;
			case '2': o=opt2; break;
		}
		var rs=table.rows.length;
		var cs=0;
		var num=0;
		var code=0;
		var cell=null;
		for(var r=0;r<rs;r++){
			cs=table.rows[r].cells.length;
			for(var c=0;c<cs;c++){
				if(num<o.length)
					code=o[num];
				else
					code=0;
				cell=table.rows[r].cells[c].childNodes[0];
				if(code==0){
					cell.removeAttribute('id');
					cell.innerHTML='&nbsp;';
				}else{
					if(cell.id)
						cell.id=sprintf('cs%s',code);
					else
						cell.setAttribute('id',sprintf('cs%s',code));
					cell.innerHTML=sprintf('&#%s',code);
				}
				num++;
			}
		}
	};
	var cellSize=20;
	var maxRows=10;
	var maxCells=16;
	var rows=new Array();
	var cells=null;
	for(var r=0;r<maxRows;r++){
		cells=new Array();
		for(var c=0;c<maxCells;c++){
			cells.push({
				attributes: {
					align: 'center',
					vAlign: 'middle'
				},
				style: {
					width: cellSize+'px',
					height: cellSize+'px',
					backgroundColor: '#FFFFFF'
				},
				items: [
					new jsCore.element({
						tag: 'div',
						text: '&nbsp;',
						on: {
							click: function(){
								var self=null;
								if(jsCore.browser.isIE)
									self=arguments[0].srcElement;
								else
									self=this;
								if(self.id&&self.id.length>0){
									jsCore.func.insertSymbol(self.id.substring(2));
									jsCore.func.recoverState();
								}
							},
							mouseover: function(){
								var tView=$('symbolView');
								var tCode=$('symbolCode');
								var self=null;
								var id='';
								if(jsCore.browser.isIE)
									self=arguments[0].srcElement;
								else
									self=this;
								if(self.id&&self.id.length>0){
									id=self.id.substring(2);
									jsCore.dom.set.text.replace(tView,sprintf('&#%s;',id));
									jsCore.dom.set.text.replace(tCode,sprintf('&amp;#%s;',id));
								}else{
									jsCore.dom.set.text.replace(tView,'&nbsp;');
									jsCore.dom.set.text.replace(tCode,'&nbsp;');
								}
							}
						}
					})
				]
			});
		}
		rows.push({cells:cells});
	}
	var st=new jsCore.table({
		id: 'symbolsTable',
		attributes: {
			cellPadding: '1',
			cellSpacing: '1'
		},
		style: {
			backgroundColor: '#000000',
			cursor: 'pointer'
		},
		rows: rows
	});
	renderCodeTable('0',st);
	var win_content=new jsCore.table({
		attributes: {
			cellSpacing: '5',
			cellPadding: '0'
		},
		rows: [
			{
				cells: [
					{
						attributes: {
							colSpan: '4'
						},
						items: [
							new jsCore.element({
								tag: 'span',
								style: {
									padding: '0px 5px 0px 0px'
								},
								text: ' '
							}),
							new jsCore.tbSelect({
								tag: 'select',
								id: 'menuSymbolMode',
								menu: optmenu,
								on: {
									change: function(){
										var self=null;
										if(jsCore.browser.isIE)
											self=arguments[0].srcElement;
										else
											self=this;
										renderCodeTable(self.value,$('symbolsTable'));
									}
								}
							})
						]
					}
				]
			},
			{
				cells: [
					{
						id: 'cellST',
						attributes: {
							colSpan: '4'
						},
						items: [st]
					}
				]
			},
			{
				cells: [
					{
						attributes: {
							align: 'center',
							width: '50',
							height: '30'
						},
						text: ''
					},
					{
						id: 'symbolView',
						attributes: {
							width: '35',
							height: '30',
							align: 'center',
							vAlign: 'middle'
						},
						style: {
							fontSize: '18px',
							border: '1px solid #9398A5',
							backgroundColor: '#FFFFFF'
						}
					},
					{
						attributes: {
							align: 'center',
							width: '40',
							height: '30'
						},
						text: ':'
					},
					{
						id: 'symbolCode',
						attributes: {
							width: '200',
							height: '30'
						},
						text: '&nbsp;'
					}
				]
			},
			{
				cells: [
					{
						attributes: {
							colSpan: '4',
							align: 'right'
						},
						items: [
							new jsCore.Button({
								text: '',
								on: {
									click: function(){
										jsCore.func.recoverState();
									},
									mouseover: jsCore.func.buttonOver,
									mouseout: jsCore.func.buttonOut
								}
							})
						]
					}
				]
			}
		]
	});
	return jsCore.ui.makeDialog(win_content,' ');
};
var tablePicker=function(){
	var grArray=new Array();
	var gcArray=null;
	var cellSize=20;
	var runRender=null;
	for(var r=0;r<10;r++){
		gcArray=new Array();
		for(var c=0;c<10;c++){
			gcArray.push(
				{
					id: sprintf('ctp%sx%s',r+1,c+1),
					attributes: {
						width: cellSize,
						height: cellSize
					},
					style: {
						background: '#FFFFFF'
					},
					items: [
						new jsCore.image({
							id: '_'+sprintf('%sx%s',r+1,c+1),
							style: {
								width: cellSize+'px',
								height: cellSize+'px',
								cursor: 'pointer',
								filter: 'alpha(opacity=0)'
							},
							on: {
								click: function(){
									var self=null
									if(jsCore.browser.isIE)
										self=arguments[0].srcElement;
									else
										self=this;
									var tid=self.id.substring(1);
									jsCore.storage[jsCore.ui.calledButton]=tid;
									jsCore.func.insertTable(self);
									jsCore.func.recoverState();
								},
								mouseover: function(){
									var self=null
									if(jsCore.browser.isIE)
										self=arguments[0].srcElement;
									else
										self=this;
									var arr=self.id.substring(1).split('x');
									var name='';
									for(r=0;r<10;r++){
										for(c=0;c<10;c++){
											name='ctp'+(r+1)+'x'+(c+1);
											if((r+1)>parseInt(arr[0])||(c+1)>parseInt(arr[1]))
												jsCore.dom.set.style($(name),'backgroundColor','#FFFFFF');
											else
												jsCore.dom.set.style($(name),'backgroundColor','#FF00FF');
										}
									}
									jsCore.dom.set.text.replace($('tpInfo'),': '+arr[0]+' x '+arr[1]);
								}
							}
						})
					]
				}
			);
		}
		grArray.push({cells:gcArray});
	}
	return jsCore.ui.makeDDContainer(
		new jsCore.element({
			items:[
				new jsCore.table({
					attributes: {
						cellPadding: '0',
						cellSpacing: '0',
						border: '0'
					},
					rows: [
						{
							cells: [
								{
									items: [
										new jsCore.table({
											attributes: {
												cellPadding: '1',
												cellSpacing: '1'
											},
											style: {
												backgroundColor: '#000000'
											},
											rows: grArray
										})
									]
								}
							]
						},
						{
							cells: [
								{
									id: 'tpInfo',
									attributes: {
										height: '25',
										vAlign: 'middle'
									},
									style: {
										textIndent: '70px'
									},
									text: ':'
								}
							]
						}
					]
				})
			]
		})
	);
};
var imagesPicker=function(){
	return jsCore.ui.makeDDContainer(
		new jsCore.element({
			items: [
				new jsCore.element({
					style: {
						fontSize: '10px',
						margin: '0px 0px 5px 0px'
					},
					text: '  :'
				}),
				new jsCore.element({
					id: 'imgsListArea',
					style: {
						width: '200px',
						height: '200px',
						backgroundColor: '#FFFFFF',
						overflowY: 'scroll',
						overflowX: 'hidden'
					}
				})
			]
		})
	);
};
var findPicker=function(){
	return jsCore.ui.makeDDContainer(
		new jsCore.element({
			items: [
				new jsCore.element({
					style: {
						fontSize: '10px',
						margin: '0px 0px 5px 0px'
					},
					text: '  :'
				}),
				new jsCore.element({
					style: {
						width: '200px'
					},
					items: [
						new jsCore.input({
							id: 'txtFind',
							style: {
								width: '140px',
								cssFloat: 'left',
								margin: '0px 5px 0px 0px'
							},
							on: {
								keypress: function(){
									var e=arguments[0];
									if(e.keyCode==13){
										if(jsCore.browser.isIE){
											e.keyCode=null;
										}
										jsCore.func.makeSearch();
										jsCore.func.recoverState();
									}else if(arguments[0].keyCode==27){
										if(jsCore.browser.isIE){
											e.keyCode=null;
										}
										jsCore.func.recoverState();
									}
								}
							}
						}),
						new jsCore.Button({
							id: 'btnFindOK',
							text: '',
							style: {
								cssFloat: 'left'
							},
							on: {
								click: function(){
									jsCore.func.makeSearch();
									jsCore.func.recoverState();
								},
								mouseover: jsCore.func.buttonOver,
								mouseout: jsCore.func.buttonOut
							}
						})
					]
				})
			]
		})
	);
};
