var manageTable=function(){
	var self=this;

	var change_param=function(){
		var myself=arguments[0];
		var nd=jsCore.storage.tableProperty.newData;
		switch(myself.id){
			case 'tblWidthData':
				nd.tw=parseInt(myself.value)||0;
				break;
			case 'tblWidthPx':
				nd.twp=parseInt(myself.value)||0;
				break;
			case 'tblBorderData':
				nd.tb=parseInt(myself.value)||0;
				break;
			case 'tblCellSpacData':
				nd.tcs=parseInt(myself.value)||0;
				break;
			case 'tblCellPadData':
				nd.tcp=parseInt(myself.value)||0;
				break;
			case 'cellWidthData':
				nd.cw=parseInt(myself.value)||0;
				break;
			case 'cellWidthPx':
				nd.cwp=parseInt(myself.value)||0;
				break;
			case 'cellHeightData':
				nd.ch=parseInt(myself.value)||0;
				break;
			case 'cellBorderData':
				nd.cb=parseInt(myself.value)||0;
				break;
		}
		jsCore.func.setTableParam(true);
	};
	var input_keyup=function(){
		var myself=null;
		if(jsCore.browser.isIE)
			myself=arguments[0].srcElement;
		else
			myself=this;
		var ids=jsCore.storage.imgDataStorage;
		var digits='0123456789';
		var str='';
		if(myself.value.length>0){
			for(var a=0;a<myself.value.length;a++)
				if(digits.indexOf(myself.value.charAt(a))!=-1)
					str+=myself.value.charAt(a);
		}
		myself.value=str;
		change_param(myself);
	};
	var pxprcMenu=function(){
		return new jsCore.tbSelect({
			id: arguments[0]||'',
			cls: 'select_prop',
			menu: {
				optPx: {
					value: '0',
					text: 'px'
				},
				optPrc: {
					value: '1',
					text: '%'
				}
			},
			on: {
				change: function(){
					var myself=null;
					if(jsCore.browser.isIE)
						myself=arguments[0].srcElement;
					else
						myself=this;
					change_param(myself);
				}
			}
		});
	};
	return jsCore.ui.makeDialog(new jsCore.element({
		items: [
			new jsCore.table({
				style: {
					width: '100%'
				},
				rows: [
					{
						cells: [
							{
								items: [
									new jsCore.element({
										tag: 'fieldset',
										style: {
											padding: '5px'
										},
										items: [
											new jsCore.element({
												tag: 'legend',
												text: ' '
											}),
											new jsCore.table({
												style: {
													width: '100%'
												},
												rows: [
													{
														cells: [
															{
																text: '',
																style: {
																	width: '190px'
																}
															},
															{
																items: [
																	new jsCore.input({
																		id: 'tblWidthData',
																		cls: 'input_prop',
																		text: '0',
																		on: {
																			keyup: input_keyup
																		}
																	}),
																	pxprcMenu('tblWidthPx')
																]
															}
														]
													},
													{
														cells: [
															{
																text: ' ',
																style: {
																	width: '190px'
																}
															},
															{
																items: [
																	new jsCore.input({
																		id: 'tblBorderData',
																		cls: 'input_prop',
																		text: '0',
																		on: {
																			keyup: input_keyup
																		}
																	}),
																	new jsCore.element({
																		tag: 'span',
																		style: {
																			padding: '0px 0px 0px 5px'
																		},
																		items: [
																			jsCore.dom.create.text('px')
																		]
																	})
																]
															}
														]
													},
													{
														cells: [
															{
																text: '  ',
																style: {
																	width: '190px'
																}
															},
															{
																items: [
																	new jsCore.input({
																		id: 'tblCellSpacData',
																		cls: 'input_prop',
																		text: '0',
																		on: {
																			keyup: input_keyup
																		}
																	}),
																	new jsCore.element({
																		tag: 'span',
																		style: {
																			padding: '0px 0px 0px 5px'
																		},
																		items: [
																			jsCore.dom.create.text('px')
																		]
																	})
																]
															}
														]
													},
													{
														cells: [
															{
																text: '    ',
																style: {
																	width: '190px'
																}
															},
															{
																items: [
																	new jsCore.input({
																		id: 'tblCellPadData',
																		cls: 'input_prop',
																		text: '0',
																		on: {
																			keyup: input_keyup
																		}
																	}),
																	new jsCore.element({
																		tag: 'span',
																		style: {
																			padding: '0px 0px 0px 5px'
																		},
																		items: [
																			jsCore.dom.create.text('px')
																		]
																	})
																]
															}
														]
													}
												]
											})
										]
									})
								]
							}
						]
					},
					{
						cells: [
							{
								items: [
									new jsCore.element({
										tag: 'fieldset',
										style: {
											padding: '5px'
										},
										items: [
											new jsCore.element({
												tag: 'legend',
												text: ' '
											}),
											new jsCore.table({
												style: {
													width: '100%'
												},
												rows: [
													{
														cells: [
															{
																text: '',
																style: {
																	width: '190px'
																}
															},
															{
																items: [
																	new jsCore.input({
																		id: 'cellWidthData',
																		cls: 'input_prop',
																		text: '0',
																		on: {
																			keyup: input_keyup
																		}
																	}),
																	pxprcMenu('cellWidthPx')
																]
															}
														]
													},
													{
														cells: [
															{
																text: '',
																style: {
																	width: '190px'
																}
															},
															{
																items: [
																	new jsCore.input({
																		id: 'cellHeightData',
																		cls: 'input_prop',
																		text: '0',
																		on: {
																			keyup: input_keyup
																		}
																	}),
																	new jsCore.element({
																		tag: 'span',
																		style: {
																			padding: '0px 0px 0px 5px'
																		},
																		items: [
																			jsCore.dom.create.text('px')
																		]
																	})
																]
															}
														]
													},
													{
														cells: [
															{
																text: ' ',
																style: {
																	width: '190px'
																}
															},
															{
																items: [
																	new jsCore.input({
																		id: 'cellBorderData',
																		cls: 'input_prop',
																		text: '0',
																		on: {
																			keyup: input_keyup
																		}
																	}),
																	new jsCore.element({
																		tag: 'span',
																		style: {
																			padding: '0px 0px 0px 5px'
																		},
																		items: [
																			jsCore.dom.create.text('px')
																		]
																	})
																]
															}
														]
													}
												]
											})
										]
									})
								]
							}
						]
					}
				]
			}),
			new jsCore.element({
				items: [
					new jsCore.Button({
						id: 'tblPropCancel',
						text: '',
						style: {
							margin: '0px 5px 3px 5px',
							cssFloat: 'right'
						},
						on: {
							click: function(){
								with(jsCore.func){
									setTableParam(false);
									recoverState();
								}
							},
							mouseover: jsCore.func.buttonOver,
							mouseout: jsCore.func.buttonOut
						}
					}),
					new jsCore.Button({
						id: 'tblPropOK',
						text: 'K',
						style: {
							margin: '0px 0px 3px 5px',
							cssFloat: 'right'
						},
						on: {
							click: function(){
								with(jsCore.func){
									setTableParam(true);
									recoverState();
								}
							},
							mouseover: jsCore.func.buttonOver,
							mouseout: jsCore.func.buttonOut
						}
					})
				]
			})
		]
	}),' ');
};