jsCore.ajax={
	reqXH: null,
	blnRequestEnabled: true,
	method: 'GET',
	action: '',
	data4obj: null,
	json: null,
	ready: false,
	dataType: '',
	content: '',
	error: '',
	init: function(){
/**
 *   
 * method => arguments[0] -   [GET, POST]
 * action => arguments[1] - url 
 * parametrs => arguments[2] -   
 */
		var object=jsCore.ajax;
		object.reqXH=null;
		object.blnRequestEnabled=true;
		object.method=arguments[0]||'GET';
		object.action=arguments[1]||'';
		if(arguments[2]){
			var sec=new Date().getTime();
			object.action+='?'+arguments[2]+'&now='+sec;
		}
		object.data4obj=arguments[3]||null;
		object.ready=false;
		object.dataType='';
		object.content='';
		object.error='';
		object.constructor=this;
		object.query=jsCore.ajax.query;
		object.readystate=jsCore.ajax.readystate;
		object.customLoad=jsCore.ajax.customLoad;
		object.loadDoc=jsCore.ajax.loadDoc;
		object.newpage=jsCore.ajax.newpage;
		object.saveSuccess=jsCore.ajax.saveSuccess;
		return object;
	},
	query: function(){
		if(jsCore.ajax.blnRequestEnabled){
			try{
				if(!jsCore.ajax.reqXH){
					jsCore.ajax.reqXH=zXmlHttp.createRequest();
				}else if(jsCore.ajax.reqXH.readyState!=0){
					jsCore.ajax.reqXH.abort();
				}
				if(jsCore.ajax.action.length>0){
					jsCore.ajax.reqXH.onreadystatechange=jsCore.ajax.readystate;
//Method POST
					if(jsCore.ajax.method.toUpperCase()==='POST'){
						jsCore.ajax.reqXH.open(jsCore.ajax.method,jsCore.ajax.action,true);
						jsCore.ajax.reqXH.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
						jsCore.ajax.reqXH.send(jsCore.ajax.data4obj);
						jsCore.ajax.data4obj=null;
//Method GET
					}else{
						jsCore.ajax.reqXH.open(jsCore.ajax.method,jsCore.ajax.action,true);
						jsCore.ajax.reqXH.send(null);
					}
				}
			}catch(e){
				jsCore.ajax.blnRequestEnabled=false;
				jsCore.ajax.ready=true;
			}
		}
	},
	readystate: function(){
//   
		if(jsCore.ajax.reqXH.readyState == 4){
//     
			if(jsCore.ajax.reqXH.status == 200){
				var ct=jsCore.ajax.reqXH.getResponseHeader("Content-Type");
				ct=ct.split("; ");
				jsCore.ajax.dataType=ct[0];
/**
 * Header: text/html
 * Header: text/plain
 */
				if((jsCore.ajax.dataType=="text/html")||(jsCore.ajax.dataType=="text/plain")){
					jsCore.ajax.content=jsCore.ajax.reqXH.responseText;
/**
 * Header: text/newpage
 */
				}else if(jsCore.ajax.dataType=="text/newpage"){
					jsCore.ajax.json=jsCore.ajax.reqXH.responseText;
/**
 * Header: text/json
 */
				}else if(jsCore.ajax.dataType=="text/json"){
					jsCore.ajax.json=jsCore.ajax.reqXH.responseText;
/**
 * Header: text/xml
 */
				}else if(jsCore.ajax.dataType=="text/xml"){
					jsCore.ajax.content=jsCore.ajax.reqXH.responseXML.documentElement;
				}
				if(jsCore.ajax.data4obj){
					jsCore.ajax.customLoad();
				}else if(jsCore.ajax.dataType=="text/newpage"){
					jsCore.ajax.newpage();
				}else if(jsCore.ajax.dataType=="text/empty"){
					jsCore.ajax.saveSuccess();
				}else{
					jsCore.ajax.loadDoc();
				}
			} else {
				jsCore.debug("  "+ jsCore.ajax.reqXH.status+":\n" + jsCore.ajax.reqXH.statusText,110,'ajax.js','ajax::readystate');
			}
		}
	},
	customLoad: function(){
		if(jsCore.ajax.json){
			eval('var d='+jsCore.ajax.json+';');
			var o=jsCore.ajax.data4obj;
			if(o.options.length>0){
				for (var b=o.options.length-1;b>=0;b--) {
					o.options[b]=null;
					o.options[b]=null;
				}
			}
			for(var a=0;a<d.length;a++){
				o.options[o.length]=new Option(d[a]['text'],d[a]['value']);
				if(d[a]['value']=='folder'||d[a]['text']=='..'){
					jsCore.dom.set.cls.add(o.options[o.length-1],'folder');
				}else{
					jsCore.dom.set.cls.add(o.options[o.length-1],'file');
					if(jsCore.storage.imgDataStorage){
						var root=(d[0]['text']==='..' ? d[0]['value'] : mediaFolder)
						var src=jsCore.storage.imgDataStorage.hsource;
						var short_name=src.substring((base_url+path+'/').length,src.length);
						if(jsCore.storage.imgDataStorage.selectedImage && (root+'/'+d[a]['text'])===short_name)
							o.options[o.length-1].selected=true;
					}
				}
			}
		}
	},
	loadDoc: function(){
		re_doc.open();
		re_doc.write(this.content);
		re_doc.close();
		var m=$('memo');
		var r=$('richedit');
		var si=$('statIcon');
		var sa=$('statAction');
		m.replaceText(r.getText());
		md5_file=md5(m.value);
		jsCore.dom.event.add(re_doc,'click',jsCore.func.renderStatInfo);
		jsCore.dom.event.add(re_doc,'mouseup',jsCore.func.renderStatInfo);
		jsCore.dom.event.add(re_doc,'keyup',function(){
			if(runit)
				clearTimeout(runit);
			runit=setTimeout(jsCore.func.renderStatInfo,100);
		});
		jsCore.dom.set.source(si,jsCore.imgURL+'misc/'+'edit.png');
		jsCore.dom.set.text.replace(sa,'');
		r.setEditable();
		r.contentWindow.focus();
		jsCore.func.renderStatInfo();
		var span=jsCore.dom.create.tag('span');
		span.innerHTML=jsCore.storage.tree[jsCore.storage.tree.length-1].innerHTML;
		var new_span=excludeFont(span);
		jsCore.storage.tree[jsCore.storage.tree.length-1].innerHTML=new_span.innerHTML;
		jsCore.func.renderStatInfo();
		if(jsCore.browser.isIE){
			var range=new IEExtRange(re_doc);
			range.setStartBefore(re_doc.body.childNodes[0]);
			range.collapse(true);
			var s=new IEExtSelection(r.contentWindow);
			s.removeAllRanges();
			s.addRange(range);
		}
/*		m.replaceText(r.getText());
		if(jsCore.browser.isGecko){
			console.log();
		}*/
	},
	newpage: function(){
		eval('edit_file='+jsCore.ajax.json+';');
		jsCore.func.getEditPage();
	},
	saveSuccess: function(){
		var m=$('memo');
		var r=$('richedit');
		var si=$('statIcon');
		var sa=$('statAction');
		if(!jsCore.func.visibled(m))
			m.replaceText(r.getText());
		md5_file=md5(m.value);
		jsCore.dom.set.source(si,jsCore.imgURL+'misc/'+'edit.png');
		jsCore.dom.set.text.replace(sa,'');
		jsCore.func.renderStatInfo();
		r.setEditable();
		r.contentWindow.focus();
		jsCore.storage.getTreeNodes();
	}
};