jsCore.browser={
	isGecko:	(navigator.userAgent.toLowerCase().indexOf("gecko")!=-1 ? true : false),
	isKonq:		(navigator.userAgent.toLowerCase().indexOf("konqueror")!=-1 ? true : false),
	isSafari:	(navigator.userAgent.toLowerCase().indexOf("safari")!=-1 ? true : false),
	isOpera:	(navigator.userAgent.toLowerCase().indexOf("opera")!=-1 ? true : false),
	isIE:		(navigator.userAgent.toLowerCase().indexOf("msie")!=-1 ? true : false),
	type:		'',
	version:	'',
	platform:	''
};
/**
 * Firefox
 * Mozilla/5.0 (X11; U; FreeBSD i386; ru-RU; rv:1.9.0.10) Gecko/2009050715 Firefox/3.0.10
 * Mozilla/5.0 (Windows; U; Windows NT 6.0; ru; rv:1.9.0.10) Gecko/2009042316 Firefox/3.0.10 (.NET CLR 3.5.30729)
 *
 * Konqueror
 * Mozilla/5.0 (compatible; Konqueror/4.2; FreeBSD) KHTML/4.2.2 (like Gecko)
 *
 * Opera
 * Opera/9.64 (Windows NT 6.0; U; ru) Presto/2.1.1
 * Opera/9.64 (X11; FreeBSD 7.2-PRERELEASE i386; U; ru) Presto/2.1.1
 *
 * Safari
 * Mozilla/5.0 (Windows; U; Windows NT 6.0; ru-RU) AppleWebKit/523.16 (KHTML, like Gecko) Version/4.0 Safari/528.16
 *
 * Internet Explorer
 * Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0) - ???
 * Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; ...) - Windows XP
 * Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; ...) - Windows XP
 * Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.0; ...) - Windows Vista
 * Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; ...) - Windows 7
 */
/**
 * navigator -  FF    
 *    
 */
var data=null;
var os=null;
if(jsCore.browser.isGecko&&!jsCore.browser.isSafari&&!jsCore.browser.isKonq){
	data=navigator.userAgent.split(')');
	jsCore.browser.type=data[1].trim().split(' ')[1].trim().split('/')[0].trim();
	jsCore.browser.version=data[1].trim().split(' ')[1].trim().split('/')[1].trim();
	os=data[0].trim().split(';')[2].trim().split(' ');
}else if(jsCore.browser.isKonq){
	data=navigator.userAgent.split(';');
	jsCore.browser.type=data[1].trim().split('/')[0].trim();
	jsCore.browser.version=data[1].trim().split('/')[1].trim();
	os=data[2].trim().split(')')[0].trim();
}else if(jsCore.browser.isSafari){
	data=navigator.userAgent.split(')');
	jsCore.browser.type=data[2].trim().split(' ')[1].trim().split('/')[0].trim();
	jsCore.browser.version=data[2].trim().split(' ')[0].trim().split('/')[1].trim();
	os=data[0].trim().split(';')[2].trim().split(' ');
}else if(jsCore.browser.isOpera){
	data=navigator.userAgent.split('(');
	jsCore.browser.type=data[0].trim().split('/')[0].trim();
	jsCore.browser.version=data[0].trim().split('/')[1].trim();
	os=data[1].trim().split(';')[0].trim().split(' ');
}else if(jsCore.browser.isIE){
	data=navigator.userAgent.split(';');
	if(data[1].trim().split(' ')[0].trim().toLowerCase()==='msie')
		jsCore.browser.type='Microsoft Internet Explorer';
	jsCore.browser.version=data[1].trim().split(' ')[1].trim();
	os=data[2].trim().split(' ');
}
if(os.length>0){
	jsCore.browser.platform=os[0].trim();
	if(jsCore.browser.platform.toLowerCase()==='windows'){
		switch(os[os.length-1]){
			case '5.1':
				jsCore.browser.platform+=' XP';
				break;
			case '6.0':
				jsCore.browser.platform+=' Vista';
				break;
			case '6.1':
				jsCore.browser.platform+=' 7';
				break;
		}
	}else{
		jsCore.browser.platform+=' ('+os[os.length-1].trim()+')';
	}
}else{
	jsCore.browser.platform=os;
}
/*
alert(
	navigator.userAgent+"\n"
	+'Browser: '+jsCore.browser.type+"\n"
	+'Version: '+jsCore.browser.version+"\n"
	+'Platform: '+jsCore.browser.platform
);
*/

