var isIE=(navigator.userAgent.toLowerCase().indexOf("msie")!=-1 ? true : false);
if(isIE){
	var IEExtSelection=function(){
		var w=arguments[0]||null;
		var s={
/**
 * standard variables data
 *****************************
 * @property anchorNode
 * @property anchorOffset
 * @property focusNode
 * @property focusOffset
 * @property isCollapsed
 * @property rangeCount
 */
			anchorNode: w,
			anchorOffset: 0,
			focusNode: w,
			focusOffset: 0,
			isCollapsed: true,
			rangeCount: 0,
/**
 * addon variables data
 *****************************
 * @property _hiddenElem	invisible Element
 * @property _ranges		Array of TextRanges
 */
			_hiddenElem: '\uFEFF',
			_ranges: new Array(),
/**
 * standard functions
 *****************************
 * working:
 * @function addRange
 * @function collapseToEnd
 * @function collapsetoStart
 * @function getRangeAt
 * @function removeAllRanges
 * @function toString
 *
 * not implemented:
 * @function collapse
 * @function containsNode
 * @function deleteFromDocument
 * @function extend
 * @function removeRange
 * @function selectAllChildren
 */
			addRange: function(r){
				var t=this;
				t._ranges.push(r);
				t.rangeCount=t._ranges.length;
				t._setParam();
				t.getRangeAt(0)._range.select();
			},
			collapse: function(){
//not implemented yet
			},
			collapseToEnd: function(){
				var t=this;
				var r=t._ranges;
				r.setStart(r.endContainer,r.endOffset);
				t._setParam();
			},
			collapsetoStart: function(){
				var t=this;
				var r=t._ranges;
				r.setEnd(r.startContainer,r.startOffset);
				t._setParam();
			},
			containsNode: function(){
//not implemented yet
			},
			deleteFromDocument: function(){
//not implemented yet
			},
			extend: function(){
//not implemented yet
			},
			getRangeAt: function(i){
				var t=this;
				return t._ranges[i];
			},
			removeAllRanges: function(){
				var t=this;
				t._ranges=new Array();
				t.rangeCount=0;
				t._setParam();
			},
			removeRange: function(){
//not implemented yet
			},
			selectAllChildren: function(){
//not implemented yet
			},
/**
 * addon functions
 *****************************
 * @function _setParam
 * @function _toString (prototype toString)
 * @function _getRangePoints
 * @function _init
 */
			_setParam: function(){
				var t=this;
				if(t._ranges.length>0){
					var r=t.getRangeAt(0);
					t.anchorNode=r.startContainer;
					t.anchorOffset=r.startOffset;
					t.focusNode=r.endContainer;
					t.focusOffset=r.endOffset;
					t.isCollapsed=r._isCollapsed();
				}else{
					t.anchorNode=w;
					t.anchorOffset=0;
					t.focusNode=w;
					t.focusOffset=0;
					t.isCollapsed=true;
				}
			},
			_toString: function(){
				var t=this;
				var r=t.getRangeAt(0);
				return r.text;
			},
			_getRangePoints: function(rng){
				var clone=rng.cloneRange();
				var r=clone._range;
//not implemented yet
			},
			_init: function(){
				var t=this;
				var d=arguments[0]||document;
				var r=new IEExtRange(d);
				r._init(d.selection.createRange());
				t.addRange(r);
			}
		};
		s._init();
		return s;
	};
	IEExtSelection.prototype.toString=IEExtSelection._toString;
	var IEExtRange=function(){
		var d=arguments[0]||document;
		var newRng={
/**
 * standard constants
 */
			START_TO_START: 0,
			START_TO_END: 1,
			END_TO_END: 2,
			END_TO_START: 3,
/**
 * standard variables data
 *****************************
 * @property collapsed
 * @property commonAncestorContainer
 * @property endContainer
 * @property endOffset
 * @property startContainer
 * @property startOffset
 */
			collapsed: true,
			commonAncestorContainer: d,
			endContainer: d,
			endOffset: 0,
			startContainer: d,
			startOffset: 0,
/**
 * addon variables data
 *****************************
 * @property _range		phisical TextRange
 */
			_range: null,
/**
 * standard functions
 *****************************
 * working:
 * @function cloneContents
 * @function cloneRange
 * @function collapse
 * @function compareBoundaryPoints
 * @function selectNode
 * @function selectNodeContents
 * @function setEnd
 * @function setEndAfter
 * @function setEndBefore
 * @function setStart
 * @function setStartAfter
 * @function setStartBefore
 *
 * not implemented:
 * @function compareNode
 * @function comparePoints
 * @function createContextualFragment
 * @function deleteContents
 * @function detach
 * @function extractContents
 * @function insertNode
 * @function intersectsNode
 * @function isPointInRange
 * @function surroundContents
 */
			cloneContents: function(){
//not implemented yet
			},
			cloneRange: function(){
				var t=this;
				var n=new IEExtRange(d);
				n.collapsed=t.collapsed;
				n.commonAncestorContainer=t.commonAncestorContainer;
				n.endContainer=t.endContainer;
				n.endOffset=t.endOffset;
				n.startContainer=t.startContainer;
				n.startOffset=t.startOffset;
				n._range=t._range;
				return n;
			},
			collapse: function(lb){
				var t=this;
				if(lb){
					t.endContainer=t.startContainer;
					t.endOffset=t.startOffset;
				}else{
					t.startContainer=t.endContainer;
					t.startOffset=t.endOffset;
				}
				t.collapsed=true;
			},
			compareBoundaryPoints: function(type,range){
				var t=this;
				var sc=t.startContainer;
				var so=t.startOffset;
				var ec=t.endContainer;
				var eo=t.endOffset;
				if(type===0)//START_TO_START
					return t._comparePoints(sc,so,sc,so);
				if(type===1)//START_TO_END
					return t._comparePoints(sc,so,ec,eo);
				if(type===2)//END_TO_END
					return t._comparePoints(ec,eo,ec,eo);
				if(type===3)//END_TO_START
					return t._comparePoints(ec,eo,sc,so);
			},
			compareNode: function(){
//not implemented yet
			},
			comparePoint: function(){
//not implemented yet
			},
			createContextualFragment: function(){
//not implemented yet
			},
			deleteContents: function(){
//not implemented yet
			},
			detach: function(){
//not implemented yet
			},
			extractContents: function(){
//not implemented yet
			},
			insertNode: function(){
//not implemented yet
			},
			intersectsNode: function(){
//not implemented yet
			},
			isPointInRange: function(){
//not implemented yet
			},
			selectNode: function(n){
				var t=this;
				t.setStartBefore(n);
				t.setEndAfter(n);
			},
			selectNodeContents: function(n){
				var t=this;
				t.setStart(n,0);
				t.setEnd(n,n.nodeType===1?n.childNodes.length:n.nodeValue.length);
			},
			setEnd: function(n,o){
				var t=this;
				t._setPoint(false,n,o);
			},
			setEndAfter: function(n){
				var t=this;
				t.setEnd(n.parentNode,t._nodeIDX(n)+1);
			},
			setEndBefore: function(n){
				var t=this;
				t.setEnd(n.parentNode,t._nodeIDX(n));
			},
			setStart: function(n,o){
				var t=this;
				t._setPoint(true,n,o);
			},
			setStartAfter: function(n){
				var t=this;
				t.setStart(n.parentNode,t._nodeIDX(n)+1);
			},
			setStartBefore: function(n){
				var t=this;
				t.setStart(n.parentNode,t._nodeIDX(n));
			},
			surroundContents: function(){
//not implemented yet
			},
/**
 * addon functions
 *****************************
 * @function _nodeIDX
 * @function _isCollapsed
 * @function _findStartAncestor
 * @function _comparePoints
 * @function _setPoint
 * @function _toString (prototype toString)
 * @function _init
 */
			_nodeIDX: function(n){
				var i=0;
				while(n.previousSibling){
					i++;
					n=n.previousSibling;
				}
				return i;
			},
			_isCollapsed: function(){
				var t=this;
				return (t.startContainer==t.endContainer&&t.startOffset==t.endOffset);
			},
			_findStartAncestor: function(sc,ec){
				var ps=sc;
				var pe=null;
				while(ps){
					pe=ec;
					while(pe&&ps!=pe)
						pe=pe.parentNode;
					if(ps==pe)
						break;
					ps=ps.parentNode;
				}
				if(!ps&&sc.ownerDocument)
					return sc.ownerDocument.documentElement;
				return ps;
			},
			_comparePoints: function(sc,so,ec,eo){
				if(sc==ec){
					if(so==eo)
						return 0;//equal
					else if(so<eo)
						return -1;//before
					else
						return 1;//after
				}
				var t=this;
				var tc=null;//temp container
				var to=null;//temp offset
				var n=null;//finded node
				tc=ec;
				while(tc&&tc.parentNode!=sc)
					tc=tc.parentNode;
				if(tc){
					to=0;
					n=sc.firstChild;
					while(n!=tc&&to<so){
						to++;
						n=n.nextSibling;
					}
					if(so<=to)
						return -1;//before
					else
						return 1;//after
				}
				tc=sc;
				while(tc&&tc.parentNode!=ec)
					tc=tc.parentNode;
				if(tc){
					to=0;
					n=ec.firstChild;
					while(n!=tc&&to<eo){
						to++;
						n=n.nextSibling;
					}
					if(to<eo)
						return -1;//before
					else
						return 1;//after
				}
				var root=t._findStartAncestor(sc,ec);
				var child_s=sc;//child of startContainer
				while(child_s&&child_s.parentNode!=root)
					child_s=child_s.parentNode;
				if(!child_s)
					child_s=root;
				var child_e=ec;//chils of endContainer
				while(child_e&&child_e.parentNode!=root)
					child_e=child_e.parentNode;
				if(!child_e)
					child_e=root;
				if(child_s==child_e)
					return 0;//equal
				n=root.firstChild;
				while(n){
					if(n==child_s)
						return -1;//before
					if(n==child_e)
						return 1;//after
					n=n.nextSibling;
				}
			},
			_setPoint: function(home,n,i){
				var t=this;
				if(home){
					t.startContainer=n;
					t.startOffset=i;
				}else{
					t.endContainer=n;
					t.endOffset=i;
				}
				var ec=t.endContainer;
				while(ec.parentNode)
					ec=ec.parentNode;
				var sc=t.startContainer;
				while(sc.parentNode)
					sc=sc.parentNode;
				if(sc!=ec){
					t.collapse(home);
				}else{
					if(t._comparePoints(t.startContainer,t.startOffset,t.endContainer,t.endOffset)>0)
						t.collapse(home);
				}
				t.collapsed=t._isCollapsed();
				t.commonAncestorContainer=t._findStartAncestor(t.startContainer,t.endContainer);

				if(home){//setting physical point for TextRange
					if(n.nodeType==3){
						var tmp=n.parentNode.insertBefore(d.createElement('span'),n);
						tmp.innerHTML='&nbsp;';
						t._range.moveToElementText(tmp);
						t._range.collapse(false);
						tmp.parentNode.removeChild(tmp);
					}else{
						t._range.moveToElementText(n);
						t._range.collapse(true);
					}
					t._range.move("character",t.startOffset);
				}else
					t._range.moveEnd("character",t.endOffset-t.startOffset);
			},
			_toString: function(){
				var t=this;
				return t._range.text;
			},
			_init: function(){
				var r=arguments[0]||null;
				var t=this;
				if(r){
					t._range=r;
					t._range.collapse(true);
				}else
					t._range=d.body.createTextRange();
			}
		};
		newRng._init();
		return newRng;
	};
	IEExtRange.prototype.toString=IEExtRange._toString;
}
