jsCore.storage={
	parentObject: null,
	range: null,
	buffer: '',
	clipboard: null,
	savedCopy: null,
	tbActiveItems: new Array(),
	tbDisabledItems: new Array(),
	tbLocked: new Array(),
	tree: null,
	savedTree: null,
	restoredTree: false,
	setFontColor: '000000',
	setFontBgColor: 'FFFFFF',
	setBackColor: 'FFFFFF',
	afterCode: false,
/**
 *    
 *       
 */
	get: function(){
//  
		obj=$('richedit');
		var range=null;
//Gecko, Opera
		if(!jsCore.func.visibled($('memo'))){
			if(jsCore.browser.isGecko || jsCore.browser.isOpera){
				jsCore.storage.clear();
//     
				if(obj.contentWindow.getSelection){
// 
					var buffer=obj.contentWindow.getSelection();
//   ,   
					if(
						buffer.anchorNode.childNodes[buffer.anchorOffset]
						&& buffer.anchorNode.childNodes[buffer.anchorOffset].nodeType!=3
					){
						jsCore.storage.parentObject=buffer.anchorNode.childNodes[buffer.anchorOffset];
					}
					range=buffer.getRangeAt(0);
//   
					if(range.offsetStart==range.offsetEnd && range.startContainer==range.endContainer && buffer.toString().length==0){
//       
						jsCore.storage.range=range;
//    
					}else{
// ,      HTML   
						jsCore.storage.clipboard=jsCore.dom.create.tag('span');
// clipboard  HTML-  
						jsCore.storage.clipboard.appendChild(range.cloneContents());
// buffer    
						jsCore.storage.buffer=buffer;
						jsCore.storage.range=range;
					}
				}
//IE
			}else if(jsCore.browser.isIE){
//     
				range=re_doc.selection.createRange();
//   ,   
				if(range.length>0){
					jsCore.storage.parentObject=range.item(0);
				}else{
					jsCore.storage.parentObject=range.parentElement();
				}
// buffer    
				jsCore.storage.buffer=range.text||'';
// clipboard  HTML-  
				jsCore.storage.clipboard=range.htmlText||'';
//       
				jsCore.storage.range=range;
			}else{
//Not used yet
			}
		}
	},
	getTreeNodes: function(){
		jsCore.storage.get();
		if(jsCore.storage.range){
			var o=null;
			if(jsCore.storage.parentObject){
				o=jsCore.storage.parentObject;
			}else{
				if(jsCore.browser.isGecko){
					if(jsCore.storage.clipboard
						&& jsCore.storage.clipboard.childNodes
						&& jsCore.storage.clipboard.childNodes.length==1
						&& jsCore.storage.clipboard.childNodes[0].nodeType!=3
						&& jsCore.storage.clipboard.childNodes[0].innerHTML==jsCore.storage.buffer){
							o=jsCore.storage.range.startContainer.childNodes[0];
					}else{
						if(jsCore.storage.range.commonAncestorContainer.nodeType!=3){
							o=jsCore.storage.range.commonAncestorContainer;
						}else{
							o=jsCore.storage.range.commonAncestorContainer.parentNode;
						}
					}
				}
			}
			if(!o||!o.tagName){
				o=jsCore.dom.get.iframeBody($('richedit')).body;
			}
			if(o){
				if(!o.tagName){
					jsCore.debug(o,106,'storage.js','no tagName -=[ !!! BUG !!! ]=-');
				}else{
					if(o.tagName.toLowerCase()!=='html'){
						jsCore.storage.tree=new Array();
						while(o && o.tagName.toLowerCase()!=='body'){
							if(o.tagName){
								jsCore.storage.tree.push(o);
								o=o.parentNode;
							}else{
								o=o.parentNode;
							}
							if(o==null)
								break;
							if(o.tagName==null)
								o=o.parentNode;
						}
						if(o)
							jsCore.storage.tree.push(o);
					}
				}
			}
		}
	},
	saveClipboard: function(){
		if(jsCore.storage.buffer.toString().length>0)
			jsCore.storage.savedCopy=jsCore.storage.clipboard;
	},
	stateInNode: function(o){
		var rcw=$('richedit').contentWindow;
		rcw.focus();
		jsCore.storage.selectNode(o);
		if(jsCore.browser.isIE){
			jsCore.storage.range.collapse(true);
			jsCore.storage.range.select();
		}else{
			jsCore.storage.buffer=rcw.getSelection();
			jsCore.storage.buffer.collapse(o,0);
		}
		rcw.focus();
	},
	selectNode: function(o){
		var r=null;
		if(jsCore.browser.isIE){
			r = re_doc.body.createTextRange();
			r.moveToElementText(o);
			r.select();
		}else{
			var s=$('richedit').contentWindow.getSelection();
			r=document.createRange();
			r.selectNodeContents(o);
			s.removeAllRanges();
			s.addRange(r);
		}
		jsCore.storage.get();
	},
	saveTree: function(){
		jsCore.storage.savedTree=new Array();
		jsCore.storage.savedTree=jsCore.storage.tree;
	},
	restoreTree: function(){
		jsCore.storage.tree=jsCore.storage.savedTree;
		jsCore.storage.savedTree=new Array();
		jsCore.storage.restoredTree=true;
	},
	select: function(){
		var id=0;
		if(jsCore.browser.isIE)
			id=parseInt(arguments[0].srcElement.id);
		else
			id=parseInt(this.id);
		jsCore.storage.selectNode(jsCore.storage.tree[id]);
		jsCore.func.renderStatInfo();
		jsCore.func.scrollToElem(jsCore.storage.tree[id]);
	},
	clear: function(){
		with(jsCore.storage){
			buffer='';
			clipboard='';
			parentObject=null;
			range=null;
			tree=null;
		}
	},
	imgDataStorage: {
		selectedImage: null,
		hsource: '',
		hWidth: 0,
		hHeight: 0,
		htitle: '',
		halign: 'default',
		hpadding: {
			top: 0,
			right: 0,
			bottom: 0,
			left: 0
		},
		source: '',
		srcWidth: 0,
		curWidth: 0,
		srcHeight: 0,
		curHeight: 0,
		title: '',
		align: 'default',
		padding: {
			top: 0,
			right: 0,
			bottom: 0,
			left: 0
		},
		clear: function(){
			var ids=jsCore.storage.imgDataStorage;
			ids.selectedImage=null;
			ids.hsource='';
			ids.hWidth=0;
			ids.hHeight=0;
			ids.htitle='';
			ids.halign='default';
			ids.hpadding.top=0;
			ids.hpadding.right=0;
			ids.hpadding.bottom=0;
			ids.hpadding.left=0;
			ids.source='';
			ids.srcWidth=0;
			ids.srcHeight=0;
			ids.curWidth=0;
			ids.curHeight=0;
			ids.title='';
			ids.align='default';
			ids.padding.top=0;
			ids.padding.right=0;
			ids.padding.bottom=0;
			ids.padding.left=0;
			$('imgname').innerHTML='';
			$('preview_image').innerHTML='';
			$('image_src_size').innerHTML='';
			$('imageSize0').check();
			$('pxWidth').value='0';
			$('pxWidth').enable();
			$('pxHeight').value='0';
			$('pxHeight').enable();
			$('prcWidth').value='100';
			$('prcWidth').disable();
			$('prcHeight').value='100';
			$('prcHeight').disable();
			$('proportion').check();
			jsCore.dom.set.style($('recover_size'),'display','none');
			$('image_title').value='';
			jsCore.dom.set.style($('imgalign_default'),'border','2px solid #0000FF');
			jsCore.dom.set.style($('imgalign_left'),'border','0px');
			jsCore.dom.set.style($('imgalign_right'),'border','0px');
			jsCore.dom.set.style($('imgalign_under'),'border','0px');
			jsCore.dom.set.style($('imgalign_above'),'border','0px');
			$('padInputTop').value='0';
			$('padInputLeft').value='0';
			$('imageChange').src=jsCore.imgURL+'misc/float_default.gif';
			$('padInputRight').value='0';
			$('padInputBottom').value='0';
		},
		save: function(o){
			if(o&&o.tagName.toLowerCase()==='img'){
				jsCore.dom.set.item.add(jsCore.dom.get.body(),new jsCore.image({
					id: 'hidden_image',
					style: {
						position: 'absolute',
						top: '-99999px',
						left: '-99999px'
					},
					source: jsCore.dom.get.source(o),
					on: {
						load: function(){
							var ids=jsCore.storage.imgDataStorage;
							var self_load=null;
							if(jsCore.browser.isIE)
								self_load=arguments[0].srcElement;
							else
								self_load=this;
							with(ids){
								selectedImage=o;
								hsource=jsCore.dom.get.source(o);
								hWidth=jsCore.dom.get.width(o);
								hHeight=jsCore.dom.get.height(o);
								htitle=o.getAttribute('alt')||o.getAttribute('title')||'';
							}
							if(jsCore.dom.get.style(o,jsCore.browser.isIE?'styleFloat':'cssFloat')==='left'){
								ids.halign='left';
							}else if(jsCore.dom.get.style(o,jsCore.browser.isIE?'styleFloat':'cssFloat')==='right'){
								ids.halign='right';
							}else if(jsCore.dom.get.style(o,'position')==='absolute'){
								if(jsCore.dom.get.style(o,'zIndex')==='-1'){
									ids.halign='under';
								}else if(jsCore.dom.get.style(o,'zIndex')==='1'){
									ids.halign='above';
								}
							}else{
								ids.halign='default';
							}
							with(ids){
								hpadding.top=parseInt(jsCore.dom.get.style(o,'paddingTop'));
								hpadding.right=parseInt(jsCore.dom.get.style(o,'paddingRight'));
								hpadding.bottom=parseInt(jsCore.dom.get.style(o,'paddingBottom'));
								hpadding.left=parseInt(jsCore.dom.get.style(o,'paddingLeft'));
								source=ids.hsource;
								srcWidth=jsCore.dom.get.width(self_load);
								srcHeight=jsCore.dom.get.height(self_load);
								curWidth=ids.hWidth;
								curHeight=ids.hHeight;
								title=ids.htitle;
							}
							if(ids.curWidth!==ids.srcWidth){
								$('pxWidth').value=ids.curWidth;
								$('prcWidth').value=parseInt(ids.curWidth*100/ids.srcWidth);
							}else{
								$('pxWidth').value=ids.srcWidth;
								$('prcWidth').value='100';
							}
							if(ids.curHeight!==ids.srcHeight){
								$('pxHeight').value=ids.curHeight;
								$('prcHeight').value=parseInt(ids.curHeight*100/ids.srcHeight);
							}else{
								$('pxHeight').value=ids.srcHeight;
								$('prcHeight').value='100';
							}
							$('image_title').value=ids.title;
							ids.align=ids.halign;
							with(ids){
								padding.top=ids.hpadding.top;
								padding.right=ids.hpadding.right;
								padding.bottom=ids.hpadding.bottom;
								padding.left=ids.hpadding.left;
							}
							$('padInputTop').value=ids.padding.top;
							$('padInputRight').value=ids.padding.right;
							$('padInputBottom').value=ids.padding.bottom;
							$('padInputLeft').value=ids.padding.left;
							with(jsCore.dom.set){
								style($('imgalign_default'),'border','0px');
								style($('imgalign_'+ids.align),'border','2px solid #0000FF');
								style($('imgalign_'+ids.align),'cursor','pointer');
								source($('imageChange'),jsCore.imgURL+'misc/float_'+ids.align+'.gif');
							}
							$('image_src_size').innerHTML=ids.srcWidth+' x '+ids.srcHeight;
							var src=jsCore.dom.get.source(o);
							if(src.indexOf(base_url)>=0 && src.indexOf(path)>=0){
								var short_name=src.substring((base_url+path+'/').length,src.length);
								var gfc='root';
								if(dirname(short_name)!==mediaFolder){
									gfc=dirname(short_name).substring(mediaFolder.length+1,dirname(short_name).length);
								}
								var gc=new jsCore.ajax.init('GET',url_editor+'/'+transURL,'gfc='+gfc+'&base_root='+base_root+path,$('select_file'));
								gc.query();
								jsCore.dom.set.item.clear($('preview_image'));
								var curStyle=null;
								if(jsCore.browser.isIE&&parseInt(jsCore.browser.version)==7){
									curStyle={
										maxWidth: '98px',
										maxHeight: '198px'
									};
								}else{
									curStyle={
										position: 'absolute',
										left: '-9999px',
										top: '-9999px',
										filter: 'alpha(opacity=0)'
									}
								}
								jsCore.dom.set.item.add($('preview_image'),new jsCore.image({
									id: 'sel_image',
									style: curStyle,
									source: ids.hsource,
									on: {
										load: function(){
											var myself=null;
											if(jsCore.browser.isIE)
												myself=arguments[0].srcElement;
											else
												myself=this;
											if(jsCore.browser.isIE&&parseInt(jsCore.browser.version)==7){
												//nothing to do
											}else{
												if(myself.width>myself.height){
													if(myself.width>98){
														with(jsCore.dom.set){
															style(myself,'width','98px');
															style(myself,'height','auto');
														}
													}
												}else{
													if(myself.height>198){
														if(myself.width>98){
															with(jsCore.dom.set){
																style(myself,'width','98px');
																style(myself,'height','auto');
															}
														}else{
															with(jsCore.dom.set){
																style(myself,'width','auto');
																style(myself,'height','198px');
															}
														}
													}
												}
												with(jsCore.dom.set){
													style(myself,'position','');
													style(myself,'left','auto');
													style(myself,'top','auto');
													style(myself,'filter','alpha(opacity=100)');
												}
											}
										}
									}
								}));
							}
							if(ids.srcWidth && ids.srcHeight)
								jsCore.dom.set.style($('recover_size'),'display','');
							jsCore.dom.remove(self_load);
							jsCore.dom.set.text.replace($('imgname'),short_name);
						}
					}
				}));
			}
		},
		restore: function(){
			var ids=jsCore.storage.imgDataStorage;
			if(ids.selectedImage){
				with(jsCore.dom.set){
					source(ids.selectedImage,ids.hsource);
					width(ids.selectedImage,ids.hWidth);
					height(ids.selectedImage,ids.hHeight);
					style(ids.selectedImage,'padding',ids.hpadding.top+'px '+ids.hpadding.right+'px '+ids.hpadding.bottom+'px '+ids.hpadding.left+'px');
				}
				switch(ids.halign){
					case 'left':
						with(jsCore.dom.set){
							style(ids.selectedImage,'position','');
							style(ids.selectedImage,'zIndex','');
							style(ids.selectedImage,jsCore.browser.isIE?'styleFloat':'cssFloat','left');
						}
						break;
					case 'right':
						with(jsCore.dom.set){
							style(ids.selectedImage,'position','');
							style(ids.selectedImage,'zIndex','');
							style(ids.selectedImage,jsCore.browser.isIE?'styleFloat':'cssFloat','right');
						}
						break;
					case 'under':
						with(jsCore.dom.set){
							style(ids.selectedImage,jsCore.browser.isIE?'styleFloat':'cssFloat','');
							style(ids.selectedImage,'position','absolute');
							style(ids.selectedImage,'zIndex','-1');
						}
						break;
					case 'above':
						with(jsCore.dom.set){
							style(ids.selectedImage,jsCore.browser.isIE?'styleFloat':'cssFloat','');
							style(ids.selectedImage,'position','absolute');
							style(ids.selectedImage,'zIndex','1');
						}
						break;
					default:
						with(jsCore.dom.set){
							style(ids.selectedImage,'position','');
							style(ids.selectedImage,'zIndex','');
							style(ids.selectedImage,jsCore.browser.isIE?'styleFloat':'cssFloat','');
						}
						break;
				}
				with(ids.selectedImage){
					setAttribute('alt',ids.htitle);
					setAttribute('title',ids.htitle);
				}
			}
		}
	},
	search: {
		doc: document,
		body: document.body,
		srch: '',
		lastIdx: -1,
		result: new Array(),
		clear: function(){
			with(jsCore.storage.search){
				doc=document;
				body=document.body;
				srch='';
				lastIdx=-1;
				result=new Array();
			}
		},
		getTextNodeList: function(parentNode,list){
			for(var a=0;a<parentNode.childNodes.length;a++){
				if(parentNode.childNodes[a].nodeType==3){
					if(parentNode.childNodes[a].nodeValue.length==1&&parentNode.childNodes[a].nodeValue==="\n")
						continue;
					else
						list.push({
							n: parentNode.childNodes[a],
							s: list[list.length-1]?parseInt(list[list.length-1].s)+parseInt(list[list.length-1].l):0,
							l: parentNode.childNodes[a].length
						});
				}else{
					jsCore.storage.search.getTextNodeList(parentNode.childNodes[a],list);
				}
			}
		},
		search: function(){
			var ss=jsCore.storage.search;
			if(ss.srch!==''){
				var b=ss.body;
				var list=new Array();
				ss.getTextNodeList(b,list);
//				console.log(list);
/*				var r=ss.doc.createRange();
				r.selectNodeContents(b);*/
				var c='';
				var v=null;
				for(var a=0;a<list.length;a++){
					v=list[a].n.nodeValue;
					c+=v.replace(/\n/gim," ");
/* 
 *    ,   
 *  " "
					if(v.charAt(v.length-1)!==" "&&v.charAt(v.length-1)!=="\n"){
						console.log('"'+v+'"');
						c+=' ';
					}
 */
				}
//				console.log(c);
				var p=new RegExp(ss.srch,"ig");
//				eval('var p=/'+ss.srch+'/ig;');
				var data=null;
				var startContainer=null;
				var startOffset=0;
				var endContainer=null;
				var endOffset=0;
				var start=0;
				var end=0;
				var ls=0;
				var ll=0;
				while((data=p.exec(c))!=null){
					startContainer=null;
					startOffset=0;
					endContainer=null;
					endOffset=0;
					start=p.lastIndex-ss.srch.length;
					end=p.lastIndex;
//					end=start+parseInt(list[a].l);
					for(var a=0;a<list.length;a++){
						ls=parseInt(list[a].s);
						ll=ls+parseInt(list[a].l)+1;
						if(start>=ls&&start<ll){
							startContainer=list[a].n;
							startOffset=start-ls;
						}
						if(end>=ls&&end<ll){
							endContainer=list[a].n;
							endOffset=end-ls;
						}
//						console.log('[nodeValue,ls,ll,start,end]: ',list[a].n.nodeValue,ls,ll,start,end);
						if(startContainer&&startOffset&&endContainer&&endOffset)
							break;
					}
//					console.log('[===========FIND===========]: ','"'+startContainer.nodeValue+'"',startOffset,'"'+endContainer.nodeValue+'"',endOffset);
					ss.result.push({
						sc: startContainer,
						so: startOffset,
						ec: endContainer,
						eo: endOffset
					});
				}
			}
		},
		init: function(){
			var ss=jsCore.storage.search;
			ss.clear();
// document
			ss.doc=arguments[0]||document;
// body
			ss.body=arguments[1]||document.body;
// search phrase
			if(arguments[2]){
				with(ss){
					srch=arguments[2];
					search();
				}
			}
		}
	},
	tableProperty: {
		objTable: null,
		objCell: null,
		savedData: {
			tw: 0,
			twp: 0,
			tb: 0,
			tcs: 0,
			tcp: 0,
			cw: 0,
			cwp: 0,
			ch: 0,
			cb: 0
		},
		newData: {
			tw: 0,
			twp: 0,
			tb: 0,
			tcs: 0,
			tcp: 0,
			cw: 0,
			cwp: 0,
			ch: 0,
			cb: 0
		}
	}
};