<?php 
include("../1.php");
include("pclzip.lib.php");
require_once('AES128.php');

function aes_enc($string) {
	$encstr = '';
	$aes = new AES128(false, false);			// (toHEX, debug)
	$key = $aes->makeKey(CD_AES);
	$parts = preg_split('/(.{16})/', $string, -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);
	for ($ii = 0; $ii < count($parts); $ii++) {
		$ct = base64_encode($aes->blockEncrypt($parts[$ii], $key));
		$encstr .= $ct;
	}
	return $encstr;
}

function aes_dec($string) {
	$decstr = '';
	$aes = new AES128(false, false);			// (toHEX, debug)
	$key = $aes->makeKey(CD_AES);
	$parts = preg_split('/(.{24})/', $string, -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);
	for ($ii = 0; $ii < count($parts); $ii++) {
		$ct = $aes->blockDecrypt(base64_decode($parts[$ii]), $key);
		$decstr .= $ct;
	}
	return $decstr;
}

function rmrf ($dir) {
	if (is_dir($dir)) {
		$res = array();
		if (substr($dir, -1) != '/') {
			$dir .= '/';
		}
		$handle = opendir($dir);
		while (false !== ($file = readdir($handle))) {
			if ($file != '.' && $file != '..') {
				$path = $dir . $file;
				if (is_dir($path)) {
					$res = array_merge($res, rmrf($path));
				} else {
					unlink($path);
					$res[] .= $path;
				}
			}
		}
		closedir($handle);
		rmdir($dir);
		$res[] .= $dir;
		return $res;		// array of deleted items
	} else {
		return false;
	}
}

?>