<?php 
function cp1251_utf8($str) {
	$output = "";
	$other[1025] = "";
	$other[1105] = "";
	$other[1028] = "";
	$other[1108] = "";
	$other[1030] = "I";
	$other[1110] = "i";
	$other[1031] = "";
	$other[1111] = "";

	for ($i=0; $i < strlen($str); $i++) {
		if (ord($str{$i}) > 191){
			$output .= "&#" . (ord($str{$i})+848) . ";";
		} else {
			if (array_search($str{$i}, $other) === false){
				$output .= $str{$i};
			} else {
				$output .= "&#" . array_search($str{$i}, $other) . ";";
			}
		}
	}
	return $output;
}

function utf8_cp1251($s) {
	$out = "";
	$c1 = "";
	$byte2 = false;
	for ($c=0; $c < strlen($s); $c++) {
		$i = ord($s[$c]);
		if ($i <= 127) {
			$out .= $s[$c];
		}
		if ($byte2) {
			$new_c2 = ($c1 & 3) * 64 + ($i&63);
			$new_c1 = ($c1 >> 2) & 5;
			$new_i = $new_c1 * 256 + $new_c2;
			if ($new_i == 1025) {
				$out_i = 168;
			} else {
				if ($new_i == 1105) {
					$out_i = 184;
				} else {
					$out_i = $new_i - 848;
				}
			}
			$out .= chr($out_i);
			$byte2 = false;
		}
		if (($i >> 5) == 6) {
			$c1 = $i;
			$byte2 = true;
		}
	}
	return $out;
}

//   ,   - 2  
function mysql_iconv($string, $from="cp1251", $to="utf8") {
	$character_set_database = sqldb_result(sqldb_query("SELECT @@character_set_client"),0,0);
	$character_set_results = sqldb_result(sqldb_query("SELECT @@character_set_results"),0,0);

	sqldb_query("SET character_set_client=$from");
	sqldb_query("SET character_set_results=$to");

	$string_escaped = mysql_real_escape_string($string);
	$converted_string = cp1251_utf8($string_escaped);
	$converted_string = sqldb_result(sqldb_query("SELECT '$string_escaped'"),0,0);

	sqldb_query("SET character_set_client=$character_set_database");
	sqldb_query("SET character_set_results=$character_set_results");

	return $converted_string;
}
?>