<?php

include_once("1.php");
include_once("1main.php");

//       . 
define("DELAY_BEFORE_REFRESH", 1); // (seconds)
//        
define("TEXT_DELIMITER", "<!-- TEXT_DELIMITER -->");
//    (      
//       )
$TRY_CODE = session_id(); 
//      
define("TMP_FILE_FOR_PRINT", ini_get("session.save_path")."/".$TRY_CODE.".prnt");
//   
define("START_DIALOG_STR", "For printing training material has been divided into [NUMBER] parts. Press OK to start printing part #1");
define("NEXT_STEP_STR", "Part #[NUMBER] has been prepared for printing. You are kindly requested to wait until printing of the previous part will be completed.");

class Page_Composer
{
	var $step;        //   ( )
	var $blocks;      //   ()
	var $try_code;    //     (ID )
	var $print_text;  //    
	function Page_Composer($step, $blocks, $try_code)
	{
		$this->step = $step;
		$this->blocks = $blocks;
		$this->try_code = $try_code;
	}
	//   
	function checkParams()
	{
		$is_valid = false;
		//     
		if ($this->step != $this->blocks) {
			//    ID      
			if ($this->try_code == session_id() && file_exists(TMP_FILE_FOR_PRINT)) {
				$fp = fopen(TMP_FILE_FOR_PRINT, "r");
				$text = fread($fp, filesize(TMP_FILE_FOR_PRINT));
				fclose($fp);
				$blocks_in_file = explode(TEXT_DELIMITER, $text);
				//        -    
				//     GET
				if ((count($blocks_in_file) == $this->blocks) && $this->step >= 0 && $this->step < $blocks_in_file) {
					//    
					$this->print_text = $blocks_in_file[$this->step];
					$is_valid = true;
				}
			}
		}
		return $is_valid;
	}
	//  
	function endPrint()
	{
		if (file_exists(TMP_FILE_FOR_PRINT)) {
			unlink(TMP_FILE_FOR_PRINT);
		}
	}
	//   
	function getVisualPage($redirect)
	{
		GLOBAL $CCOURSES, $charset, $sitepath;
		$get_str = "&blocks=".$this->blocks."&try_code=".$this->try_code."&step=";
		if ($redirect) {
			//  
			if ($this->step == 0) {
				$dialog = str_replace("[NUMBER]", $this->blocks, START_DIALOG_STR);
			} else {
				$dialog = str_replace("[NUMBER]", ($this->step + 1), NEXT_STEP_STR);
			}
			$html_text = "<HTML>\n<HEAD>\n<SCRIPT language=\"JavaScript\">\n<!--\n";
			$html_text .= "if (confirm('".$dialog."')) {\n";
			$html_text .= "window.location='print_parts.php?redirect=0".$get_str.$this->step."';\n";
			$html_text .= "} else {\n";
			$html_text .= "//document.rollback.submit();\n";
			$html_text .= "window.location='print_parts.php?action=end_print'";
			$html_text .= "}\n";
			$html_text .= "//-->\n";
			$html_text .= "</SCRIPT>\n";
			$html_text .= "</HEAD>\n<BODY></BODY>\n</HTML>";
		} else {
			$script = 	"<SCRIPT>
			function _POS(flashname)
			{	
			if(navigator.appName.indexOf('Netscape') == -1)
				document.all(flashname+'_pict').style.display='none';
			else
			{	
				document.all(flashname+'_pict').style.display = 'block';
				document.all(flashname).style.display = 'none';
			}
			}
			</SCRIPT>";
			$html_text = "<html><head>\n";
			$html_text .= "<META HTTP-EQUIV='Refresh' CONTENT='".DELAY_BEFORE_REFRESH."; url=print_parts.php?redirect=1".$get_str.($this->step + 1)."'>\n";
			$html_text .= $script.$charset;
			$html_text .= "\n<link rel=\"stylesheet\" href=\"".$sitepath.$CCOURSES."/".f_name("styles").".css\" type=\"text/css\">\n";
			$html_text .= "<SCRIPT language='JavaScript'>\n window.print();\n </SCRIPT>\n";
			$html_text .= "</head><body>";
			$html_text .= "<style>ul { list-style: none;}</style>";
			$html_text .= $this->print_text."</body></html>";
		}
		return $html_text;
	}
	//  
	function getCloseWindow()
	{
		$html_text = "<html>\n<head>\n</head>\n";
		$html_text .= "<script>\n window.close();\n </script>\n<body>\n</body>\n</html>\n";
		return $html_text;
	}
}

/////////////////
//  

//   (  )
$step = isset($_GET['step']) ? abs(intval($_GET['step'])) : 0;
//  
$bloks = isset($_GET['blocks']) ? abs(intval($_GET['blocks'])) : 0;
//    
$try_code = isset($_GET['try_code']) ? abs(intval($_GET['try_code'])) : 0;
//  
$action = (isset($_GET['action'])) ? $_GET['action'] : "check_params";
//      
if (isset($_GET['redirect'])) {
	$redirect = ($_GET['redirect'] == 0 || $_GET['redirect'] == 1) ? $_GET['redirect'] : 1; 
} else {
	$redirect = 1;
}

$Page_Composer = &new Page_Composer($step, $bloks, $try_code);

if ($action == "check_params") {
	//   
	if ($Page_Composer->checkParams()) {
		echo $Page_Composer->getVisualPage($redirect);
	} else {
		$action = "end_print";
	}
} else {
	$action = "end_print";
}
if ($action == "end_print") {
	//  
	$Page_Composer->endPrint();
	//  
	echo $Page_Composer->getCloseWindow();
}
?>