<?php 
###############################################################
#
# Depart library provides needle functions
# "depart_lib.php" by Dmitriy, dmitriy.zherlygin@ileader.ru
#
###############################################################

# function strpad
function strPad($count) {
    global $res;
    $res = '';
    for($i=0; $i<=$count; $i++) $res .= "&nbsp;&nbsp;";
    return $res;
};


# insert function
function insert($templ, $needle, $content) {
        $content = str_replace("Array","",$content);
    return preg_replace("/\{$templ\}/", $needle, $content);
}


# fill template by hash elements
function fillNodeTemplate($hash, $activeId, $level) {

    #$level = ($level <= 1)? 0 : $level;

    $template   = '<option value="{value}" {active}>{levelPad}{name}</option>'; // option template

    $resContent = insert("value", $hash['DID'],   $template);
    $resContent = insert("name",  $hash['title'], $resContent);

    // fill level padding
    $strPad     = strPad ($level-1);
    $resContent = insert("levelPad",  $strPad , $resContent);

    // fill selected status
    $activeStatus = ($activeId == $hash['DID']) ? "selected" : "" ;
    $resContent = insert("active", $activeStatus, $resContent);

    return $resContent;
}



# prepare nodesList
function nodesList($parentId, $activeId=false) {

    static $level = 0; // count levels
    if ($parentId == 0 )  $level =0;

    // prepre and make sql query
    global $depart_table;
     $nodesQuery = "SELECT ".f_name("Title")." AS Title, ".f_name("Description")." AS Description, DID FROM $depart_table WHERE ParentDID = ".$parentId." ORDER BY Title";

    $resRows    = sqldb_query($nodesQuery) or die(sqldb_error());
    $level++;

    if (num_rows($resRows)) {
        $resContent='';
        while ($nodeSqlRow = fetch_array($resRows)) {

            //check for child nodes
            $childRes    = nodesList($nodeSqlRow['DID'], $activeId);
            $resContent .= fillNodeTemplate($nodeSqlRow, $activeId, $level)."\n";

            // if parent node
            if ($childRes) $resContent .= $childRes;
        }
        $level--;
    }
    else {
        // node has no childs
        $level--;
        return 0;
    }

    return $resContent;
}
?>