<?php 
require('../1.php');
global $sco_target_table;

// Taken/updated from http://www.moodle.com/ SCORM 1.2 module

session_start();
define (DEBUG_DEVELOPER, FALSE);
    if (isset($userdata->status)) {
        if ($userdata->status == '') {
            $userdata->entry = 'ab-initio';
        } else {
            if (isset($userdata->{'cmi.core.exit'}) && ($userdata->{'cmi.core.exit'} == 'suspend')) {
                $userdata->entry = 'resume';
            } else {
                $userdata->entry = '';
            }
        }
    }
$MID = $_SESSION['s']['mid'];
$TID = $_SESSION['s']['user']['target'];
$CID = $_SESSION['s']['user']['course'];
$student_name = $_SESSION['s']['user']['lname'] . ', ' . $_SESSION['s']['user']['fname'];
//$student_name = 'Student, Joe';
//$userdata->credit = 'credit';
//$userdata->mode = 'normal';
//$student_name = 'Learner, Mary';
//$userdata->credit = 'no-credit';
//$userdata->mode = 'browse';

$udata = get_vars();
$userdata->{'cmi.core.lesson_location'} = $udata['cmi.core.lesson_location'];
$userdata->{'cmi.core.lesson_status'} = $udata['cmi.core.lesson_status'];
$userdata->{'cmi.core.score.raw'} = $udata['cmi.core.score.raw'];
$userdata->{'cmi.core.score.max'} = $udata['cmi.core.score.max'];
$userdata->{'cmi.core.score.min'} = $udata['cmi.core.score.min'];
$userdata->{'cmi.core.total_time'} = $udata['cmi.core.total_time'];
$userdata->{'cmi.core.exit'} = $udata['cmi.core.exit'];
$userdata->{'cmi.suspend_data'} = $udata['cmi.suspend_data'];
$userdata->{'cmi.comments'} = $udata['cmi.comments'];
$userdata->entry = $udata['entry'];

$ldata = get_adlcp();
$userdata->datafromlms = $ldata['dfl'];
$userdata->masteryscore = $ldata['ms'];
$userdata->maxtimeallowed = $ldata['mta'];
$userdata->timelimitaction = $ldata['tla'];

//$attempt = '';
$scorm->auto = 1;

function get_vars() {
	global $CID, $TID, $MID;
	$udata = array();
	//bragin
	$sql = "SELECT value, param FROM sco_sdata WHERE CID = " . $CID . " AND TID = '" . $TID . "' AND PID = " . $MID;
	out_err($sql);
	if (!$res = @sqldb_query($sql)) {
		out_err(sqldb_error());
	}
	if (num_rows($res) > 0) {
		$udata['entry'] = 'resume';
		while($row = fetch_array($res)) {
			$udata[$row['param']] = $row['value'];
			out_err($row['param'] . " = " . $row['value']);
		}
	} else {
		$udata['entry'] = 'ab-initio';
	}

	if ($udata['entry'] == 'resume' && !(isset($udata['cmi.core.exit']) && $udata['cmi.core.exit'] == 'suspend'))
		$udata['entry'] = '';
	//bragin	
	$sql = "SELECT value, param FROM sco_ldata WHERE CID = " . $CID . " AND TID = '" . $TID . "' AND PID = " . $MID;
	$res = @sqldb_query($sql);
	if (num_rows($res) > 0) {
		while($row = fetch_array($res)) {
			$udata[$row['param']] = $row['value'];
		}
	}
	return $udata;
}

function get_adlcp() {
	global $CID, $TID, $sco_target_table;
	//bragin
	$sql = "SELECT ad_dfl, ad_ms, ad_mta, ad_tla FROM $sco_target_table WHERE CID = " . $CID . " AND TID = '" . $TID . "'";
	out_err($sql);
	$ldata = array();
	if ($res = @sqldb_query($sql)) {
		if (num_rows($res) > 0) {
			$row = fetch_array($res);
			$ldata['dfl'] = $row['ad_dfl'];
			$ldata['ms'] = $row['ad_ms'];
			$ldata['mta'] = $row['ad_mta'];
			$ldata['tla'] = $row['ad_tla'];
		}
	}
	return $ldata;
}

function out_err($err) {
	$f = @fopen('dbg5.dat', "a");
	if (!$f) {
		return "SCORM_AJAX: Error opening file";
	} else {
		fwrite($f, date("Y-m-d H:i:s") . "\t" . $err . "\n");
		fclose($f);
		return "SCORM_AJAX: OK\n";
	}
}
?>
//
// SCORM 1.2 API Implementation
//
function SCORMapi1_2() {
    // Standard Data Type Definition
    CMIString255 = '^.{0,255}$';
    CMIString4096 = '^.{0,4096}$';
    CMIDecimal = '^-?([0-9]{0,5})(\.[0-9]{0,5})?$';
    CMITime = '^([0-2][0-9]):([0-5][0-9]):([0-5][0-9])(\.[0-9]{1,2})?$';
    CMITimespan = '^([0-9]{2,4}):([0-9]{2}):([0-9]{2})(\.[0-9]{1,2})?$';
    CMIInteger = '^([0-9]{1,5})$';
    CMISInteger = '^-?([0-9]{1,5})$';
    CMIIdentifier = '^[\\w|\\-]{1,255}$';
    CMIFeedback = CMIString255;
    CMIIndex = '[._](\\d+).';
    // Vocabulary Data Type Definition
    CMIStatus = '^passed$|^completed$|^failed$|^incomplete$|^browsed$';
    CMIStatus2 = '^passed$|^completed$|^failed$|^incomplete$|^browsed$|^not attempted$';
    CMIExit = '^time-out$|^suspend$|^logout$|^$';
    CMIType = '^true-false$|^choice$|^fill-in$|^numeric$|^likert$|^matching$|^performance$|^sequencing$';
    CMIResult = '^correct$|^wrong$|^unanticipated$|^neutral$|^([0-9]{0,3})?(\.[0-9]{1,2})?$';
    NAVEvent = '^previous$|^continue$';
    // Children lists
    cmi_children = 'core, suspend_data, launch_data, comments, objectives, student_data, student_preference, interactions';
    core_children = 'student_id, student_name, lesson_location, credit, lesson_status, entry, score, total_time, lesson_mode, exit, session_time';
    score_children = 'raw, min, max';
    objectives_children = 'id, score, status';
    student_data_children = 'mastery_score, max_time_allowed, time_limit_action';
    student_preference_children = 'audio, language, speed, text';
    interactions_children = 'id, objectives, time, type, correct_responses, weighting, student_response, result, latency';
    // Data ranges
    score_range = '0#100';
    audio_range = '-1#100';
    speed_range = '-100#100';
    weighting_range = '-100#100';
    text_range = '-1#1';
    // The SCORM 1.2 data model
    var datamodel =  {
        'cmi._children':{'defaultvalue':cmi_children, 'mod':'r', 'writeerror':'402'},
        'cmi._version':{'defaultvalue':'3.4', 'mod':'r', 'writeerror':'402'},
        'cmi.core._children':{'defaultvalue':core_children, 'mod':'r', 'writeerror':'402'},
        'cmi.core.student_id':{'defaultvalue':'<?php echo $MID?>', 'format':CMIIdentifier, 'mod':'r', 'writeerror':'403'},
        'cmi.core.student_name':{'defaultvalue':'<?php echo addslashes($student_name)?>', 'format':CMIIdentifier, 'mod':'r', 'writeerror':'403'},
        'cmi.core.lesson_location':{'defaultvalue':'<?php echo isset($userdata->{'cmi.core.lesson_location'})?$userdata->{'cmi.core.lesson_location'}:'' ?>', 'format':CMIString255, 'mod':'rw', 'writeerror':'405'},
        'cmi.core.credit':{'defaultvalue':'<?php echo $userdata->credit ?>', 'mod':'r', 'writeerror':'403'},
        'cmi.core.lesson_status':{'defaultvalue':'<?php echo isset($userdata->{'cmi.core.lesson_status'})?$userdata->{'cmi.core.lesson_status'}:'' ?>', 'format':CMIStatus, 'mod':'rw', 'writeerror':'405'},
        'cmi.core.entry':{'defaultvalue':'<?php echo $userdata->entry ?>', 'mod':'r', 'writeerror':'403'},
        'cmi.core.score._children':{'defaultvalue':score_children, 'mod':'r', 'writeerror':'402'},
        'cmi.core.score.raw':{'defaultvalue':'<?php echo isset($userdata->{'cmi.core.score.raw'})?$userdata->{'cmi.core.score.raw'}:'' ?>', 'format':CMIDecimal, 'range':score_range, 'mod':'rw', 'writeerror':'405'},
        'cmi.core.score.max':{'defaultvalue':'<?php echo isset($userdata->{'cmi.core.score.max'})?$userdata->{'cmi.core.score.max'}:'' ?>', 'format':CMIDecimal, 'range':score_range, 'mod':'rw', 'writeerror':'405'},
        'cmi.core.score.min':{'defaultvalue':'<?php echo isset($userdata->{'cmi.core.score.min'})?$userdata->{'cmi.core.score.min'}:'' ?>', 'format':CMIDecimal, 'range':score_range, 'mod':'rw', 'writeerror':'405'},
        'cmi.core.total_time':{'defaultvalue':'<?php echo isset($userdata->{'cmi.core.total_time'})?$userdata->{'cmi.core.total_time'}:'00:00:00' ?>', 'mod':'r', 'writeerror':'403'},
        'cmi.core.lesson_mode':{'defaultvalue':'<?php echo $userdata->mode ?>', 'mod':'r', 'writeerror':'403'},
        'cmi.core.exit':{'defaultvalue':'<?php echo isset($userdata->{'cmi.core.exit'})?$userdata->{'cmi.core.exit'}:'' ?>', 'format':CMIExit, 'mod':'w', 'readerror':'404', 'writeerror':'405'},
        'cmi.core.session_time':{'format':CMITimespan, 'mod':'w', 'defaultvalue':'00:00:00', 'readerror':'404', 'writeerror':'405'},
        'cmi.suspend_data':{'defaultvalue':'<?php echo isset($userdata->{'cmi.suspend_data'})?$userdata->{'cmi.suspend_data'}:'' ?>', 'format':CMIString4096, 'mod':'rw', 'writeerror':'405'},
        'cmi.launch_data':{'defaultvalue':'<?php echo $userdata->datafromlms ?>', 'mod':'r', 'writeerror':'403'},
        'cmi.comments':{'defaultvalue':'<?php echo isset($userdata->{'cmi.comments'})?$userdata->{'cmi.comments'}:'' ?>', 'format':CMIString4096, 'mod':'rw', 'writeerror':'405'},
        'cmi.comments_from_lms':{'mod':'r', 'writeerror':'403'},
        'cmi.objectives._children':{'defaultvalue':objectives_children, 'mod':'r', 'writeerror':'402'},
        'cmi.objectives._count':{'mod':'r', 'defaultvalue':'0', 'writeerror':'402'},
        'cmi.objectives.n.id':{'pattern':CMIIndex, 'format':CMIIdentifier, 'mod':'rw', 'writeerror':'405'},
        'cmi.objectives.n.score._children':{'pattern':CMIIndex, 'mod':'r', 'writeerror':'402'},
        'cmi.objectives.n.score.raw':{'defaultvalue':'', 'pattern':CMIIndex, 'format':CMIDecimal, 'range':score_range, 'mod':'rw', 'writeerror':'405'},
        'cmi.objectives.n.score.min':{'defaultvalue':'', 'pattern':CMIIndex, 'format':CMIDecimal, 'range':score_range, 'mod':'rw', 'writeerror':'405'},
        'cmi.objectives.n.score.max':{'defaultvalue':'', 'pattern':CMIIndex, 'format':CMIDecimal, 'range':score_range, 'mod':'rw', 'writeerror':'405'},
        'cmi.objectives.n.status':{'pattern':CMIIndex, 'format':CMIStatus2, 'mod':'rw', 'writeerror':'405'},
        'cmi.student_data._children':{'defaultvalue':student_data_children, 'mod':'r', 'writeerror':'402'},
        'cmi.student_data.mastery_score':{'defaultvalue':'<?php echo $userdata->masteryscore ?>', 'mod':'r', 'writeerror':'403'},
        'cmi.student_data.max_time_allowed':{'defaultvalue':'<?php echo $userdata->maxtimeallowed ?>', 'mod':'r', 'writeerror':'403'},
        'cmi.student_data.time_limit_action':{'defaultvalue':'<?php echo $userdata->timelimitaction ?>', 'mod':'r', 'writeerror':'403'},
        'cmi.student_preference._children':{'defaultvalue':student_preference_children, 'mod':'r', 'writeerror':'402'},
        'cmi.student_preference.audio':{'defaultvalue':'0', 'format':CMISInteger, 'range':audio_range, 'mod':'rw', 'writeerror':'405'},
        'cmi.student_preference.language':{'defaultvalue':'', 'format':CMIString255, 'mod':'rw', 'writeerror':'405'},
        'cmi.student_preference.speed':{'defaultvalue':'0', 'format':CMISInteger, 'range':speed_range, 'mod':'rw', 'writeerror':'405'},
        'cmi.student_preference.text':{'defaultvalue':'0', 'format':CMISInteger, 'range':text_range, 'mod':'rw', 'writeerror':'405'},
        'cmi.interactions._children':{'defaultvalue':interactions_children, 'mod':'r', 'writeerror':'402'},
        'cmi.interactions._count':{'mod':'r', 'defaultvalue':'0', 'writeerror':'402'},
        'cmi.interactions.n.id':{'pattern':CMIIndex, 'format':CMIIdentifier, 'mod':'w', 'readerror':'404', 'writeerror':'405'},
        'cmi.interactions.n.objectives._count':{'pattern':CMIIndex, 'mod':'r', 'defaultvalue':'0', 'writeerror':'402'},
        'cmi.interactions.n.objectives.n.id':{'pattern':CMIIndex, 'format':CMIIdentifier, 'mod':'w', 'readerror':'404', 'writeerror':'405'},
        'cmi.interactions.n.time':{'pattern':CMIIndex, 'format':CMITime, 'mod':'w', 'readerror':'404', 'writeerror':'405'},
        'cmi.interactions.n.type':{'pattern':CMIIndex, 'format':CMIType, 'mod':'w', 'readerror':'404', 'writeerror':'405'},
        'cmi.interactions.n.correct_responses._count':{'pattern':CMIIndex, 'mod':'r', 'defaultvalue':'0', 'writeerror':'402'},
        'cmi.interactions.n.correct_responses.n.pattern':{'pattern':CMIIndex, 'format':CMIFeedback, 'mod':'w', 'readerror':'404', 'writeerror':'405'},
        'cmi.interactions.n.weighting':{'pattern':CMIIndex, 'format':CMIDecimal, 'range':weighting_range, 'mod':'w', 'readerror':'404', 'writeerror':'405'},
        'cmi.interactions.n.student_response':{'pattern':CMIIndex, 'format':CMIFeedback, 'mod':'w', 'readerror':'404', 'writeerror':'405'},
        'cmi.interactions.n.result':{'pattern':CMIIndex, 'format':CMIResult, 'mod':'w', 'readerror':'404', 'writeerror':'405'},
        'cmi.interactions.n.latency':{'pattern':CMIIndex, 'format':CMITimespan, 'mod':'w', 'readerror':'404', 'writeerror':'405'},
        'nav.event':{'defaultvalue':'', 'format':NAVEvent, 'mod':'w', 'readerror':'404', 'writeerror':'405'}
    };
    //
    // Datamodel inizialization
    //
    var cmi = new Object();
        cmi.core = new Object();
        cmi.core.score = new Object();
        cmi.objectives = new Object();
        cmi.student_data = new Object();
        cmi.student_preference = new Object();
        cmi.interactions = new Object();

    // Navigation Object
    var nav = new Object();

    for (element in datamodel) {
        if (element.match(/\.n\./) == null) {
            if ((typeof eval('datamodel["'+element+'"].defaultvalue')) != 'undefined') {
                eval(element+' = datamodel["'+element+'"].defaultvalue;');
            } else {
                eval(element+' = "";');
            }
        }
    }

<?php
    $count = 0;
    $objectives = '';
    foreach($userdata as $element => $value){
        if (substr($element,0,14) == 'cmi.objectives') {
            preg_match('/.(\d+)./',$element,$matches);
            $element = preg_replace('/.(\d+)./',"_\$1.",$element);
            if ($matches[1] == $count) {
                $count++;
                $end = strpos($element,$matches[1])+strlen($matches[1]);
                $subelement = substr($element,0,$end);
                echo '    '.$subelement." = new Object();\n";
                echo '    '.$subelement.".score = new Object();\n";
                echo '    '.$subelement.".score._children = score_children;\n";
                echo '    '.$subelement.".score.raw = '';\n";
                echo '    '.$subelement.".score.min = '';\n";
                echo '    '.$subelement.".score.max = '';\n";
            }
            echo '    '.$element.' = \''.$value."';\n";
        }
    }
    if ($count > 0) {
        echo '    cmi.objectives._count = '.$count.";\n";
    }
?>

    if (cmi.core.lesson_status == '') {
        cmi.core.lesson_status = 'not attempted';
    } 
    
    //
    // API Methods definition
    //
    var Initialized = false;

    function LMSInitialize (param) {
//    	AjaxReq("/traintest/teachers/scorm_ajax.php", "init=start");
        errorCode = "0";
        if (param == "") {
            if (!Initialized) {
                <?php 
                    if (DEBUG_DEVELOPER) {
                        echo 'alert("Initialized SCORM 1.2");';
                    }
                ?>
                Initialized = true;
                errorCode = "0";
//		    	AjaxReq("/traintest/teachers/scorm_ajax.php", "init=OK");
                return "true";
            } else {
                errorCode = "101";
            }
        } else {
            errorCode = "201";
        }
//    	AjaxReq("/traintest/teachers/scorm_ajax.php", "init=not_OK");
        return "false";
    }
    
    function LMSFinish (param) {
//    	AjaxReq("/traintest/teachers/scorm_ajax.php", "finish=start");
        errorCode = "0";
        if (param == "") {
            if (Initialized) {
                <?php 
                    if (DEBUG_DEVELOPER) {
                        echo 'alert("Finished SCORM 1.2");';
                    }
                ?>
                Initialized = false;
                result = StoreData(cmi,true);
                if (nav.event != '') {
                    if (nav.event == 'continue') {
                        setTimeout('top.document.location=top.next;',500);
                    } else {
                        setTimeout('top.document.location=top.prev;',500);
                    }
                } else {
                    if (<?php echo $scorm->auto ?> == 1) {
                        setTimeout('top.document.location=top.next;',500);
                    }
                }    
//		    	AjaxReq("/traintest/teachers/scorm_ajax.php", "finish=OK");
                return "true";
            } else {
                errorCode = "301";
            }
        } else {
            errorCode = "201";
        }
//    	AjaxReq("/traintest/teachers/scorm_ajax.php", "finish=not_OK");
        return "false";
    }
    
    function LMSGetValue (element) {
//    	AjaxReq("/traintest/teachers/scorm_ajax.php", "get=start&"+element);
        errorCode = "0";
        if (Initialized) {
            if (element !="") {
                expression = new RegExp(CMIIndex,'g');
                elementmodel = element.replace(expression,'.n.');
                if ((typeof eval('datamodel["'+elementmodel+'"]')) != "undefined") {
                    if (eval('datamodel["'+elementmodel+'"].mod') != 'w') {
                            element = element.replace(expression, "_$1.");
                            elementIndexes = element.split('.');
                        subelement = 'cmi';
                        i = 1;
                        while ((i < elementIndexes.length) && (typeof eval(subelement) != "undefined")) {
                            subelement += '.'+elementIndexes[i++];
                        }
                            if (subelement == element) {
                            errorCode = "0";
                            <?php 
 			                   if (DEBUG_DEVELOPER) {
                                    echo 'alert(element+": "+eval(element));';
                                }
                            ?>
//					    	AjaxReq("/traintest/teachers/scorm_ajax.php", "get=OK&"+element+"="+eval(element));
                            return eval(element);
                        } else {
                            errorCode = "0"; // Need to check if it is the right errorCode
                        }
                    } else {
                        errorCode = eval('datamodel["'+elementmodel+'"].readerror');
                    }
                } else {
                    childrenstr = '._children';
                    countstr = '._count';
                    if (elementmodel.substr(elementmodel.length-childrenstr.length,elementmodel.length) == childrenstr) {
                        parentmodel = elementmodel.substr(0,elementmodel.length-childrenstr.length);
                        if ((typeof eval('datamodel["'+parentmodel+'"]')) != "undefined") {
                            errorCode = "202";
                        } else {
                            errorCode = "201";
                        }
                    } else if (elementmodel.substr(elementmodel.length-countstr.length,elementmodel.length) == countstr) {
                        parentmodel = elementmodel.substr(0,elementmodel.length-countstr.length);
                        if ((typeof eval('datamodel["'+parentmodel+'"]')) != "undefined") {
                            errorCode = "203";
                        } else {
                            errorCode = "201";
                        }
                    } else {
                        errorCode = "201";
                    }
                }
            } else {
                errorCode = "201";
            }
        } else {
            errorCode = "301";
        }
//    	AjaxReq("/traintest/teachers/scorm_ajax.php", "get=not_OK&"+element);
        return "";
    }
    
    function LMSSetValue (element,value) {
//    	AjaxReq("/traintest/teachers/scorm_ajax.php", "set=start&"+element+"="+value);
        errorCode = "0";
        if (Initialized) {
            if (element != "") {
                expression = new RegExp(CMIIndex,'g');
                elementmodel = element.replace(expression,'.n.');
                if ((typeof eval('datamodel["'+elementmodel+'"]')) != "undefined") {
                    if (eval('datamodel["'+elementmodel+'"].mod') != 'r') {
                        expression = new RegExp(eval('datamodel["'+elementmodel+'"].format'));
                        value = value+'';
                        matches = value.match(expression);
                        if (matches != null) {
                            //Create dynamic data model element
                            if (element != elementmodel) {
                                elementIndexes = element.split('.');
                                subelement = 'cmi';
                                for (i=1;i < elementIndexes.length-1;i++) {
                                    elementIndex = elementIndexes[i];
                                    if (elementIndexes[i+1].match(/^\d+$/)) {
                                        if ((typeof eval(subelement+'.'+elementIndex)) == "undefined") {
                                            eval(subelement+'.'+elementIndex+' = new Object();');
                                            eval(subelement+'.'+elementIndex+'._count = 0;');
                                        }
                                        if (elementIndexes[i+1] == eval(subelement+'.'+elementIndex+'._count')) {
                                            eval(subelement+'.'+elementIndex+'._count++;');
                                        } 
                                        if (elementIndexes[i+1] > eval(subelement+'.'+elementIndex+'._count')) {
                                            errorCode = "201";
                                        }
                                        subelement = subelement.concat('.'+elementIndex+'_'+elementIndexes[i+1]);
                                        i++;
                                    } else {
                                        subelement = subelement.concat('.'+elementIndex);
                                    }
                                    if ((typeof eval(subelement)) == "undefined") {
                                        eval(subelement+' = new Object();');
                                        if (subelement.substr(0,14) == 'cmi.objectives') {
                                            eval(subelement+'.score = new Object();');
                                            eval(subelement+'.score._children = score_children;');
                                            eval(subelement+'.score.raw = "";');
                                            eval(subelement+'.score.min = "";');
                                            eval(subelement+'.score.max = "";');
                                        }
                                        if (subelement.substr(0,16) == 'cmi.interactions') {
                                            eval(subelement+'.objectives = new Object();');
                                            eval(subelement+'.objectives._count = 0;');
                                            eval(subelement+'.correct_responses = new Object();');
                                            eval(subelement+'.correct_responses._count = 0;');
                                        }
                                    }
                                }
                                element = subelement.concat('.'+elementIndexes[elementIndexes.length-1]);
                            }
                            //Store data
                            if (errorCode == "0") {
                                if ((typeof eval('datamodel["'+elementmodel+'"].range')) != "undefined") {
                                    range = eval('datamodel["'+elementmodel+'"].range');
                                    ranges = range.split('#');
                                    value = value*1.0;
                                    if ((value >= ranges[0]) && (value <= ranges[1])) {
                                        eval(element+'="'+value+'";');
                                        errorCode = "0";
                                        <?php 
 						                   if (DEBUG_DEVELOPER) {
                                                echo 'alert(element+":= "+value);';
                                            }
                                        ?>
//								    	AjaxReq("/traintest/teachers/scorm_ajax.php", "set=OK&"+element+"="+value);
                                        return "true";
                                    } else {
                                        errorCode = eval('datamodel["'+elementmodel+'"].writeerror');
                                    }
                                } else {
                                    if (element == 'cmi.comments') {
                                        eval(element+'+="'+value+'";');
                                    } else {
                                        eval(element+'="'+value+'";');
                                    }
                                    errorCode = "0";
                                    <?php 
 					                   if (DEBUG_DEVELOPER) {
                                            echo 'alert(element+":= "+value);';
                                        }
                                    ?>
//							    	AjaxReq("/traintest/teachers/scorm_ajax.php", "set=OK&"+element+"="+value);
                                    return "true";
                                }
                            }
                        } else {
                            errorCode = eval('datamodel["'+elementmodel+'"].writeerror');
                        }
                    } else {
                        errorCode = eval('datamodel["'+elementmodel+'"].writeerror');
                    }
                } else {
                    errorCode = "201"
                }
            } else {
                errorCode = "201";
            }
        } else {
            errorCode = "301";
        }
//    	AjaxReq("/traintest/teachers/scorm_ajax.php", "set=not_OK&"+element+"="+value);
        return "false";
    }
    
    function LMSCommit (param) {
//    	AjaxReq("/traintest/teachers/scorm_ajax.php", "commit=start");
        errorCode = "0";
        if (param == "") {
            if (Initialized) {
                result = StoreData(cmi,false);
                <?php 
                    if (DEBUG_DEVELOPER) {
                        echo 'alert("Data Committed");';
                    }
                ?>
//		    	AjaxReq("/traintest/teachers/scorm_ajax.php", "commit=OK");
                return "true";
            } else {
                errorCode = "301";
            }
        } else {
            errorCode = "201";
        }
//    	AjaxReq("/traintest/teachers/scorm_ajax.php", "commit=not_OK");
        return "false";
    }
    
    function LMSGetLastError () {
        return errorCode;
    }
    
    function LMSGetErrorString (param) {
        if (param != "") {
            var errorString = new Array();
            errorString["0"] = "No error";
            errorString["101"] = "General exception";
            errorString["201"] = "Invalid argument error";
            errorString["202"] = "Element cannot have children";
            errorString["203"] = "Element not an array - Cannot have count";
            errorString["301"] = "Not initialized";
            errorString["401"] = "Not implemented error";
            errorString["402"] = "Invalid set value, element is a keyword";
            errorString["403"] = "Element is read only";
            errorString["404"] = "Element is write only";
            errorString["405"] = "Incorrect data type";
            return errorString[param];
        } else {
           return "";
        }
    }
    
    function LMSGetDiagnostic (param) {
        if (param == "") {
            param = errorCode;
        }
        return param;
    }

    function AddTime (first, second) {
        var sFirst = first.split(":");
        var sSecond = second.split(":");
        var cFirst = sFirst[2].split(".");
        var cSecond = sSecond[2].split(".");
        var change = 0;

        FirstCents = 0;  //Cents
        if (cFirst.length > 1) {
            FirstCents = parseInt(cFirst[1],10);
        }
        SecondCents = 0;
        if (cSecond.length > 1) {
            SecondCents = parseInt(cSecond[1],10);
        }
        var cents = FirstCents + SecondCents;
        change = Math.floor(cents / 100);
        cents = cents - (change * 100);
        if (Math.floor(cents) < 10) {
            cents = "0" + cents.toString();
        }

        var secs = parseInt(cFirst[0],10)+parseInt(cSecond[0],10)+change;  //Seconds
        change = Math.floor(secs / 60);
        secs = secs - (change * 60);
        if (Math.floor(secs) < 10) {
            secs = "0" + secs.toString();
        }

        mins = parseInt(sFirst[1],10)+parseInt(sSecond[1],10)+change;   //Minutes
        change = Math.floor(mins / 60);
        mins = mins - (change * 60);
        if (mins < 10) {
            mins = "0" + mins.toString();
        }

        hours = parseInt(sFirst[0],10)+parseInt(sSecond[0],10)+change;  //Hours
        if (hours < 10) {
            hours = "0" + hours.toString();
        }

        if (cents != '0') {
            return hours + ":" + mins + ":" + secs + '.' + cents;
        } else {
            return hours + ":" + mins + ":" + secs;
        }
    }

    function TotalTime() {
        total_time = AddTime(cmi.core.total_time, cmi.core.session_time);
        return '&'+underscore('cmi.core.total_time')+'='+escape(total_time);
    }

    function CollectData(data,parent) {
        var datastring = '';
        for (property in data) {
            if (typeof data[property] == 'object') {
                datastring += CollectData(data[property],parent+'.'+property);
            } else {
                element = parent+'.'+property;
                expression = new RegExp(CMIIndex,'g');
                elementmodel = element.replace(expression,'.n.');
                if (elementmodel != "cmi.core.session_time") {
                    if ((typeof eval('datamodel["'+elementmodel+'"]')) != "undefined") {
                        if (eval('datamodel["'+elementmodel+'"].mod') != 'r') {
                            elementstring = '&'+underscore(element)+'='+escape(data[property]);
                            if ((typeof eval('datamodel["'+elementmodel+'"].defaultvalue')) != "undefined") {
                                if (eval('datamodel["'+elementmodel+'"].defaultvalue') != data[property]) {
                                    datastring += elementstring;
                                }
                            } else {
                                datastring += elementstring;
                            }
                        }
                    }
                }
            }
        }
        return datastring;
    }

    function StoreData(data,storetotaltime) {
        if (storetotaltime) {
            if (cmi.core.lesson_status == 'not attempted') {
                cmi.core.lesson_status = 'completed';
            }
            if (cmi.core.lesson_mode == 'normal') {
                if (cmi.core.credit == 'credit') {
                    if (cmi.core.lesson_status == 'completed') {
                        if (cmi.student_data.mastery_score != '') {
                            if (parseFloat(cmi.core.score.raw) >= parseFloat(cmi.student_data.mastery_score)) {
                                cmi.core.lesson_status = 'passed';
                            } else {
                                cmi.core.lesson_status = 'failed';
                            }
                        }
                    }
                }
            }
            if (cmi.core.lesson_mode == 'browse') {
                if (datamodel['cmi.core.lesson_status'].defaultvalue == '') {
                    cmi.core.lesson_status = 'browsed';
                }
            }
            datastring = CollectData(data,'cmi');
            datastring += TotalTime();
        } else {
            datastring = CollectData(data,'cmi');
        }
//        datastring += '&attempt=<?php echo $attempt?>';
//        datastring += '&scoid=<?php echo $CID?>';
        
//        var myRequest = NewHttpReq();
//        result = DoRequest(myRequest, "/traintest/teachers/scorm_ajax.php", datastring);
        result = AjaxReq("/traintest/teachers/scorm_ajax.php", datastring);
//        results = result.split('\n');
//        errorCode = results[1];
//        return results[0];
		return result;
    }

    this.LMSInitialize = LMSInitialize;
    this.LMSFinish = LMSFinish;
    this.LMSGetValue = LMSGetValue;
    this.LMSSetValue = LMSSetValue;
    this.LMSCommit = LMSCommit;
    this.LMSGetLastError = LMSGetLastError;
    this.LMSGetErrorString = LMSGetErrorString;
    this.LMSGetDiagnostic = LMSGetDiagnostic;
}

var API = new SCORMapi1_2();

var errorCode = "0";

function underscore(str) {
    return str.replace(/\./g, "___");
}

function AjaxReq(ajax_url, ajax_str) {
	var myAjax = new Ajax.Request(
			ajax_url, 
			{
				asynchronous: false,
				contentType: 'application/x-www-form-urlencoded',
				method: 'post', 
				parameters: ajax_str, 
				onSuccess: function (t) {
					return t.responseText;
				},
				onSuccess: function (t) {
					return t.status;
				}
			});
}

